# [Jira](https://jira.cloudera.com/browse/VIZ-)

## Purpose of the PR 🤔

Include brief description of what this PR does and why it is necessary.

## Changed 💡

Describe changes made -- what was the old behavior?

If commit messages are meaningful, a list of the commits here is acceptable

## [Quanta](https://quanta.infra.cloudera.com/#/runDetails?gtn=)

Revision: 42ec98c876
Commit: VIZ-3073: Update copyright in python files to include 2025 (#1997)

## Test scenarios :test_tube:

Include scenarios, steps for reproducing the issue, and the expected/buggy behavior. Example below:

### Hide legend settings in the Marks tab for Combined Bar-Line visual

1. Create a Combined Bar-Line visual
2. Open Visual **Settings** tab
3. Open **Marks** sub tab

- **EXPECTED**: Check there is no legend related setting
- **PREVIOUS BEHAVIOR**: **Legend style** and **Legend order** settings were shown

<img width="1719" alt="Screenshot 2023-08-16 at 22 49 00" src="https://github.infra.cloudera.com/storage/user/3386/files/f481b2fa-3f43-4d8c-ba51-77f9f773b99b">

## Safety checks ✅

- [ ] I have performed a self-review of my code
- [ ] I have considered quanta run (and have a green run if necessary)
  - Note: Include quanta link with commit hash and message
- [ ] I have considered adding new unit tests or e2e tests
- [ ] I have added labels, project, and milestone as applicable
- [ ] If I made any migrations, I have added the has-migration label and made notes about my changes in the [migrations sheet](https://docs.google.com/spreadsheets/d/1nJ-QsEZ2q8nnL0lik2cJ9suexPRT4MifIqiO028mqe0/edit?usp=sharing)
- _Before Merge_ Github actions have linked this PR to the related jira and marked it as "Start Review"
- _After Merge:_ I have resolved the related jira and set the correct fix version on it

### Notes for the functional reviewer

- Check bug scenario is fixed (first make sure you are reproducing error)
- Make suggestions based on what a typical user might expect or want
- Consider edge cases related to the area being fixed and make sure they are handled appropriately

### Notes for the code reviewer

- Code follows general good practices and doesn’t have any obvious refactoring that could be made
- Code changes are easy to understand
- There’s no edge cases not covered by code changes (check where changed functions are used)
- Double-check file and variable naming change are changed everywhere
- Suggest missing unit tests or test cases
