# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# This ties us into the standard django 'ready' mechanism for doing
# initialization after all models are loaded.

import os
import sys
from django.apps import AppConfig

class ArcwebConfig(AppConfig):

  name = 'arcwebbase'
  verbose_name = 'Arcadia Visualization Web Server'

  def ready(self):
    # We only want to do the logging/threading init when actually doing runserver
    # not on various other django commands (migrate, shell, etc.) so here we
    # check.
    # Note that running under 'runcpserver', arcviz_initialize is called directly
    if 'runserver' in sys.argv or os.environ.get('ARCVIZ_INITIALIZE'):
      from arcwebbase.initialize import arcviz_initialize
      arcviz_initialize()
