# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations, models
import arcwebbase.validator
from django.conf import settings
import apps.models


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='APIKey',
            fields=[
                ('id', models.AutoField(verbose_name='ID', primary_key=True, serialize=False, auto_created=True)),
                ('apikey', models.CharField(max_length=128, unique=True)),
                ('apikey_hash', models.CharField(max_length=64, unique=True)),
                ('active', models.BooleanField()),
                ('expire_time', models.DateTimeField(blank=True, null=True, default=apps.models._default_expire_time)),
                ('create_time', models.DateTimeField(null=True, auto_now_add=True)),
                ('update_time', models.DateTimeField(null=True, auto_now=True)),
                ('user', models.ForeignKey(on_delete=models.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'ordering': ['user'],
            },
        ),
        migrations.CreateModel(
            name='UserProfile',
            fields=[
                ('id', models.AutoField(verbose_name='ID', primary_key=True, serialize=False, auto_created=True)),
                ('user_data', models.TextField(max_length=32768, default='{}', validators=[arcwebbase.validator.validateStringNoHtml])),
                ('create_time', models.DateTimeField(null=True, auto_now_add=True)),
                ('update_time', models.DateTimeField(null=True, auto_now=True)),
                ('user', models.OneToOneField(on_delete=models.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
