# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations, models
from django.conf import settings
from arcwebbase.migration_helper import south_migration_applied


def check_compatibility(apps, shcema_editor):
    if not south_migration_applied('0004_auto__add_apikey', 'apps') or \
       not south_migration_applied('0016_fill_dataset_settings', 'datasets') or \
       not south_migration_applied('0010_creating_scheduler_log_part_2', 'jobs') or \
       not south_migration_applied('0001_initial', 'rbac') or \
       not south_migration_applied('0030_gaugeline', 'reports'):
        raise Exception("The current version is not supported for automated upgrade. Please consult Cloudera.")

class Migration(migrations.Migration):

    dependencies = [
        ('apps', '0001_initial'),
    ]

    operations = [
        migrations.RunPython(check_compatibility),
    ]
