# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.13 on 2022-08-25 14:00

from django.db import migrations, models
import uuid
from util.cleanup_currency_format import main as cleanup_currency_format


class Migration(migrations.Migration):

    dependencies = [
        ('apps', '0009_shorturl'),
        ('reports', '0026_update_email_protocol_settings'),
        ('datasets', '0013_move_cml_id'),
    ]

    operations = [
        migrations.AlterModelOptions(
            name='shorturl',
            options={'ordering': ['-update_time']},
        ),
        migrations.AlterField(
            model_name='shorturl',
            name='slug',
            field=models.CharField(db_index=True, default=uuid.uuid4, max_length=36, unique=True),
        ),
        migrations.RunPython(cleanup_currency_format),
    ]
