# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django import template
from util.ff_flipper import FeatureFlipper

register = template.Library()

@register.simple_tag
def site_setting_name(capitalize = True):
    try:
        site_word = 'explore data' if FeatureFlipper().get_flipper_value('enable_explore_style') else 'site'
    except Exception:
        site_word = 'site'

    full_name = f'{site_word} settings'
    if capitalize:
        return full_name.title()

    return full_name
