# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
class UsageRouter:

  app_label = 'usage'
  db_name = 'usage'

  def db_for_read(self, model, **hints):
    if model._meta.app_label == self.app_label:
      return self.db_name
    return None

  def db_for_write(self, model, **hints):
    if model._meta.app_label == self.app_label:
      return self.db_name
    return None

  def allow_migrate(self, db, app_label, model_name=None, **hints):
    if db == self.db_name and app_label == self.app_label:
      return True
    elif db != self.db_name and app_label != self.app_label:
      return True
    return False