# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.core.management.base import BaseCommand, CommandError

import argparse

class Command(BaseCommand):
  help = 'Run cli commands'

  def add_arguments(self, parser):
    parser.add_argument('commands', metavar='C', type=str, nargs='*',
                        help=argparse.SUPPRESS)

    # We are writing our own cli and want to parse -- and - arguments within it
    # Change the prefix for django command flags to be + instead so it does not
    # interfere.
    parser.prefix_chars = "+"

  def handle(self, *args, **options):
    args = ['cli']
    args.extend(options.get('commands'))

    import cli.acli
    cli.acli.run(args)
