# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.db import connection


def south_migration_exist():
  if 'south_migrationhistory' in connection.introspection.table_names():
    return True
  else:
    return False

def south_migration_applied(name, app_name=None):
  """
  check if a south migration file has been applied or not
  :param name: name of migration file
  :param app_name: name of the app that the migration belongs to
  :return:
  """
  if 'south_migrationhistory' not in connection.introspection.table_names():
    # new install, all south migrations are already applied through initial migration
    return True
  sql = "select id from south_migrationhistory where migration= '%s'" % name
  if app_name:
    sql += " and app_name ='%s'" % app_name
  with connection.cursor() as cursor:
    cursor.execute(sql)
    row = cursor.fetchall()

  if not row:
    return False

  return True