# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from .settings import *
from .settings_tests import *

import json
import tempfile

from jobs.views_encryption import encrypt_secret

RETENTION = 5
DO_LOGGING = 1

TEMPFILE = tempfile.NamedTemporaryFile(dir='/tmp').name

# Example data connection configurations
TEST_DATACONNECTIONS = {
  'arcengine': {
    'dataconnection_type': 'arcengine',
    'dataconnection_password': '',
    'dataconnection_info': {'PARAMS' : {
      'USERNAME': 'admin',
      'IMPERSONATION': False,
      'SETTINGS': {},
      'AUTH': 'nosasl',
      'HOST': 'localhost',
      'PORT': '31050',
      'TIMEOUT': 30,
      'SESSION_TIMEOUT': 30,
      'CACHE': {'ENABLED': 1, 'RETENTION': RETENTION},
    }}
  },
  'impala_arcengine': {
    'dataconnection_type': 'impala',
    'dataconnection_password': '',
    'dataconnection_info': {'PARAMS' : {
      'USERNAME': 'admin',
      'IMPERSONATION': False,
      'SETTINGS': {},
      'AUTH': 'nosasl',
      'HOST': 'localhost',
      'PORT': '21050',
      'TIMEOUT': 30,
      'SESSION_TIMEOUT': 30,
      'CACHE': {'ENABLED': 1, 'RETENTION': RETENTION},
    }}
  },
  'hive': {
    'dataconnection_type': 'hive',
    'dataconnection_password': '',
    'dataconnection_info': {'PARAMS': {
      'USERNAME': 'vagrant',
      'IMPERSONATION': False,
      'SETTINGS': {},
      'AUTH': 'plain',
      'HOST': 'localhost',
      'PORT': '11050',
      'TIMEOUT': 30,
      'SESSION_TIMEOUT': 30,
      'CACHE': {'ENABLED': 1, 'RETENTION': RETENTION},
    }},
  },
  'mysql': {
    'dataconnection_type': 'mysql',
    'dataconnection_password': json.dumps(encrypt_secret('cloudera')),
    'dataconnection_info': {'PARAMS' : {
      'USERNAME': 'root',
      'DATABASE': 'arcadia',
      'Authentication': 'No Authentication',
      'SETTINGS': {},
      'HOST': 'viz-team-4.cdsw-int.cloudera.com',
      'PORT': '3310',
      'CACHE': {'ENABLED': 1, 'RETENTION': RETENTION},
    }}
  }
}