# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from .settings import *

import tempfile

# FORCE_SCRIPT_NAME = "/arc"
LOGIN_URL = '/apps/login'
ADMIN_API_URL_LIST = ['*']
DJANGO_TEST_ENV = True
RBAC_POLL_SECONDS = 0
ACCESS_LOG = False
ADMIN_API_DEMO_LIST = ['*']
dbfile = tempfile.NamedTemporaryFile(dir='/tmp').name
dbfile_usage = tempfile.NamedTemporaryFile(dir='/tmp').name

import os

if os.environ.get('METADATA_STORE', 'sqlite') == 'sqlite':
  DATABASES['default'].update({'TEST': {'NAME': dbfile}, 'NAME': dbfile})

DATABASES['usage'].update({'TEST': {'NAME': dbfile_usage}, 'NAME': dbfile_usage})

CACHES = {
  'default' : {
    'BACKEND':'django.core.cache.backends.locmem.LocMemCache',
  },

  'axes_cache' : {
    'BACKEND':'django.core.cache.backends.dummy.DummyCache',
  }
}

AXES_CACHE = 'axes_cache'

PDF_OPTIONS['ENABLE_CHROMIUM_PDF'] = False

# To have Django query logging:
#  - run "manage.py test --debug-mode" # this sets DEBUG=True
#  - uncomment the line below:
#LOGGING['loggers']['django.db.backends'] = {'level': 'DEBUG'}