# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import django.test

class TestViews(django.test.TestCase):

  def test_root_url_redirection(self):
    client = django.test.client.Client()
    response = client.get('/')

    # regular users get redirected to the apps page
    self.assertEquals(response.status_code, 302)

  def test_root_url_redirection_for_healthcheck(self):
    client = django.test.client.Client(HTTP_USER_AGENT='Go-http-client/1.1')
    response = client.get('/')

    # Health-checker agent does not get redirected:
    self.assertEquals(response.status_code, 200)
