# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.conf import settings
from django.contrib.sessions.models import Session


def is_health_check_agent(httpUserAgent: str = None):
  if httpUserAgent is None:
    return False

  return any([httpUserAgent.startswith(agentPrefix)
            for agentPrefix in settings.HEALTH_CHECK_AGENTS])


def delete_all_sessions():
  # this can be very slow
  # Session.objects.all().delete()

  # the lines below issue a sinqle query
  # no triggers are fired and no cascade deletes are performed
  # (hopefully there are no such references)
  all_sessions = Session.objects.all()
  all_sessions._raw_delete(all_sessions.db)
