# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
cli commands for reports
"""

from cli.core import table

from jobs.models import JobLog

def logs(argsl):
  cnt = 0

  t = table.Table('Job Logs', headers=["ID", "Last Task", "Error Message"])

  for jl in JobLog.objects.all().order_by("-start_time"):
    cnt += 1
    if cnt < 5:
      print(dir(jl))

    t.add_row([jl.id, jl.get_last_task(), jl.error_message])

  t.display()

_COMMANDS = [
  ('logs', logs, True, '',
    'job logs. Show all job logs'),
]

def plugin_defn():
  """
  Return meta information about the plugin
  """

  defn = {
    'help'    :
      'Commands to work with jobs',
    'commands': _COMMANDS
  }
  return defn
