# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

ARC_DATATYPE_UNKNOWN    = "UNKNOWN"
ARC_DATATYPE_STRING     = "STRING"
ARC_DATATYPE_INT        = "INT"
ARC_DATATYPE_BIGINT     = "BIGINT"
ARC_DATATYPE_REAL       = "REAL"
ARC_DATATYPE_DOUBLE     = "DOUBLE"
ARC_DATATYPE_BOOLEAN    = "BOOLEAN"
ARC_DATATYPE_TIMESTAMP  = "TIMESTAMP"
ARC_DATATYPE_BINARY     = "BINARY"
ARC_DATATYPE_VECTOR     = "VECTOR"
ARC_DATATYPE_TEXT       = "TEXT"

ARC_DATATYPES_ALL = [
  ARC_DATATYPE_UNKNOWN,
  ARC_DATATYPE_STRING,
  ARC_DATATYPE_INT,
  ARC_DATATYPE_BIGINT,
  ARC_DATATYPE_REAL,
  ARC_DATATYPE_DOUBLE,
  ARC_DATATYPE_BOOLEAN,
  ARC_DATATYPE_TIMESTAMP,
  ARC_DATATYPE_BINARY,
  ARC_DATATYPE_VECTOR,
  ARC_DATATYPE_TEXT
]

#
# Convert from ARC_DATATYPE_ values to display_to_table_type keys
# that are stored within each dataconnection
#
ARC_DATATYPE_TO_NOMINAL = {
  ARC_DATATYPE_UNKNOWN: "String",
  ARC_DATATYPE_STRING: "String",
  ARC_DATATYPE_INT: "Integer",
  ARC_DATATYPE_BIGINT: "Integer",
  ARC_DATATYPE_REAL: "Real",
  ARC_DATATYPE_DOUBLE: "Real",
  ARC_DATATYPE_BOOLEAN: "Boolean",
  ARC_DATATYPE_TIMESTAMP: "Timestamp",
  ARC_DATATYPE_BINARY: "String",
  ARC_DATATYPE_VECTOR: 'Vector',
  ARC_DATATYPE_TEXT: 'Text'
}
