# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import os
import logging

from util.ff_flipper import FeatureFlipper

CML_IMPALA = "impala"
CML_HIVE = "hive"

VIZCML_RW = "vizcml-rw"
VIZCML_RO = "vizcml-ro"

LOGGER = logging.getLogger("arcweb")


def get_cmldata():
    try:
        import cml.data_v1 as cmldata

        return cmldata
    except:
        LOGGER.warning("Could not import cml.data_v1 library")
        FeatureFlipper().set_flipper('enable_cml_sync', False, 'SETTINGS')
        return None


def get_project_dataconnections(cmldata):
    try:
        connections = cmldata.get_project_dataconnections()
        return connections
    except Exception as e:
        LOGGER.warning(f'MLExplore: Sync fails, cannot fetch project data connections due to: {e}')
        FeatureFlipper().set_flipper('enable_cml_sync', False, 'SETTINGS')
        return []
