# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import json
from jobs.views_encryption import encrypt_secret


class ConnectionImporter(object):
    def parse_connection(self, connection_name, connection_type, password, params, cml_id, cml_status):
        if password is not None:
            password = json.dumps(encrypt_secret(password))
        
        if connection_type=='impyla':
            params['CONNECTIONNAME_EXTENDED'] = 'cdw-impyla';
        if connection_type=='hyve':
            params['CONNECTIONNAME_EXTENDED'] = 'cdw-hyve';
        if connection_type=='postgres':
            params['CONNECTIONNAME_EXTENDED'] = 'ssb';

        return {
            'dataconnection_name': connection_name,
            'dataconnection_type': connection_type,
            'dataconnection_password': password,
            'dataconnection_info': json.dumps({
                'PARAMS': params
            }),
            'cml_id': cml_id,
            'cml_status': json.dumps(cml_status),
        }

    def connect(self):
        raise NotImplementedError
