# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# It is map in frontend/src/arc_screen_apps/types/data-connection-type.ts
# If you change a value here please change in the above file as well!
from django.conf import settings

DATACONN_ARCENGINE = 'arcengine'
DATACONN_ARCENGINE_V2 = 'arcengine_v2'
DATACONN_SPARKSQL = 'sparksql'
DATACONN_HIVE = 'hive'
DATACONN_HYVE = 'hyve'
DATACONN_IMPALA = 'impala'
DATACONN_SQLITE = 'sqlite'
DATACONN_DUCKDB = 'duckdb'
DATACONN_DRUID = 'druid'
DATACONN_MYSQL = 'mysql'
DATACONN_MARIADB = 'mariadb'
DATACONN_PG = 'postgres'
DATACONN_REDSHIFT = 'redshift'
DATACONN_MONGODB = 'mongodb'
DATACONN_ODBC = 'odbc'
DATACONN_ASTER = 'aster'
DATACONN_SOLR = 'solr'
DATACONN_DRILL = 'drill'
DATACONN_ORACLE = 'oracle'
DATACONN_MSSQL = 'mssqlserver'
DATACONN_KSQL = 'ksql'
DATACONN_TERADATA = 'teradata'
DATACONN_BIGQUERY = 'bigquery'
DATACONN_SNOWFLAKE = 'snowflake'
DATACONN_VERTICA = 'vertica'
DATACONN_ATHENA = 'athena'
DATACONN_DENODO = 'denodo'
DATACONN_ELASTICSEARCH = 'elasticsearch'
DATACONN_CASSANDRA = 'cassandra'
DATACONN_IMPYLA = 'impyla'

from dataconn.ext.main import connection_types, connection_names

KNOWN_CONNECTION_TYPES = set([DATACONN_ARCENGINE, DATACONN_SPARKSQL,
    DATACONN_HIVE, DATACONN_IMPALA, DATACONN_SQLITE, DATACONN_MYSQL,
    DATACONN_MARIADB, DATACONN_PG, DATACONN_REDSHIFT, DATACONN_DUCKDB,
    DATACONN_MONGODB, DATACONN_ODBC, DATACONN_ASTER, DATACONN_DRILL,
    DATACONN_ORACLE, DATACONN_SOLR, DATACONN_MSSQL, DATACONN_KSQL,
    DATACONN_TERADATA, DATACONN_BIGQUERY, DATACONN_SNOWFLAKE,
    DATACONN_VERTICA, DATACONN_ATHENA, DATACONN_DENODO,
    DATACONN_ELASTICSEARCH, DATACONN_CASSANDRA, DATACONN_IMPYLA,
    DATACONN_DRUID, DATACONN_HYVE, DATACONN_ARCENGINE_V2]) | set(connection_types())

GENERAL_CONNECTION_TYPES = {}
GENERAL_CONNECTION_TYPES[DATACONN_MARIADB] = 'MariaDB'
GENERAL_CONNECTION_TYPES[DATACONN_MYSQL] = 'MySQL'
GENERAL_CONNECTION_TYPES[DATACONN_SQLITE] = 'SQLite'
GENERAL_CONNECTION_TYPES[DATACONN_SPARKSQL] = 'Spark SQL'

GENERAL_CONNECTION_TYPES[DATACONN_SOLR] = 'Solr (Tech Preview)'
GENERAL_CONNECTION_TYPES[DATACONN_PG] = 'PostgreSQL'

if settings.ENABLE_DATACONN_DUCKDB:
  GENERAL_CONNECTION_TYPES[DATACONN_DUCKDB] = 'DuckDB'

if settings.ENABLE_DATACONN_DRUID:
  GENERAL_CONNECTION_TYPES[DATACONN_DRUID] = 'Druid (Tech Preview)'

if settings.ENABLE_DATACONN_HIVE:
  GENERAL_CONNECTION_TYPES[DATACONN_HIVE] = 'Hive (legacy)'

if settings.ENABLE_DATACONN_HYVE:
  GENERAL_CONNECTION_TYPES[DATACONN_HYVE] = 'Hive'

if settings.ENABLE_DATACONN_IMPALA:
  GENERAL_CONNECTION_TYPES[DATACONN_IMPALA] = 'Impala (legacy)'

if settings.ENABLE_DATACONN_IMPYLA:
  GENERAL_CONNECTION_TYPES[DATACONN_IMPYLA] = 'Impala'

if settings.ENABLE_DATACONN_ARCENGINE:
  GENERAL_CONNECTION_TYPES[DATACONN_ARCENGINE] = 'Arcadia (legacy)'

if settings.ENABLE_DATACONN_ARCENGINE_V2:
  GENERAL_CONNECTION_TYPES[DATACONN_ARCENGINE_V2] = 'Arcadia'

if settings.ENABLE_DATACONN_ASTER:
  GENERAL_CONNECTION_TYPES[DATACONN_ASTER] = 'TD Aster'

if settings.ENABLE_DATACONN_REDSHIFT:
  GENERAL_CONNECTION_TYPES[DATACONN_REDSHIFT] = 'Amazon Redshift'

if settings.ENABLE_DATACONN_MSSQL:
  GENERAL_CONNECTION_TYPES[DATACONN_MSSQL] = 'Microsoft SQL Server'

if settings.ENABLE_DATACONN_ORACLE:
  GENERAL_CONNECTION_TYPES[DATACONN_ORACLE] = 'Oracle'

if settings.ENABLE_DATACONN_DENODO:
  GENERAL_CONNECTION_TYPES[DATACONN_DENODO] = 'Denodo'

if settings.ENABLE_DATACONN_DRILL:
  GENERAL_CONNECTION_TYPES[DATACONN_DRILL] = 'Apache Drill'

if settings.ENABLE_DATACONN_BIGQUERY:
  GENERAL_CONNECTION_TYPES[DATACONN_BIGQUERY] = 'Google BigQuery'

if settings.ENABLE_DATACONN_SNOWFLAKE:
  GENERAL_CONNECTION_TYPES[DATACONN_SNOWFLAKE] = 'Snowflake (Tech Preview)'

if settings.ENABLE_DATACONN_KSQL:
  GENERAL_CONNECTION_TYPES[DATACONN_KSQL] = 'Confluent KSQL'

if settings.ENABLE_DATACONN_TERADATA:
  GENERAL_CONNECTION_TYPES[DATACONN_TERADATA] = 'Teradata'

if settings.ENABLE_DATACONN_VERTICA:
  GENERAL_CONNECTION_TYPES[DATACONN_VERTICA] = 'Vertica'

if settings.ENABLE_DATACONN_ELASTICSEARCH:
  GENERAL_CONNECTION_TYPES[DATACONN_ELASTICSEARCH] = 'Elasticsearch'

if settings.ENABLE_DATACONN_CASSANDRA:
  GENERAL_CONNECTION_TYPES[DATACONN_CASSANDRA] = 'Apache Cassandra'

if settings.ENABLE_DATACONN_ATHENA:
  GENERAL_CONNECTION_TYPES[DATACONN_ATHENA] = 'Amazon Athena'

GENERAL_CONNECTION_TYPES.update(connection_names())

ALL_CONNECTION_TYPES = GENERAL_CONNECTION_TYPES.copy()

IMPALA_TYPES = set([DATACONN_ARCENGINE, DATACONN_IMPALA, DATACONN_IMPYLA, DATACONN_ARCENGINE_V2])
ARCENGINE_TYPES = set([DATACONN_ARCENGINE, DATACONN_ARCENGINE_V2])

def isImpalaBased(conntype):
  return conntype in IMPALA_TYPES

def isArcEngineBased(conntype):
  return conntype in ARCENGINE_TYPES

def supportsVectorDataType(conntype):
  return conntype == DATACONN_SOLR

