# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# special commands are prepended with a dot
# their built queries are not expected to be similar among different connections
# they are often executed outside BuildRequestExecutor's execute method
SPECIAL_CMDS = {
  'SHOW_DATABASES': '.databases',
  'SHOW_TABLES':    '.tables',   # using "dbname" data_api json field
  'VALIDATE': '.validate',
  'DATA_IMPORT': '.data_import',
  'SHOW_AVIEWS': '.show_aviews',
  'REFRESH_AVIEWS': '.refresh_aviews',
  'DROP_AVIEWS': '.drop_aviews',
  'INVALIDATE_METADATA': '.invalidate_metadata',
  'COMPUTE_STATS': '.compute_stats',
  'ROWS': '.rows'
}

VALIDATE_CMDS = { # using "validate" data_api json field
  'column': '.validate-column',
  'filter': '.validate-filter',
  'query': '.validate-query',
  'join': '.validate-join',
}

# normal commands are not prepended with a dot
# their built queries are expected to be similar among different connections
# they are often executed using BuildRequestExecutor's execute method
NORM_CMDS = {
  'SQL': 'SQL',
  'getrows': 'getrows',
  'CREATEAVIEW': 'createaview',
  'SAVE_TABLE': 'save_table',
  'MR': 'MR',
  'COLUMN_STATS': 'columnstats',
  'HTTP': 'HTTP',
  'SOLR': 'SOLR',
}
