# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from .connections_types import DATACONN_HYVE
from .dataconn_impyla import ImpylaConnProperties, ImpylaConn

import logging
LOGGER = logging.getLogger('arcweb')

class HyveConnProperties(ImpylaConnProperties):
  def __init__(self, conn_type=DATACONN_HYVE):
    super(HyveConnProperties, self).__init__(conn_type)
    self.supports_limit_outside_union = False
    self.supports_nulls_order = False

#
# TODO: change hive sql generation in the future to use ordinal positions for
# group by and order by in generated SQL queries.
# If running Hive 0.11 or below, you can set the following connection property:
# set hive.groupby.orderby.position.alias=true;
#
class HyveConn(ImpylaConn):
  def __init__(self, params, connection_id, conn_type=DATACONN_HYVE):
    super(HyveConn, self).__init__(params, connection_id, conn_type=conn_type)

  # overridden method
  def properties(self):
    return HyveConnProperties()

