# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from . import dataconn_arcengine
from .dataconn_dataengine import ConnProperties
from .connections_types import DATACONN_IMPALA
from django.conf import settings

import time

class ImpalaConnProperties(ConnProperties):
  def __init__(self):
    super(ImpalaConnProperties, self).__init__()
    self.supports_async = True
    self.supports_deriveddata = True
    self.supports_tableproperties = True
    self.supports_nulls_order = True
    self.display_to_table_type = {
      "String": "string",
      "Integer": "bigint",
      "Real": "double",
      "Boolean": "boolean",
      "Timestamp": "timestamp"
    }

class ImpalaConn(dataconn_arcengine.ArcEngineConn):
  def __init__(self, params, connection_id):
    dataconn_arcengine.ArcEngineConn.__init__(self, params, connection_id, conn_type=DATACONN_IMPALA)

  def properties(self):
    return ImpalaConnProperties()

