# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from . import dataconn_hive
from .connections_types import DATACONN_SPARKSQL

class SparkSQLConnProperties(dataconn_hive.HiveConnProperties):

  def __init__(self):
    super(SparkSQLConnProperties, self).__init__()
    self.supports_limit_outside_union = False
    self.supports_import_data_perm = False
    self.import_data_insertrows = 500
    self.supports_deriveddata = True
    self.date_type = "date"
    self.display_to_table_type = {
      "String": "string",
      "Integer": "bigint",
      "Real": "double",
      "Boolean": "boolean",
      "Timestamp": "timestamp",
      "Date": "date"
    }

class SparkSQLConn(dataconn_hive.HiveConn):
  def __init__(self, params, connection_id):
    dataconn_hive.HiveConn.__init__(self, params,
        connection_id, conn_type=DATACONN_SPARKSQL)

  def properties(self):
    return SparkSQLConnProperties()
