# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.test import TestCase

from . import rows_data

class RowsDataTests(TestCase):
  def setUp(self):
    pass

  def test_singlearray(self):
    data = rows_data.RowsData(10240)
    data.addRow([1, 2])
    self.assertEqual(len(data), 6)
    self.assertEqual(data.fetchAndClose(), "[[1,2]]")

  def test_multiplearray(self):
    data = rows_data.RowsData(10240)
    data.addRow([1, 2])
    data.addRow([3, 4])
    self.assertEqual(len(data), 12)
    self.assertEqual(data.fetchAndClose(), "[[1,2],[3,4]]")

  def test_multiplearray_str(self):
    data = rows_data.RowsData(10240)
    data.addRow([1, 2])
    data.addRow([3, 4])
    data.addRow(["five", "six"])
    self.assertEqual(len(data), 27)
    self.assertEqual(data.fetchAndClose(), '[[1,2],[3,4],["five","six"]]')

