# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
#
# Autogenerated by Thrift Compiler (0.11.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py
#

from thrift.Thrift import TType, TMessageType, TFrozenDict, TException, TApplicationException
from thrift.protocol.TProtocol import TProtocolException
from thrift.TRecursive import fix_spec

import sys

from thrift.transport import TTransport
all_structs = []


class TQueryExecMethod(object):
    ARCENGINE_BASE = 0
    ARCENGINE_AVIEW = 1
    DJANGO_CACHE = 2
    FALLBACK = 3
    SQL_INJECTION_DETECTED = 4

    _VALUES_TO_NAMES = {
        0: "ARCENGINE_BASE",
        1: "ARCENGINE_AVIEW",
        2: "DJANGO_CACHE",
        3: "FALLBACK",
        4: "SQL_INJECTION_DETECTED",
    }

    _NAMES_TO_VALUES = {
        "ARCENGINE_BASE": 0,
        "ARCENGINE_AVIEW": 1,
        "DJANGO_CACHE": 2,
        "FALLBACK": 3,
        "SQL_INJECTION_DETECTED": 4,
    }


class TCacheInvalidationObject(object):
    """
    Attributes:
     - databaseName
     - tableName
     - tldt
     - crc
    """


    def __init__(self, databaseName=None, tableName=None, tldt=None, crc=None,):
        self.databaseName = databaseName
        self.tableName = tableName
        self.tldt = tldt
        self.crc = crc

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRING:
                    self.databaseName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.STRING:
                    self.tableName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.STRING:
                    self.tldt = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.STRING:
                    self.crc = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TCacheInvalidationObject')
        if self.databaseName is not None:
            oprot.writeFieldBegin('databaseName', TType.STRING, 1)
            oprot.writeString(self.databaseName.encode('utf-8') if sys.version_info[0] == 2 else self.databaseName)
            oprot.writeFieldEnd()
        if self.tableName is not None:
            oprot.writeFieldBegin('tableName', TType.STRING, 2)
            oprot.writeString(self.tableName.encode('utf-8') if sys.version_info[0] == 2 else self.tableName)
            oprot.writeFieldEnd()
        if self.tldt is not None:
            oprot.writeFieldBegin('tldt', TType.STRING, 3)
            oprot.writeString(self.tldt.encode('utf-8') if sys.version_info[0] == 2 else self.tldt)
            oprot.writeFieldEnd()
        if self.crc is not None:
            oprot.writeFieldBegin('crc', TType.STRING, 4)
            oprot.writeString(self.crc.encode('utf-8') if sys.version_info[0] == 2 else self.crc)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.databaseName is None:
            raise TProtocolException(message='Required field databaseName is unset!')
        if self.tableName is None:
            raise TProtocolException(message='Required field tableName is unset!')
        if self.tldt is None:
            raise TProtocolException(message='Required field tldt is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TSQLInjectionObject(object):
    """
    Attributes:
     - databaseName
     - tableName
     - referencedColumns
    """


    def __init__(self, databaseName=None, tableName=None, referencedColumns=None,):
        self.databaseName = databaseName
        self.tableName = tableName
        self.referencedColumns = referencedColumns

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRING:
                    self.databaseName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.STRING:
                    self.tableName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.LIST:
                    self.referencedColumns = []
                    (_etype3, _size0) = iprot.readListBegin()
                    for _i4 in range(_size0):
                        _elem5 = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                        self.referencedColumns.append(_elem5)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TSQLInjectionObject')
        if self.databaseName is not None:
            oprot.writeFieldBegin('databaseName', TType.STRING, 1)
            oprot.writeString(self.databaseName.encode('utf-8') if sys.version_info[0] == 2 else self.databaseName)
            oprot.writeFieldEnd()
        if self.tableName is not None:
            oprot.writeFieldBegin('tableName', TType.STRING, 2)
            oprot.writeString(self.tableName.encode('utf-8') if sys.version_info[0] == 2 else self.tableName)
            oprot.writeFieldEnd()
        if self.referencedColumns is not None:
            oprot.writeFieldBegin('referencedColumns', TType.LIST, 3)
            oprot.writeListBegin(TType.STRING, len(self.referencedColumns))
            for iter6 in self.referencedColumns:
                oprot.writeString(iter6.encode('utf-8') if sys.version_info[0] == 2 else iter6)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.databaseName is None:
            raise TProtocolException(message='Required field databaseName is unset!')
        if self.tableName is None:
            raise TProtocolException(message='Required field tableName is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TFilterAssociation(object):
    """
    Attributes:
     - filterExpr
     - tableNames
    """


    def __init__(self, filterExpr=None, tableNames=None,):
        self.filterExpr = filterExpr
        self.tableNames = tableNames

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRING:
                    self.filterExpr = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.LIST:
                    self.tableNames = []
                    (_etype10, _size7) = iprot.readListBegin()
                    for _i11 in range(_size7):
                        _elem12 = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                        self.tableNames.append(_elem12)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TFilterAssociation')
        if self.filterExpr is not None:
            oprot.writeFieldBegin('filterExpr', TType.STRING, 1)
            oprot.writeString(self.filterExpr.encode('utf-8') if sys.version_info[0] == 2 else self.filterExpr)
            oprot.writeFieldEnd()
        if self.tableNames is not None:
            oprot.writeFieldBegin('tableNames', TType.LIST, 2)
            oprot.writeListBegin(TType.STRING, len(self.tableNames))
            for iter13 in self.tableNames:
                oprot.writeString(iter13.encode('utf-8') if sys.version_info[0] == 2 else iter13)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.filterExpr is None:
            raise TProtocolException(message='Required field filterExpr is unset!')
        if self.tableNames is None:
            raise TProtocolException(message='Required field tableNames is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TExtMetadataReq(object):
    """
    Attributes:
     - cacheInvalidationObjectsInput
     - sqlInjectionObjectsInput
     - filterAssociations
     - fallbackEnabled
     - systemFunctionsAllowed
     - performSQLInjectionChecks
    """


    def __init__(self, cacheInvalidationObjectsInput=None, sqlInjectionObjectsInput=None, filterAssociations=None, fallbackEnabled=None, systemFunctionsAllowed=None, performSQLInjectionChecks=None,):
        self.cacheInvalidationObjectsInput = cacheInvalidationObjectsInput
        self.sqlInjectionObjectsInput = sqlInjectionObjectsInput
        self.filterAssociations = filterAssociations
        self.fallbackEnabled = fallbackEnabled
        self.systemFunctionsAllowed = systemFunctionsAllowed
        self.performSQLInjectionChecks = performSQLInjectionChecks

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.LIST:
                    self.cacheInvalidationObjectsInput = []
                    (_etype17, _size14) = iprot.readListBegin()
                    for _i18 in range(_size14):
                        _elem19 = TCacheInvalidationObject()
                        _elem19.read(iprot)
                        self.cacheInvalidationObjectsInput.append(_elem19)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.LIST:
                    self.sqlInjectionObjectsInput = []
                    (_etype23, _size20) = iprot.readListBegin()
                    for _i24 in range(_size20):
                        _elem25 = TSQLInjectionObject()
                        _elem25.read(iprot)
                        self.sqlInjectionObjectsInput.append(_elem25)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.LIST:
                    self.filterAssociations = []
                    (_etype29, _size26) = iprot.readListBegin()
                    for _i30 in range(_size26):
                        _elem31 = TFilterAssociation()
                        _elem31.read(iprot)
                        self.filterAssociations.append(_elem31)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.BOOL:
                    self.fallbackEnabled = iprot.readBool()
                else:
                    iprot.skip(ftype)
            elif fid == 5:
                if ftype == TType.BOOL:
                    self.systemFunctionsAllowed = iprot.readBool()
                else:
                    iprot.skip(ftype)
            elif fid == 6:
                if ftype == TType.BOOL:
                    self.performSQLInjectionChecks = iprot.readBool()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TExtMetadataReq')
        if self.cacheInvalidationObjectsInput is not None:
            oprot.writeFieldBegin('cacheInvalidationObjectsInput', TType.LIST, 1)
            oprot.writeListBegin(TType.STRUCT, len(self.cacheInvalidationObjectsInput))
            for iter32 in self.cacheInvalidationObjectsInput:
                iter32.write(oprot)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        if self.sqlInjectionObjectsInput is not None:
            oprot.writeFieldBegin('sqlInjectionObjectsInput', TType.LIST, 2)
            oprot.writeListBegin(TType.STRUCT, len(self.sqlInjectionObjectsInput))
            for iter33 in self.sqlInjectionObjectsInput:
                iter33.write(oprot)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        if self.filterAssociations is not None:
            oprot.writeFieldBegin('filterAssociations', TType.LIST, 3)
            oprot.writeListBegin(TType.STRUCT, len(self.filterAssociations))
            for iter34 in self.filterAssociations:
                iter34.write(oprot)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        if self.fallbackEnabled is not None:
            oprot.writeFieldBegin('fallbackEnabled', TType.BOOL, 4)
            oprot.writeBool(self.fallbackEnabled)
            oprot.writeFieldEnd()
        if self.systemFunctionsAllowed is not None:
            oprot.writeFieldBegin('systemFunctionsAllowed', TType.BOOL, 5)
            oprot.writeBool(self.systemFunctionsAllowed)
            oprot.writeFieldEnd()
        if self.performSQLInjectionChecks is not None:
            oprot.writeFieldBegin('performSQLInjectionChecks', TType.BOOL, 6)
            oprot.writeBool(self.performSQLInjectionChecks)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.cacheInvalidationObjectsInput is None:
            raise TProtocolException(message='Required field cacheInvalidationObjectsInput is unset!')
        if self.sqlInjectionObjectsInput is None:
            raise TProtocolException(message='Required field sqlInjectionObjectsInput is unset!')
        if self.filterAssociations is None:
            raise TProtocolException(message='Required field filterAssociations is unset!')
        if self.fallbackEnabled is None:
            raise TProtocolException(message='Required field fallbackEnabled is unset!')
        if self.systemFunctionsAllowed is None:
            raise TProtocolException(message='Required field systemFunctionsAllowed is unset!')
        if self.performSQLInjectionChecks is None:
            raise TProtocolException(message='Required field performSQLInjectionChecks is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TExtMetadataResp(object):
    """
    Attributes:
     - aviewUsed
     - rewrStmt
     - cacheInvalidationObjects
     - queryExecMethod
     - queryExecDetails
    """


    def __init__(self, aviewUsed=None, rewrStmt=None, cacheInvalidationObjects=None, queryExecMethod=None, queryExecDetails=None,):
        self.aviewUsed = aviewUsed
        self.rewrStmt = rewrStmt
        self.cacheInvalidationObjects = cacheInvalidationObjects
        self.queryExecMethod = queryExecMethod
        self.queryExecDetails = queryExecDetails

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.BOOL:
                    self.aviewUsed = iprot.readBool()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.STRING:
                    self.rewrStmt = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.LIST:
                    self.cacheInvalidationObjects = []
                    (_etype38, _size35) = iprot.readListBegin()
                    for _i39 in range(_size35):
                        _elem40 = TCacheInvalidationObject()
                        _elem40.read(iprot)
                        self.cacheInvalidationObjects.append(_elem40)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.I32:
                    self.queryExecMethod = iprot.readI32()
                else:
                    iprot.skip(ftype)
            elif fid == 5:
                if ftype == TType.STRING:
                    self.queryExecDetails = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TExtMetadataResp')
        if self.aviewUsed is not None:
            oprot.writeFieldBegin('aviewUsed', TType.BOOL, 1)
            oprot.writeBool(self.aviewUsed)
            oprot.writeFieldEnd()
        if self.rewrStmt is not None:
            oprot.writeFieldBegin('rewrStmt', TType.STRING, 2)
            oprot.writeString(self.rewrStmt.encode('utf-8') if sys.version_info[0] == 2 else self.rewrStmt)
            oprot.writeFieldEnd()
        if self.cacheInvalidationObjects is not None:
            oprot.writeFieldBegin('cacheInvalidationObjects', TType.LIST, 3)
            oprot.writeListBegin(TType.STRUCT, len(self.cacheInvalidationObjects))
            for iter41 in self.cacheInvalidationObjects:
                iter41.write(oprot)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        if self.queryExecMethod is not None:
            oprot.writeFieldBegin('queryExecMethod', TType.I32, 4)
            oprot.writeI32(self.queryExecMethod)
            oprot.writeFieldEnd()
        if self.queryExecDetails is not None:
            oprot.writeFieldBegin('queryExecDetails', TType.STRING, 5)
            oprot.writeString(self.queryExecDetails.encode('utf-8') if sys.version_info[0] == 2 else self.queryExecDetails)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.aviewUsed is None:
            raise TProtocolException(message='Required field aviewUsed is unset!')
        if self.rewrStmt is None:
            raise TProtocolException(message='Required field rewrStmt is unset!')
        if self.cacheInvalidationObjects is None:
            raise TProtocolException(message='Required field cacheInvalidationObjects is unset!')
        if self.queryExecMethod is None:
            raise TProtocolException(message='Required field queryExecMethod is unset!')
        if self.queryExecDetails is None:
            raise TProtocolException(message='Required field queryExecDetails is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)
all_structs.append(TCacheInvalidationObject)
TCacheInvalidationObject.thrift_spec = (
    None,  # 0
    (1, TType.STRING, 'databaseName', 'UTF8', None, ),  # 1
    (2, TType.STRING, 'tableName', 'UTF8', None, ),  # 2
    (3, TType.STRING, 'tldt', 'UTF8', None, ),  # 3
    (4, TType.STRING, 'crc', 'UTF8', None, ),  # 4
)
all_structs.append(TSQLInjectionObject)
TSQLInjectionObject.thrift_spec = (
    None,  # 0
    (1, TType.STRING, 'databaseName', 'UTF8', None, ),  # 1
    (2, TType.STRING, 'tableName', 'UTF8', None, ),  # 2
    (3, TType.LIST, 'referencedColumns', (TType.STRING, 'UTF8', False), None, ),  # 3
)
all_structs.append(TFilterAssociation)
TFilterAssociation.thrift_spec = (
    None,  # 0
    (1, TType.STRING, 'filterExpr', 'UTF8', None, ),  # 1
    (2, TType.LIST, 'tableNames', (TType.STRING, 'UTF8', False), None, ),  # 2
)
all_structs.append(TExtMetadataReq)
TExtMetadataReq.thrift_spec = (
    None,  # 0
    (1, TType.LIST, 'cacheInvalidationObjectsInput', (TType.STRUCT, [TCacheInvalidationObject, None], False), None, ),  # 1
    (2, TType.LIST, 'sqlInjectionObjectsInput', (TType.STRUCT, [TSQLInjectionObject, None], False), None, ),  # 2
    (3, TType.LIST, 'filterAssociations', (TType.STRUCT, [TFilterAssociation, None], False), None, ),  # 3
    (4, TType.BOOL, 'fallbackEnabled', None, None, ),  # 4
    (5, TType.BOOL, 'systemFunctionsAllowed', None, None, ),  # 5
    (6, TType.BOOL, 'performSQLInjectionChecks', None, None, ),  # 6
)
all_structs.append(TExtMetadataResp)
TExtMetadataResp.thrift_spec = (
    None,  # 0
    (1, TType.BOOL, 'aviewUsed', None, None, ),  # 1
    (2, TType.STRING, 'rewrStmt', 'UTF8', None, ),  # 2
    (3, TType.LIST, 'cacheInvalidationObjects', (TType.STRUCT, [TCacheInvalidationObject, None], False), None, ),  # 3
    (4, TType.I32, 'queryExecMethod', None, None, ),  # 4
    (5, TType.STRING, 'queryExecDetails', 'UTF8', None, ),  # 5
)
fix_spec(all_structs)
del all_structs
