# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
#
# Autogenerated by Thrift Compiler (0.11.0)
#
# DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
#
#  options string: py
#

from thrift.Thrift import TType, TMessageType, TFrozenDict, TException, TApplicationException
from thrift.protocol.TProtocol import TProtocolException
from thrift.TRecursive import fix_spec

import sys

from thrift.transport import TTransport
all_structs = []


class TLogApplication(object):
    CATALOGD = 0
    STATESTORED = 1
    ARCENGINED = 2

    _VALUES_TO_NAMES = {
        0: "CATALOGD",
        1: "STATESTORED",
        2: "ARCENGINED",
    }

    _NAMES_TO_VALUES = {
        "CATALOGD": 0,
        "STATESTORED": 1,
        "ARCENGINED": 2,
    }


class TContinuationToken(object):
    """
    Attributes:
     - fileName
     - fileSize
     - offset
     - nodeName
     - fileTime
    """


    def __init__(self, fileName=None, fileSize=None, offset=None, nodeName=None, fileTime=None,):
        self.fileName = fileName
        self.fileSize = fileSize
        self.offset = offset
        self.nodeName = nodeName
        self.fileTime = fileTime

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRING:
                    self.fileName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.I64:
                    self.fileSize = iprot.readI64()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.I64:
                    self.offset = iprot.readI64()
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.STRING:
                    self.nodeName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 5:
                if ftype == TType.I64:
                    self.fileTime = iprot.readI64()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TContinuationToken')
        if self.fileName is not None:
            oprot.writeFieldBegin('fileName', TType.STRING, 1)
            oprot.writeString(self.fileName.encode('utf-8') if sys.version_info[0] == 2 else self.fileName)
            oprot.writeFieldEnd()
        if self.fileSize is not None:
            oprot.writeFieldBegin('fileSize', TType.I64, 2)
            oprot.writeI64(self.fileSize)
            oprot.writeFieldEnd()
        if self.offset is not None:
            oprot.writeFieldBegin('offset', TType.I64, 3)
            oprot.writeI64(self.offset)
            oprot.writeFieldEnd()
        if self.nodeName is not None:
            oprot.writeFieldBegin('nodeName', TType.STRING, 4)
            oprot.writeString(self.nodeName.encode('utf-8') if sys.version_info[0] == 2 else self.nodeName)
            oprot.writeFieldEnd()
        if self.fileTime is not None:
            oprot.writeFieldBegin('fileTime', TType.I64, 5)
            oprot.writeI64(self.fileTime)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.fileName is None:
            raise TProtocolException(message='Required field fileName is unset!')
        if self.fileSize is None:
            raise TProtocolException(message='Required field fileSize is unset!')
        if self.offset is None:
            raise TProtocolException(message='Required field offset is unset!')
        if self.nodeName is None:
            raise TProtocolException(message='Required field nodeName is unset!')
        if self.fileTime is None:
            raise TProtocolException(message='Required field fileTime is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TServerLogSharedReq(object):
    """
    Attributes:
     - maxBytes
     - startPoint
     - continuationToken
     - timestamp
     - duration
     - continueForever
     - nodes
     - coordinators_only
    """


    def __init__(self, maxBytes=1000000, startPoint=0, continuationToken=None, timestamp=0, duration=7200, continueForever=False, nodes=None, coordinators_only=False,):
        self.maxBytes = maxBytes
        self.startPoint = startPoint
        self.continuationToken = continuationToken
        self.timestamp = timestamp
        self.duration = duration
        self.continueForever = continueForever
        self.nodes = nodes
        self.coordinators_only = coordinators_only

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.I32:
                    self.maxBytes = iprot.readI32()
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.I32:
                    self.startPoint = iprot.readI32()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.STRUCT:
                    self.continuationToken = TContinuationToken()
                    self.continuationToken.read(iprot)
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.I64:
                    self.timestamp = iprot.readI64()
                else:
                    iprot.skip(ftype)
            elif fid == 5:
                if ftype == TType.I32:
                    self.duration = iprot.readI32()
                else:
                    iprot.skip(ftype)
            elif fid == 6:
                if ftype == TType.BOOL:
                    self.continueForever = iprot.readBool()
                else:
                    iprot.skip(ftype)
            elif fid == 7:
                if ftype == TType.LIST:
                    self.nodes = []
                    (_etype3, _size0) = iprot.readListBegin()
                    for _i4 in range(_size0):
                        _elem5 = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                        self.nodes.append(_elem5)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            elif fid == 8:
                if ftype == TType.BOOL:
                    self.coordinators_only = iprot.readBool()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TServerLogSharedReq')
        if self.maxBytes is not None:
            oprot.writeFieldBegin('maxBytes', TType.I32, 1)
            oprot.writeI32(self.maxBytes)
            oprot.writeFieldEnd()
        if self.startPoint is not None:
            oprot.writeFieldBegin('startPoint', TType.I32, 2)
            oprot.writeI32(self.startPoint)
            oprot.writeFieldEnd()
        if self.continuationToken is not None:
            oprot.writeFieldBegin('continuationToken', TType.STRUCT, 3)
            self.continuationToken.write(oprot)
            oprot.writeFieldEnd()
        if self.timestamp is not None:
            oprot.writeFieldBegin('timestamp', TType.I64, 4)
            oprot.writeI64(self.timestamp)
            oprot.writeFieldEnd()
        if self.duration is not None:
            oprot.writeFieldBegin('duration', TType.I32, 5)
            oprot.writeI32(self.duration)
            oprot.writeFieldEnd()
        if self.continueForever is not None:
            oprot.writeFieldBegin('continueForever', TType.BOOL, 6)
            oprot.writeBool(self.continueForever)
            oprot.writeFieldEnd()
        if self.nodes is not None:
            oprot.writeFieldBegin('nodes', TType.LIST, 7)
            oprot.writeListBegin(TType.STRING, len(self.nodes))
            for iter6 in self.nodes:
                oprot.writeString(iter6.encode('utf-8') if sys.version_info[0] == 2 else iter6)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        if self.coordinators_only is not None:
            oprot.writeFieldBegin('coordinators_only', TType.BOOL, 8)
            oprot.writeBool(self.coordinators_only)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TGlogServerLogInternalReq(object):
    """
    Attributes:
     - sharedReq
     - logLevel
     - app
    """


    def __init__(self, sharedReq=None, logLevel=None, app=None,):
        self.sharedReq = sharedReq
        self.logLevel = logLevel
        self.app = app

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRUCT:
                    self.sharedReq = TServerLogSharedReq()
                    self.sharedReq.read(iprot)
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.I32:
                    self.logLevel = iprot.readI32()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.I32:
                    self.app = iprot.readI32()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TGlogServerLogInternalReq')
        if self.sharedReq is not None:
            oprot.writeFieldBegin('sharedReq', TType.STRUCT, 1)
            self.sharedReq.write(oprot)
            oprot.writeFieldEnd()
        if self.logLevel is not None:
            oprot.writeFieldBegin('logLevel', TType.I32, 2)
            oprot.writeI32(self.logLevel)
            oprot.writeFieldEnd()
        if self.app is not None:
            oprot.writeFieldBegin('app', TType.I32, 3)
            oprot.writeI32(self.app)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.sharedReq is None:
            raise TProtocolException(message='Required field sharedReq is unset!')
        if self.logLevel is None:
            raise TProtocolException(message='Required field logLevel is unset!')
        if self.app is None:
            raise TProtocolException(message='Required field app is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TProfilesServerLogInternalReq(object):
    """
    Attributes:
     - sharedReq
     - queryId
    """


    def __init__(self, sharedReq=None, queryId=None,):
        self.sharedReq = sharedReq
        self.queryId = queryId

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRUCT:
                    self.sharedReq = TServerLogSharedReq()
                    self.sharedReq.read(iprot)
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.STRING:
                    self.queryId = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TProfilesServerLogInternalReq')
        if self.sharedReq is not None:
            oprot.writeFieldBegin('sharedReq', TType.STRUCT, 1)
            self.sharedReq.write(oprot)
            oprot.writeFieldEnd()
        if self.queryId is not None:
            oprot.writeFieldBegin('queryId', TType.STRING, 2)
            oprot.writeString(self.queryId.encode('utf-8') if sys.version_info[0] == 2 else self.queryId)
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.sharedReq is None:
            raise TProtocolException(message='Required field sharedReq is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)


class TServerLogSharedResp(object):
    """
    Attributes:
     - continuationToken
     - logData
     - errorMessage
     - nodeName
     - fileName
     - nodesToFetch
    """


    def __init__(self, continuationToken=None, logData=None, errorMessage=None, nodeName=None, fileName=None, nodesToFetch=None,):
        self.continuationToken = continuationToken
        self.logData = logData
        self.errorMessage = errorMessage
        self.nodeName = nodeName
        self.fileName = fileName
        self.nodesToFetch = nodesToFetch

    def read(self, iprot):
        if iprot._fast_decode is not None and isinstance(iprot.trans, TTransport.CReadableTransport) and self.thrift_spec is not None:
            iprot._fast_decode(self, iprot, [self.__class__, self.thrift_spec])
            return
        iprot.readStructBegin()
        while True:
            (fname, ftype, fid) = iprot.readFieldBegin()
            if ftype == TType.STOP:
                break
            if fid == 1:
                if ftype == TType.STRUCT:
                    self.continuationToken = TContinuationToken()
                    self.continuationToken.read(iprot)
                else:
                    iprot.skip(ftype)
            elif fid == 2:
                if ftype == TType.STRING:
                    self.logData = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 3:
                if ftype == TType.STRING:
                    self.errorMessage = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 4:
                if ftype == TType.STRING:
                    self.nodeName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 5:
                if ftype == TType.STRING:
                    self.fileName = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                else:
                    iprot.skip(ftype)
            elif fid == 6:
                if ftype == TType.LIST:
                    self.nodesToFetch = []
                    (_etype10, _size7) = iprot.readListBegin()
                    for _i11 in range(_size7):
                        _elem12 = iprot.readString().decode('utf-8') if sys.version_info[0] == 2 else iprot.readString()
                        self.nodesToFetch.append(_elem12)
                    iprot.readListEnd()
                else:
                    iprot.skip(ftype)
            else:
                iprot.skip(ftype)
            iprot.readFieldEnd()
        iprot.readStructEnd()

    def write(self, oprot):
        if oprot._fast_encode is not None and self.thrift_spec is not None:
            oprot.trans.write(oprot._fast_encode(self, [self.__class__, self.thrift_spec]))
            return
        oprot.writeStructBegin('TServerLogSharedResp')
        if self.continuationToken is not None:
            oprot.writeFieldBegin('continuationToken', TType.STRUCT, 1)
            self.continuationToken.write(oprot)
            oprot.writeFieldEnd()
        if self.logData is not None:
            oprot.writeFieldBegin('logData', TType.STRING, 2)
            oprot.writeString(self.logData.encode('utf-8') if sys.version_info[0] == 2 else self.logData)
            oprot.writeFieldEnd()
        if self.errorMessage is not None:
            oprot.writeFieldBegin('errorMessage', TType.STRING, 3)
            oprot.writeString(self.errorMessage.encode('utf-8') if sys.version_info[0] == 2 else self.errorMessage)
            oprot.writeFieldEnd()
        if self.nodeName is not None:
            oprot.writeFieldBegin('nodeName', TType.STRING, 4)
            oprot.writeString(self.nodeName.encode('utf-8') if sys.version_info[0] == 2 else self.nodeName)
            oprot.writeFieldEnd()
        if self.fileName is not None:
            oprot.writeFieldBegin('fileName', TType.STRING, 5)
            oprot.writeString(self.fileName.encode('utf-8') if sys.version_info[0] == 2 else self.fileName)
            oprot.writeFieldEnd()
        if self.nodesToFetch is not None:
            oprot.writeFieldBegin('nodesToFetch', TType.LIST, 6)
            oprot.writeListBegin(TType.STRING, len(self.nodesToFetch))
            for iter13 in self.nodesToFetch:
                oprot.writeString(iter13.encode('utf-8') if sys.version_info[0] == 2 else iter13)
            oprot.writeListEnd()
            oprot.writeFieldEnd()
        oprot.writeFieldStop()
        oprot.writeStructEnd()

    def validate(self):
        if self.logData is None:
            raise TProtocolException(message='Required field logData is unset!')
        return

    def __repr__(self):
        L = ['%s=%r' % (key, value)
             for key, value in self.__dict__.items()]
        return '%s(%s)' % (self.__class__.__name__, ', '.join(L))

    def __eq__(self, other):
        return isinstance(other, self.__class__) and self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not (self == other)
all_structs.append(TContinuationToken)
TContinuationToken.thrift_spec = (
    None,  # 0
    (1, TType.STRING, 'fileName', 'UTF8', None, ),  # 1
    (2, TType.I64, 'fileSize', None, None, ),  # 2
    (3, TType.I64, 'offset', None, None, ),  # 3
    (4, TType.STRING, 'nodeName', 'UTF8', None, ),  # 4
    (5, TType.I64, 'fileTime', None, None, ),  # 5
)
all_structs.append(TServerLogSharedReq)
TServerLogSharedReq.thrift_spec = (
    None,  # 0
    (1, TType.I32, 'maxBytes', None, 1000000, ),  # 1
    (2, TType.I32, 'startPoint', None, 0, ),  # 2
    (3, TType.STRUCT, 'continuationToken', [TContinuationToken, None], None, ),  # 3
    (4, TType.I64, 'timestamp', None, 0, ),  # 4
    (5, TType.I32, 'duration', None, 7200, ),  # 5
    (6, TType.BOOL, 'continueForever', None, False, ),  # 6
    (7, TType.LIST, 'nodes', (TType.STRING, 'UTF8', False), None, ),  # 7
    (8, TType.BOOL, 'coordinators_only', None, False, ),  # 8
)
all_structs.append(TGlogServerLogInternalReq)
TGlogServerLogInternalReq.thrift_spec = (
    None,  # 0
    (1, TType.STRUCT, 'sharedReq', [TServerLogSharedReq, None], None, ),  # 1
    (2, TType.I32, 'logLevel', None, None, ),  # 2
    (3, TType.I32, 'app', None, None, ),  # 3
)
all_structs.append(TProfilesServerLogInternalReq)
TProfilesServerLogInternalReq.thrift_spec = (
    None,  # 0
    (1, TType.STRUCT, 'sharedReq', [TServerLogSharedReq, None], None, ),  # 1
    (2, TType.STRING, 'queryId', 'UTF8', None, ),  # 2
)
all_structs.append(TServerLogSharedResp)
TServerLogSharedResp.thrift_spec = (
    None,  # 0
    (1, TType.STRUCT, 'continuationToken', [TContinuationToken, None], None, ),  # 1
    (2, TType.STRING, 'logData', 'UTF8', None, ),  # 2
    (3, TType.STRING, 'errorMessage', 'UTF8', None, ),  # 3
    (4, TType.STRING, 'nodeName', 'UTF8', None, ),  # 4
    (5, TType.STRING, 'fileName', 'UTF8', None, ),  # 5
    (6, TType.LIST, 'nodesToFetch', (TType.STRING, 'UTF8', False), None, ),  # 6
)
fix_spec(all_structs)
del all_structs
