# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.12 on 2018-05-16 20:11
from __future__ import unicode_literals
import json
import arcwebbase.validator
from django.db import migrations, models
from jobs.views_encryption import encrypt_secret
from arcwebbase.migration_helper import south_migration_applied


def encrypt_passwords(apps):
    DataConnection = apps.get_model('datasets', 'dataconnection')
    for id, password in DataConnection.objects.all().values_list('id',
                                                                 'dataconnection_password'):
        DataConnection.objects.filter(id=id) \
            .update(
            dataconnection_password=json.dumps(encrypt_secret(str(password))))

def forward(apps, shcema_editor):
    if not south_migration_applied('0017_encrypt_dataconnection_pass'):
        encrypt_passwords(apps)

class Migration(migrations.Migration):

    atomic = False

    dependencies = [
        ('datasets', '0001_initial'),
    ]

    operations = [
        migrations.AlterField(
            model_name='dataconnection',
            name='dataconnection_password',
            field=models.TextField(blank=True, max_length=4000, validators=[arcwebbase.validator.validateStringNoHtml]),
        ),
        migrations.RunPython(forward)
    ]
