# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.4 on 2018-10-15 17:37
from __future__ import unicode_literals

from django.db import migrations

def update_search_enabled(apps, schema_editor):
    from datasets.views import _get_search_enabled
    # Transfer dataset search enable information to search_enabled field
    DataSet = apps.get_model('datasets', 'DataSet')
    all_datasets = DataSet.objects.all()

    for ds in all_datasets:
        ds.search_enabled = _get_search_enabled(ds.dataset_settings)
        ds.save(update_fields=['search_enabled'])

class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0003_dataset_search_enabled'),
    ]

    operations = [
        migrations.RunPython(update_search_enabled, reverse_code=migrations.RunPython.noop),
    ]
