# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.6 on 2022-04-12 16:15

import arcwebbase.validator
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0010_alter_dataset_dashboards'),
    ]

    operations = [
        migrations.AddField(
            model_name='dataconnection',
            name='cml_id',
            field=models.BigIntegerField(blank=True, default=None, null=True),
        ),
        # Original 0011 Migration used a JSONField type here.
        #  This isn't compatible with certain versions of MySQL and MariaDB so we needed to change the migration
        #  to use a TextField type instead.
        #
        # migrations.AddField(
        #     model_name='dataconnection',
        #     name='cml_status',
        #     field=models.JSONField(default=dict)
        # ),
        migrations.AddField(
            model_name='dataconnection',
            name='cml_status',
            field=models.TextField(default='{}')
        ),
        migrations.AlterField(
            model_name='dataconnection',
            name='dataconnection_password',
            field=models.TextField(blank=True, max_length=4000, null=True, validators=[arcwebbase.validator.validateStringNoHtml]),
        ),
    ]
