# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.15 on 2022-09-19 21:59

from django.db import migrations
import json


def add_viz_app_name(apps, _):
  DataConnection = apps.get_model('datasets', 'dataconnection')
  for connection in DataConnection.objects.filter(dataconnection_type__in=['impyla', 'hyve']):
      params = json.loads(connection.dataconnection_info)
      params_object = params.get('PARAMS')
      if params_object and not params_object.get('APP_NAME'):
          params_object['APP_NAME'] = 'viz'
          connection.dataconnection_info = json.dumps(params)
          connection.save(update_fields=['dataconnection_info'])


class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0013_move_cml_id'),
    ]

    operations = [
        migrations.RunPython(
        add_viz_app_name,
        migrations.RunPython.noop,
        ),
    ]
