# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.15 on 2022-09-19 21:59

from django.db import migrations
import json

def alter_extract_rewrites_enabled_values(apps, _):
    Extract = apps.get_model('datasets', 'extract')
    for extract in Extract.objects.all():
        extract_config = json.loads(extract.extract_config)
        rewrite_props = extract_config.get('rewrite_properties', {})
        enabled_value = rewrite_props.pop('enabled', True)
        rewrite_props['rewrite_status'] = 'disabled' if enabled_value == False else 'enabled'
        extract_config['rewrite_properties'] = rewrite_props
        extract.extract_config = json.dumps(extract_config)
        extract.save(update_fields=['extract_config'])

class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0015_alter_extract_tgtdataconnection'),
    ]

    operations = [
        migrations.RunPython(
        alter_extract_rewrites_enabled_values,
        migrations.RunPython.noop,
        ),
    ]
