# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.15 on 2022-09-19 21:59

from django.db import migrations
import json

def update_dataset_type_singletable(apps, _):
    Dataset = apps.get_model('datasets', 'dataset')
    for ds in Dataset.objects.all():
        dataset_info = json.loads(ds.dataset_info)
        if len(dataset_info) == 1:
            ds.dataset_type = 'singletable'
            ds.save(update_fields=['dataset_type'])


class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0016_alter_extract_rewrites_enabled_values'),
    ]

    operations = [
        migrations.RunPython(
        update_dataset_type_singletable,
        migrations.RunPython.noop,
        ),
    ]
