# Generated by Django 3.2.24 on 2024-09-20 14:53
from django.db import migrations, models
import django.db.models.deletion

from datasets.migration_utils import apply_conditionally_on_segment_dataset_existence

def create_dataset_segment_entries(apps, _):

    DatasetSegment = apps.get_model('datasets', 'DatasetSegment')
    Segment = apps.get_model('datasets', 'Segment')

    for segment in Segment.objects.all():
        DatasetSegment.objects.create(
            dataset_id=segment.dataset_id,
            segment_id=segment.id,
            dataset_version_id=segment.dataset.version_id
            )

class Migration(migrations.Migration):

    dependencies = [
        ('datasets', '0019_postgres_friendly_version_of_0018_1'),
    ]

    operations = []

    def apply(self, project_state, schema_editor, collect_sql=False):
        return apply_conditionally_on_segment_dataset_existence(
            '0020_postgres_friendly_version_of_0018_2.py',
            self,
            project_state,
            schema_editor,
            collect_sql
        )

    operations += [
        migrations.CreateModel(
            name='DatasetSegment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('dataset_version_id', models.IntegerField(null=True)),
                ('dataset', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datasets.dataset')),
                ('segment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datasets.segment')),
            ],
            options={
                'unique_together': {('dataset', 'segment', 'dataset_version_id')},
            },
        ),
        migrations.RunPython(create_dataset_segment_entries),
    ]
