# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django import forms
from django.utils.safestring import mark_safe

class DataSourceForm(forms.Form):
    datasource_file = forms.FileField(
        label='Import data from CSV file',
        help_text=mark_safe('<div class="help-text">Maximum file size: 50 MB</div><br>')
    )
    datasource_active_dataconnid = forms.IntegerField(
        label='Hidden active dataconnection id')
