# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import logging

# create logger
LOGGER = logging.getLogger("arcweb")

class CsvUrlToData(object):
  def __init__(self, url_request):
    self.url_request = url_request
    url = url_request.url()
    self.name = url
    self._handled = False

    # Transform simple github urls into raw urls
    if url.startswith('https://github.com'):
      url = self.transformUrl(url)
      url_request.url(url)

    self.response = url_request.response()
    headers = self.response.headers
    fields = headers.get('X-Soda2-Fields', None)
    if fields is None:
      self.data = self.response.text.encode('utf8')
      self._handled = True
      return

  def handled(self):
    return self._handled

  def transformUrl(self, url):
    url = url.replace('github.com', 'raw.githubusercontent.com', 1)
    url = url.replace('/blob', '', 1)
    return url

  def chunks(self):
    return [self.data]

  def error(self):
    return self.error

