# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import requests

class UrlRequest(object):
  """
  Helper object to make a remote requests exactly once when used
  from within multiple objects
  """

  def __init__(self, url):
    self._url = url
    self._response = None

  def _makeRemoteCall(self):
    if not self._response:
      self._response = requests.get(self._url, verify=False)

  def url(self, newUrl=None):
    if newUrl is None:
      return self._url

    if self._url != newUrl:
      self._url = newUrl
      self._response = None

    return self._url

  def response(self):
    self._makeRemoteCall()
    return self._response
