# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
urls for datasources 
"""

from django.urls import re_path
from datasources import views

urlpatterns = [
  re_path(r'^dataimport$', views.dataimport_html, name='data-import'),
  re_path(r'^dataimport/(?P<datasource_id>\d+)$', views.dataimport_html),
  re_path(r'^dataimport.json$', views.dataimport_json, name='data-import-json'),
  re_path(r'^dataimport.json/(?P<datasource_id>\d+)$', views.dataimport_json),
]

