# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.


import django.test

from apps.tests.userrole import base
from datasets.models import DataSet
from instant import instant


class TestMigrate(django.test.TestCase):

    def test_create_samples(self):

        # an admin is needed:
        base.make_user(instant.ADMIN_USERNAME, is_superuser=True)

        ds_count_1 = len(DataSet.objects.all())
        instant.createSamples()

        ds_count_2 = len(DataSet.objects.all())
        self.assertTrue(ds_count_2 > ds_count_1, "Sample datasets were created")

