# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.6 on 2022-03-07 21:47

from django.db import migrations, models
import django.db.models.deletion

# WHY IS THIS MIGRATION NEEDED?
#
# In some cases with legacy Arcadia databases the Null property for the schedule ForeignKey was reset to Not NULL,
# possibly as part of a side effect from the Alter Table commands to update AutoFields to BigAutoFields when the upgrade
# to Django 3.x after CDV 6.3.2. This does not happen with fresh installations when applying migrations.
#
# This becomes an issue when deleting a user, and the cascading delete that follow including deleting past job schedule
# history for the deleted user, which then throws error when Django tries to set schedule_id to NULL.
#

class Migration(migrations.Migration):

    dependencies = [
        ('jobs', '0007_alter_schedulegroup_run_interval'),
    ]

    operations = [
        # Unset NULL property temporarily
        migrations.AlterField(
            model_name='jobtarget',
            name='schedule',
            field=models.ForeignKey(blank=True, on_delete=django.db.models.deletion.CASCADE,
                                    to='jobs.JobSchedule')
        ),
        # Set NULL property once again
        migrations.AlterField(
            model_name='jobtarget',
            name='schedule',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE,
                                    to='jobs.JobSchedule')
        ),
    ]
