# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 3.2.13 on 2022-09-13 19:01

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):
    def clone_creator_value_to_owner(apps, schema_editor):
        JobSchedule = apps.get_model('jobs', 'jobschedule')

        for job in JobSchedule.objects.all():
            job.owner = job.creator
            job.save(update_fields=['owner'])

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('jobs', '0008_alter_jobtarget_schedule_null_property'),
    ]

    operations = [
        migrations.AddField(
            model_name='jobschedule',
            name='owner',
            field=models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='owned_jobschedule_set', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AlterField(
            model_name='jobschedule',
            name='creator',
            field=models.ForeignKey(default=1, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),

        migrations.RunPython(clone_creator_value_to_owner)
    ]
