# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.db import migrations
from django.db.models import Q


def copy_key(apps, schema_editor):
    JobTarget = apps.get_model('jobs', 'JobTarget')
    trigger_targets = JobTarget.objects.filter(target_type="T")
    for target in trigger_targets:
        schedule = target.schedule
        schedule.trigger_target = target
        schedule.save()


class Migration(migrations.Migration):
    dependencies = [
        ('jobs', '0016_jobschedule_trigger_target')
    ]

    operations = [
        migrations.RunPython(copy_key,
                             migrations.RunPython.noop,
                             ),
    ]
