# -*- coding: utf-8 -*-r
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from south.db import db
from south.v2 import SchemaMigration
from django.db import models
from apps.config import product_name

class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding model 'JobSchedule'
        db.create_table('jobs_jobschedule', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('create_time', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, null=True, blank=True)),
            ('update_time', self.gf('django.db.models.fields.DateTimeField')(auto_now=True, null=True, blank=True)),
            ('run_interval', self.gf('django.db.models.fields.CharField')(default=None, max_length=200, blank=True)),
            ('job_name', self.gf('django.db.models.fields.CharField')(default=f'Email: {product_name} Image', max_length=200, null=True)),
            ('minimum_time_interval', self.gf('django.db.models.fields.CharField')(default=None, max_length=200, blank=True)),
        ))
        db.send_create_signal('jobs', ['JobSchedule'])

        # Adding model 'JobTarget'
        db.create_table('jobs_jobtarget', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('creator', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['auth.User'])),
            ('create_time', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, null=True, blank=True)),
            ('update_time', self.gf('django.db.models.fields.DateTimeField')(auto_now=True, null=True, blank=True)),
            ('target', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['jobs.JobTarget'], null=True, blank=True)),
            ('schedule', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['jobs.JobSchedule'], null=True, blank=True)),
        ))
        db.send_create_signal('jobs', ['JobTarget'])

        # Adding model 'JobTargetEmail'
        db.create_table('jobs_jobtargetemail', (
            ('jobtarget_ptr', self.gf('django.db.models.fields.related.OneToOneField')(to=orm['jobs.JobTarget'], unique=True, primary_key=True)),
            ('email_subject', self.gf('django.db.models.fields.CharField')(default='Data Notification', max_length=200, null=True)),
            ('message', self.gf('django.db.models.fields.TextField')(default='', blank=True)),
            ('app_id', self.gf('django.db.models.fields.PositiveIntegerField')(default=None, null=True, blank=True)),
            ('image_type', self.gf('django.db.models.fields.CharField')(default='A', max_length=4)),
        ))
        db.send_create_signal('jobs', ['JobTargetEmail'])

        # Adding model 'JobLog'
        db.create_table('jobs_joblog', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('start_time', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, null=True, blank=True)),
            ('end_time', self.gf('django.db.models.fields.DateTimeField')(auto_now=True, null=True, blank=True)),
            ('target', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['jobs.JobTarget'])),
            ('contents_archive', self.gf('django.db.models.fields.TextField')(default='', blank=True)),
            ('status', self.gf('django.db.models.fields.CharField')(default='R', max_length=1)),
            ('image', self.gf('django.db.models.fields.files.ImageField')(max_length=100, blank=True)),
        ))
        db.send_create_signal('jobs', ['JobLog'])

        # Adding model 'JobContent'
        db.create_table('jobs_jobcontent', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('create_time', self.gf('django.db.models.fields.DateTimeField')(auto_now_add=True, null=True, blank=True)),
            ('field', self.gf('django.db.models.fields.CharField')(default=None, max_length=200, blank=True)),
            ('value', self.gf('django.db.models.fields.TextField')(default='', blank=True)),
        ))
        db.send_create_signal('jobs', ['JobContent'])

        # Adding M2M table for field target on 'JobContent'
        m2m_table_name = db.shorten_name('jobs_jobcontent_target')
        db.create_table(m2m_table_name, (
            ('id', models.AutoField(verbose_name='ID', primary_key=True, auto_created=True)),
            ('jobcontent', models.ForeignKey(orm['jobs.jobcontent'], null=False)),
            ('jobtarget', models.ForeignKey(orm['jobs.jobtarget'], null=False))
        ))
        db.create_unique(m2m_table_name, ['jobcontent_id', 'jobtarget_id'])


    def backwards(self, orm):
        # Deleting model 'JobSchedule'
        db.delete_table('jobs_jobschedule')

        # Deleting model 'JobTarget'
        db.delete_table('jobs_jobtarget')

        # Deleting model 'JobTargetEmail'
        db.delete_table('jobs_jobtargetemail')

        # Deleting model 'JobLog'
        db.delete_table('jobs_joblog')

        # Deleting model 'JobContent'
        db.delete_table('jobs_jobcontent')

        # Removing M2M table for field target on 'JobContent'
        db.delete_table(db.shorten_name('jobs_jobcontent_target'))


    models = {
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'ordering': "(u'content_type__app_label', u'content_type__model', u'codename')", 'unique_together': "((u'content_type', u'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'symmetrical': 'False', 'related_name': "u'user_set'", 'blank': 'True', 'to': "orm['auth.Group']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'symmetrical': 'False', 'related_name': "u'user_set'", 'blank': 'True', 'to': "orm['auth.Permission']"}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        'jobs.jobcontent': {
            'Meta': {'object_name': 'JobContent'},
            'create_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now_add': 'True', 'blank': 'True'}),
            'field': ('django.db.models.fields.CharField', [], {'default': 'None', 'max_length': '200', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'target': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['jobs.JobTarget']", 'symmetrical': 'False'}),
            'value': ('django.db.models.fields.TextField', [], {'default': "''", 'blank': 'True'})
        },
        'jobs.joblog': {
            'Meta': {'object_name': 'JobLog'},
            'contents_archive': ('django.db.models.fields.TextField', [], {'default': "''", 'blank': 'True'}),
            'end_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'image': ('django.db.models.fields.files.ImageField', [], {'max_length': '100', 'blank': 'True'}),
            'start_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now_add': 'True', 'blank': 'True'}),
            'status': ('django.db.models.fields.CharField', [], {'default': "'R'", 'max_length': '1'}),
            'target': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['jobs.JobTarget']"})
        },
        'jobs.jobschedule': {
            'Meta': {'object_name': 'JobSchedule'},
            'create_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now_add': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'job_name': ('django.db.models.fields.CharField', [], {'default': f"'Email: {product_name}'", 'max_length': '200', 'null': 'True'}),
            'minimum_time_interval': ('django.db.models.fields.CharField', [], {'default': 'None', 'max_length': '200', 'blank': 'True'}),
            'run_interval': ('django.db.models.fields.CharField', [], {'default': 'None', 'max_length': '200', 'blank': 'True'}),
            'update_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now': 'True', 'blank': 'True'})
        },
        'jobs.jobtarget': {
            'Meta': {'object_name': 'JobTarget'},
            'create_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now_add': 'True', 'blank': 'True'}),
            'creator': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['auth.User']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'schedule': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['jobs.JobSchedule']", 'null': 'True', 'blank': 'True'}),
            'target': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['jobs.JobTarget']", 'null': 'True', 'blank': 'True'}),
            'update_time': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'auto_now': 'True', 'blank': 'True'})
        },
        'jobs.jobtargetemail': {
            'Meta': {'object_name': 'JobTargetEmail', '_ormbases': ['jobs.JobTarget']},
            'app_id': ('django.db.models.fields.PositiveIntegerField', [], {'default': 'None', 'null': 'True', 'blank': 'True'}),
            'email_subject': ('django.db.models.fields.CharField', [], {'default': "'Data Notification'", 'max_length': '200', 'null': 'True'}),
            'image_type': ('django.db.models.fields.CharField', [], {'default': "'A'", 'max_length': '4'}),
            'jobtarget_ptr': ('django.db.models.fields.related.OneToOneField', [], {'to': "orm['jobs.JobTarget']", 'unique': 'True', 'primary_key': 'True'}),
            'message': ('django.db.models.fields.TextField', [], {'default': "''", 'blank': 'True'})
        }
    }

    complete_apps = ['jobs']
