# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import json
from jobs.views_encryption import encrypt_secret
from jobs.views_encryption import decrypt_secret
from django.test import TestCase

class EncryptionDecryptionWorksAsExpected(TestCase):
    def test_when_connection_name_change_should_update(self):
        secrets = ['124xcvbn%^&()_!', 'Hellolmabela this is just a long password!', "mn::::\| /|]'`.,.,m.,m,.<>{}"]
        for secret in secrets:
            encrypted_secret = json.dumps(encrypt_secret(secret))
            self.assertEqual(decrypt_secret(**json.loads(encrypted_secret)), secret)
