# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

import os

from django.urls import re_path
from django.shortcuts import render

templates = os.listdir(os.path.join(os.getcwd(), 'qunit/templates/tests'))

file_names = [template.split('.')[0] for template in templates]
file_names.sort()

urlpatterns = [
  re_path(r'^$', lambda request: render(request, 'tests.html', { "file_names": file_names })),
  re_path(r'(?P<file_name>.+)', lambda request, file_name: render(request, f"tests/{file_name}.html") , name="qunit")
]
