# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.12 on 2018-05-17 03:07
from __future__ import unicode_literals

from django.db import migrations, models
from arcwebbase.migration_helper import south_migration_applied, south_migration_exist
from rbac import migrateperms

import django.apps.registry


def forward(apps: django.apps.registry.Apps, shcema_editor):
    migrateperms.migratePerms(dryrun=False, apps=apps)


class Migration(migrations.Migration):

    atomic = False

    dependencies = [
        ('rbac', '0001_initial'),
        ('datasets', '0001_initial'),
    ]

    if not south_migration_applied('0002_auto__add_field_role_require_all_groups'):
        operations = [
            migrations.AddField(model_name='role',
                                name='require_all_groups',
                                field=models.BooleanField(default=False),
            ),
            migrations.RunPython(forward)
        ]
    elif not south_migration_exist():
        # new install
        operations = [migrations.RunPython(forward)]
    else:
        # upgrade where 0002 has been applied
        operations = []

