# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.5 on 2018-06-05 02:36
from __future__ import unicode_literals

from django.db import migrations
from types import MethodType

def migrate_settings_styles(apps, forward):
  from rbac.models import Role as NewRole
  Role = apps.get_model('rbac', 'role')

  for r in Role.objects.all():
    # Bind methods from the real Model to the fake model.
    r.privList = MethodType(NewRole.privList, r)
    r.migrate_settings_styles = MethodType(NewRole.migrate_settings_styles, r)
    r.migrate_settings_styles(forward)

def forwards(apps, schema_editor):
  migrate_settings_styles(apps, True)

def backwards(apps, schema_editor):
  migrate_settings_styles(apps, False)

class Migration(migrations.Migration):

    dependencies = [
        ('rbac', '0002_auto_20180517_0308'),
    ]

    operations = [
      migrations.RunPython(forwards, backwards)
    ]
