# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from south.utils import datetime_utils as datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding model 'Role'
        db.create_table('rbac_role', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('name', self.gf('django.db.models.fields.CharField')(max_length=1000, null=True, blank=True)),
            ('description', self.gf('django.db.models.fields.CharField')(max_length=1000, null=True, blank=True)),
            ('privileges', self.gf('django.db.models.fields.TextField')(max_length=32768, null=True, blank=True)),
            ('users', self.gf('django.db.models.fields.TextField')(max_length=8192, null=True, blank=True)),
            ('groups', self.gf('django.db.models.fields.TextField')(max_length=8192, null=True, blank=True)),
            ('sentry_groups', self.gf('django.db.models.fields.TextField')(max_length=8192, null=True, blank=True)),
        ))

        db.send_create_signal('rbac', ['Role'])

    def backwards(self, orm):
        # Deleting model 'Role'
        db.delete_table('rbac_role')


    models = {
        'rbac.role': {
            'Meta': {'object_name': 'Role'},
            'description': ('django.db.models.fields.CharField', [], {'max_length': '1000', 'null': 'True', 'blank': 'True'}),
            'groups': ('django.db.models.fields.TextField', [], {'max_length': '8192', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '1000', 'null': 'True', 'blank': 'True'}),
            'privileges': ('django.db.models.fields.TextField', [], {'max_length': '32768', 'null': 'True', 'blank': 'True'}),
            'sentry_groups': ('django.db.models.fields.TextField', [], {'max_length': '8192', 'null': 'True', 'blank': 'True'}),
            'users': ('django.db.models.fields.TextField', [], {'max_length': '8192', 'null': 'True', 'blank': 'True'})
        }
    }

    complete_apps = ['rbac']
