# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.test import TestCase

from django.test import TestCase

from django.core.exceptions import ValidationError

from rbac.models import Role

INVALID_FIELD = 'a<b'
INVALID_MSG = 'Invalid character in field a<b'

class ModelValidation(TestCase):
  def test_role(self):
    role = Role(
        name='role name',
        description='role description',
        privileges='',
        users='role users',
        groups='role groups',
        sentry_groups='sentry groups')
    role.save()

    role = Role(
        name=INVALID_FIELD,
        description=INVALID_FIELD,
        privileges=INVALID_FIELD,
        users=INVALID_FIELD,
        groups=INVALID_FIELD,
        sentry_groups=INVALID_FIELD)
    with self.assertRaises(ValidationError):
      try:
        role.save()
      except ValidationError as v:
        self.assertEqual(v.messages, [INVALID_MSG] * 6)
        raise

