# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
Register reports for the admin site
"""

from django.contrib import admin

from reports.models import Report, ReportUser, ReportUsage, ReportImage, \
    AppGroup, UserAppGroupMembership, ColorPalette, DateRanges, CustomCSS, \
    ParameterSet

class CustomCSSAdmin(admin.ModelAdmin):
  pass

admin.site.register(CustomCSS, CustomCSSAdmin)

class ColorPaletteAdmin(admin.ModelAdmin):
  pass

admin.site.register(ColorPalette, ColorPaletteAdmin)

class ParameterSetAdmin(admin.ModelAdmin):
  pass

admin.site.register(ParameterSet, ParameterSetAdmin)

class DateRangesAdmin(admin.ModelAdmin):
  pass

admin.site.register(DateRanges, DateRangesAdmin)

class AppGroupAdmin(admin.ModelAdmin):
  """AppGroup admin site"""
  pass

admin.site.register(AppGroup, AppGroupAdmin)

class UserAppGroupMembershipAdmin(admin.ModelAdmin):
  """UserAppGroupMembership admin site"""
  pass

admin.site.register(UserAppGroupMembership, UserAppGroupMembershipAdmin)

class ReportAdmin(admin.ModelAdmin):
  """Report admin site"""
  pass

admin.site.register(Report, ReportAdmin)

class ReportUserAdmin(admin.ModelAdmin):
  """ReportUser admin site"""
  pass

admin.site.register(ReportUser, ReportUserAdmin)

class ReportUsageAdmin(admin.ModelAdmin):
  """ReportUsage admin site"""
  pass

admin.site.register(ReportUsage, ReportUsageAdmin)

class ReportImageAdmin(admin.ModelAdmin):
  """ReportImage admin site"""
  pass

admin.site.register(ReportImage, ReportImageAdmin)

