# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

from .models import Report
from vizlib.querylog import ComponentType, logAction


def get_dc_info(dataset):
    # Handle old-style datasets without data connections
    if dataset and dataset.dataconnection:
      dcid = dataset.dataconnection.id
      dctype = dataset.dataconnection.dataconnection_type
      dcname = dataset.dataconnection.dataconnection_name
    else:
      dcid = ''
      dctype = ''
      dcname = ''
    return dcid, dctype, dcname

def auditApp(report: Report, action, request=None, appgroup_id='', app_id=''):
  # Handle old-style datasets without data connections
  if report.dataset and report.dataset.dataconnection:
    dcid = report.dataset.dataconnection.id
    dctype = report.dataset.dataconnection.dataconnection_type
    dcname = report.dataset.dataconnection.dataconnection_name
  else:
    dcid = ''
    dctype = ''
    dcname = ''

  visual_id = ''
  if report.category() == 'dashboard':
    app_id = report.id
  else:
    visual_id = report.id

  logAction(action=action, component_type=ComponentType.APP,
      app_id=app_id,
      visual_id=visual_id,
      visual_type=report.report_type,
      visual_name=report.report_name,
      component_id=report.id, 
      dataset_id=report.dataset.id, 
      dataset_name=report.dataset.dataset_name,
      dataconnection_id=dcid,
      dataconnection_type=dctype, 
      dataconnection_name=dcname,
      appgroup_id=appgroup_id,
      request=request)