# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.conf import settings
from rbac.roles_constants import DEFAULT_USER_GROUP
from arcwebbase.settings import SITE_SETTING_DEFAULTS
from apps.config import default_support_email, default_documentation_url, default_support_web_page_label,default_support_web_page_link, default_documentation_label, default_embeddings_engine_settings, default_completion_engine_settings, default_bedrock_embedding_transformers, default_bedrock_completion_transformers

ALL_CLONE_REPORT_IDS = None
ALL_PARENT_REPORT_IDS = None

FINAL_SETTINGS = {
    'dashboard_width': '1400',
    'dashboard_loading_message_in_viewmode': 'true',
    'doc_link_url': default_documentation_url,
    'doc_link_text': default_documentation_label,
    'email_enabled': 'false',
    'email_host_user': '',
    'email_host_password': '',
    'email_username': '',
    'email_host': '',
    'email_port': '',
    'email_protocol': 'EMAIL_USE_TLS',
    'email_prefix': settings.DEFAULT_EMAIL_PREFIX,
    'embedding_input_param': 'chunk',
    'completion_input_param': 'prompt',
    'embedding_response_param': 'response',
    'completion_response_param': 'response',
    'ai_engine': 'open_ai',
    'ai_default_engine': 'open_ai',
    'ai_default_cml_auth_mode': 'jwt',
    'ai_api_key': '',
    'bedrock_credentials': '',
    'ai_auth_key': '',
    'ai_service_url': '',
    'embeddings_model': '',
    'completion_model': '',
    'embeddings_bedrock_model': 'amazon.titan-embed-text-v1',
    'completion_bedrock_model': 'amazon.titan-text-lite-v1',
    'ai_embeddings_settings': '{}',
    'ai_completion_settings': '{}',
    'completion_extra_arg': '{}',
    'embeddings_custom_engine_settings_default': default_embeddings_engine_settings,
    'completion_custom_engine_settings_default': default_completion_engine_settings,
    'embeddings_bedrock_custom_transformers': default_bedrock_embedding_transformers,
    'completion_bedrock_custom_transformers': default_bedrock_completion_transformers,
    'ai_term_agreed': 'false',
    'ai_term_agreed_date': '',
    'completion_temperature': '1',
    'completion_stream': 'true',
    'google_api_id': '',
    'google_client_id': '',
    'mapbox_access_token': '',
    'local_mapbox_server': '',
    'inspect_settings_enabled': 'false',
    'site_csv_download_on': 'true',
    'enable_usage_analytics': 'true',
    'usage_analytics_expiration_days': '60',
    'site_enable_custom_styles': 'true',
    'site_enable_download_from_url': 'true',
    'site_png_download_on': 'false',
    'site_thumbnails_enable': 'true',
    'support_option': 'web_page',
    'support_web_page_link_text': default_support_web_page_label,
    'support_web_page_link_url': default_support_web_page_link,
    'support_email': default_support_email,
    'min_pw_length': '5',
    'pw_require_number': 'false',
    'pw_require_symbol': 'false',
    'webhook_enabled': 'false',
    'jira_enabled': 'false',
    'jserrors_enabled': 'true',
    'page_profile_enabled': 'true',
    'page_profile_appview_enabled': 'true',
    'bulk_max_entries': SITE_SETTING_DEFAULTS.get('bulk_max_entries', '10000'),
    'bulk_max_interval': SITE_SETTING_DEFAULTS.get('bulk_max_interval', '7'),
    'bulk_max_retention': SITE_SETTING_DEFAULTS.get('bulk_max_retention', '365'),
    'default_group_membership_for_new_users': DEFAULT_USER_GROUP,
    'site_max_trellis_displayed': '17',
    'visual_max_dataresults': '10',
    'csv_excel_cache_result': 'true',
    'visual_maxrows': SITE_SETTING_DEFAULTS.get('visual_maxrows', '100000'),
    'maximum_canvas_width': SITE_SETTING_DEFAULTS.get('maximum_canvas_width', '8000'),
    'download_maxrows': SITE_SETTING_DEFAULTS.get('download_maxrows', '1000000'),
    'site_thumbnails_ip': 'http://127.0.0.1:8100',
    'login_instructions': '',
    'webhook_whitelist': '',
    'remotedata_url_whitelist': '',
    'advanced_settings': '',
    'jira_server': '',
    'jira_user': '',
    'jira_password': '',
    'jira_newissue_defaults': '',
    'unnamed_versions_deletion_interval': '7',
    'unnamed_versions_max_retention': '30',
    'notification_max_retention': SITE_SETTING_DEFAULTS.get('notification_max_retention', '1')
  }