# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.12 on 2018-07-13 18:19
from __future__ import unicode_literals

from django.db import migrations, models
import uuid


def fill_uuid(apps, schema_editor):
    colorpalette = apps.get_model('reports', 'colorpalette')
    for id in colorpalette.objects.all().values_list('id', flat=True):
        colorpalette.objects.filter(id=id).update(uuid=uuid.uuid4())

class Migration(migrations.Migration):

    atomic = False

    dependencies = [
        ('reports', '0003_auto_20180518_1848'),
    ]

    operations = [
        migrations.AddField(
            model_name='colorpalette',
            name='imported_uuid',
            field=models.CharField(blank=True, max_length=100, null=True),
        ),
        migrations.AddField(
            model_name='colorpalette',
            name='uuid',
            field=models.CharField(blank=True, max_length=36, null=True),
        ),
        migrations.RunPython(fill_uuid),
        migrations.AlterField(
            model_name='colorpalette',
            name='uuid',
            field=models.CharField(default=uuid.uuid4, max_length=36,
                                   unique=True),
        ),
    ]
