# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.5 on 2018-08-24 22:58
from __future__ import unicode_literals

from django.db import migrations, models
from types import MethodType

from reports.models import Report as NewReport

# Do a save on all reports to populate the has_css_styles field
def migrate_data_forward(apps, schema_editor):
  Report = apps.get_model('reports', 'Report')
  uplist = []
  for r in Report.objects.all():
    r.get_css_styles = MethodType(NewReport.get_css_styles, r)
    if r.get_css_styles() is not None:
      uplist.append(r.id)
      if len(uplist) > 100:
        Report.objects.filter(id__in=uplist).update(has_css_styles=True)
        uplist = []
  if uplist:
    Report.objects.filter(id__in=uplist).update(has_css_styles=True)

def migrate_data_backward(apps, schema_editor):
  pass

class Migration(migrations.Migration):

    atomic = False

    dependencies = [
        ('reports', '0005_appgroup_workspace'),
    ]

    operations = [
        migrations.AddField(
            model_name='report',
            name='has_css_styles',
            field=models.BooleanField(default=False),
        ),
        migrations.RunPython(
            migrate_data_forward,
            migrate_data_backward,
        ),
    ]
