# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# Generated by Django 1.11.4 on 2018-10-16 17:04
from __future__ import unicode_literals

from django.db import migrations

def update_relationships(apps, schema_editor):
    Report = apps.get_model('reports', 'Report')
    Search = apps.get_model('searches', 'Search')
    all_reports = Report.objects.exclude(report_type__in=['dashboard', 'picklist', 'daterange']).all()
    for report in all_reports:
        if report.report_name:
            report_title = report.report_name
            search = Search.objects.filter(search_text=report_title)
            if search.exists():
                report.report_search_text = search.first().search_text
                report.save(update_fields=['report_search_text'])

class Migration(migrations.Migration):

    dependencies = [
        ('reports', '0008_report_report_search_text'),
        ('searches', '0003_add_foreign_keys_and_update_user'),
    ]

    operations = [
        migrations.RunPython(update_relationships, reverse_code=migrations.RunPython.noop),
    ]
