# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations
import json, os, tempfile, math, copy

# Make sure site_thumbnails_enable is not admin only
def update_site_thumbnails_enable(apps, schema_editor):
  AppSetting = apps.get_model('reports', 'appsetting')
  AppSetting.objects\
    .filter(setting_key='site_thumbnails_enable')\
    .update(setting_read_admin_only=False)

def migrate_data_backward(apps, schema_editor):
  pass

class Migration(migrations.Migration):
  dependencies = [
    ('reports', '0015_auto_20201209_0516'),
  ]

  operations = [
    migrations.RunPython(
      update_site_thumbnails_enable,
      migrate_data_backward,
    ),
  ]
