# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations
from util.ff_flipper import FeatureFlipper
from arcwebbase.settings import *

def set_extracts_setting_from_advanced_settings(apps, schema):
  AppSetting = apps.get_model('reports', 'appsetting')

  for a in AppSetting.objects.filter(setting_key="advanced_settings"):
    try:
        exec(a.setting_value)
        if FEATURE_FLIPPERS:
            for flipper in FEATURE_FLIPPERS:
                if flipper['id'] == 'site_enable_extracts':
                    FeatureFlipper().set_flipper('site_enable_extracts', flipper['value'], 'DB')
    except:
        pass

class Migration(migrations.Migration):
  dependencies = [
    ('reports', '0024_dashboard_dataset_association'),
  ]
  operations = [
    migrations.RunPython(
      set_extracts_setting_from_advanced_settings,
      migrations.RunPython.noop,
    ),
  ]
