# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations
import json, os, tempfile, math, copy

# Make sure site_thumbnails_enable is not admin only
def update_email_protocol_none(apps, _):
  AppSetting = apps.get_model('reports', 'appsetting')

  email_protocol = AppSetting.objects\
  .filter(setting_key='email_protocol')\
  .first()

  if email_protocol and email_protocol.setting_value == 'None':
    from reports.views_settings import setting_update_single
    setting_update_single('email_protocol', 'NEITHER', False)

def migrate_data_backward(apps, _):
  pass

class Migration(migrations.Migration):
  dependencies = [
    ('reports', '0026_update_email_protocol_settings'),
  ]

  operations = [
    migrations.RunPython(
      update_email_protocol_none,
      migrate_data_backward,
    ),
  ]
