# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations

def update_title(apps, schema_editor):
    AppNotificationCenter = apps.get_model('reports', 'appnotificationcenter')
    for notification in AppNotificationCenter.objects.all():
        if notification.title == '':
            notification.title = 'Error in the custom settings'
            notification.body = notification.body.replace('Error in the custom settings: \n', '')

            notification.save()


def migrate_data_backward(apps, schema_editor):
  pass

class Migration(migrations.Migration):
  dependencies = [
    ('reports', '0029_auto_20221227_0931'),
  ]

  operations = [
    migrations.RunPython(
      update_title,
      migrate_data_backward,
    ),
  ]
