# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.db import migrations

def migrate_status(apps, schema_editor):
    Notification = apps.get_model('reports', 'appnotificationcenter')
    for notification in Notification.objects.all():
        notification.status = 'R' if notification.read else 'U'
        notification.save()

class Migration(migrations.Migration):
  dependencies = [
    ('reports', '0032_appnotificationcenter_status'),
  ]
  operations = [
    migrations.RunPython(
      migrate_status,
      migrations.RunPython.noop,
    ),
  ]