# -*- coding: utf-8 -*-
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from __future__ import unicode_literals

from django.db import migrations
import django.apps.registry
from datasets.dashboard_association import init_associate_dashboards_to_datasets
import json


def forward(apps: django.apps.registry.Apps, shcema_editor):
    init_associate_dashboards_to_datasets(apps)

class Migration(migrations.Migration):
    dependencies = [
        ("reports", "0038_remove_orphan_visuals"),
        ("datasets", "0017_update_dataset_type_singletable"),
    ]
    operations = [
        migrations.RunPython(
            forward,
            migrations.RunPython.noop,
        ),
    ]
