# Generated by Django 3.2.24 on 2024-07-25 12:53

from django.db import migrations, models
from django.utils import timezone
from datetime import datetime

def copy_timestamp_to_last_occurrence(apps, schema_editor):
    Notifications = apps.get_model('reports', 'appnotificationcenter')
    notifications = Notifications.objects.all()

    for notification in notifications:
        latest_timestamp = notification.timestamps['timestamps'][0]
        notification.last_occurrence = timezone.make_aware(datetime.fromtimestamp(latest_timestamp / 1000))

    Notifications.objects.bulk_update(notifications, ['last_occurrence'])

class Migration(migrations.Migration):

    dependencies = [
        ('reports', '0040_auto_20240725_0402'),
    ]

    operations = [
        migrations.AddField(
            model_name='appnotificationcenter',
            name='last_occurrence',
            field=models.DateTimeField(default=timezone.now),
        ),
        migrations.RunPython(copy_timestamp_to_last_occurrence, migrations.RunPython.noop)
    ]
