# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.db import migrations
import logging

def update_sample_app_group_type(apps, schema):
        AppGroup = apps.get_model('reports', 'AppGroup')
        samplesApp = AppGroup.objects.filter(group_name="Sample App").order_by('create_time').first()

        if samplesApp:
            samplesApp.group_type = 'sample-app'
            samplesApp.save()
        else:
            logging.info('Samples App does not exist.')

class Migration(migrations.Migration):

    dependencies = [
        ('reports', '0042_update_shared_visual_dashboards'),
    ]

    operations = [
        migrations.RunPython(update_sample_app_group_type, migrations.RunPython.noop),
    ]
