# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
Models for saves SQL queries
"""

from django.db import models

from datasets.models import DataConnection

class Bookmark(models.Model):
  query = models.TextField(max_length=16384)

  # dataconnection this query was run on
  dataconnection = models.ForeignKey(DataConnection, on_delete=models.CASCADE)

  # Create time, user
  create_time = models.DateTimeField(auto_now_add=True, null=True, blank=True)
  create_user = models.CharField(max_length=200, blank=True)

  # Update time
  update_time = models.DateTimeField(auto_now=True, null=True, blank=True)

class Query(models.Model):
  query = models.TextField(max_length=16384)

  # dataconnection this query was run on
  dataconnection = models.ForeignKey(DataConnection, on_delete=models.CASCADE)

  # Create time, user
  create_time = models.DateTimeField(auto_now_add=True, null=True, blank=True)
  create_user = models.CharField(max_length=200, blank=True)

