# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
views to run sql statements
"""

from django.urls import re_path

from sqlrun import views, views_jsonselect, views_async

urlpatterns = [
  re_path(r'^p\d+/asyncstatus$', views.asyncstatus, name='asyncstatus'),
  re_path(r'^p\d+/asyncstatus_async$', views_async.asyncstatus_async, name='asyncstatus'),
  re_path(r'^p\d+/asyncresults$', views.asyncresults, name='asyncresults'),
  re_path(r'^p\d+/asyncresults_async$', views_async.asyncresults_async, name='asyncresults'),
  re_path(r'^p\d+/asynccancel$', views.asynccancel, name='asynccancel'),
  re_path(r'^p\d+/asynccancel_async$', views_async.asynccancel_async, name='asynccancel'),

  re_path(r'^p\d+/asynccancel_qt$', views_async.asynccancel_qt, name='asynccancel-qt'),
  re_path(r'^p\d+/asynccancel_qt/(?P<all>.*)$', views_async.asynccancel_qt, name='asynccancel-qt-all'),

  re_path(r'^csvdownloadStore$', views.csvdownloadStore,
      name='sqlrun-csvdownloadsession'),

  re_path(r'^xlsxdownloadStore$', views.xlsxdownloadStore,
      name='sqlrun-xlsxdownloadsession'),

  re_path(r'^jsonselect$', views.jsonselect, name='sqlrun-jsonselect'),
  re_path(r'^jsonselect_parallel$', views_jsonselect.jsonselect_parallel,
      name='sqlrun-jsonselect-parallel'),
  re_path(r'^jsonselect_parallel_async$', views_async.jsonselect_parallel_async,
      name='sqlrun-jsonselect-parallel-async'),

  # Allow for query tracker URLs for debugging
  re_path(r'^jsonselect_parallel_async/.*$', views_async.jsonselect_parallel_async),

  re_path(r'^longrunningtask$', views.longrunningtask, name='sqlrun-longrunningtask'),
  re_path(r'^viewrec$', views.viewrec, name='sqlrun-viewrec'),
  re_path(r'^viewrec_sql$', views.viewrec_sql, name='sqlrun-viewrec-sql'),
  re_path(r'^viewrec_queries$', views.viewrec_queries, name='sqlrun-viewrec-queries'),
]

