window.arc = window.arc || {};

(function() {
'use strict';

arc.action = arc.action || {};
arc.action.plugins = arc.action.plugins || {};
arc.action.extensions = arc.action.extensions || [];

arc.action.plugins.openURL = function() {
  let c = function() {
    return 'openURL';
  };

  let viz,
      lib;

  c.settings = function() {
    return [
      {
        id: 'url',
        displayName: 'URL to open',
        type: 'string',
        defaultValue: '',
      },
    ];
  };

  c.viz = function(_) {
    if (!arguments.length) return viz;
    viz = _;
    lib = viz.viz_lib();
    return c;
  };

  c.run = function(params) {
    const { url } = params;
    if (url) {
      arc.misc.openInNewWindow(url);
    }
  };

  return c;
};

function openURLExtension() {
  let ext = function() {
    return 'openURLExtension';
  };

  ext.action_name = function() {
    return 'openURL';
  };

  ext.action_label = function() {
    return 'Open URL';
  };

  ext.action = arc.action.plugins.openURL;

  return ext;
}

arc.action.extensions.push(openURLExtension());

}());
