window.arc = window.arc || {};

(function() {
'use strict';

arc.action = arc.action || {};
arc.action.plugins = arc.action.plugins || {};
arc.action.extensions = arc.action.extensions || [];

arc.action.plugins.search = function() {
  let c = function() {
    return 'search';
  };

  let viz,
      lib;

  c.viz = function(_) {
    if (!arguments.length) return viz;
    viz = _;
    lib = viz.viz_lib();
    return c;
  };

  c.run = function(params) {
    const includeAll = (params.includeAll === 'true'),
          datasetIds = new Set(),
          datasets = [];

    if (includeAll && arc.globals.dashboard) {
      arc.globals.dashboard.eachViz(function checkForSearchableDataset(viz) {
        const dataset = viz.dataset();
        if (dataset) {
          let searchSettings = dataset.searchSettings();
          if (!searchSettings.enabled) {
            return;
          }

          const datasetId = dataset.dataset_id();
          if (datasetIds.has(datasetId)) {
            return;
          }

          datasetIds.add(datasetId);
          datasets.push(viz.dataset());
        }
      });
    } else {
      datasets.push(lib.dataset());
    }

    arc.topnav.runModal(undefined, datasets);
  };

  c.settings = function() {
    return [
      {
        id: 'includeAll',
        displayName: 'Include all datasets on this sheet',
        type: 'boolean',
        defaultValue: 'true',
      },
    ];
  };

  return c;
};

function searchExtension() {
  let ext = function() {
    return 'searchExtension';
  };

  ext.enabled = function() {
    return arc.frontend.featureFlipper.getValueById('site_enable_search');
  };

  ext.action_name = function() {
    return 'search';
  };

  ext.action_label = function() {
    return 'Search Dataset';
  };

  ext.action = arc.action.plugins.search;

  return ext;
}

arc.action.extensions.push(searchExtension());

}());
