window.arc = window.arc || {};

(function() {
'use strict';

arc.datasources = arc.datasources || {};

// A 'DataSource' object reflects the 'DataSource' model in the Django backend
// 'DataSource.deserialize' converts from model object to this object
// 'DataSource.save' creates/updates this object
// 'DataSource.delete' deletes this object
arc.datasources.DataSource = function() {
  var datasource_id,
      datasource_external_table,
      datasource_col_delimiter,
      datasource_num_header_rows,
      datasource_has_header,
      datasource_src_filename,
      datasource_tablename,
      datasource_database,
      datasource_columns_kvs = {},
      datasource_columns_kvs_arr = [],
      datasource_columns_kvs_arr_edited = [],
      datasource_rows,
      datasource_domapi,
      datasource_url,
      datasource_dataconnection_id,
      datasource_dataconnection_type,
      datasource_headers,
      datasource_sample_rows,
      datasource_errors,
      datasource_fill_missing_columns,
      datasource_skip_bad_rows,
      datasource_locale,
      datasource_escapechar,
      datasource_vector_similarity_fn,
      datasource_hnsw_max_conn,
      datasource_hnsw_beam_width,
      csrf_token;

  let datasource_dataconnection_name;
  var DataSource  = function() {};

  DataSource.datasource_id = function(_) {
    if (!arguments.length) return datasource_id;
    datasource_id = _;
    return DataSource;
  };

  DataSource.datasource_col_delimiter = function(_) {
    if (!arguments.length) return datasource_col_delimiter;
    datasource_col_delimiter = _;
    return DataSource;
  };

  DataSource.datasource_vector_similarity_fn = function(_) {
    if (!arguments.length) return datasource_vector_similarity_fn;
    datasource_vector_similarity_fn = _;
    return DataSource;
  };

  DataSource.datasource_hnsw_max_conn = function(_) {
    if (!arguments.length) return datasource_hnsw_max_conn;
    datasource_hnsw_max_conn = _;
    return DataSource;
  };

  DataSource.datasource_hnsw_beam_width = function(_) {
    if (!arguments.length) return datasource_hnsw_beam_width;
    datasource_hnsw_beam_width = _;
    return DataSource;
  };

  DataSource.datasource_external_table = function(_) {
    if (!arguments.length) return datasource_external_table;
    datasource_external_table = _;
    return DataSource;
  };

  DataSource.datasource_has_header = function(_) {
    if (!arguments.length) return datasource_has_header;
    datasource_has_header = _;
    return DataSource;
  };

  DataSource.datasource_num_header_rows = function(_) {
    if (!arguments.length) return datasource_num_header_rows;
    datasource_num_header_rows = _;
    return DataSource;
  };

  DataSource.datasource_src_filename = function(_) {
    if (!arguments.length) return datasource_src_filename;
    datasource_src_filename = _.trim();
    return DataSource;
  };

  DataSource.datasource_tablename = function(_) {
    if (!arguments.length) return datasource_tablename;
    datasource_tablename = _.trim();
    return DataSource;
  };

  DataSource.datasource_database = function(_) {
    if (!arguments.length) return datasource_database;
    datasource_database = _.trim();
    return DataSource;
  };

  DataSource.datasource_perm = function(_) {
    if (!arguments.length) return datasource_perm;
    datasource_perm = _;
    return DataSource;
  };

  DataSource.datasource_url = function(_) {
    if (!arguments.length) return datasource_url;
    datasource_url = _;
    return DataSource;
  };

  DataSource.datasource_dataconnection_id = function(_) {
    if (!arguments.length) return datasource_dataconnection_id;
    datasource_dataconnection_id = _;
    return DataSource;
  };

  DataSource.datasource_dataconnection_name = function(_) {
    if (!arguments.length) return datasource_dataconnection_name;
    datasource_dataconnection_name = _;
    return DataSource;
  };

  DataSource.datasource_dataconnection_type = function(_) {
    if (!arguments.length) return datasource_dataconnection_type;
    datasource_dataconnection_type = _;
    return DataSource;
  };

  DataSource.datasource_headers = function(_) {
    if (!arguments.length) return datasource_headers;
    datasource_headers = _;
    return DataSource;
  };

  DataSource.datasource_sample_rows = function(_) {
    if (!arguments.length) return datasource_sample_rows;
    datasource_sample_rows = _;
    return DataSource;
  };

  DataSource.datasource_errors = function(_) {
    if (!arguments.length) return datasource_errors;
    datasource_errors = _;
    return DataSource;
  };

  DataSource.datasource_fill_missing_columns = function(_) {
    if (!arguments.length) return datasource_fill_missing_columns;
    datasource_fill_missing_columns = _;
    return DataSource;
  };

  DataSource.datasource_skip_bad_rows = function(_) {
    if (!arguments.length) return datasource_skip_bad_rows;
    datasource_skip_bad_rows = _;
    return DataSource;
  };

  DataSource.datasource_locale = function(_) {
    if (!arguments.length) return datasource_locale;
    datasource_locale = _;
    return DataSource;
  };

  DataSource.datasource_escapechar = function(_) {
    if (!arguments.length) return datasource_escapechar;
    datasource_escapechar = _;
    return DataSource;
  };

  DataSource.csrf_token = function(_) {
    if (!arguments.length) return csrf_token;
    csrf_token = _;
    return DataSource;
  };

  DataSource.datasource_domapi = function(_) {
    if (!arguments.length) return datasource_domapi;
    datasource_domapi = _;
    return DataSource;
  };

  DataSource.datasource_rows = function(_) {
    if (!arguments.length) return datasource_rows;
    datasource_rows = _;
    return DataSource;
  };

  DataSource.deserialize = function(_) {
    DataSource.datasource_id(_.datasource_id)
         .datasource_col_delimiter(_.datasource_col_delimiter)
         .datasource_num_header_rows(_.datasource_num_header_rows)
         .datasource_external_table(_.datasource_external_table)
         .datasource_has_header(_.datasource_has_header)
         .datasource_src_filename(_.datasource_src_file)
         .datasource_tablename(_.datasource_tablename)
         .datasource_database(_.datasource_database)
         .datasource_dataconnection_id(_.datasource_dataconnection_id)
         .datasource_dataconnection_name(_.datasource_dataconnection_name)
         .datasource_dataconnection_type(_.datasource_dataconnection_type)
         .datasource_headers(_.datasource_headers)
         .datasource_sample_rows(_.datasource_sample_rows)
         .datasource_errors(_.datasource_errors)
         .datasource_fill_missing_columns(_.datasource_fill_missing_columns)
         .datasource_skip_bad_rows(_.datasource_skip_bad_rows)
         .datasource_locale(_.datasource_locale)
         .datasource_escapechar(_.datasource_escapechar)
         .datasource_vector_similarity_fn(_.datasource_vector_similarity_fn)
         .datasource_hnsw_max_conn(_.datasource_hnsw_max_conn)
         .datasource_hnsw_beam_width(_.datasource_hnsw_beam_width);
    return DataSource;
  };

  DataSource.paintDataDetail = function() {

    // Paint column headers
    d3.select(datasource_domapi.datasource_table_div())
      .selectAll("thead > tr > th")
      .remove();

    var hrows = d3.select(datasource_domapi.datasource_table_div())
        .select("thead > tr")
        .selectAll("th")
        .data(datasource_columns_kvs_arr)
        .enter()
          .append("th");

    hrows.html(function(d) {
          return (datasource_domapi.datasource_col_header_tmpl());
        });

    // TODO: use the table drawing trick here
    hrows.selectAll(".datasource-colname")
        .property("value", function(d, i) {
          var d1 = d3.select($(this).closest("th")[0]).datum();

          // Hack for Hive since it returns tablename in addition to
          // column name
          return d1.colname;
        });

    hrows.selectAll(".view-column-name")
         .text(function(d, i) {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.colname;
        });

    const dcType = DataSource.datasource_dataconnection_type();
    const dcSupportsVectorDataType = arc.dataconnection.supportsVectorDataType(dcType);
    if (dcSupportsVectorDataType) {
      if ($('#data-import-table .dropdown-item [value="Vector"]').length <= 0) {
        const $vector_types_template = $('#vector-types-template').html();
        $('#data-import-table .dropdown-menu').append($vector_types_template);
      }
    }

    var colts = hrows.selectAll(".dropdown-toggle > div");
    colts.attr('value', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype;
    });
    colts.classed('type-real', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype === "Real";
    });
    colts.classed('type-integer', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype === "Integer";
    });
    colts.classed('type-boolean', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype === "Boolean";
    });
    colts.classed('type-timestamp', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype === "Timestamp";
    });
    colts.classed('type-string', function() {
          var d1 = d3.select($(this).closest("th")[0]).datum();
          return d1.coltype === "String";
    });
    colts.classed('type-vector', function() {
      const d1 = d3.select($(this).closest('th')[0]).datum();
      return d1.coltype === 'Vector';
    });
    colts.classed('type-text', function() {
      const d1 = d3.select($(this).closest('th')[0]).datum();
      return d1.coltype === 'Text';
    });

    // Handle changing column type.
    $('.dropdown-menu a').offOn('click.changeColumnType', function() {
      var selText = $(this).find('div').html();
      var d1 = d3.select($(this).closest("th")[0]).datum();
      var updatedcoltype = d3.select(this).select('div').attr("value");
      var updatedcolcss = d3.select(this).select('div').attr("class");
      $(this).parents('.btn-group')
             .find('.dropdown-toggle')
             .html('<div class="datasource-coltype ' +
                   updatedcolcss + '" value=' +
                   updatedcoltype + '>' + selText +
                   '</div>');

      if (dcSupportsVectorDataType) {
        toggleVectorSettings();
      }
    });

    // Paint the data rows
    d3.select(datasource_domapi.datasource_table_div())
      .select("tbody")
      .selectAll("tr")
      .remove();

    var drows =
      d3.select(datasource_domapi.datasource_table_div())
        .select("tbody")
        .selectAll("tr")
        .data(datasource_rows)
        .enter()
          .append("tr");

    // create a cell in each row for each column
    var cells = drows.selectAll("td")
                    .data(function(row, i) {
                      return row;
                    })
                    .enter()
                      .append("td")
                      .text(function(d, i) {
                        return d;
                      });

    $(datasource_domapi.datasource_refresh_spin_span()).hide();

    if (dcSupportsVectorDataType) {
      if ($('#import-edit-details #locale-popover').length <= 0) {
        const $locale_popover_template = $('#locale-popover-template').html();
        $(`label[for='datasource-locale']`).append($locale_popover_template);
      }

      toggleVectorSettings();
    }

    function toggleVectorSettings() {
      if ($('.datasource-coltype[value="Vector"]').length >= 1) {
        if ($('#import-edit-details #vector-similarity-fn').length <= 0) {
          const $vectorSettingsTemplate = $('#vector-settings-template').html();
          $('#import-edit-details form .pull-left:last').append($vectorSettingsTemplate);
          $('[data-toggle="popover"]').popover();
        }
      } else {
        $('#import-edit-details #vector-similarity-fn-div').remove();
        $('#import-edit-details #hnsw-max-conn-div').remove();
        $('#import-edit-details #hnsw-beam-width-div').remove();
      }
    }
  };

  function isNameValid(colname, permit_dots) {
    if (colname.match(/^[0-9]+/)) {
      return false;
    }

    // Impala identifier rules are alphanumeric and starting with an
    // alphabetic character
    var check_headers = ['arcengine', 'arcengine_v2', 'impala', 'impyla', 'sparksql'];
    if ($.inArray(datasource_dataconnection_type, check_headers) === -1) {
      return true;
    }

    if (permit_dots) {
      if (!colname.match(/^[0-9A-Za-z_\.]+$/)) {
        return false;
      }
    } else {
      if (!colname.match(/^[0-9A-Za-z_]+$/)) {
        return false;
      }
    }

    return true;
  }

  DataSource.setup = function() {
    DataSource.setupRefreshBtn()
              .setupConfirmBtn();

    return DataSource;
  };

  const getTableNameInputValue = () => $(datasource_domapi.datasource_tablename_div()).val();
  const getDatabaseInputValue = () => $(datasource_domapi.datasource_database_div()).val();

  const createDataset = (shouldCreateDashboard, databaseName, dataTableName) => {
    const errorTitle = 'Failed to save the dataset';
    const displaySavingDatasetError = (errorMsg) => {
      $('#import-confirm-modal').modal('hide');
      arc.report.alertMessage(
        errorTitle,
        `The data successfully imported to ${datasource_dataconnection_name} dataconnection but failed to create dataset: ${errorMsg}.
        \n
        If you want to create a ${shouldCreateDashboard ? 'dashboard' : 'dataset'}, go to the data page and create the dataset manually ${shouldCreateDashboard ? 'first' : ''}.`
        );
    };

    const autogeneratedDatasetName = `autogenerated_from_${dataTableName}`;

    arc.datasets.createFromTable(
      datasource_dataconnection_id,
      datasource_dataconnection_type,
      autogeneratedDatasetName,
      databaseName,
      dataTableName,
      (errorMsg, Dataset) => {
        if (!errorMsg) {
          const id = Dataset.dataset_id();
          const newDashboardUrl = `${arc.frontend.globals.urls.reportBuildUrl}/0?report_type=dashboard&dataset_id=${id}`;
          const datasetDetailsUrl = `${arc.frontend.globals.urls.staticUrl}/../apps/dataset/${id}`;
          const redirectUrl = shouldCreateDashboard ? newDashboardUrl : datasetDetailsUrl;
          window.open(redirectUrl, '_self');
        } else {
          displaySavingDatasetError(errorMsg);
        }
      },
      (errorMsg) => displaySavingDatasetError(errorMsg)
    );
  };

  DataSource.setupConfirmBtn = function() {
    d3.select(datasource_domapi.datasource_confirm_import_yes_btn())
        .on('click.datasource-confirm-import-yes', () => {
          $('#datasource-cancel-import').prop('disabled', true);
          $(datasource_domapi.datasource_confirm_import_spin_div()).show();
          DataSource.save(true, () => {
            const shouldCreateDashboard = $('#createDashboard:checked').length;
            const shouldCreateDataset = $('#createDataset:checked').length;
            const dataTableName = getTableNameInputValue();
            const databaseName = getDatabaseInputValue();
            const connectionExplorerUrl = `${arc.frontend.globals.urls.staticUrl}/../apps/datasql?dataconnection_id=${datasource_dataconnection_id}&dataconnection_name=${datasource_dataconnection_name}&database_name=${databaseName}&datatable_name=${dataTableName}#explorer-tab`;
            if (!shouldCreateDashboard && !shouldCreateDataset) {
              window.open(connectionExplorerUrl, '_self');
              return;
            }

            createDataset(shouldCreateDashboard, databaseName, dataTableName);
          });
        });

    d3.select(datasource_domapi.datasource_confirm_import_btn())
        .on("click.datasource-confirm-import", function() {
          const $modal = $(datasource_domapi.datasource_confirm_import_modal());
          if (arc.misc.modalShown($modal)) {
            return;
          }

          arc.report.alertMessageAllHide();
          $("#datasource-cancel-import").removeAttr("disabled");
          $(datasource_domapi.datasource_confirm_import_spin_div()).hide();
          $modal.modal('show');
        });

    return DataSource;
  };

  DataSource.setupRefreshBtn = function() {
    d3.select(datasource_domapi.datasource_refresh_btn())
      .on("click.datasource_refresh-btn", function() {
        arc.report.alertMessageAllHide();
        $(datasource_domapi.datasource_refresh_spin_span()).show();
        DataSource.save(false, DataSource.reloadDataSource);
      });
    return DataSource;
  };

  const option = '<option value="%LOC_LOC%">%LOC_NAME%</option>';

  DataSource.paintDataLocations = function(_) {
    d4.queue()
      .defer(d3.json, `${arc.frontend.globals.urls.dataconnectionUrl}/${datasource_dataconnection_id}`)
      .await(function(error, dataconnections) {
        const dcInfo = JSON.parse(dataconnections[0].info);
        const locations = dcInfo.PARAMS.LOCATIONS;

        const keys = Object.keys(locations || {});
        keys.forEach(function(key) {
          const value = locations[key];
        });

        if (keys && keys.length > 0) {
          $('#datasource-location').closest('.form-group')
                                   .removeClass('arc-invisible');

          const $sel = $('#datasource-location');
          $sel.empty();

          $sel.append(arc.misc.safe_substitute(option, {
            LOC_LOC: "",
            LOC_NAME: "(default)",
          }));

          keys.forEach(function(key) {
            const value = locations[key];
            $sel.append(arc.misc.safe_substitute(option, {
              LOC_LOC: value,
              LOC_NAME: key,
            }));
          });
        }
      });
  };

  DataSource.paintDataSource = function(_) {

    // database name and tablename
    if (datasource_database !== '') {
      $(datasource_domapi.datasource_database_div())
        .val(datasource_database);
    }

    $(datasource_domapi.datasource_tablename_div())
      .val(datasource_tablename);

    if ($(datasource_domapi.datasource_col_delimiter_div())
            .find("option:selected").attr("value") !== "other")
    {
      $(datasource_domapi.datasource_col_delimiter_div())
        .val(datasource_col_delimiter);
    }
    if ($(datasource_domapi.datasource_locale_div())
            .find("option:selected").attr("value") !== "other")
    {
      $(datasource_domapi.datasource_locale_div())
        .val(datasource_locale);
    }

    const dc_type = DataSource.datasource_dataconnection_type();
    if (arc.dataconnection.isArcEngineOrImpala(dc_type)) {
      $(datasource_domapi.datasource_external_table_div()).closest('div').show();
    }

    $(datasource_domapi.datasource_external_table_div())
      .prop("checked", datasource_external_table ? 1 : 0);
    $(datasource_domapi.datasource_num_header_rows_div())
      .prop("checked", datasource_has_header ? 1 : 0);
    $(datasource_domapi.datasource_skip_bad_rows_div())
      .prop("checked", datasource_skip_bad_rows ? 1 : 0);
    $(datasource_domapi.datasource_fill_missing_columns_div())
      .prop("checked", datasource_fill_missing_columns ? 1 : 0);
    $(datasource_domapi.datasource_escapechar_div())
      .prop("checked", datasource_escapechar ? 1 : 0);

    d3.select(datasource_domapi.datasource_src_filename_div())
      .text(datasource_src_filename);

    $(datasource_domapi.datasource_vector_similarity_fn_div())
      .val(datasource_vector_similarity_fn);

    $(datasource_domapi.datasource_hnsw_max_conn_div())
    .val(datasource_hnsw_max_conn);

    $(datasource_domapi.datasource_hnsw_beam_width_div())
    .val(datasource_hnsw_beam_width);

    // paint the headers, rows and columns of the actual data
    DataSource.getDataDetail(DataSource.paintDataDetail);

    //present row report
    var msg = "";
    if (datasource_errors.report.error !== 0) {
      var title = "parsing error: " + datasource_errors.report.error +
            " line(s) have errors. Please resolve the problems and try again. " +
          "You may use the options on the right to resolve the problem";
      if (datasource_errors.report.error > 1000) {
        msg += "Showing the first 1000 lines with error<br/>";
      }
      var num_of_col = datasource_headers.length;
      datasource_errors.bad_rows.forEach(function(row) {
        for (var item in row) {
          msg += " line " + item + ": ";
          if (row[item].num_of_col !== num_of_col) {
            msg += "number of columns is " +
                        row[item].num_of_col +
                        " instead of " + num_of_col;
            }
          if (row[item].type_errors.length > 0) {
            msg += " column type errors: " +
                        JSON.stringify(row[item].type_errors, null, 2);
           }
          msg += "<br/>";
          }
      });
      arc.report.alertMessage(title, msg, { is_html: true });
    }else {
      if (datasource_errors.report.filled !== 0) {
        msg += "The missing columns of " +
            datasource_errors.report.filled +
            " line(s) are filled with NULL<br/>";
      }
      if (datasource_errors.report.skipped !== 0) {
        msg += datasource_errors.report.skipped +
            " line(s) are skipped";
      }

      if (msg !== "") {
        arc.report.alertMessageSmallBase({ type: 'alert-warning',
                                          alertHeader: 'Warning',
                                          alertMessage: msg,
                                          fadeOut: false,
                                          useHTML: true });
      }
    }

    $('[data-toggle="popover"]').popover();

    return DataSource;
  };

  DataSource.reloadDataSource_cb = function(reload_datasource_data) {
    reload_datasource_data.forEach(function(thisds) {
        DataSource.deserialize(thisds);
    });

    $(datasource_domapi.datasource_refresh_spin_span()).hide();
  };

  // This should be called after a refresh, reloads only a specific data source
  DataSource.reloadDataSource = function(reload_datasource_data) {
    DataSource.deserialize(reload_datasource_data);
              DataSource.paintDataSource();
  };

  DataSource.getDataDetail = function(done_cb) {
    var qr = datasource_headers;
    datasource_columns_kvs_arr = datasource_headers;
          DataSource.datasource_rows(datasource_sample_rows);
          if (done_cb) {
            done_cb();
          }
    return DataSource;
  };

  DataSource.delete = function(delete_cb, always_done_cb) {
    DataSource.makeRESTCall(delete_cb, 'DELETE',
                          DataSource.datasource_id(), undefined, undefined,
                          always_done_cb);
  };

  // For updating an existing DataSource
  DataSource.save = function(import_confirmed, save_cb) {
    var datasource_save_data = {};

    var rows = d3.select(datasource_domapi.datasource_table_div())
                 .selectAll("thead > tr > th");

    datasource_columns_kvs_arr_edited = [];
    rows.each(function() {
      var colname = d3.select(this)
                      .select(".datasource-colname")
                      .property('value');
      var coltype = d3.select(this)
                      .select(".datasource-coltype")
                      .attr('value');
      datasource_columns_kvs_arr_edited.push({'colname': colname,
            'coltype': coltype});
    });

    var different = false;
    for (var i = 0; i < datasource_columns_kvs_arr.length; i++) {
      var origcolname = datasource_columns_kvs_arr[i].colname;

      // Hack for Hive since it returns tablename in addition to
      // column name
      if (!isNameValid(datasource_columns_kvs_arr_edited[i].colname)) {
        arc.report.alertMessage("Invalid colname " +
          datasource_columns_kvs_arr_edited[i].colname, "Only " +
          "alphanumeric characters allowed, starting with alphabetic.");
        $(datasource_domapi.datasource_refresh_spin_span()).hide();
        $('#import-confirm-modal').modal('hide');
        datasource_columns_kvs_arr_edited = [];
        return;
      }
    }

    datasource_save_data.datasource_headers =
                          JSON.stringify(datasource_columns_kvs_arr_edited);

    const new_tablename = getTableNameInputValue();
    const new_dbname = getDatabaseInputValue();
    let new_location;
    if (!$('#datasource-location').hasClass('arc-invisible')) {
      new_location = $('#datasource-location option:selected').attr('value');
    }

    const cancelSave = () => {
      $(datasource_domapi.datasource_refresh_spin_span()).hide();
      $('#import-confirm-modal').modal('hide');
      datasource_columns_kvs_arr_edited = [];
    };

    var dbnameerror = !isNameValid(new_dbname);
    var tablenameerror = !isNameValid(new_tablename, true);
    if (dbnameerror || tablenameerror) {
      arc.report.alertMessage("Invalid " +
            (dbnameerror ? "database name" : "table name") + ". Only " +
            "alphanumeric characters allowed, starting with alphabetic.");
      cancelSave();
      return;
    }
    datasource_save_data.datasource_tablename = new_tablename;
    datasource_save_data.datasource_database = new_dbname;
    datasource_save_data.datasource_location = new_location;

    //datasource_save_data.datasource_col_delimiter =
    //    $(datasource_domapi.datasource_col_delimiter_div()).val();

    datasource_save_data.datasource_vector_similarity_fn =
    $(datasource_domapi.datasource_vector_similarity_fn_div()).val();

    const isPositiveNumber = (s) => /^[1-9][0-9]*$/.test(s);

    let hnsw_max_conn = $(datasource_domapi.datasource_hnsw_max_conn_div()).val();
    hnsw_max_conn = hnsw_max_conn === '' ? 16 : hnsw_max_conn; // set to default if empty
    const hnswMCContainsOnlyNums = isPositiveNumber(hnsw_max_conn);

    let hnsw_beam_width = $(datasource_domapi.datasource_hnsw_beam_width_div()).val();
    hnsw_beam_width = hnsw_beam_width === '' ? 100 : hnsw_beam_width; // set to default if empty
    const hnswBWContainsOnlyNums = isPositiveNumber(hnsw_beam_width);

    const dc_type = DataSource.datasource_dataconnection_type();
    if (arc.dataconnection.supportsVectorDataType(dc_type) &&
        $('.datasource-coltype[value="Vector"]').length >= 1 &&
        (!hnswMCContainsOnlyNums || !hnswBWContainsOnlyNums)) {
      arc.report.alertMessage(`Invalid hnsw ${!hnswMCContainsOnlyNums ? 'max connections' :
        'beam width'} value. It must be a positive number.`);
      cancelSave();
      return;
    }

    datasource_save_data.datasource_hnsw_max_conn = hnsw_max_conn;
    datasource_save_data.datasource_hnsw_beam_width = hnsw_beam_width;

    var import_type = $(datasource_domapi.datasource_importtype_div()).val();
    datasource_save_data.datasource_importtype = import_type;

    var col_dim = $(datasource_domapi.datasource_col_delimiter_div()).val();
    if (col_dim === 'other') {
      datasource_save_data.datasource_col_delimiter = $('#col-other')[0].value;
    } else {
      datasource_save_data.datasource_col_delimiter = col_dim;
    }

    var locale = $(datasource_domapi.datasource_locale_div()).val();
    if (locale === 'other') {
      datasource_save_data.datasource_locale = $('#locale-other')[0].value;
    } else {
      datasource_save_data.datasource_locale = locale;
    }

    // allow for multiple number of header lines
    datasource_save_data.datasource_external_table =
        $(datasource_domapi.datasource_external_table_div()).prop("checked") ? 1 : 0;
    datasource_save_data.datasource_has_header =
        $(datasource_domapi.datasource_num_header_rows_div()).prop("checked") ? 1 : 0;
    datasource_save_data.datasource_skip_bad_rows =
        $(datasource_domapi.datasource_skip_bad_rows_div()).prop("checked") ? 1 : 0;
    datasource_save_data.datasource_fill_missing_columns =
        $(datasource_domapi.datasource_fill_missing_columns_div()).prop("checked") ? 1 : 0;
    datasource_save_data.datasource_escapechar =
        $(datasource_domapi.datasource_escapechar_div()).prop("checked") ? 1 : 0;
    datasource_save_data.datasource_import_confirmed = import_confirmed;
    DataSource.makeRESTCall(save_cb, 'PUT', DataSource.datasource_id(),
                           'json', datasource_save_data);
  };

  DataSource.makeRESTCall = function(makeRESTCall_cb, request_type,
                            datasource_id, request_format, request_data,
                            done_cb) {

    makeRESTCall_cb = makeRESTCall_cb || function() {};
    request_format = request_format || 'html';
    request_data = request_data || {};
    request_data.csrfmidddlewaretoken = csrf_token;
    request_data.id = datasource_id;

    var url = datasource_url;
    if (request_format === 'json') {
      url += '.json';
    }
    if (datasource_id) {
      url += "/" + datasource_id;
    }

    $.ajax({
      url: url,
      data: request_data,
      type: request_type,
      beforeSend: function(xhr) {
        // Because of a jquery bug when handling PUT requests,
        // we have to explicitly set X-CSRFToken here
        xhr.setRequestHeader("X-CSRFToken", csrf_token);
      },
    })
    .done(function(req) {
      makeRESTCall_cb(req);
    })
    .fail(function(req) {
      arc.report.alertMessage("Failed to " + request_type + " DataSource",
          req.responseText ? req.responseText : req);
      $(datasource_domapi.datasource_confirm_import_modal()).modal('hide');
    })
    .always(function(req) {
      if (done_cb) {
        done_cb(req);
      }
    });

    return DataSource;
  };

  return DataSource;
};

// Get any html requirements from here. Do not assume knowlege of a
// separate template file. Any html div knowledge that's needed by this JS
// file should be retrieved from this function.  The values should be set up
// in the template html file where arc.datasources.datasources is being
// initialized
arc.datasources.domapi = function() {

  var datasource_table_div,
      datasource_database_div,
      datasource_tablename_div,
      datasource_importtype_div,
      datasource_locale_div,
      datasource_escapechar_div,
      datasource_col_delimiter_div,
      datasource_external_table_div,
      datasource_num_header_rows_div,
      datasource_skip_bad_rows_div,
      datasource_fill_missing_columns_div,
      datasource_src_filename_div,
      datasource_confirm_import_modal,
      datasource_confirm_import_yes_btn,
      datasource_confirm_import_btn,
      datasource_confirm_import_spin_div,
      datasource_refresh_btn,
      datasource_refresh_spin_span,
      datasource_col_header_tmpl,
      datasource_vector_similarity_fn_div,
      datasource_hnsw_max_conn_div,
      datasource_hnsw_beam_width_div;

  var datasources_domapi = function() {};

  datasources_domapi.datasource_table_div = function(_) {
    if (!arguments.length) return (datasource_table_div);
    datasource_table_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_database_div = function(_) {
    if (!arguments.length) return (datasource_database_div);
    datasource_database_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_tablename_div = function(_) {
    if (!arguments.length) return (datasource_tablename_div);
    datasource_tablename_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_importtype_div = function(_) {
    if (!arguments.length) return (datasource_importtype_div);
    datasource_importtype_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_col_delimiter_div = function(_) {
    if (!arguments.length) return (datasource_col_delimiter_div);
    datasource_col_delimiter_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_vector_similarity_fn_div = function(_) {
    if (!arguments.length) return (datasource_vector_similarity_fn_div);
    datasource_vector_similarity_fn_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_hnsw_max_conn_div = function(_) {
    if (!arguments.length) return (datasource_hnsw_max_conn_div);
    datasource_hnsw_max_conn_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_hnsw_beam_width_div = function(_) {
    if (!arguments.length) return (datasource_hnsw_beam_width_div);
    datasource_hnsw_beam_width_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_external_table_div = function(_) {
    if (!arguments.length) return (datasource_external_table_div);
    datasource_external_table_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_num_header_rows_div = function(_) {
    if (!arguments.length) return (datasource_num_header_rows_div);
    datasource_num_header_rows_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_skip_bad_rows_div = function(_) {
    if (!arguments.length) return (datasource_skip_bad_rows_div);
    datasource_skip_bad_rows_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_locale_div = function(_) {
    if (!arguments.length) return (datasource_locale_div);
    datasource_locale_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_escapechar_div = function(_) {
    if (!arguments.length) return (datasource_escapechar_div);
    datasource_escapechar_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_fill_missing_columns_div = function(_) {
    if (!arguments.length) return (datasource_fill_missing_columns_div);
    datasource_fill_missing_columns_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_src_filename_div = function(_) {
    if (!arguments.length) return (datasource_src_filename_div);
    datasource_src_filename_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_confirm_import_btn = function(_) {
    if (!arguments.length) return (datasource_confirm_import_btn);
    datasource_confirm_import_btn = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_confirm_import_modal = function(_) {
    if (!arguments.length) return (datasource_confirm_import_modal);
    datasource_confirm_import_modal = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_confirm_import_yes_btn = function(_) {
    if (!arguments.length) return (datasource_confirm_import_yes_btn);
    datasource_confirm_import_yes_btn = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_confirm_import_spin_div = function(_) {
    if (!arguments.length) return (datasource_confirm_import_spin_div);
    datasource_confirm_import_spin_div = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_refresh_btn = function(_) {
    if (!arguments.length) return (datasource_refresh_btn);
    datasource_refresh_btn = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_refresh_spin_span = function(_) {
    if (!arguments.length) return (datasource_refresh_spin_span);
    datasource_refresh_spin_span = _;
    return (datasources_domapi);
  };

  datasources_domapi.datasource_col_header_tmpl = function(_) {
    if (!arguments.length) return (datasource_col_header_tmpl);
    datasource_col_header_tmpl = _;
    return (datasources_domapi);
  };

  return datasources_domapi;
};

}());
