window.arc = window.arc || {};

(function() {
'use strict';

arc.data = arc.data || {};

arc.data.queryParallelRunner = function() {
  var queryParallelRunner = function() {
    return 'arc.data.queryParallelRunner';
  };

  var calls = [],
      pending = 0;

  function serializeAndMakeCalls() {
    if (calls.length > 0) {
      var currentCalls = calls;
      calls = [];

      var _pl = [],
          _cbl = [];
      currentCalls.forEach(function(c) {
        if (arc.globals.arcviz_settings && arc.globals.arcviz_settings.COMPRESS_DSREQ) {
          if (c.params.dsreq) {
            let dsreqLocal = JSON.parse(c.params.dsreq);
            let type = dsreqLocal.type;
            c.params.dsreq = JSON.stringify(arc.misc.makeSparseDsreq(dsreqLocal));

            // Note that the columnstats dsreq type needs the sql
            // command to be specified
            if (type !== 'columnstats') {
              if (c.params.query) {
                delete c.params.query;
              }
            }
          }
        }

        _pl.push(c.params);
        _cbl.push(c.cb);
      });

      makeCall(_pl, _cbl);
    }
  }

  function makeCall(paramsl, cbl) {
    ++pending;
    arc.sqlrun.runSQLWithParamsParallel(paramsl, cbl, function finallyCb() {
      --pending;
      serializeAndMakeCalls();
    });
  }

  queryParallelRunner.cancel = function(callId) {
    calls = calls.filter(function(call) {
      if (call.callId === callId) {
        call.cb('Cancelled');
        return false;
      }

      return true;
    });

    return queryParallelRunner;
  };

  queryParallelRunner.add = function(callId, params, cb) {
    calls.push({
      callId: callId,
      params: params,
      cb: cb,
    });

    if (pending === 0) {
      setTimeout(serializeAndMakeCalls, 0);
      return queryParallelRunner;
    }

    return queryParallelRunner;
  };

  return queryParallelRunner;
};

}());

