window.arc = window.arc || {};

(function() {
'use strict';

arc.filter = arc.filter || {};

arc.filter.patternPicker = function() {
  var setting = arc.visual.setting()
                   .id('pattern_picker')
                   .tab('Pattern')
                   .type(arc.visual.settingTypeEnum.CUSTOM)
                   .add_name('PATTERN_PICKER')
                   .value('');

  var data = {};

  var filterInput;

  setting.filterInput = function(_) {
    if (!arguments.length) return filterInput;
    filterInput = _;
    return setting;
  };

  function valueCb(value) {
    data = {};
    $.extend(data, value);

    paintSettings();
  }

  function fetch_fn() {
    var div_id = setting.div_id();
    var $sel = $('#' + div_id);

    data = {};

    data.exclude = $sel.find('.filter-pick-exclude').prop('checked');
    data.pattern_type = $sel.find('.filter-pattern-container select').val();
    data.pattern_text = $sel.find('.filter-pattern-container input.search-text').val();

    data.expr = filterInput.patternFilter(data.pattern_type,
        data.pattern_text, data.exclude, data.ignorecase);
    return data;
  }

  function paint_fn(d3_sel) {
    var div_id = setting.div_id();
    d3_sel.append('div')
          .attr('id', div_id);

    var $sel = $('#' + div_id);
    $sel.append($('#filter-pattern-template').html());

    paintSettings();
  }

  function paintSettings() {
    if (data === '') {
      return;
    }

    var div_id = setting.div_id();
    var $sel = $('#' + div_id);

    $sel.find('.filter-pick-exclude').prop('checked', (data.exclude === true));
    if (data.pattern_type && data.pattern_type.length > 0) {
      $sel.find('.filter-pattern-container select').val(data.pattern_type);
    }

    $sel.find('.filter-pattern-container input.search-text').val(data.pattern_text);
  }

  setting.valueCb(valueCb)
         .paint_fn(paint_fn)
         .fetch_fn(fetch_fn);

  return setting;
};

}());
