window.arc = window.arc || {};

(function() {
'use strict';

arc.filter = arc.filter || {};

arc.filter.uploadPicker = function() {
  var setting = arc.visual.setting()
                   .id('upload_picker')
                   .tab('Set values')
                   .type(arc.visual.settingTypeEnum.CUSTOM)
                   .add_name('UPLOAD_PICKER')
                   .value('');

  var data = {};

  var filterInput;

  setting.filterInput = function(_) {
    if (!arguments.length) return filterInput;
    filterInput = _;
    return setting;
  };

  function valueCb(value) {
    data = {};
    $.extend(data, value);

    paintSettings();
  }

  function fetch_fn() {
    var div_id = setting.div_id();
    var $sel = $('#' + div_id);

    data = {};
    data.exclude = $sel.find('.filter-pick-exclude').prop('checked');
    data.value = $sel.find('textarea').val();

    var values = data.value.split('\n')
                           .filter(function(s) {
                             return (s.trim().length > 0);
                           });

    if (values.length === 0) {
      data.expr = '';
      return data;
    }

    var coltype = filterInput.coltype();

    if (!arc.report.coltypeIsBoolean(coltype) &&
        !arc.report.coltypeIsNumber(coltype)) {
      values = values.map(function(d) {
        return "'" + d + "'";
      });
    }

    data.expr = filterInput.valuesFilter(values, data.exclude);
    return data;
  }

  function paint_fn(d3_sel) {
    var div_id = setting.div_id();
    d3_sel.append('div')
          .attr('id', div_id);

    var $sel = $('#' + div_id);
    $sel.append($('#filter-upload-template').html());

    paintSettings();
  }

  function paintSettings() {
    if (data === '') {
      return;
    }

    var div_id = setting.div_id();
    var $sel = $('#' + div_id);

    $sel.find('.filter-pick-exclude')
        .prop('checked', (data.exclude ? true : false));
    $sel.find('textarea').val(data.value);
  }

  setting.inputValues = function(rows) {
  };

  setting.valueCb(valueCb)
         .paint_fn(paint_fn)
         .fetch_fn(fetch_fn);

  return setting;
};

}());
