window.arc = window.arc || {};

(function () {
    'use strict';

    arc.dataprofileHelper = arc.dataprofileHelper || {};

    arc.dataprofileHelper.plotProfileHistogram =
    (dataset, column, chartDiv, minMaXResult, onError) => {
         // columns is arc.datasets.Column
        arc.globals.reports = arc.reporttracker.reports();
        arc.globals.params = arc.params.tracker();
        const loader = arc.loadbar()
                        .dom_id(`#${chartDiv} .viz-refresh-indicator`)
                        .refresh_icon(true);
        const histogram = arc.visual.plugins.histogram();
        const driver = arc.report.driver(histogram);
        // We need to have a shelf holder, even if it does not existing in the dom.
        histogram.viz_drawDesigner('app-shelves-fake');
        driver.dataset(dataset)
            .chart_div(chartDiv)
            .params(arc.params.tracker());

        // Create the shelf for histogram visual to add the colum we want profile
        const shelf_elem = arc.report.columnToShelfElement(dataset, column);
        const aggregate_shelf = driver.shelf_data()[0];
        const se = arc.report.shelfElementPostProcess({
            shelf_elem,
            shelf_type: aggregate_shelf.type,
            shelf_property: aggregate_shelf.property,
            shelf_id: aggregate_shelf.shelf_name,
            tgtshelf_is_aggregate: true,
        });

        const se_d = {};
        se.save(se_d);

        driver.shelves().add('aggregates_shelf', [se_d]);

        histogram.viz_setSettings({
            user_settings: {
                show_y_axis: 'false',
                show_x_axis: 'true',
                y_axis_label: 'true',
                x_axis_label: 'false',
                color_opacity: '100',
                bar_mark_size: '20-20',
                inline_measure_display: 'true',
                bucket_count: '10',
                // It look better to add some extra space between columns (not to much to )
                space_between_histogram_bars: 'true',
            }
        });

        histogram.viz_lib().colors(['#f96702']);
        histogram.viz_lib().loader(loader);
        histogram.viz_lib().alertMessage = onError;

        // X shelf of the histogram visual is the histogram buckets.
        const aggregatCols =
            arc.data.column()
                .colname(column.display_name())
                .coltype('INT')
                .colproperty(arc.report.columnTypeEnum.AGGREGATE)
                .colsource('x_shelf')
                .colindex(1);

        // Setup results
        const result = arc.data.result();
        result.rows([minMaXResult]);
        const cols = [aggregatCols, aggregatCols];
        result.columns(cols);

        // create the visual by setting the data and then drawing it
        histogram.viz_setDataResult(result);
        histogram.viz_drawVisual(chartDiv);
        return histogram;
    };

    const addShelfItemToShelf = (colum_shelf_elem, driver, shelf, shelfName, isAggregate) => {
        const shelfElem = arc.report.shelfElementPostProcess({
            shelf_elem: colum_shelf_elem,
            shelf_type: shelf.type,
            shelf_property: shelf.property,
            shelf_id: shelf.shelf_name,
            tgtshelf_is_aggregate: isAggregate,
        });

        const se_d = {};
        shelfElem.save(se_d);
        driver.shelves().add(shelfName, [se_d]);
    };

    // Helper method to add  Recourd Count shelf element to the shelf
    const addRecordCountToShelf = (driver, dataset, shelfName) => {
        const shelf = driver.shelf_data().find((s) => s.name === shelfName);
        const recordCount_shelf_elem =
            arc.report.shelf.record_count_element(dataset.dataconnection_type());
        recordCount_shelf_elem.col_alias('Count');
        const order = arc.report.shelf.order();
        order.ascending(false);
        order.priority(1);
        recordCount_shelf_elem.order(order);

        addShelfItemToShelf(recordCount_shelf_elem, driver, shelf, shelfName, true);
    };

    // Helper method to able to transform a column to a shelf element and add it to the shelf
    const addColumnToShelf = (driver, column, dataset, shelfName, isAggregate) => {
        const colum_shelf_elem = arc.report.columnToShelfElement(dataset, column);
        const shelf = driver.shelf_data().find((s) => s.name === shelfName);
        addShelfItemToShelf(colum_shelf_elem, driver, shelf, shelfName, isAggregate);
    };

    arc.dataprofileHelper.plotTopFrequentValueVisual = (dataset, column, chart_div) => {
        // columns is arc.datasets.Column
        const loader = arc.loadbar()
            .dom_id(`#${chart_div} .viz-refresh-indicator`)
            .refresh_icon(true);
        arc.globals.reports = arc.reporttracker.reports();
        arc.globals.params = arc.params.tracker();
        const bar = arc.visual.plugins.bar();
        const driver = arc.report.driver(bar)
            .dataset(dataset)
            .chart_div(chart_div)
            .params(arc.params.tracker());

        bar.viz_drawDesigner('app-shelves-fake');
        bar.viz_setSettings({
            user_settings: {
                max_rowcount: '10',
                show_y_axis: 'true',
                show_x_axis: 'false',
                y_axis_label: 'false',
                x_axis_label: 'true',
                color_opacity: '100',
                bar_mark_size: '17-17',
                inline_measure_display: 'true',
            }
        });
        bar.user_settings().find_by_id('bar_mark_size').hidden(false);
        bar.viz_lib().loader(loader);
        bar.viz_lib().colors(['#008cff']);
        addColumnToShelf(driver, column, dataset, 'y_shelf', false);
        addRecordCountToShelf(driver, dataset, 'x_shelf');
        driver.loader(loader);
        driver.refresh(true, undefined, true); // draws
        return bar;
    };
}());
