window.arc = window.arc || {};

(function() {
'use strict';

arc.misc = arc.misc || {};

/*
 * Used by the dashboard and by ksql code to display and control
 * page-level pause & play.
 *
 */
arc.misc.playpause = function() {
  let p = function() { return 'playpause'; };

  let playing = true,
      playCb,
      pauseCb;

  let playpauseID = $.now();

  let $pause = $('.main-app .viz-params-pause');
  let $play = $('.main-app .viz-params-play');

  $play.off('click.play' + playpauseID)
       .on('click.play' + playpauseID, function() {
         if (playCb) {
           playCb();
         }

         p.showAsPlaying();
       });

  $pause.off('click.pause' + playpauseID)
        .on('click.pause' + playpauseID, function() {
          if (pauseCb) {
            pauseCb();
          }

          p.showAsPaused();
        });

  p.isPlaying = function() {
    return playing;
  };

  p.hide = function() {
    $pause.addClass('arc-invisible');
    $play.addClass('arc-invisible');
  };

  p.show = function() {
    if (playing) {
      p.showAsPlaying();
    } else {
      p.showAsPaused();
    }
  };

  p.showAsPaused = function() {
    playing = false;
    $pause.addClass('arc-invisible');
    $play.removeClass('arc-invisible');

    return p;
  };

  p.showAsPlaying = function() {
    playing = true;
    $pause.removeClass('arc-invisible');
    $play.addClass('arc-invisible');

    return p;
  };

  p.setPlayCb = function(f) {
    playCb = f;
  };

  p.setPauseCb = function(f) {
    pauseCb = f;
  };

  return p;
};

}());
