window.arc = window.arc || {};

(function() {
'use strict';

arc.license = arc.license || {};

function paintConn(conn, data) {
  // painting connection info
  var key;
  for (key in data) {
    conn.find('#' + key).text(data[key] + ' ');
  }

  //painting days till expiration
  if (data.end_date !== undefined) {
    var expiry = moment(data.end_date);
    conn.find('#days_to').text(expiry.diff(moment.utc(), 'days') + ' ');
  }

  // painting alerts
  var $alert = $('#alert');
  if (data.error !== null) {
    if (data.error.type === 3) {
      if ($('#top-alert').prop('hidden')) {
        $('#top-warn').prop('hidden', false)
          .find('span').text(' ' + data.error.text);
      }
    } else {
      $('#top-warn').prop('hidden', true);
      if (data.error.type === 4) {
       $('#top-alert').prop('hidden', false)
        .find('span').text(' ' + data.error.text);
      } else {
        $('#top-alert').prop('hidden', false);
      }
    }

    // adding field specific alert
    var new_alert = $alert.clone(true);
    new_alert.find('span').text(' ' + data.error.text);
    new_alert.prop('hidden', false);
    if (data.error.type === 0) {
      conn.find('#conn_name').append(new_alert[0]);
    } else if (data.error.type === 1) {
      conn.find('#days_to').append(new_alert[0]);
      $('#top-alert').prop('hidden', false);
    } else if (data.error.type === 2) {
      conn.find('#num_nodes').append(new_alert[0]);
      $('#top-alert').prop('hidden', false);
    }
  }
}

arc.license.paint = function (data) {
  var i;
  var $conn_div = $('#arc-conn');
  var $conn_list = $('#conn-list');
  for (i = 0; i < data.length; i++) {
    if (data[i].conn_name === '__arcadia_ui_') {
      var $arcviz  = $('#arc-arcviz');
      $arcviz.show();
      paintConn($arcviz, data[i]);
    } else {
      var new_conn = $conn_div.clone(true);
      new_conn.attr('id', 'arc-conn-' + i)
              .removeAttr('hidden');
      $conn_list.append(new_conn[0]);
      paintConn($('#arc-conn-' + i), data[i]);
    }
  }
};

arc.license.setup = function () {
  // set apply_button_press to true to show success message
  $('#import-license')
    .off('click')
    .on('click', function() {
      arc.misc.localStorage().setItem('apply_button_press', true);
    });
};

arc.license.alertSetup = function (license) {
  const $footer = $('#footer-banner');
  $footer.find('.banner-close-btn')
      .off('click.close_banner')
      .on('click.close_banner', function() {
        $('#footer-banner').fadeOut();
    });

  if (license.status === 2) {
    $('#license-alert').show()
                       .find('span').text(license.msg);
    $('#license-alert-sign').show();
    $footer
      .removeClass('banner-license-warning')
      .addClass('banner-license-expired')
      .find('span').text(license.msg);
    $('#footer-banner').show();
  } else if (license.status === 1) {
    $('#license-warn').show()
                      .find('span').text(license.msg);
    $('#license-warn-sign').show();
    var url_split = window.location.href.split('/');
    if (['home', 'apps', 'data'].indexOf(url_split[url_split.length - 1].split('?')[0]) >= 0) {
      $footer
        .removeClass('banner-license-expired')
        .addClass('banner-license-warning')
        .find('span').text(license.msg);
      $footer.show();
    }
  } else if (license.status === 0) {
    const ls = arc.misc.localStorage();
    if (ls.getItem('apply_button_press') === 'true') {
      ls.setItem('apply_button_press', false);
      arc.report.alertMessageSmall('License file has been applied successfully', 'alert-success');
    }
  }
};

}());
