window.arc = window.arc || {};

(function() {
'use strict';

arc.site = arc.site || {};
arc.site.settings = arc.site.settings || {};

arc.site.settings.defaultGroupMembershipForNewUsers = function() {
  return arc.visual.setting()
            .id('default_group_membership_for_new_users')
            .tab('RBAC Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('DEFAULT_GROUP')
            .add_label('Default group membership for new users')
            .info('When users login to the system for the first time, ' +
                'they get added into the groups specified here. ' +
                'Multiple groups can be specified, separated by commas.')
            .value('');
};

arc.site.settings.advancedSettings = function() {
  return arc.visual.setting()
            .id('advanced_settings')
            .tab('Advanced Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('ADVANCED_SETTINGS')
            .add_label('Use key=value lines below to override default configuration settings')
            .is_textarea(true)
            .value('');
};

arc.site.settings.inspectSettingsEnabled = function() {
  return arc.visual.setting()
            .id('inspect_settings_enabled')
            .tab('Logs and Usage')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('INSPECT_SETTINGS_ENABLED')
            .add_label('Enable the "Server Settings" tab within the "Logs and Usage" page')
            .value('false');
};

arc.site.settings.pageProfileEnabled = function() {
  return arc.visual.setting()
            .id('page_profile_enabled')
            .tab('Debugging')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('PAGE_PROFILE_ENABLED')
            .add_label('Enable the "Show Usage Info" and Ctrl-Shift-G shortcut to view ' +
                'page profiles within all pages')
            .value('true');
};

arc.site.settings.pageProfileAppviewEnabled = function() {
  return arc.visual.setting()
            .id('page_profile_appview_enabled')
            .tab('Debugging')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('PAGE_PROFILE_APPVIEW_ENABLED')
            .add_label('Additionally enable the Ctrl-Shift-G shortcut to view page profiles ' +
                'within dashboard/app view pages')
            .value('true');
};

arc.site.settings.enableScheduling = function() {
  return arc.visual.setting()
            .id('scheduling_enabled')
            .tab('Jobs')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SCHEDULING_ENABLED')
            .info('Requires Visualization Server restart for changes to take effect.')
            .add_label('Enable scheduled jobs')
            .value('true');
};

arc.site.settings.bulkMaxEntries = function() {
  return arc.visual.setting()
            .id('bulk_max_entries')
            .tab('Job logs')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('BULK_MAX_JOBLOGS_ENTRIES')
            .add_label('Maximum Entries')
            .infoblock('The number of job logs kept after bulk process.')
            .value('10000');
};

arc.site.settings.bulkMaxInterval = function() {
  return arc.visual.setting()
            .id('bulk_max_interval')
            .tab('Job logs')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('BULK_MAX_JOBLOGS_INTERVAL')
            .add_label('Check Interval')
            .infoblock('The number of days between log deletion checks.')
            .value('7');
};

arc.site.settings.bulkMaxRetention = function() {
  return arc.visual.setting()
            .id('bulk_max_retention')
            .tab('Job logs')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('BULK_MAX_JOBLOGS_RETENTION')
            .add_label('Maximum Retention Days')
            .infoblock('The maximum lifetime for the job logs in days.')
            .value('365');
};

arc.site.settings.unnamedVersionDeletionInterval = function() {
  return arc.visual.setting()
            .id('unnamedVersionDeletionInterval')
            .tab('Version Control')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('UNNAMED_VERSION_DELETION_INTERVAL')
            .add_label('Unnamed Dataset Version Deletion Interval')
            .infoblock('The number of days before unnamed datasets get deleted.')
            .value('7');
};

arc.site.settings.unnamedVersionMaxRetention = function() {
  return arc.visual.setting()
            .id('unnamedVersionMaxRetention')
            .tab('Version Control')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('UNNAMED_VERSION_DMAX_RETENTION')
            .add_label('Unnamed Dataset Version Maximum Retention Days')
            .infoblock('The maximum lifetime for an unnamed dataset versions in days.')
            .value('30');
};

arc.site.settings.accessTrackerEnabled = function() {
  return arc.visual.setting()
            .id('access_tracker_enabled')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ACCESS_TRACKER_ENABLED')
            .add_label('Enable dashboard/application access tracking')
            .value('false');
};

arc.site.settings.accessTrackerURL = function() {
  return arc.visual.setting()
            .id('access_tracker_url')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('ACCESS_TRACKER_URL')
            .add_label('Access tracker URL')
            .value('');
};

arc.site.settings.accessTrackerUser = function() {
  return arc.visual.setting()
            .id('access_tracker_user')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('ACCESS_TRACKER_USER')
            .add_label('Access tracker user')
            .value('');
};

arc.site.settings.accessTrackerPassword = function() {
  return arc.visual.setting()
            .id('access_tracker_password')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.PASSWORD)
            .add_name('ACCESS_TRACKER_PASSWORD')
            .add_label('Access tracker password');
};

arc.site.settings.accessTrackerSourceSystemId = function() {
  return arc.visual.setting()
            .id('access_tracker_source_id')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('ACCESS_TRACKER_SOURCE_ID')
            .add_label('Access tracker Source ID')
            .value('');
};

arc.site.settings.accessTrackerSourceSystemURL = function() {
  return arc.visual.setting()
            .id('access_tracker_source_url')
            .tab('Access Tracker')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('ACCESS_TRACKER_SOURCE_URL')
            .add_label('Access tracker Source URL')
            .value('');
};

arc.site.settings.jiraEnabled = function() {
  return arc.visual.setting()
            .id('jira_enabled')
            .tab('JIRA Settings')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('JIRA_ENABLED')
            .add_label('Allow users to interact with a JIRA system')
            .value('false');
};

arc.site.settings.jiraServer = function() {
  return arc.visual.setting()
            .id('jira_server')
            .tab('JIRA Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('JIRA_SERVER')
            .add_label('JIRA Server URL')
            .value('');
};

arc.site.settings.jiraUser = function() {
  return arc.visual.setting()
            .id('jira_user')
            .tab('JIRA Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('JIRA_USER')
            .add_label('JIRA User')
            .value('');
};

arc.site.settings.jiraPassword = function() {
  return arc.visual.setting()
            .id('jira_password')
            .tab('JIRA Settings')
            .type(arc.visual.settingTypeEnum.PASSWORD)
            .add_name('JIRA_PASSWORD')
            .add_label('JIRA Password');
};

arc.site.settings.newIssueDefaults = function() {
  return arc.visual.setting()
            .id('jira_newissue_defaults')
            .tab('JIRA Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('JIRA_NEWISSUE_DEFAULTS')
            .add_label('JSON string with default values for new issues')
            .is_textarea(true)
            .value('');
};

arc.site.settings.webhookEnabled = function() {
  return arc.visual.setting()
            .id('webhook_enabled')
            .tab('Webhook Settings')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('WEBHOOK_ENABLED')
            .add_label('Allow users to interact with webhooks')
            .value('false');
};

const multipleValuesMessage = 'Multiple values should be separated by a new line.';

arc.site.settings.webhookWhitelist = function() {
  return arc.visual.setting()
            .id('webhook_whitelist')
            .tab('Webhook Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('WEBHOOK_WHITELIST')
            .add_label('Whitelist of URLs that webhook actions are permitted to interact with')
            .infoblock(multipleValuesMessage)
            .is_textarea(true)
            .value('');
};

arc.site.settings.remoteDataURLWhitelist = function() {
  return arc.visual.setting()
            .id('remotedata_url_whitelist')
            .tab('Remote Data Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('REMOTEDATA_URL_WHITELIST')
            .add_label('Whitelist of URLs that remote data columns can be fetched from')
            .infoblock(`The url used in cviz_rest functions need be be added here.
              ${multipleValuesMessage}`)
            .is_textarea(true)
            .value('');
};

arc.site.settings.email_enabled = function() {
  return arc.visual.setting()
            .id('email_enabled')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('EMAIL_ENABLED')
            .add_label('Permit emails')
            .info('This setting is required to allow users to email visuals and receive job and extract refresh status messages.')
            .value('false');
};

arc.site.settings.email_prefix = function() {
  return arc.visual.setting()
  .id('email_prefix')
  .tab('Email Settings')
  .type(arc.visual.settingTypeEnum.STRING)
  .add_name('EMAIL_PREFIX')
  .add_label('Default email subject prefix')
  .value(arc.globals.email_prefix);
};

arc.site.settings.email_protocol = function() {
  return arc.visual.setting()
  .id('email_protocol')
  .tab('Email Settings')
  .type(arc.visual.settingTypeEnum.RADIO)
  .group('Email protocol: ')
  .add_name('EMAIL_USE_SSL')
  .add_label('SSL')
  .add_name('EMAIL_USE_TLS')
  .add_label('TLS')
  .add_name('NEITHER')
  .add_label('None')
  .value('EMAIL_USE_TLS');
};

arc.site.settings.email_host_password = function() {
  return arc.visual.setting()
            .id('email_host_password')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.PASSWORD)
            .add_name('EMAIL_HOST_PASSWORD')
            .add_label('Password');
};

arc.site.settings.email_host_user = function() {
  return arc.visual.setting()
            .id('email_host_user')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('EMAIL_HOST_USER')
            .add_label('Email Address')
            .value('');
};

arc.site.settings.email_username = function() {
  return arc.visual.setting()
            .id('email_username')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('EMAIL_USERNAME')
            .infoblock('Optional: Defaults to email address if empty')
            .add_label('Username')
            .value('');
};

arc.site.settings.email_host = function() {
  return arc.visual.setting()
            .id('email_host')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('EMAIL_HOST')
            .add_label('SMTP Host')
            .placeholder('eg: smtp.gmail.com')
            .value('');
};

arc.site.settings.email_port = function() {
  return arc.visual.setting()
            .id('email_port')
            .tab('Email Settings')
            .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
            .add_name('EMAIL_PORT')
            .add_label('Port')
            .placeholder('eg: 587')
            .value('');
};

arc.site.settings.dashboard_width = function() {
  return arc.visual.setting()
            .id('dashboard_width')
            .tab('Dashboards')
            .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
            .add_name('DASHBOARD_WIDTH')
            .add_label('Default Dashboard Width')
            .add_class('d-flex align-items-center')
            .infoblock('Clear field for full width.')
            .value('1400');
};

arc.site.settings.dashboard_loading_message_in_viewmode = function() {
  return arc.visual.setting()
            .id('dashboard_loading_message_in_viewmode')
            .tab('Dashboards')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SHOW_LOADING_DATA_MESSAGE_IN_VIEW_MODE')
            .add_label('Show "This dashboard is still loading data" in view mode')
            .value('true');
};

arc.site.settings.hideRefreshButtonFromConnectionExplorer = function() {
  return arc.visual.setting()
            .id('site_hide_refresh_button_from_connection_explorer')
            .tab('Connection Explorer')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('HIDE_REFRESH_BUTTON_FROM_CONNECTION_EXPLORER')
            .add_label('Hide "Refresh" button from Connection Explorer')
            .value('false');
};

arc.site.settings.enableColumnRename = function() {
  return arc.visual.setting()
            .id('site_enable_column_rename')
            .tab('Dataset Creation')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_COLUMN_RENAME')
            .add_label('Enable automatic field renaming during dataset creation')
            .value('false');
};

arc.site.settings.enableCustomStyles = function() {
  return arc.visual.setting()
            .id('site_enable_custom_styles')
            .tab('Features')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_CUSTOM_STYLES')
            .add_label('Enable Custom Styles')
            .value('true');
};

arc.site.settings.enableDownloadFromURL = function() {
  return arc.visual.setting()
            .id('site_enable_download_from_url')
            .tab('Features')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_DOWNLOAD_FROM_URL')
            .add_label('Enable Data Downloads from URL')
            .value('true');
};

arc.site.settings.enableExploreInterfaces = function() {
  return arc.visual.setting()
            .id('site_enable_explore_interfaces')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_EXPLORE_INTERFACES')
            .add_label('Enable Explore')
            .value('true');
};

arc.site.settings.enableVisualTransitions = function() {
  return arc.visual.setting()
            .id('site_enable_visual_transitions')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_VISUAL_TRANSITIONS')
            .add_label('Enable Visual Transitions')
            .value('false');
};

arc.site.settings.maxTrellisDisplayed = function() {
  return arc.visual.setting()
            .id('site_max_trellis_displayed')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MAX_TRELLIS_DISPLAYED')
            .add_label('Max Count Of Trellises To Be Displayed Before Warning')
            .value(17);
};

arc.site.settings.enableDerivedData = function() {
  return arc.visual.setting()
            .id('site_enable_derived_data')
            .tab('Features')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_DERIVED_DATA')
            .add_label('Enable Derived Data')
            .value('true');
};

arc.site.settings.enableThumbnails = function() {
  return arc.visual.setting()
            .id('site_thumbnails_enable')
            .tab('Snapshots')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_THUMBNAILS')
            .add_label('Enable snapshots (required for thumbnails, email, and image downloads)')
            .value('false');
};

arc.site.settings.allowPNGDownloadDefault = function() {
  return arc.visual.setting()
            .id('site_png_download_on')
            .tab('Snapshots')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_SNAPSHOT')
            .add_label('Enable "Download as Image/PDF" by default')
            .value('false');
};

arc.site.settings.thumbnails_ip = function() {
  return arc.visual.setting()
            .id('site_thumbnails_ip')
            .tab('Snapshots')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('IP/Hostname to use to connect back to the server')
            .value('http://127.0.0.1');
};

arc.site.settings.docLinkText = function() {
  return arc.visual.setting()
            .id('doc_link_text')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Text to display for documentation link')
            .value(arc.frontend.globals.documentation.label);
};

arc.site.settings.docLinkURL = function() {
  return arc.visual.setting()
            .id('doc_link_url')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('URL for documentation link')
            .value(arc.frontend.globals.documentation.url);
};

arc.site.settings.supportOption = function() {
  return arc.visual.setting()
            .id('support_option')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.RADIO)
            .group('Show Support: ')
            .add_name('web_page')
            .add_label('web page link')
            .add_name('email')
            .add_label('email address')
            .value('web_page');
};

arc.site.settings.supportWebPageLinkText = function() {
  return arc.visual.setting()
            .id('support_web_page_link_text')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Text to display for Support web page link')
            .value(arc.frontend.globals.supportWebPageLabel);
};

arc.site.settings.supportWebPageLinkURL = function() {
  return arc.visual.setting()
            .id('support_web_page_link_url')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('URL for Support web page link')
            .value(arc.frontend.globals.supportWebPageUrl);
};

arc.site.settings.supportEmail = function() {
  return arc.visual.setting()
            .id('support_email')
            .tab('Help Menu')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Email address for Support')
            .value(arc.frontend.globals.supportEmail);
};

arc.site.settings.googleMapsApiKey = function() {
  return arc.visual.setting()
            .id('google_api_id')
            .tab('Interactive Map Visual Keys and Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Google API Id')
            .value('');
};

arc.site.settings.googleMapsClientKey = function() {
  return arc.visual.setting()
            .id('google_client_id')
            .tab('Interactive Map Visual Keys and Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Google Client Id')
            .value('');
};

arc.site.settings.mapboxAccessToken = function() {
  return arc.visual.setting()
            .id('mapbox_access_token')
            .tab('Interactive Map Visual Keys and Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Mapbox Token')
            .value('');
};

arc.site.settings.localMapboxServer = function() {
  return arc.visual.setting()
            .id('local_mapbox_server')
            .tab('Interactive Map Visual Keys and Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('IP/Hostname of Atlas Mapbox Server (optional)')
            .value('');
};

arc.site.settings.allowCSVDownloadDefault = function() {
  return arc.visual.setting()
            .id('site_csv_download_on')
            .tab('CSV Settings')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_CSV')
            .add_label('Enable "Download as CSV/Excel" by default')
            .value('true');
};

arc.site.settings.visualMaxDataResults = function() {
  const isLegacyConnectorEnabled = arc.globals.arcviz_settings.ENABLE_DATACONN_ARCENGINE ||
    arc.globals.arcviz_settings.ENABLE_DATACONN_IMPALA ||
    arc.globals.arcviz_settings.ENABLE_DATACONN_HIVE;

  const legacyMessage = isLegacyConnectorEnabled ? 'as well as LEGACY connection visuals and downloads ' : '';
  const impalaMessage = arc.globals.arcviz_settings.ENABLE_DATACONN_IMPYLA ? 'Impala, ' : '';
  const hiveMessage = arc.globals.arcviz_settings.ENABLE_DATACONN_HYVE ? 'Hive, ' : '';
  const setting = arc.visual.setting()
            .id('visual_max_dataresults')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Maximum data results size for visuals and downloads (in MB)')
            .infoblock(`${impalaMessage}${hiveMessage}SQLITE connection CSV/Excel downloads ${legacyMessage} are not limited by this size`)
            .value('10');

  return setting;
};

arc.site.settings.visualMaxRows = function() {
  return arc.visual.setting()
            .id('visual_maxrows')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Maximum data rows for visuals')
            .value('5000');
};

arc.site.settings.downloadMaxRows = function() {
  return arc.visual.setting()
            .id('download_maxrows')
            .tab('CSV Settings')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Maximum data rows for download requests')
            .value('10000');
};

arc.site.settings.usageAnalyticsExpirationDays = function() {
  return arc.visual.setting()
            .id('usage_analytics_expiration_days')
            .tab('Usage Analytics')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_label('Maximum days for expiring usage data')
            .value('60');
};

arc.site.settings.enableRemoteUserAuth = function() {
    return arc.visual.setting()
              .id('enable_remote_user_auth')
              .tab('Authentication')
              .type(arc.visual.settingTypeEnum.CHECKBOX)
              .add_name('ENABLE_REMOTE_USER_AUTH')
              .add_label('Permit authentication via the REMOTE_USER http header')
              .value('false');
};

arc.site.settings.minimumPasswordLength = function() {
    return arc.visual.setting()
              .id('min_pw_length')
              .tab('Authentication')
              .type(arc.visual.settingTypeEnum.INTEGER)
              .add_name('MIN_PASSWORD_LENGTH')
              .add_label('Minimum password length')
              .value('5');
};

arc.site.settings.passwordRequireNumber = function() {
    return arc.visual.setting()
              .id('pw_require_number')
              .tab('Authentication')
              .type(arc.visual.settingTypeEnum.CHECKBOX)
              .add_name('PASSWORD_REQUIRE_NUMBER')
              .add_label('Require that passwords contain one or more numbers ')
              .value('false');
};

arc.site.settings.passwordRequireSymbol = function() {
    return arc.visual.setting()
              .id('pw_require_symbol')
              .tab('Authentication')
              .type(arc.visual.settingTypeEnum.CHECKBOX)
              .add_name('PASSWORD_REQUIRE_SYMBOL')
              .add_label('Require that passwords contain one or more symbols ')
              .value('false');
};

arc.site.settings.maximumCanvasWidth = function() {
  return arc.visual.setting()
            .id('maximum_canvas_width')
            .tab('Visuals')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('MAXIMUM_CANVAS_WIDTH')
            .add_label('Maximum width of canvas visuals')
            .info('Defines the maximum width a canvas visual can be. ' +
              'If a canvas is too wide it can cause browsers to crash')
            .value('8000');
};

arc.site.settings.enableJSErrorReporting = function() {
  return arc.visual.setting()
            .id('jserrors_enabled')
            .tab('Debugging')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('JSERRORS_ENABLED')
            .add_label('Verbose Error Reporting. Display Javascript page ' +
                'errors on screen in app view/edit pages')
            .value('true');
};

arc.site.settings.loginInstructions = function() {
  return arc.visual.setting()
              .id('login_instructions')
              .tab('Login Page')
              .type(arc.visual.settingTypeEnum.STRING)
              .add_name('LOGIN_INSTRUCTIONS')
              .add_label('Instructions to display on login page')
              .is_textarea(true)
              .value('');
};

arc.site.siteSettings = function(encryptionSupported, thumbnailSupported) {
  const settings = function() { return 'arc.site.settings'; };

  const userSettings = arc.visual.settings();

  const hasDependents = [];
  arc.frontend.featureFlipper.getAll().forEach((flipper) => {
    if (flipper.level === 'DB') {
      const ffSetting =
        arc.visual.setting()
          .id(flipper.id)
          .tab(flipper.tab || 'Features')
          .type(arc.visual.settingTypeEnum.CHECKBOX)
          .add_name(flipper.id)
          .add_label(flipper.label)
          .info(flipper.info)
          .value(String(flipper.value))
          .level('DB')
          .is_flipper(true);

      if (flipper.dependents) {
        hasDependents.push({
          ffSetting,
          dependents: flipper.dependents,
        });
      }

      userSettings.addSetting(ffSetting);
    }
  });

  hasDependents.forEach(({ ffSetting, dependents }) => {
    const dependentSettings = dependents.map((settingId) => userSettings.find_by_id(settingId));
    ffSetting.addDependents(dependentSettings);
  });

  const hideRefreshButton = arc.site.settings.hideRefreshButtonFromConnectionExplorer();
  const enableColumnRename = arc.site.settings.enableColumnRename();
  const enableCustomStyles = arc.site.settings.enableCustomStyles();
  const dashboardWidth = arc.site.settings.dashboard_width();
  const showMessageInViewMode = arc.site.settings.dashboard_loading_message_in_viewmode();
  const enableExploreInterfaces = arc.site.settings.enableExploreInterfaces();
  const enableVisualTransitions = arc.site.settings.enableVisualTransitions();
  const maxTrellisDisplayed = arc.site.settings.maxTrellisDisplayed();
  const enableDerivedData = arc.site.settings.enableDerivedData();
  const enableThumbnails = arc.site.settings.enableThumbnails();
  const alwaysPNG = arc.site.settings.allowPNGDownloadDefault();
  const alwaysCSV = arc.site.settings.allowCSVDownloadDefault();

  const usageAnalyticsExpirationDays = arc.site.settings.usageAnalyticsExpirationDays()
  .add_postpaint_fn(() => {
    const $div = $(`#${usageAnalyticsExpirationDays.div_id()}`);
    const $deleteButton = $('<button>').addClass('deletebutton');
    const $status = $('<div class="alert arc-invisible" role="alert" style="margin-top:5px">');
    $deleteButton.text('Delete Usage Data')
               .addClass('btn btn-secondary')
               .css('margin-top', 10)
               .css('margin-bottom', 10)
               .attr('data-test-id', 'delete-usage-data');
    $div.append($deleteButton);
    $div.append($status);
    $deleteButton.on('click', () => {
      deleteUsageData($status);
    });
  });

  const visualMaxDataResults = arc.site.settings.visualMaxDataResults();
  const visualMaxRows = arc.site.settings.visualMaxRows();
  const maxCanvasWidth = arc.site.settings.maximumCanvasWidth();
  const download_maxrows = arc.site.settings.downloadMaxRows();
  const thumbnailsIp = arc.site.settings.thumbnails_ip();
  const docLinkText = arc.site.settings.docLinkText();
  const docLinkURL = arc.site.settings.docLinkURL();
  const supportOption = arc.site.settings.supportOption();
  const supportWebPageLinkText = arc.site.settings.supportWebPageLinkText();
  const supportWebPageLinkURL = arc.site.settings.supportWebPageLinkURL();
  const supportEmail = arc.site.settings.supportEmail();
  const enableScheduling = arc.site.settings.enableScheduling();
  const bulkMaxEntries = arc.site.settings.bulkMaxEntries();
  const bulkMaxInterval = arc.site.settings.bulkMaxInterval();
  const bulkMaxRetention = arc.site.settings.bulkMaxRetention();
  const email_host_user = arc.site.settings.email_host_user();
  const email_username = arc.site.settings.email_username();
  const email_host_password = arc.site.settings.email_host_password();
  const email_host = arc.site.settings.email_host();
  const email_port = arc.site.settings.email_port();
  const email_protocol = arc.site.settings.email_protocol();
  const email_enabled = arc.site.settings.email_enabled();
  const email_prefix = arc.site.settings.email_prefix().add_postpaint_fn(() => {
    const $div = $(`#${email_prefix.div_id()}`);
    const $testButton = $('<button>').addClass('testbutton');
    const $status = $('<div class="alert arc-invisible" role="alert" style="margin-top:5px">');
    $testButton.text('Send Test Email')
               .addClass('btn btn-secondary')
               .css('margin-top', 10)
               .css('margin-bottom', 10)
               .attr('data-test-id', 'send-test-email');
    $div.append($testButton);
    $div.append($status);
    $testButton.on('click', () => {
      testEmailSettings(true, $status);
    });
  });
  const unnamedVersionDeletionInterval = arc.site.settings.unnamedVersionDeletionInterval();
  const unnamedVersionMaxRetention = arc.site.settings.unnamedVersionMaxRetention();
  const jserrors_enabled = arc.site.settings.enableJSErrorReporting();
  const login_instructions = arc.site.settings.loginInstructions();

  const jiraEnabled = arc.site.settings.jiraEnabled();
  const jiraServer = arc.site.settings.jiraServer();
  const jiraUser = arc.site.settings.jiraUser();
  const jiraPassword = arc.site.settings.jiraPassword();
  const jiraNewIssueDefaults = arc.site.settings.newIssueDefaults();

  const googleMapsApiKey = arc.site.settings.googleMapsApiKey();
  const googleMapsClientKey = arc.site.settings.googleMapsClientKey();
  const mapboxAccessToken = arc.site.settings.mapboxAccessToken();
  const localMapboxServer = arc.site.settings.localMapboxServer();
  const minimumPasswordLength = arc.site.settings.minimumPasswordLength();
  const passwordRequireNumber = arc.site.settings.passwordRequireNumber();
  const passwordRequireSymbol = arc.site.settings.passwordRequireSymbol();

  const inspectSettingsEnabled = arc.site.settings.inspectSettingsEnabled();

  const supportAndDocOptions = arc.frontend.featureFlipper.getValueById('enable_explore_style') ? [] :
    [
      docLinkText,
      docLinkURL,
      supportOption,
      supportWebPageLinkText,
      supportWebPageLinkURL,
      supportEmail,
    ];
  const emailSettings = arc.frontend.featureFlipper.getValueById('enable_jobs') ?
    [
      email_enabled,
      email_host_user,
      email_username,
      email_host_password,
      email_host,
      email_port,
      email_protocol,
      email_prefix,
    ] : [];
  userSettings
                           .addSetting([
                             hideRefreshButton,
                             enableColumnRename,
                             enableDerivedData,
                             enableCustomStyles,
                             arc.site.settings.enableDownloadFromURL(),
                             dashboardWidth,
                             showMessageInViewMode,
                             enableExploreInterfaces,
                             enableVisualTransitions,
                             maxTrellisDisplayed,
                             enableThumbnails,
                             thumbnailsIp,
                             alwaysPNG,
                             alwaysCSV,
                             usageAnalyticsExpirationDays,
                             visualMaxDataResults,
                             visualMaxRows,
                             maxCanvasWidth,
                             download_maxrows,
                             ...supportAndDocOptions,
                             googleMapsApiKey,
                             googleMapsClientKey,
                             mapboxAccessToken,
                             localMapboxServer,
                             ...emailSettings,
                             arc.site.settings.enableRemoteUserAuth(),
                             minimumPasswordLength,
                             arc.site.settings.defaultGroupMembershipForNewUsers(),
                             passwordRequireNumber,
                             passwordRequireSymbol,
                             login_instructions,
                             inspectSettingsEnabled,
                             jserrors_enabled,
                             arc.site.settings.pageProfileEnabled(),
                             arc.site.settings.pageProfileAppviewEnabled(),
                             bulkMaxEntries,
                             bulkMaxInterval,
                             bulkMaxRetention,
                             unnamedVersionDeletionInterval,
                             unnamedVersionMaxRetention,
    ]);

  if (arc.frontend.featureFlipper.getValueById('enable_jobs')) {
    userSettings.addSetting([enableScheduling]);
  }

    if (arc.globals.arcviz_settings.ENABLE_VISUAL_ACTION) {
      if (arc.globals.arcviz_settings.ENABLE_JIRA) {
        userSettings.addSetting([
                       jiraEnabled,
                       jiraServer,
                       jiraUser,
                       jiraPassword,
                       jiraNewIssueDefaults,
                     ]);
      }

    if (arc.globals.arcviz_settings.ENABLE_WEBHOOK) {
      userSettings.addSetting([
                    arc.site.settings.webhookEnabled(),
                    arc.site.settings.webhookWhitelist(),
                  ]);
    }

    userSettings.addSetting([
                  arc.site.settings.remoteDataURLWhitelist(),
                ]);
  }

    if (arc.globals.cdvSubMode === 'C1C') {
      userSettings.addSetting([
        arc.site.settings.accessTrackerEnabled(),
        arc.site.settings.accessTrackerURL(),
        arc.site.settings.accessTrackerUser(),
        arc.site.settings.accessTrackerPassword(),
        arc.site.settings.accessTrackerSourceSystemId(),
        arc.site.settings.accessTrackerSourceSystemURL(),
      ]);
    }

  if (arc.globals.enable_advanced_settings) {
    userSettings.addSetting([arc.site.settings.advancedSettings()]);
  }

  let needsSave = {};

  settings.initialize = function($div) {
    d4.queue()
      .defer(d3.json, arc.frontend.globals.urls.siteSettingsUrl)
      .await((error, _in_settings) => {
        if (error) {
          arc.report.alertMessage('Failed to fetch settings');
          return;
        }

        const settings_h = {};
        _in_settings.forEach((s) => {
          settings_h[s.setting_key] = s.setting_value;
        });

        userSettings.settings().forEach((setting) => {
          if (setting.id() in settings_h && !setting.is_flipper()) {
            setting.value(settings_h[setting.id()]);
          }
        });

        userSettings.paint({
          default: $div,
        });

        function ifPasswordChanged(setting) {
          const isNotPassword = setting.type() !== arc.visual.settingTypeEnum.PASSWORD;
          const isNotBlank = setting.value() !== undefined;
          return isNotPassword || isNotBlank;
        }

        function markNeedsSave(name) {
          arc.report.pagenav.needs_save(true);
          $('.save-btn').addClass('app-btn-highlight');
          needsSave[name] = true;
        }

        userSettings.settings().forEach((setting) => {
          setting.changeCb('site', () => {
            setting.process_value();
            if (ifPasswordChanged(setting)) {
              markNeedsSave(setting.id());
            }

            // Setup for adding error alerts
            const $settingDiv = $(`#${setting.div_id()}`);
            let $status = $settingDiv.find('.alert');
            const $input = $settingDiv.find('input');
            if (!$status.length) {
              $status = $('<div class="alert arc-invisible" role="alert" style="margin-top:5px">');
            } else {
              $status.addClass('arc-invisible');
              $status.removeClass('alert-danger');
              $status.text('');
            }

            function unveilAlert() {
              $status.removeClass('arc-invisible');
              $status.addClass('alert-danger');
              $settingDiv.append($status);
              $('.page-header a.save-btn').removeClass('app-btn-highlight');
            }

            // special callback for enabling visual email, saving password,
            // and enabling thumbnails
            const requiresThumbnail = setting.id() === 'site_thumbnails_enable' ||
                                    setting.id() === 'site_png_download_on';

            if (setting.id() === 'email_enabled' && setting.isChecked) {
              $settingDiv.append($status);
              testEmailSettings(false, $status, $input);
            } else if ((setting.id() === 'email_host_password' ||
                        (setting.id() === 'jira_password')) &&
                       encryptionSupported === 'False') {
               $status.text('Encryption is not supported due to missing dependencies. ' +
                            'Please see Documentation.');
               setting.value('<placeholder>');
               $input.val('<placeholder>');
               unveilAlert();
            } else if (requiresThumbnail && setting.isChecked &&
                       thumbnailSupported === 'False') {
              $status.text('Snapshots are not supported due to missing dependencies. ' +
                           'Please see Documentation.');
              setting.value('false');
              $input.prop('checked', false);
              unveilAlert();
            } else if (setting.id() === 'min_pw_length') {
              if (parseInt(setting.value(), 10) < 5) {
                $status.text('Minimum password length must be at least five.');
                unveilAlert();
              }
            } else if (setting.id() === 'visual_max_dataresults') {
              if (!$.isNumeric(setting.value())) {
                $status.text('Visual max data results size must be numeric');
                unveilAlert();
              } else {
                const m = parseInt(setting.value(), 10);

                // At least 10 MB and at most 10G
                if ((m < 10) || (m > 10000)) {
                  $status.text('Visual max data results size must be between 10M and 10G');
                  unveilAlert();
                }
              }
            } else if (setting.id() === 'visual_maxrows') {
              if (!$.isNumeric(setting.value()) || (parseInt(setting.value(), 10) < 5000)) {
                $status.text('Visual row limit must be valid number >= 5000');
                unveilAlert();
              }
            } else if (setting.id() === 'download_maxrows') {
              if (!$.isNumeric(setting.value()) || (parseInt(setting.value(), 10) < 10000)) {
                $status.text('Download row limit must be valid number >= 10000');
                unveilAlert();
              }
            }
          });
        });

        $('#site-save-btn').offOn('click.siteSave', () => {
          const data = [];
          const flippers = [];
          let needsReload = false;
          const fieldsForReload = ['min_pw_length', 'pw_require_symbol', 'pw_require_number'];
          userSettings.settings().forEach((setting) => {
            if (setting.id() in needsSave && ifPasswordChanged(setting)) {
              if (setting.is_flipper()) {
                flippers.push({
                  id: setting.id(),
                  label: setting.labels()[0],
                  value: setting.value(),
                  level: setting.level(),
                  info: setting.info()
                });
              } else {
                data.push({
                  setting_key: setting.id(),
                  setting_value: setting.value(),
                  setting_read_admin_only: 0
                });
              }

              if (setting.id() === 'doc_link_text') {
                $('#docs-link').text(setting.value());
              }

              if (setting.id() === 'doc_link_url') {
                $('#docs-link').attr('href', setting.value());
              }

              if (setting.id() === 'support_web_page_link_text') {
                $('#support-web-page-link').text(setting.value());
              }

              if (setting.id() === 'support_web_page_link_url') {
                $('#support-web-page-link').attr('href', setting.value());
              }

              if (setting.id() === 'support_email' && supportOption.value() === 'email' &&
                    arc.globals.arcviz_settings.HELP_SHOW_SUPPORT_EMAIL) {
                const emailHyperlink = $('#support-email');
                emailHyperlink.find('span').text(setting.value());
                const hrefA = emailHyperlink.attr('href').split('?');
                const hrefString = `mailto:${setting.value()}?${hrefA[hrefA.length - 1]}`;
                emailHyperlink.attr('href', hrefString);
              }

              if (fieldsForReload.includes(setting.id())) {
                needsReload = true;
              }
            }
          });
          settings.save({ settings: data, flippers }, () => {
            needsSave = {};
            arc.report.pagenav.needs_save(false);
            $('.save-btn').removeClass('app-btn-highlight');
            if (needsReload) {
              window.location.reload();
            }
          });
        });
      });

    return settings;
  };

  settings.save = function(data, done_cb) {
    const post_data = {
      csrfmiddlewaretoken: arc.globals.csrf_token,
      data: JSON.stringify(data)
    };
    const url = arc.frontend.globals.urls.siteSettingsUrl;

    // save event
    $.ajax({
      url,
      data: post_data,
      type: 'POST',
      beforeSend(xhr) {
        // Because of a jquery bug when handling PUT requests,
        // we have to explicitly set X-CSRFToken here
        xhr.setRequestHeader('X-CSRFToken', arc.globals.csrf_token);
      }
    })
    .fail((req) => {
      arc.report.alertMessage('Failed to update settings',
          req.responseText ? req.responseText : req);
    })
    .done(() => {
      arc.report.alertMessageSmall('Settings successfully saved', 'alert-success');
    })
    .always(() => {
      if (done_cb) {
        done_cb();
      }
    });

    return settings;
  };

  return settings;

  // Helper Functions
  function deleteUsageData($status) {
    const modal = arc.misc.deleteConfirmation();
    modal.objectType('The Usage Data')
     .askUser(() => {
        modal.hideModal();

        $status.addClass('arc-invisible');

        $.ajax({
          url: arc.frontend.globals.urls.deleteUsageDatabaseUrl,
          type: 'DELETE',
          beforeSend(xhr) {
            // Because of a jquery bug when handling PUT requests,
            // we have to explicitly set X-CSRFToken here
            xhr.setRequestHeader('X-CSRFToken', arc.globals.csrf_token);
          },
        })
        .done(() => {
          $status.removeClass('arc-invisible');
          $status.removeClass('alert-danger');
          $status.addClass('alert-success');
          $status.text('The usage data was successfully deleted');
        })
        .fail(() => {
          $status.removeClass('arc-invisible');
          $status.removeClass('alert-success');
          $status.addClass('alert-danger');
          $status.text('Could not delete the usage data');
        });
     });
  }

  function testEmailSettings(isEvent, $status, $input) {
    $status.addClass('arc-invisible');
    const thumbnailsNotSupported = thumbnailSupported === 'False';
    const encryptionNotSupported = encryptionSupported === 'False';
    const params = {
      EMAIL_HOST: email_host,
      EMAIL_PORT: email_port,
      EMAIL_HOST_USER: email_host_user,
      EMAIL_HOST_PASSWORD: email_host_password,
      EMAIL_PROTOCOL: email_protocol
    };
    const missingParams = [];
    let currentSetting;
    let currentValue;
    Object.keys(params).forEach((setting) => {
      currentSetting = params[setting];
      currentValue = currentSetting.value();
      if (setting !== 'EMAIL_HOST_PASSWORD' && currentValue === '') {
        missingParams.push(currentSetting.labels()[0]);
      }

      params[setting] = currentValue;
    });

    if (missingParams.length || thumbnailsNotSupported || encryptionNotSupported) {
      $status.removeClass('arc-invisible alert-success');
      $status.addClass('alert-danger');
      if (!isEvent) {
        $input.prop('checked', false);
        email_enabled.value(false);
      }

      $status.empty();

      if (missingParams.length) {
        $status.append(`Need to fill out ${missingParams.join(', ')}`);
      }

      if (thumbnailsNotSupported) {
        $status.append('Snapshots are not supported due to missing dependencies. ' +
                       'Please see Documentation.');
      }

      if (encryptionNotSupported) {
        $status.append('Encryption is not enabled due to missing dependencies. ' +
                       'Please see Documentation.');
      }

      return;
    }

    $status.addClass('arc-invisible');

    if (!isEvent) {
      return;
    }

    params.email_username = email_username.value();
    params.email_prefix = email_prefix.value();
    $.ajax({
      url: arc.frontend.globals.urls.emailTestUrl,
      data: params,
      type: 'POST',
      beforeSend(xhr) {
        // Because of a jquery bug when handling PUT requests,
        // we have to explicitly set X-CSRFToken here
        xhr.setRequestHeader('X-CSRFToken', arc.globals.csrf_token);
      },
    })
    .done((resp) => {
      $status.removeClass('arc-invisible');
      $status.removeClass('alert-danger');
      $status.addClass('alert-success');
      $status.text(resp);
    })
    .fail((resp) => {
      $status.removeClass('arc-invisible');
      $status.removeClass('alert-success');
      $status.addClass('alert-danger');
      if (resp.responseText) {
        // replace \n with colon
        $status.text(resp.responseText.replace(/\\n/g, ': '));
      } else {
        $status.text('Authentication failed');
      }
    });
  }
};
}());
