window.arc = window.arc || {};

(function() {
'use strict';

arc.topnav = arc.topnav || {};

let allSearchDatasets,
    initialSearchDatasets,
    currentDatasets;

arc.topnav.initialSearchDatasets = function(datasets) {
  initialSearchDatasets = datasets.slice(0);
};

arc.topnav.resetDatasets = function() {
  initialSearchDatasets = allSearchDatasets;
};

arc.topnav.setCurrentDatasets = function(datasets) {
  currentDatasets = datasets;
};

function fetchAll(cb) {
  if (allSearchDatasets) {
    if (cb) {
      cb();
    }

    return;
  }

  arc.search.utils.fetchAllDatasets(
      function(datasets) {
        allSearchDatasets = datasets.slice(0);
        if (cb) {
          cb();
        }
      },
      function(err) {
        console.log('Error fetching datasets', err);
      });
}

function createModal(dataset_ids, activeSearchDatasets, initialText) {
  if (dataset_ids) {
    const datasets_set = new Set(dataset_ids);
    activeSearchDatasets = allSearchDatasets
        .filter(function(d) {
          return datasets_set.has(d.dataset_id());
        });

    if (activeSearchDatasets.length === 0) {
      activeSearchDatasets = allSearchDatasets.slice(0);
    }
  } else if (!activeSearchDatasets) {
    activeSearchDatasets = allSearchDatasets.slice(0);
  }

  arc.search.modal()
     .text(initialText)
     .datasets(activeSearchDatasets)
     .activate();
}

arc.topnav.runModal = function(dataset_ids, activeSearchDatasets, initialText) {
  if (activeSearchDatasets) {
    createModal(undefined, activeSearchDatasets, initialText);
    return;
  }

  fetchAll(function() {
    createModal(dataset_ids, activeSearchDatasets, initialText);
  });
};

arc.topnav.setup = function() {
  $('.topmenu-search-link')
    .off('click')
    .on('click', function() {
      arc.topnav.runModal(undefined, currentDatasets || initialSearchDatasets);
    });

  handleSearchInUrl();
};

function getSearchVar() {
  const vars = {};
  const parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m, key, value) {
    vars[key] = decodeURIComponent(value);
  });

  return vars.search;
}

function handleSearchInUrl() {
  if (arc.screen.isAppsScreen) {
    const searchText = getSearchVar();
    if (searchText) {
      arc.topnav.runModal(undefined, currentDatasets || initialSearchDatasets, searchText);
    }
  }
}

})();
