window.arc = window.arc || {};

(function() {
'use strict';

arc.search = arc.search || {};

arc.search.inputWrapper = function() {
  const inputWrapper = function() { return 'arc.search.inputWrapper'; };

  let text = '';
  let datasets;
  let input;
  let searchCb;
  let keystrokeCb;
  let autoHighlights;
  let container;
  let $container;
  let $search;
  let searchCompiler;
  let searchHighlight;

  inputWrapper.searchCb = function(_) {
    if (!arguments.length) return searchCb;
    searchCb = _;
    return inputWrapper;
  };

  inputWrapper.keystrokeCb = function(_) {
    if (!arguments.length) return keystrokeCb;
    keystrokeCb = _;
    return inputWrapper;
  };

  inputWrapper.$container = function() {
    return $container;
  };

  inputWrapper.searchCompiler = function() {
    return searchCompiler;
  };

  inputWrapper.container = function(_) {
    if (!arguments.length) return container;
    container = _;
    $container = $(container);
    return inputWrapper;
  };

  inputWrapper.text = function(_) {
    if (!arguments.length) return text;
    text = _;
    if ($search) {
      $search.text(text || '');
    }

    return inputWrapper;
  };

  inputWrapper.autoHighlights = function(_) {
    if (!arguments.length) return autoHighlights;
    autoHighlights = _;
    return inputWrapper;
  };

  inputWrapper.datasets = function(_) {
    if (!arguments.length) return datasets;
    datasets = _;
    if (input) {
      input.datasets(datasets);
    }

    return inputWrapper;
  };

  inputWrapper.runSearch = function(textToSearch) {
    input.runSearch(textToSearch);
    return inputWrapper;
  };

  inputWrapper.input = function() {
    return input;
  };

  inputWrapper.shown = function() {
    $search.trigger('focus');
    if (text) {
      $search.text(text);
      input.runSearch(text);
    }
  };

  inputWrapper.setup = function() {
    $container = $(container);
    $search = $container.find('.pop-search-box');
    $search.text(text || '');

    searchCompiler = arc.search.searchCompiler();
    searchHighlight = arc.search.highlight()
                                .container(container);

    input = arc.search.input()
               .autoHighlights(autoHighlights)
               .autoSuggestContainer(container)
               .datasets(datasets)
               .$elem($search)
               .searchHighlight(searchHighlight)
               .searchCb(searchCb)
               .keystrokeCb(keystrokeCb);

    input.setup();

    if (datasets.length === 1) {
      searchCompiler.dataset(datasets[0])
                    .initialize();
    }

    searchHighlight.searchCompiler(searchCompiler);
    return inputWrapper;
  };

  return inputWrapper;
};
}());
