window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.bullet = arc.settings.bullet || {};

arc.settings.bullet.bulletBgColor = function() {
  var s = arc.visual.setting();

  s.id('bullet_bg_color')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_name('BULLETCHART_BG_COLOR')
   .add_label('Background Color')
   .value('black');

  return s;
};

arc.settings.bullet.bulletFgColor = function() {
  var s = arc.visual.setting();

  s.id('bullet_fg_color')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_name('BULLETCHART_FG_COLOR')
   .add_label('Foreground Color')
   .value('black');

  return s;
};

arc.settings.bullet.projectionOpacity = function() {
  var s = arc.visual.setting();

  s.id('projection_opacity')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .add_name('PROJECTION_OPACITY')
   .add_label('Projection Opacity')
   .min(0)
   .max(100)
   .step(2)
   .value('40');

  return s;
};

arc.settings.bullet.reverseColors = function() {
  return arc.visual.setting()
            .id('reverse_bullet_colors')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Reverse color gradient')
            .add_name('GRADIENT_REVERSE')
            .value('false');
};

arc.settings.bullet.scaleTrellisIndependently = function() {
  return arc.visual.setting()
            .id('scale_trellis_independently')
            .tab('Trellis')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Scale independently across trellis')
            .add_name('TRELLIS_INDEPENDENT_SCALE')
            .value('false');
};

arc.settings.bullet.orientVertically = function() {
  return arc.visual.setting()
            .id('bullet_vertical')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Orient bars vertically')
            .add_name('BULLET_VERTICAL')
            .value('false');
};

arc.settings.bullet.removeDefaultLabel = function() {
  return arc.visual.setting()
            .id('remove_default_label')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Remove default label')
            .add_name('DEFAULT_LABEL')
            .value('false');
};

arc.settings.bullet.approximateNumberOfTicks = function() {
  return arc.visual.setting()
            .id('approximate_tick_count')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_label('Approximate tick count')
            .add_name('APPROXIMATE_TICK_COUNT')
            .info('This represents an approximate number of ticks, not an exact number.' +
            ' Decrease value if tick labels overlap. Select -1 for default.')
            .min(-1)
            .max(20)
            .useAsDefault(-1)
            .value(-1);
};

})();

