window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.data = arc.settings.data || {};

arc.settings.data.maxrows_default = 5000;
arc.settings.data.maxrows = function() {
  var s = arc.visual.setting();

  s.id('max_rowcount')
   .tab('Data')
   .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
   .add_name('MAX_ROWCOUNT')
   .add_label('Maximum number of rows to fetch')
   .min(0)
   .max(10000000)
   .placeholder(arc.settings.data.maxrows_default)
   .value('');

  return s;
};

arc.settings.data.downloadRows = function() {
  return arc.visual.setting()
         .id('download_rows')
         .tab('Data')
         .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
         .add_name('DOWNLOAD_ROWS')
         .add_label('Number of rows downloaded during CSV/Excel export and Detailed Data')
         .value('');
};

arc.settings.data.disableIncrementalQueries = function() {
  return arc.visual.setting()
            .id('disable_incremental_queries')
            .tab('Data')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('DISABLE_INCREMENTAL_QUERIES')
            .add_label('Disable incremental queries, overriding ' +
                'dataset level setting')
            .value('false');
};

arc.settings.data.ksqlStreamPosition = function() {
  return arc.visual.setting()
            .id('ksql_stream_position')
            .tab('Data')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Stream Position')
            .add_name('default')
            .add_label('Default')
            .add_name('earliest')
            .add_label('Earliest')
            .add_name('latest')
            .add_label('Latest')
            .value('default');
};

}());
