window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.filters = arc.settings.filters || {};

arc.settings.filters.timezone = function() {
  const s = arc.visual.setting()
               .id('filter_timezone')
               .section('Basic')
               .tab('Basic')
               .type(arc.visual.settingTypeEnum.DROPDOWN_CHOSEN)
               .group('Time Zone')
               .add_name('UTC')
               .add_label('UTC')
               .info('Note that times in the source data are expected ' +
                     'to be stored in this timezone')
               .infoblock('Select "Permit selection of time zone" above ' +
                     'to enable')
               .value('UTC');

  moment.tz.names().forEach(function(n) {
    s.add_name(n)
     .add_label(n);
  });

  return s;
};

arc.settings.filters.datasetDisplay = function() {
  const datasetSetting = arc.visual.setting()
                                  .id('picklist_dataset')
                                  .tab('Values')
                                  .type(arc.visual.settingTypeEnum.DISPLAY_ONLY)
                                  .add_name('PICKLIST_DATASET')
                                  .add_label('Dataset:')
                                  .value('');

  datasetSetting.add_postpaint_fn((tab_d3_sel) => {
    const settingsId = tab_d3_sel.attr('id');
    const $settingD3 = $(`#${settingsId} .${datasetSetting.id()}`);
    const $switchIcon = $('#visual-data-panel .app-dataset-switch').clone(true);
    $settingD3.append($switchIcon);
  });
  return datasetSetting;
};

arc.settings.filters.filterColumns = function() {
  return arc.visual.setting()
            .id('picklist_filter_columns')
            .tab('Values')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('PICKLIST_FILTER_COLUMNS')
            .add_label('Filter Fields')
            .info('Specify a comma-separated list of columns here. Filters on these columns ' +
                'will apply to this visual.')
            .value('');
};

arc.settings.filters.baseField = function() {
  return arc.visual.setting()
            .id('picklist_base_field')
            .tab('Values')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('PICKLIST_BASE_FIELD')
            .add_label('From Base Field')
            .value('');
};

arc.settings.filters.title = function() {
  return arc.visual.setting()
            .id('picklist_title')
            .tab('Values')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('PICKLIST_TITLE')
            .add_label('Title')
            .value('');
};

arc.settings.filters.outputParameter = function() {
  return arc.visual.setting()
            .id('picklist_output_parameter')
            .tab('Values')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('PICKLIST_OUTPUT_PARAMETER')
            .add_label('Output Parameter')
            .value('');
};

}());
