window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.gauge = arc.settings.gauge || {};

arc.settings.gauge.labelVerticalOffset = function() {
  var s = arc.visual.setting();

  s.id('label_vertical_offset')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .add_label('Label Offset')
   .add_class('spinner-alignright')
   .min(-100)
   .max(+100)
   .step(2)
   .value('0');

  return s;
};

arc.settings.gauge.sublabelVerticalOffset = function() {
  var s = arc.visual.setting();

  s.id('sublabel_vertical_offset')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .add_label('Sublabel Offset')
   .add_class('spinner-alignright')
   .min(-200)
   .max(+200)
   .step(2)
   .value('0');

  return s;
};

arc.settings.gauge.backgroundOpacity = function() {
  var s = arc.visual.setting();

  s.id('gauge_background_opacity')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .add_label('Background Opacity')
   .min(0)
   .max(100)
   .step(5)
   .value('20');

  return s;
};

arc.settings.gauge.gaugeFgColor = function() {
  var s = arc.visual.setting();

  s.id('gauge_fg_color')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_label('Foreground Color')
   .value('#0097a7');

  return s;
};

arc.settings.gauge.gaugeBgColor = function() {
  var s = arc.visual.setting();

  s.id('gauge_bg_color')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_label('Background Color')
   .value('#cecece');

  return s;
};

arc.settings.gauge.gaugePointerColor = function() {
  var s = arc.visual.setting();

  s.id('gauge_pointer_color')
   .section('Color')
   .tab('Color')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_label('Pointer Color')
   .value('#707070');

  return s;
};

arc.settings.gauge.gaugeOuterRadius = function() {
  var s = arc.visual.setting();

  s.id('gauge_outer_width')
   .tab('Marks')
   .add_label('Outer Width')
   .type(arc.visual.settingTypeEnum.INTEGER_RANGE)
   .validate_fn(function(val) {
     return s.validate_num_range(val, 150, 2000);
   })
   .value('200-250');

  return s;
};

arc.settings.gauge.gaugeArcThickness = function() {
  var s = arc.visual.setting();

  s.id('gauge_arc_thickness')
   .tab('Marks')
   .add_label('Arc Thickness')
   .add_class('spinner-alignright')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .min(0)
   .max(100)
   .step(2)
   .value('20');

  return s;
};

arc.settings.gauge.gaugeQualitativeArcThickness = function() {
  var s = arc.visual.setting();

  s.id('gauge_qualitative_arc_thickness')
   .tab('Marks')
   .add_label('Qualitative Thickness')
   .add_class('spinner-alignright')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .min(0)
   .max(100)
   .step(1)
   .value('5');

  return s;
};

arc.settings.gauge.gaugeQualitativeArcGap = function() {
  var s = arc.visual.setting();

  s.id('gauge_qualitative_arc_gap')
   .tab('Marks')
   .add_label('Arc Gap')
   .add_class('spinner-alignright')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .min(0)
   .max(100)
   .step(1)
   .value('5');

  return s;
};

arc.settings.gauge.labelFontSize = function() {
  var s = arc.visual.setting();

  s.id('gauge_label_font_size')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.SLIDER)
   .add_class('spinner-alignright')
   .add_label('Label Font Size')
   .min(0)
   .max(100)
   .step(1)
   .value('30');

  return s;
};

arc.settings.gauge.sublabelFontSize = function() {
  return arc.visual.setting()
                   .id('gauge_sublabel_font_size')
                   .tab('Marks')
                   .type(arc.visual.settingTypeEnum.SLIDER)
                   .add_class('spinner-alignright')
                   .add_label('Sublabel Font Size')
                   .min(0)
                   .max(100)
                   .step(1)
                   .value('18');
};

arc.settings.gauge.includeLineMark = function() {
  return arc.visual.setting()
            .id('include_gauge_line')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Include a gauge line')
            .add_name('GAUGE_LINE')
            .value('true');
};

arc.settings.gauge.alwaysShowCompareLine = function() {
  return arc.visual.setting()
            .id('always_show_compare_line')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Show compare line even if max')
            .add_name('ALWAYS_COMPARE_LINE')
            .value('false');
};

arc.settings.gauge.includeOutsideCompareLine = function() {
  return arc.visual.setting()
            .id('include_outside_compare_line')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Display compare line on qualitative arc')
            .add_name('OUTSIDE_COMPARE_LINE')
            .value('false');
};

arc.settings.gauge.keyMeasureMark = function() {
  return arc.visual.setting()
            .id('gauge_key_measure_mark')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.RADIO)
            .group('Key measure mark')
            .add_name('NEEDLE')
            .add_label('Needle')
            .add_name('LINE')
            .add_label('Line')
            .add_name('NONE')
            .add_label('None')
            .value('NEEDLE');
};

arc.settings.gauge.showGaugeAxisTicks = function() {
  return arc.visual.setting()
            .id('show_gauge_axis_ticks')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Display axis ticks')
            .add_name('GAUGE_AXIS_TICKS')
            .value('true');
};

arc.settings.gauge.showQualitativeAsPercentages = function() {
  return arc.visual.setting()
            .id('qualitative_as_percentages')
            .tab('Data')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Use percentages of "Compare To" value if no qualitative data provided')
            .add_name('QUALITATIVE_AS_PERCENTAGE')
            .value('false');
};

arc.settings.gauge.lowestQualitativePercentage = function() {
  return arc.visual.setting()
                   .id('lowest_qualitative_percentage')
                   .tab('Data')
                   .type(arc.visual.settingTypeEnum.SLIDER)
                   .add_class('spinner-alignright')
                   .add_class('spinner-medium')
                   .add_label('lowest percentage')
                   .min(0)
                   .max(200)
                   .step(5)
                   .value('60');
};

arc.settings.gauge.mediumQualitativePercentage = function() {
  return arc.visual.setting()
                   .id('medium_qualitative_percentage')
                   .tab('Data')
                   .type(arc.visual.settingTypeEnum.SLIDER)
                   .add_class('spinner-alignright')
                   .add_class('spinner-medium')
                   .add_label('middle percentage')
                   .min(0)
                   .max(200)
                   .step(5)
                   .value('80');
};

arc.settings.gauge.highestQualitativePercentage = function() {
  return arc.visual.setting()
                   .id('highest_qualitative_percentage')
                   .tab('Data')
                   .type(arc.visual.settingTypeEnum.SLIDER)
                   .add_class('spinner-alignright')
                   .add_class('spinner-medium')
                   .add_label('highest percentage')
                   .min(0)
                   .max(200)
                   .step(5)
                   .value('100');
};

arc.settings.gauge.scaleTrellisIndependently = function() {
  return arc.visual.setting()
            .id('scale_trellis_independently')
            .tab('Trellis')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Scale independently across trellis')
            .add_name('TRELLIS_INDEPENDENT_SCALE')
            .value('false');
};

})();

