window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.kpi = arc.settings.kpi || {};

arc.settings.kpi.displayFirstMeasure = function() {
  return arc.visual.setting()
            .id('display_first_measure')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('DISPLAY_FIRST_MEASURE')
            .add_label('Display the first measure')
            .info('Without this option selected, this visual will ' +
                'display the first dimension if one exists.')
            .value('true')
            .valueBeforeRestore('false');
};

arc.settings.kpi.mainFontSize = function() {
  return arc.visual.setting()
            .id('main_measure_font_size')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_class('spinner-alignright')
            .add_label('Optimal Main Value Font Size')
            .min(10)
            .max(200)
            .step(2)
            .value('36');
};

arc.settings.kpi.mainFontSizeAutosize = function() {
  return arc.visual.setting()
            .id('main_measure_font_size_autosize')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Autosize the main measure display')
            .value('true')
            .valueBeforeRestore('false');
};

arc.settings.kpi.mainValueDisplay = function() {
  return arc.visual.setting()
            .id('main_value_display')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Main Value Format')
            .add_name('value')
            .add_label('Main Measure')
            .add_name('percent')
            .add_label('Percent changed')
            .add_name('difference')
            .add_label('Delta')
            .add_name('multiple')
            .add_label('Multiple')
            .value('value');
};

arc.settings.kpi.useArrowColorForMainFont = function() {
  return arc.visual.setting()
            .id('main_as_arrow_color')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('MAIN_AS_ARROW_COLOR')
            .add_label('Use arrow color for main font color')
            .value('false');
};

arc.settings.kpi.switchCompareDirection = function() {
  return arc.visual.setting()
            .id('switch_compare_direction')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SWITCH_COMPARE_DIRECTION')
            .add_label('Flip comparison')
            .value('false');
};

arc.settings.kpi.compareArrowType = function() {
  return arc.visual.setting()
            .id('compare_arrow_type')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Arrow Type')
            .add_name('angle-double')
            .add_label('<i class="fa fa-angle-double-up"></i>')
            .add_name('arrow-circle')
            .add_label('<i class="fa fa-arrow-circle-up"></i>')
            .add_name('arrow-circle-o')
            .add_label('<i class="fa fa-arrow-circle-o-up"></i>')
            .add_name('arrow')
            .add_label('<i class="fa fa-arrow-up"></i>')
            .add_name('caret')
            .add_label('<i class="fa fa-caret-up"></i>')
            .add_name('caret-square-o')
            .add_label('<i class="fa fa-caret-square-o-up" ></i>')
            .add_name('chevron')
            .add_label('<i class="fa fa-chevron-up"></i>')
            .add_name('chevron-circle')
            .add_label('<i class="fa fa-chevron-circle-up"></i>')
            .add_name('long-arrow')
            .add_label('<i class="fa fa-long-arrow-up"></i>')
            .add_name('none')
            .add_label('None')
            .value('arrow-circle');
};

arc.settings.kpi.displayCompareFormat = function() {
  return arc.visual.setting()
            .id('compare_display_format')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Compare Display')
            .add_name('value')
            .add_label('Value')
            .add_name('percent')
            .add_label('Percent changed')
            .add_name('difference')
            .add_label('Delta')
            .add_label('Multiple')
            .add_name('multiple')
            .add_name('none')
            .add_label('Do Not Show')
            .value('value');
};

arc.settings.kpi.labelLocation = function() {
  return arc.visual.setting()
            .id('main_label_location')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Label Location')
            .add_name('below')
            .add_label('Below')
            .add_name('above')
            .add_label('Above')
            .value('below');
};

arc.settings.kpi.labelFontSize = function() {
  return arc.visual.setting()
            .id('kpi_label_font_size')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_label('Label font size')
            .add_name('KPI_LABEL_FONT_SIZE')
            .min(1)
            .max(100)
            .step(1)
            .value('14');
};

arc.settings.kpi.compareArrowLocation = function() {
  return arc.visual.setting()
            .id('kpi_arrow_location')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Compare Position')
            .add_name('right')
            .add_label('Right')
            .add_name('left')
            .add_label('Left')
            .add_name('below')
            .add_label('Below')
            .add_name('above')
            .add_label('Above')
            .value('right');
};

arc.settings.kpi.numDecimals = function() {
  return arc.visual.setting()
            .id('kpi_decimals')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_label('Decimals in Display')
            .add_name('KPI_DECIMALS')
            .value('1')
            .min('0');
};

const defaultKPIColors = {
  upColor: '#5cb85c',
  downColor: '#d9534f',
  overColor: '#e7b416',
  mainFontColor: '#000',
  labelColor: '#aaa',
};

arc.settings.kpi.upArrowColor = function() {
  return arc.visual.setting()
            .id('kpi_up_color')
            .section('Color')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_label('Color of up arrow')
            .add_name('KPI_UP_COLOR')
            .value(defaultKPIColors.upColor);
};

arc.settings.kpi.flatArrowColor = function() {
  return arc.visual.setting()
            .id('kpi_flat_color')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_label('Color of flat arrow')
            .add_name('KPI_FLAT_COLOR')
            .value(defaultKPIColors.overColor);
};

arc.settings.kpi.downArrowColor = function() {
  return arc.visual.setting()
            .id('kpi_down_color')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_label('Color of down arrow')
            .add_name('KPI_DOWN_COLOR')
            .value(defaultKPIColors.downColor);
};

arc.settings.kpi.kpiFontColor = function() {
  return arc.visual.setting()
            .id('kpi_font_color')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_label('Main text color')
            .add_name('KPI_FONT_COLOR')
            .value(defaultKPIColors.mainFontColor);
};

arc.settings.kpi.kpiLabelColor = function() {
  return arc.visual.setting()
            .id('kpi_label_color')
            .section('Color')
            .tab('Color')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_label('Label text color')
            .add_name('KPI_LABEL_COLOR')
            .value(defaultKPIColors.labelColor);
};

arc.settings.kpi.hideXTrellisLabel = function() {
  return arc.visual.setting()
                    .id('hide_x_trellis')
                    .tab('Visual Axes and Labels')
                    .type(arc.visual.settingTypeEnum.CHECKBOX)
                    .add_name('HIDE_X_TRELLIS_LABEL')
                    .add_label('Hide X trellis label')
                    .value('false')
                    .valueBeforeRestore('false');
};

arc.settings.kpi.hideYTrellisLabel = function() {
  return arc.visual.setting()
            .id('hide_y_trellis')
            .tab('Visual Axes and Labels')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('HIDE_Y_TRELLIS_LABEL')
            .add_label('Hide Y trellis label')
            .value('false')
            .valueBeforeRestore('false');
};
}());
