window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.area = arc.settings.area || {};
arc.settings.bar = arc.settings.bar || {};
arc.settings.line = arc.settings.line || {};

arc.settings.bar.waterfall = function() {
  return arc.visual.setting()
            .id('waterfall')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('WATERFALL')
            .add_label('Display unstacked bars in waterfall mode')
            .value('false');
};

arc.settings.bar.ignoreStackedNegativesWithMixedMeasures = function() {
  return arc.visual.setting()
            .id('ignore_stacked_negatives_with_mixed_measures')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('IGNORE_STACKED_NEGATIVES_WITH_MIXED_MEASURES')
            .add_label('Ignore negatives when mixed with positives')
            .info('This setting ignores negative values when both positive negative values ' +
              'are present in stacked bar/areas. Setting is only applicable when a dimension is ' +
              'on the color shelf.')
            .valueBeforeRestore('false')
            .value('false');
};

arc.settings.bar.minCellHeight = function() {
  var s = arc.visual.setting();

  s.id('min_cell_height')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('MIN_CELL_HEIGHT')
   .add_label('Min Cell Height')
   .value('');

  return s;
};

arc.settings.bar.minCellWidth = function() {
  var s = arc.visual.setting();

  s.id('min_cell_width')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('MIN_CELL_WIDTH')
   .add_label('Min Cell Width')
   .value('');

  return s;
};

arc.settings.bar.inlineMeasureDisplay = function() {
  return arc.visual.setting()
            .id('inline_measure_display')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('INLINE_MEASURE_DISPLAY')
            .add_label('Label measure values for bars')
            .value('false');
};

arc.settings.bar.inlineSumMeasureDisplay = function() {
  return arc.visual.setting()
            .id('inline_sum_measure_display')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('INLINE_SUM_MEASURE_DISPLAY')
            .add_label('Label total value of stacked measure values for bars')
            .value('false');
};

arc.settings.bar.enableDrillInto = function() {
  return arc.visual.setting()
            .id('enable_drill_into')
            .tab('General')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_DRILL_INTO')
            .add_label('Show Drill Into context menu')
            .value('true');
};

arc.settings.line.enableMultipleTooltips = function() {
  return arc.visual.setting()
            .id('enable_multiple_tooltips')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_MULTIPLE_TOOLTIPS')
            .add_label('When hovering over a dimension, show each point with ' +
                'that dimensional value')
            .value('false');
};

arc.settings.line.enableLineLabels = function() {
  return arc.visual.setting()
            .id('enable_line_labels')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('ENABLE_LINE_LABELS')
            .add_label('Show labels at the end of lines')
            .value('false');
};

arc.settings.line.maxLabelWidth = function() {
  return arc.visual.setting()
            .id('maximum_label_width')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MAXIMUM_LABEL_WIDTH')
            .add_label('Max label width')
            .min(0)
            .max(500)
            .value(200);
};

arc.settings.line.lineStyleFromColor = function() {
  return arc.visual.setting()
            .id('line_style_from_color')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('LINE_STYLE_FROM_COLOR')
            .add_label('Modify line styles per color')
            .value('false');
};

arc.settings.line.minAggAxis = function() {
  var s = arc.visual.setting();

  s.id('min_agg_axis')
   .tab('Axes')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('MIN_AGG_AXIS')
   .add_label('Min Agg Scale')
   .value('');

  return s;
};

arc.settings.line.maxAggAxis = function() {
  var s = arc.visual.setting();

  s.id('max_agg_axis')
   .tab('Axes')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('MAX_AGG_AXIS')
   .add_label('Max Agg Scale')
   .value('');

  return s;
};

arc.settings.line.secondaryMinAggAxis = function() {
  const s = arc.visual.setting();

  const secondaryMinAggAxis = s.id('secondary_min_agg_axis')
   .tab('Axes')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('SECONDARY_MIN_AGG_AXIS')
   .add_label('Sec. Min Agg Scale')
   .value('');

  return secondaryMinAggAxis;
};

arc.settings.line.secondaryMaxAggAxis = function() {
  const s = arc.visual.setting();

  const secondaryMaxAggAxis = s.id('secondary_max_agg_axis')
   .tab('Axes')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_name('SECONDARY_MAX_AGG_AXIS')
   .add_label('Sec. Max Agg Scale')
   .value('');

  return secondaryMaxAggAxis;
};

arc.settings.interpolationToCurve = function(i) {
  switch (i) {
  case 'linear':
    return d4.curveLinear;

  case 'basis':
    return d4.curveBasis;

  case 'bundle':
    return d4.curveBundle;

  case 'cardinal':
    return d4.curveCardinal;

  case 'monotone':
    return d4.curveMonotoneX;

  case 'step':
    return d4.curveStep;

  case 'step-before':
    return d4.curveStepBefore;
  }

  return d4.curveLinear;
};

arc.settings.line.lineInterpolation = function() {
  return arc.visual.setting()
            .id('line_interpolation')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Line Shape')
            .add_name('linear')
            .add_label('linear')
            .add_name('basis')
            .add_label('basis')
            .add_name('bundle')
            .add_label('bundle')
            .add_name('cardinal')
            .add_label('cardinal')
            .add_name('monotone')
            .add_label('monotone')
            .add_name('step')
            .add_label('step')
            .add_name('step-before')
            .add_label('step-before')
            .value('linear');
};

arc.settings.area.lineInterpolation = function() {
  return arc.visual.setting()
            .id('line_interpolation')
            .tab('Marks')
            .info('Area Visuals do not support the &quot;bundle&quot;' +
             ' line style. The &quot;basis&quot; style will be used instead.')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Line Shape')
            .add_name('linear')
            .add_label('linear')
            .add_name('basis')
            .add_label('basis')
            .add_name('cardinal')
            .add_label('cardinal')
            .add_name('monotone')
            .add_label('monotone')
            .add_name('step')
            .add_label('step')
            .add_name('step-before')
            .add_label('step-before')
            .value('linear');
};

arc.settings.line.showXAxis = function() {
  return arc.visual.setting()
            .id('show_x_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SHOW_X_AXIS')
            .add_label('Show X Axis')
            .value('true');
};

arc.settings.line.showYAxis = function() {
  return arc.visual.setting()
            .id('show_y_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SHOW_Y_AXIS')
            .add_label('Show Y Axis')
            .value('true');
};

arc.settings.line.showSelectionRange = function() {
  return arc.visual.setting()
            .id('show_selection_range')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SHOW_SELECTION_RANGE')
            .add_label('Show a selection brush for a range of values')
            .info('Requires date or datetime in X axis')
            .value('false');
};

arc.settings.line.continuousDimScale = function() {
  return arc.visual.setting()
            .id('dim_is_continuous')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('DIM_IS_CONTINUOUS')
            .add_label('Make dimension axis continuous')
            .info('This setting is only for numerical dimensions on the axis.')
            .value('false');
};

arc.settings.line.minDimAxis = function() {
  return arc.visual.setting()
            .id('min_dim_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MIN_DIM_AXIS')
            .add_label('Min Dim Scale')
            .info('This setting is only for numerical dimensions on the axis.')
            .value('');
};

arc.settings.line.maxDimAxis = function() {
  return arc.visual.setting()
            .id('max_dim_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MAX_DIM_AXIS')
            .add_label('Max Dim Scale')
            .info('This setting is only for numerical dimensions on the axis.')
            .value('');
};

}());
