window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.list = arc.settings.list || {};

arc.settings.list.showColumnNames = function() {
  return arc.visual.setting()
            .id('list_show_column_names')
            .section('Settings')
            .tab('List Display')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('LIST_SHOW_COLUMN_NAMES')
            .add_label('Show column names')
            .value('false');
};

arc.settings.list.listStyle = function() {
  let s = arc.visual.setting()
             .id('list_format')
             .group('Format')
             .section('Settings')
             .tab('List Display')
             .type(arc.visual.settingTypeEnum.DROPDOWN)
             .add_name('unformatted')
             .add_label('No formatting')
             .add_name('headline')
             .add_label('Headline')
             .add_name('headline-2')
             .add_label('Headline 2')
             .add_name('card')
             .add_label('Card')
             .value('headline');

  return s;
};

arc.settings.apps.marginBetweenItems = function() {
  return arc.visual.setting()
            .id('margin_between_items')
            .section('Settings')
            .tab('List Display')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MARGIN_BETWEEN_ITEMS')
            .add_label('Margin Between Items')
            .suffix('px')
            .min(0)
            .max(100)
            .step(5)
            .value(20);
};

arc.settings.apps.cardWidth = function() {
  return arc.visual.setting()
            .id('card_width')
            .section('Settings')
            .tab('List Display')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('CARD_WIDTH')
            .add_label('Card Width')
            .suffix('px')
            .min(40)
            .max(2000)
            .step(10)
            .value(200);
};

}());
