window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.mapInteractive = arc.settings.mapInteractive || {};

arc.settings.mapInteractive.showMapData = function() {
  return arc.visual.setting()
            .id('show_map_data_div')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SHOW_MAP_DATA_DIV')
            .add_label('Display map data')
            .info('This setting will place a small box in the corner of the map showing the ' +
              'center and current zoom level')
            .value('false');
};

arc.settings.mapInteractive.visualAtlasServer = function() {
  return arc.visual.setting()
            .id('visual_atlas_server')
            .tab('Map Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('VISUAL_ATLAS_SERVER')
            .add_label('Atlas server for visual')
            .value('');
};

arc.settings.mapInteractive.markerType = function() {
  return arc.visual.setting()
            .id('marker_type')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Pin Type')
            .add_name('default')
            .add_label('Default')
            .add_name('circle')
            .add_label('Circle')
            .add_name('custom')
            .add_label('Custom')
            .value('default');
};

arc.settings.mapInteractive.markersEnabled = function() {
  return arc.visual.setting()
            .id('marker_enabled')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Marker_enabled')
            .add_label('Enable Pins')
            .value('false');
};

arc.settings.mapInteractive.markerPermanentLabels = function() {
  return arc.visual.setting()
            .id('marker_permanent_labels')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Marker_Permanent_Labels')
            .add_label('Enable Permanent Labels')
            .value('false');
};

//route options
arc.settings.mapInteractive.routesEnabled = function() {
  return arc.visual.setting()
            .id('route_enabled')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Route_enabled')
            .add_label('Enable Routes')
            .value('false');
};

arc.settings.mapInteractive.startMarker = function() {
  return arc.visual.setting()
            .id('start_marker_type')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Start Pin Type')
            .add_name('default')
            .add_label('Default')
            .add_name('circle')
            .add_label('Circle')
            .add_name('none')
            .add_label('None')
            .add_name('custom')
            .add_label('Custom')
            .value('circle');
};

arc.settings.mapInteractive.middleMarker = function() {
  return arc.visual.setting()
            .id('middle_marker_type')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Middle Pin Type')
            .add_name('default')
            .add_label('Default')
            .add_name('circle')
            .add_label('Circle')
            .add_name('none')
            .add_label('None')
            .add_name('custom')
            .add_label('Custom')
            .value('none');
};

arc.settings.mapInteractive.endMarker = function() {
  return arc.visual.setting()
            .id('end_marker_type')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('End Pin Type')
            .add_name('default')
            .add_label('Default')
            .add_name('circle')
            .add_label('Circle')
            .add_name('none')
            .add_label('None')
            .add_name('custom')
            .add_label('Custom')
            .value('default');
};

arc.settings.mapInteractive.customIcon = function() {
  return arc.visual.setting()
            .id('custom_icon')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('CUSTOM_ICON')
            .add_label('Custom Icon')
            .value('');
};

arc.settings.mapInteractive.customIconSize = function() {
  return arc.visual.setting()
            .id('custom_icon_size_adjustment')
            .tab('Routes and Pins')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_name('CUSTOM_ICON_SIZE')
            .add_label('Custom Icon Size')
            .info('Adjusts the size of the custom icon as percentage of image size')
            .min(0)
            .max(100)
            .step(1)
            .value('50');
};

arc.settings.mapInteractive.mapStyles = function() {
   return arc.visual.setting()
            .id('map_style')
            .tab('Map Style')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Map Style')
            .add_name('default')
            .add_label('Default')
            .add_name('subtle')
            .add_label('Subtle')
            .add_name('dark')
            .add_label('Dark')
            .add_name('light')
            .add_label('Light')
            .add_name('muted')
            .add_label('Muted')
            .add_name('satellite')
            .add_label('Satellite')
            .value('default');
};

arc.settings.mapInteractive.mapboxId = function() {
  return arc.visual.setting()
            .id('mapbox_id')
            .tab('Map Style')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('Mapbox_Id')
            .add_label('Custom Mapbox Tileset ID')
            .info('This will replace one of the default map styles')
            .value('');
};

//heatmap options
arc.settings.mapInteractive.heatmapEnabled = function() {
  return arc.visual.setting()
            .id('heatmap_enabled')
            .tab('Heatmap')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Heatmap_enabled')
            .add_label('Enable Heatmap')
            .value('true');
};

arc.settings.mapInteractive.heatmapLegend = function() {
  return arc.visual.setting()
            .id('heatmap_legend')
            .tab('Heatmap')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Heatmap_legend')
            .add_label('Add Legend')
            .value('false');
};

arc.settings.mapInteractive.intensityMagnification = function() {
  return arc.visual.setting()
            .id('intensity_mag')
            .tab('Heatmap')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_name('Intensity')
            .add_label('Intensity Magnification')
            .min(0)
            .max(5000)
            .step(100)
            .value('1000');
};

arc.settings.mapInteractive.heatmapRadius = function() {
  return arc.visual.setting()
            .id('heatmap_radius')
            .tab('Heatmap')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_name('Heatmap_radius')
            .add_label('Radius')
            .min(1)
            .max(100)
            .step(1)
            .value('20');
};

arc.settings.mapInteractive.heatmapVisibleZoom = function() {
  return arc.visual.setting()
            .id('heatmap_visible_zoom_levels')
            .tab('Heatmap')
            .type(arc.visual.settingTypeEnum.SLIDER_RANGE)
            .add_name('HEATMAP_VISIBLE_ZOOM')
            .add_label('Visible Zoom Levels')
            .info('Available with Mapbox GL, heatmap will fade out at zoom levels not in range')
            .min(0)
            .max(22)
            .step(1)
            .value('0-22');
};

//cluster options
arc.settings.mapInteractive.clusterEnabled = function() {
  return arc.visual.setting()
            .id('cluster_enabled')
            .tab('Cluster')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Cluster_enabled')
            .add_label('Enable Cluster')
            .value('true');
};

arc.settings.mapInteractive.clusterColor = function() {
  return arc.visual.setting()
            .id('cluster_color')
            .tab('Cluster')
            .type(arc.visual.settingTypeEnum.COLOR)
            .add_name('Cluster_color')
            .add_label('Cluster Color:')
            .value('#ff9900');
};

arc.settings.mapInteractive.clusterRadius = function() {
  return arc.visual.setting()
            .id('cluster_radius')
            .tab('Cluster')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_name('Cluster_radius')
            .add_label('Radius')
            .min(30)
            .max(1000)
            .step(5)
            .value('80');
};

arc.settings.mapInteractive.circleEnabled = function() {
  return arc.visual.setting()
            .id('circle_enabled')
            .tab('Circles')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Circle_enabled')
            .add_label('Enable Circle')
            .value('false');
};

arc.settings.mapInteractive.colorLegend = function() {
  return arc.visual.setting()
            .id('circle_legend_color')
            .tab('Circles')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Circle_legend_color')
            .add_label('Add Color Legend')
            .info('Setting only applicable if the color shelf is populate')
            .value('false');
};

arc.settings.mapInteractive.circleAreaLegend = function() {
  return arc.visual.setting()
            .id('circle_legend_area')
            .tab('Circles')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('Circle_legend_area')
            .add_label('Add Area Legend')
            .info('Setting only applicable if the measure shelf is populated')
            .value('false');
};

arc.settings.mapInteractive.circleRadiusRange = function() {
  const circleAreaRange = arc.visual.setting();
  circleAreaRange.id('circle_radius_range')
            .tab('Circles')
            .type(arc.visual.settingTypeEnum.SLIDER_RANGE)
            .add_name('circle_radius_range')
            .add_label('Radius Range')
            .min(1)
            .max(100)
            .step(1)
            .value('5-30');

  return circleAreaRange;
};

arc.settings.mapInteractive.circleVisibleZoom = function() {
  return arc.visual.setting()
            .id('circle_visible_zoom')
            .tab('Circles')
            .type(arc.visual.settingTypeEnum.SLIDER_RANGE)
            .add_name('CIRCLE_VISIBLE_ZOOM')
            .add_label('Visible Zoom Levels')
            .info('Available in MapboxGL. Circles will appear within specified zoom range')
            .min(0)
            .max(22)
            .step(1)
            .value('0-22');
};

arc.settings.mapInteractive.mapboxStyle = function() {
  return arc.visual.setting()
          .id('mapboxStyle')
          .tab('Map Style')
          .type(arc.visual.settingTypeEnum.STRING)
          .add_name('Mapbox_Style')
          .add_label('Custom Mapbox Style URL')
          .info('This can be found on Mapbox Studio should be something like:' +
            'mapbox://styles/username/id')
          .value('');
};

arc.settings.mapInteractive.choroplethLayerId = function() {
  return arc.visual.setting()
            .id('choropleth_layer_id')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('SOURCE_ID')
            .add_label('Layer ID')
            .info('Specify the layer ID in the mapbox style')
            .value('');
};

arc.settings.mapInteractive.choroplethOpacity = function() {
  return arc.visual.setting()
            .id('choropleth_opacity')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.SLIDER)
            .add_name('CHORO_OPACITY')
            .add_label('Opacity')
            .min(0)
            .max(1)
            .step(0.1)
            .value(0.6);
};

arc.settings.mapInteractive.includeChoroplethLegend = function() {
  return arc.visual.setting()
            .id('choropleth_legend')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('CHORO_LEGEND')
            .add_label('Include legend')
            .value('true');
};

arc.settings.mapInteractive.saveZoomAndLocation = function() {
  return arc.visual.setting()
            .id('store_map_load_location')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('STORE_MAP_LOCATION')
            .add_label('Remember map location')
            .info('When this setting is checked, the visual opens at the same location where it ' +
              'was saved. Applicable for choropleths and empty maps')
            .value('true');
};

arc.settings.mapInteractive.startZoom = function() {
  return arc.visual.setting()
            .id('start_zom')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('START_ZOOM')
            .hidden(true)
            .value('3');
};

arc.settings.mapInteractive.startCenter = function() {
  return arc.visual.setting()
            .id('start_center')
            .tab('Choropleth')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('START_CENTER')
            .hidden('true')
            .value('-98.5794797, 39.8283459');
};

arc.settings.mapInteractive.localKey = function() {
  return arc.visual.setting()
            .id('local_map_key')
            .tab('Map Server')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('LOCAL_KEY')
            .add_label('Mapbox token for visual')
            .info('This will override the value in site settings (optional)')
            .value('');
};

arc.settings.mapInteractive.holdLocationOnManualMove = function() {
  return arc.visual.setting()
            .id('hold_location_manual_move')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('HOlD_LOCATION_MANUAL_MOVE')
            .add_label('Do not auto-update map location')
            .info('This option enables the map to stay in the same location after it is' +
              'manually moved or zoomed while streaming or changing filters.')
            .value('false');
};

arc.settings.mapInteractive.mapServer = function() {
  const googleMsg =
          `The administrator must specify a Premium Google Maps API key or Client ID in <a href="${arc.misc.getBlankTargetUrl('/arc/apps/settings')} target="_blank">Site Settings</a>.`;

  const mapboxMsg =
          `The administrator can specify a Mapbox token in <a href="${arc.misc.getBlankTargetUrl('/arc/apps/settings')}"" target="_blank">Site Settings</a> or below. `;

  const mapServerSetting =  arc.visual.setting()
                              .id('tile-style')
                              .tab('Map Server')
                              .type(arc.visual.settingTypeEnum.RADIO)
                              .group('Map Server')
                              .add_name('google')
                              .add_label('Google Maps')
                              .add_name('mapboxgl')
                              .add_label('Mapbox')
                              .value('mapboxgl');

  mapServerSetting.add_postpaint_fn(function() {
                                      if (mapServerSetting.value() === 'google') {
                                        mapServerSetting.infoblock(googleMsg);
                                      } else {
                                        mapServerSetting.infoblock(mapboxMsg);
                                      }
                                    });

  return mapServerSetting;
};

arc.settings.mapInteractive.mapStyleOptions = {
  subtle: [{"featureType":"administrative","elementType":"labels.text.fill","stylers":[{"color":"#6195a0"}]},
			{"featureType":"landscape","elementType":"all","stylers":[{"color":"#f2f2f2"}]},
			{"featureType":"landscape","elementType":"geometry.fill","stylers":[{"color":"#fafafa"}]},
			{"featureType":"poi","elementType":"all","stylers":[{"visibility":"off"}]},
			{"featureType":"poi.park","elementType":"geometry.fill","stylers":[{"color":"#e6f3d6"},{"visibility":"on"}]},
			{"featureType":"road","elementType":"all","stylers":[{"saturation":-100},{"lightness":45},{"visibility":"simplified"}]},
			{"featureType":"road.highway","elementType":"all","stylers":[{"visibility":"simplified"}]},
			{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#f7e5d6"},{"visibility":"simplified"}]},
			{"featureType":"road.highway","elementType":"labels.text","stylers":[{"color":"#4e4e4e"}]},
			{"featureType":"road.arterial","elementType":"geometry.fill","stylers":[{"color":"#f4f4f4"}]},
			{"featureType":"road.arterial","elementType":"labels.text.fill","stylers":[{"color":"#787878"}]},
			{"featureType":"road.arterial","elementType":"labels.icon","stylers":[{"visibility":"off"}]},
			{"featureType":"transit","elementType":"all","stylers":[{"visibility":"off"}]},
			{"featureType":"water","elementType":"all","stylers":[{"color":"#eaf6f8"},{"visibility":"on"}]},
			{"featureType":"water","elementType":"geometry.fill","stylers":[{"color":"#eaf6f8"}]}],
  dark: [
    {
        "featureType": "all",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "saturation": 36
            },
            {
                "color": "#707070"
            },
            {
                "lightness": 40
            }
        ]
    },
    {
        "featureType": "all",
        "elementType": "labels.text.stroke",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#000000"
            },
            {
                "lightness": 16
            }
        ]
    },
    {
        "featureType": "all",
        "elementType": "labels.icon",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 20
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "color": "#212020"
            },
            {
                "lightness": 17
            },
            {
                "weight": 1.2
            }
        ]
    },
    {
        "featureType": "landscape",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#424242"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 21
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "labels",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "labels.icon",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "lightness": "0"
            },
            {
                "gamma": "1"
            },
            {
                "weight": ".7"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "lightness": "-2"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "lightness": "-19"
            },
            {
                "saturation": "-100"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "saturation": "-100"
            },
            {
                "lightness": "16"
            },
            {
                "gamma": "0.83"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "lightness": 17
            },
            {
                "color": "#484848"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "lightness": "6"
            },
            {
                "weight": 0.2
            },
            {
                "color": "#ff0000"
            },
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "road.arterial",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 18
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 16
            }
        ]
    },
    {
        "featureType": "transit",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 19
            }
        ]
    },
    {
        "featureType": "water",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#000000"
            },
            {
                "lightness": 17
            }
        ]
    }
],
  light: [
    {
        "featureType": "administrative",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#a7a7a7"
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#737373"
            }
        ]
    },
    {
        "featureType": "landscape",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#efefef"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#dadada"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "labels",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "labels.icon",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "labels",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "color": "#696969"
            }
        ]
    },
    {
        "featureType": "road",
        "elementType": "labels.icon",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "saturation": "-100"
            },
            {
                "gamma": "0.91"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#ffffff"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#b3b3b3"
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "road.arterial",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#ffffff"
            }
        ]
    },
    {
        "featureType": "road.arterial",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "color": "#d6d6d6"
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#ffffff"
            },
            {
                "weight": 1.8
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "color": "#d7d7d7"
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "on"
            }
        ]
    },
    {
        "featureType": "transit",
        "elementType": "all",
        "stylers": [
            {
                "color": "#808080"
            },
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "water",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#d3d3d3"
            }
        ]
    }
],
  muted: [{"featureType":"administrative","elementType":"all","stylers":[{"visibility":"on"},{"lightness":33}]},
			{"featureType":"landscape","elementType":"all","stylers":[{"color":"#f2e5d4"}]},
			{"featureType":"poi.park","elementType":"geometry","stylers":[{"color":"#c5dac6"}]},
			{"featureType":"poi.park","elementType":"labels","stylers":[{"visibility":"on"},{"lightness":20}]},
			{"featureType":"road","elementType":"all","stylers":[{"lightness":20}]},
			{"featureType":"road.highway","elementType":"geometry","stylers":[{"color":"#c5c6c6"}]},
			{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#e4d7c6"}]},
			{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#fbfaf7"}]},
			{"featureType":"water","elementType":"all","stylers":[{"visibility":"on"},{"color":"#acbcc9"}]}],
};

arc.settings.mapInteractive.markerOptions = {
  basic:'<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="28px" height="36px" x="0px" y="0px" ' +
          'style="enable-background:new 0 0 28 35;" xml:space="preserve">' +
          '<style type="text/css">.st0{opacity:1;fill:white;}.st2{fill:none;stroke:#FFFFFF;stroke-miterlimit:10;}</style>' +
          '<g><path class="st0" d="M12.9,33.7c0.6,0.8,1.8,0.8,2.4,0C21.2,26.4,26,19.6,26,13.1c0-5.5-3.8-12.4-11.9-12.4' +
          'C6.4,0.6,2.3,7.2,2.3,12.4C2.3,18.9,6.8,26.1,12.9,33.7z"/></g><g>' +
          '<path fill="%ICONCOLOR%" class="st1" d="M14.1,0.6C22.2,0.6,26,7.5,26,13.1c0,6.5-4.8,13.3-10.7,20.7c-0.6,0.8-1.8,0.8-2.4,0' +
          'c-6-7.6-10.6-14.8-10.6-21.4C2.3,7.2,6.4,0.6,14.1,0.6l0,4.3c-3.6,0-6.6,2.9-6.6,6.6s2.9,6.6,6.6,6.6l0,0c3.6,0,6.6-2.9,6.6-6.6' +
          's-2.9-6.6-6.6-6.6L14.1,0.6z"/></g><g>' +
          '<path class="st2" d="M12.9,33.7c0.6,0.8,1.8,0.8,2.4,0C21.2,26.4,26,19.6,26,13.1c0-5.5-3.8-12.4-11.9-12.4' +
          'C6.4,0.6,2.3,7.2,2.3,12.4C2.3,18.9,6.8,26.1,12.9,33.7z"/></g></svg>',
};

}());
