window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.params = arc.settings.params || {};

/*
 * This parameter was converted from a CHECKBOX. That is why the 'true' value is
 * associated with dataset scope, and the 'false' value is associated with
 * explicit scope.
 */
arc.settings.params.visualDatasetScope = function() {
  return arc.visual.setting()
            .id('visual_dataset_scope')
            .tab('Parameters')
            .type(arc.visual.settingTypeEnum.DROPDOWN)
            .group('Param Scope')
            .add_name('GLOBAL')
            .add_label('All Datasets')
            .add_name('true')
            .add_label('Current Dataset')
            .add_name('false')
            .add_label('Explicit')
            .info('With Global Scope, this visual emits parameters that apply to all ' +
                'visuals in this dashboard. With Dataset Scope, emitted patameters ' +
                'apply to only those visuals in this dashboard that use the same dataset. ' +
                'With Explicit Scope, automatic filtering is turned off.')
            .value('GLOBAL');
};

arc.settings.params.sendAggregateParameters = function() {
  return arc.visual.setting()
            .id('send_aggregate_parameters')
            .tab('Parameters')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('SEND_AGGREGATES')
            .add_label('Send aggregates as parameters')
            .info('This visual emits aggregate value parameters in addition ' +
                'to dimensions.')
            .valueBeforeRestore('true')
            .value('false');
};

arc.settings.params.displayFilters = function() {
  return arc.visual.setting()
            .id('display_filters')
            .tab('Filter Settings')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('DISPLAY_FILTERS')
            .add_label('Display filter selections for each visual')
            .info('Visuals set to receive explicit scope params do not show filter selections.')
            .valueBeforeRestore('false')
            .value('false');
};

arc.settings.params.displayContextMenu = function() {
  return arc.visual.setting()
            .id('display_context_menu')
            .tab('General')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('DISPLAY_CONTEXE_MENU')
            .add_label('Display context menus within visuals')
            .valueBeforeRestore('false')
            .value('true');
};

}());
