window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.pie = arc.settings.pie || {};

arc.settings.pie.borderColorSetting = function() {
  const s = arc.visual.setting();
  s.id('mark_border_color')
   .section('Settings')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.COLOR)
   .add_name('MARK_BORDER_COLOR')
   .add_label('Border Color')
   .value('#FFF');

  return s;
};

arc.settings.pie.borderWidthSetting = function() {
  const s = arc.visual.setting();
  s.id('mark_border_width')
   .section('Settings')
   .tab('Marks')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_label('Border Width')
   .suffix('px')
   .min(0)
   .max(5)
   .value('1');

  return s;
};

arc.settings.pie.arcWidth = function () {
  return arc.visual.setting()
    .id('arc_width')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.SLIDER)
    .add_name('ARC_WIDTH')
    .add_label('Arc Width')
    .info('Width of arc drawn. Only applicable if one item on Dimensions shelf')
    .min(0)
    .max(300)
    .step(5)
    .value('80');
};

arc.settings.pie.showDimensionsOnMarks = function() {
  const showDimensionsOnMarks =
    arc.visual.setting()
    .id('showDimensionsOnMarks')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.CHECKBOX)
    .add_name('showDimensionsOnMarks')
    .add_label('Show Dimensions')
    .value('true');
  return showDimensionsOnMarks;
};

arc.settings.pie.showPercentagesOnMarks = function() {
  const showPercentagesOnMarks =
    arc.visual.setting()
    .id('showPercentagesOnMarks')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.CHECKBOX)
    .add_name('showPercentagesOnMarks')
    .add_label('Show Percentages')
    .info('Only valid if there is one item on dimension shelf.')
    .value('false');
  return showPercentagesOnMarks;
};

arc.settings.pie.markPercentageDecimal = function() {
  const markPercentageDecimal =
    arc.visual.setting()
    .id('markPercentageDecimal')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.SLIDER)
    .add_name('MARK_PERCENTAGE_DECIMALS')
    .add_label('Decimals in Percentages')
    .min(0)
    .max(10)
    .value('1');

  return markPercentageDecimal;
};

arc.settings.pie.pieOrDonut = function() {
  const pieOrDonut = arc.visual.setting()
    .id('pieOrDonut')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.CHECKBOX)
    .add_name('PieOrDonut')
    .add_label('Make chart a pie')
    .value('false');

  return pieOrDonut;
};

arc.settings.pie.defaultWidth = function() {
  const defaultWidth = arc.visual.setting()
    .id('defaultWidth')
    .tab('Marks')
    .type(arc.visual.settingTypeEnum.CHECKBOX)
    .add_name('defaultWidth')
    .add_label('Auto-select donut width')
    .info('If this is checked the Pie chart will use the default donut width.' +
      'Only applicable when one item is on the Dimension shelf, other wise default is used.')
    .value('true');

  return defaultWidth;
};

}());
