window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.range = arc.settings.range || {};

arc.settings.range.significantDigits = function() {
  var s = arc.visual.setting();

  s.id('significant_digits')
   .tab('Values')
   .type(arc.visual.settingTypeEnum.INTEGER)
   .add_label('Significant digits after decimal')
   .min(0)
   .max(10)
   .step(1)
   .value('2');

  return s;
};

arc.settings.range.saveSelections = function() {
  return arc.visual.setting()
            .id('range_save_selections')
            .tab('Values')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_label('Save range selections made in edit mode')
            .value('true');
};

arc.settings.range.allowNulls = function() {
  return arc.visual.setting()
  .id('allow_nulls')
  .tab('Values')
  .type(arc.visual.settingTypeEnum.CHECKBOX)
  .add_name('ALLOW_NULLS')
  .add_label('Permit selection of NULL values')
  .value('true');
};

arc.settings.range.fixedMinimum = function() {
  var s = arc.visual.setting();

  s.id('range_fixed_minimum')
   .tab('Data')
   .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
   .add_label('Fixed minimum value for range')
   .value('');

  return s;
};

arc.settings.range.fixedMaximum = function() {
  var s = arc.visual.setting();

  s.id('range_fixed_maximum')
   .tab('Data')
   .type(arc.visual.settingTypeEnum.INTEGER_NOSPINNER)
   .add_label('Fixed maximum value for range')
   .value('');

  return s;
};

})();
