window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.scatter = arc.settings.scatter || {};

arc.settings.scatter.labelByColor = function() {
  return arc.visual.setting()
            .id('label_by_color')
            .tab('Marks')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('LABEL_BY_COLOR')
            .add_label('Label marks by color')
            .value('true')
            .valueBeforeRestore('false');
};

arc.settings.scatter.reverse_scale_x = function() {
  return arc.visual.setting()
            .id('reverse_scale_x')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('REVERSE_SCALE_X')
            .add_label('Reverse x scale')
            .value('false');
};

arc.settings.scatter.reverse_scale_y = function() {
  return arc.visual.setting()
            .id('reverse_scale_y')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('REVERSE_SCALE_Y')
            .add_label('Reverse y scale')
            .value('false');
};

arc.settings.scatter.minXAxis = function() {
  return arc.visual.setting()
            .id('min_x_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MIN_X_AXIS')
            .add_label('Min X Scale')
            .info('This setting is only for numerical axes. Setting will be ignored if data ' +
              'go beyond value.')
            .value('');
};

arc.settings.scatter.maxXAxis = function() {
  return arc.visual.setting()
            .id('max_x_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MAX_X_AXIS')
            .add_label('Max X Scale')
            .info('This setting is only for numerical axes. Setting will be ignored if data ' +
              'go beyond value.')
            .value('');
};

arc.settings.scatter.minYAxis = function() {
  return arc.visual.setting()
            .id('min_y_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MIN_Y_AXIS')
            .add_label('Min Y Scale')
            .info('This setting is only for numerical axes. Setting will be ignored if data ' +
              'go beyond value.')
            .value('');
};

arc.settings.scatter.maxYAxis = function() {
  return arc.visual.setting()
            .id('max_y_axis')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.INTEGER)
            .add_name('MAX_Y_AXIS')
            .add_label('Max Y Scale')
            .info('This setting is only for numerical axes. Setting will be ignored if data ' +
              'go beyond value.')
            .value('');
};

arc.settings.scatter.makeYAxisContinuous = function() {
  return arc.visual.setting()
            .id('make_y_continuous')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('MAKE_Y_CONTINUOUS')
            .add_label('Make Y axis continuous')
            .info('This setting is only for numerical dimensions on the axis. De-select ' +
              'this option if you are using the values as categories.')
            .value('true');
};

arc.settings.scatter.makeXAxisContinuous = function() {
  return arc.visual.setting()
            .id('make_x_continuous')
            .tab('Axes')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('MAKE_X_CONTINUOUS')
            .add_label('Make X axis continuous')
            .info('This setting is only for numerical dimensions on the axis. De-select ' +
              'this option if you are using the values as categories.')
            .value('true');
};

}());
