window.arc = window.arc || {};

(function() {
'use strict';

arc.settings = arc.settings || {};
arc.settings.timecontrol = arc.settings.timecontrol || {};

arc.settings.timecontrol.moveStartTimeForward = function() {
  return arc.visual.setting()
            .id('move_start_time_forward')
            .tab('General')
            .type(arc.visual.settingTypeEnum.CHECKBOX)
            .add_name('MOVE_START_TIME_FORWARD')
            .add_label('Move Start Time Forward')
            .info('When moving time ahead, move both start time and end time forward. ' +
                'If this option is unchecked, we only move end time forward.')
            .value('true');
};

arc.settings.timecontrol.width = function() {
  var s = arc.visual.setting();

  s.id('timecontrol_width')
   .tab('General')
   .type(arc.visual.settingTypeEnum.STRING)
   .add_name('TIMECONTROL_WIDTH')
   .add_label('Visual Width')
   .infoblock('Clear field for full width.')
   .validate_fn(function(val) {
     if (val.trim() === '') {
       return true;
     }

     return s.validate_num_range(val, 200, 10000);
   })
   .valueBeforeRestore('500')
   .value('');

  return s;
};

arc.settings.timecontrol.minFixedDateTime = function() {
  return arc.visual.setting()
            .id('timecontrol_min_datetime')
            .tab('General')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('TIMECONTROL_MIN_DATETIME')
            .add_label('Fixed minimum date/time')
            .value('');
};

arc.settings.timecontrol.maxFixedDateTime = function() {
  return arc.visual.setting()
            .id('timecontrol_max_datetime')
            .tab('General')
            .type(arc.visual.settingTypeEnum.STRING)
            .add_name('TIMECONTROL_MAX_DATETIME')
            .add_label('Fixed maximum date/time')
            .value('');
};

}());
