window.arc = window.arc || {};

(function() {
  'use strict';

  arc.showme = arc.showme || {};

  arc.showme.api = (shelf_data, dataset_info) => {
    arc.globals.reports = arc.reporttracker.reports();
    arc.globals.params = arc.params.tracker();

    const dataset = window.arc.datasets.Dataset()
      .init_from_fetch(dataset_info);

    let viz = arc.visual.plugins.table();
    const dsSegment = arc.report.dataset_segments()
      .dataset(dataset)
      .parse_segments(dataset.segments());

    const report = arc.reporttracker.report()
      .dataset(dataset)
      .dataset_segments(dsSegment)
      .chart_div('chart_div')
      .shelves_dom_id('shelved_dom_id');
    let vizDriver = arc.report.driver(viz, false)
      .report(report)
      .dataset(dataset)
      .shelves_dom_id('shelved_dom_id');

    report.viz(vizDriver);
    vizDriver.setup();

    vizDriver = report.viz();
    viz = vizDriver.viz();

    const settings = viz.viz_getSettings();

    settings.dimensions_shelf = shelf_data.dimensions;
    settings.aggregates_shelf = shelf_data.aggregates;
    settings.filters_shelf = shelf_data.filters;
    settings.report_title = shelf_data.title;

    viz.viz_setSettings(settings);
    vizDriver.setup();

    const showmeVisualConfig = {
      vizType: shelf_data.type
    };

    const showme = arc.showme.visuals({
      isSearchShowme: true,
      vizDriver,
      showmeVisualConfig,
      displayedQuery: 'displayed query',
      pickedCb: () => {}
    });

    const elementOrdering = [...shelf_data.dimensions.map(() => 'dimension'), ...shelf_data.aggregates.map(() => 'aggregate')];

    const pickedVisual = showme.pickVisual({
      elementOrdering,
      showmeVisualConfig,
    });

    pickedVisual.vizDriver
    .dataset(dataset)
    .shelves_dom_id(report.shelves_dom_id());

    showme.computeSettings(pickedVisual);

    pickedVisual.viz.viz_lib(vizDriver);

    arc.misc.displayVisualType(pickedVisual.visualData.vizType);
    report.switchViz(
      pickedVisual.visualData.vizType,
      pickedVisual.visualData.settings,
      true
    );

    return {
      report_type: pickedVisual.visualData.vizType,
      report_data: pickedVisual.visualData.settings,
    };
};
}());
