window.arc = window.arc || {};

(function() {
  'use strict';

  arc.visual.barColorHelper = arc.visual.barColorHelper || {};

  arc.visual.barColorHelper.determineColorDomain = function(config) {
    const color_start_idx = config.color_column.colindex();
    const color_end_idx = config.last_color_column.colindex();
    const colorColumnsWithOrder = config.columns
      .slice(color_start_idx, color_end_idx + 1)
      .filter((column) => column.order());

    if (!colorColumnsWithOrder.length) {
      return arc.misc.arrayUnique(config.rows, config.color_getter);
    }

    colorColumnsWithOrder.sort(arc.data.sortColumnsByPriority);
    // Collect all the unique colors, with all data to able to sort!
    const uniqueColorsWithRowData = arc.misc.arrayUnique(config.rows, config.color_getter, true);
    // ENGESC-20591: The user can specify ordering on shelves.
    // The data os the backend organized and returned in that order.
    // When a color category is missing from a "column/category",
    // it might not picked up in the correct order via arc.misc.arrayUnique
    // This section makes sure, to get the precise color order!
    function sortByColorOrder(a, b) {
      let i = 0;

      while (i < colorColumnsWithOrder.length) {
        const colindex = colorColumnsWithOrder[i].colindex();
        const value1 = a[colindex];
        const value2 = b[colindex];
        const ordered = config.columns[colindex].order();
        if (ordered) {
          const ascending = config.columns[colindex].order().ascending();
          if (value1 < value2) return ascending ? -1 : 1;
          if (value1 > value2) return ascending ? 1 : -1;
        }

        i += 1;
      }

      return 0;
    }

    uniqueColorsWithRowData.sort(sortByColorOrder);

    return arc.misc.arrayUnique(uniqueColorsWithRowData, config.color_getter);
  };
}());
