window.arc = window.arc || {};

(function() {
'use strict';

arc.visual = arc.visual || {};

arc.visual.trellisId = arc.visual.trellisId || 0;

arc.visual.trellis = function() {
  var sort_orders_asc = {},
      table = arc.misc.trellisTable(),
      destroyed,
      rows,
      columns,
      lib,
      x_shelf_extracol,
      y_shelf_extracol,
      x_shelf_name = 'x_shelf',
      y_shelf_name = 'y_shelf',
      x_shelf_reserved = 0,
      y_shelf_reserved = 0,
      x_trellis,
      y_trellis,
      unique_x_values,
      unique_y_values,
      unique_x_values_to_pos,
      unique_y_values_to_pos,
      unique_x_pos_to_values,
      unique_y_pos_to_values,
      data_columns,
      viz_div,
      viz_div_sel,
      error_state,
      legend_graded_colors,
      legend_column,
      legends,
      reverse_legend_order,
      legend_width_override,
      legendPositioning = 'Right',
      color_is_dim,
      legend_show_cb,
      legend_hide_cb,
      color,
      color_palette,
      colorSettings,
      data_td_sel,
      legend_td_sel,
      legend_width = 0,
      legend_single_element_height,
      legend_height = 0,
      legendMarks,
      legendLabels,
      sortColorLegend = true,
      otherTrellisSettings = [],
      ignoreLargeTrellis = false,
      showAdjacentDuplicates = true,
      xIsMeasureTrellis = false,
      yIsMeasureTrellis = false,
      redrawVisualCb = function() {};

  var isTransition = false;

  let trellisMaxSize = arc.globals.max_trellis_displayed;
  const extendedTypes = ['bullet', 'gauge', 'singlevalue', 'kpi'];

  var trellis = function() { return 'arc.visual.trellis'; };

  trellis.showAdjacentDuplicates = function(_) {
    if (!arguments.length) return showAdjacentDuplicates;
    showAdjacentDuplicates = _;
    return trellis;
  };

  trellis.error_state = function(_) {
    if (!arguments.length) return error_state;
    error_state = _;
    return trellis;
  };

  trellis.ignoreLargeTrellis = function(_) {
    if (!arguments.length) return ignoreLargeTrellis;
    ignoreLargeTrellis = _;
    return trellis;
  };

  trellis.redrawVisualCb = function(_) {
    if (!arguments.length) return redrawVisualCb;
    redrawVisualCb = _;
    return trellis;
  };

  trellis.table = function(_) {
    if (!arguments.length) return table;
    table = _;
    return trellis;
  };

  trellis.legend_width = function() {
    return legend_width;
  };

  trellis.legend_height = function() {
    return legend_height;
  };

  trellis.legend_column = function(_, __) {
    if (!arguments.length) return legend_column;
    legend_column = _;
    color_is_dim = __;
    return trellis;
  };

  trellis.legends = function(_) {
    if (!arguments.length) return legends;
    legends = _;
    return trellis;
  };

  trellis.reverse_legend_order = function(_) {
    if (!arguments.length) return reverse_legend_order;
    if (_ === 'false') {
      reverse_legend_order = false;
      return trellis;
    }

    reverse_legend_order = true;
    return trellis;
  };

  trellis.legend_width_override = function(_) {
    if (!arguments.length) return reverse_legend_order;
    legend_width_override = _;
    return trellis;
  };

  trellis.legendPositioning = function(_) {
    if (!arguments.length) return legendPositioning;
    legendPositioning = _;
    return trellis;
  };

  trellis.legend_show_cb = function(_) {
    if (!arguments.length) return legend_show_cb;
    legend_show_cb = _;
    return trellis;
  };

  trellis.legend_hide_cb = function(_) {
    if (!arguments.length) return legend_hide_cb;
    legend_hide_cb = _;
    return trellis;
  };

  trellis.color = function(_, __, ___) {
    if (!arguments.length) return color;
    color = _;
    color_palette = __;
    colorSettings = ___;
    return trellis;
  };

  trellis.viz_div = function(_) {
    if (!arguments.length) return viz_div;
    viz_div = _;
    return trellis;
  };

  trellis.viz_div_sel = function(_) {
    if (!arguments.length) return viz_div_sel;
    viz_div_sel = _;
    return trellis;
  };

  trellis.getLegendContainer = function() {
    if (legend_td_sel) {
      return $(legend_td_sel.node());
    }
  };

  trellis.getVisualContainer = function() {
    if (data_td_sel) {
      return $(data_td_sel.node());
    }
  };

  trellis.data_columns = function(_) {
    if (!arguments.length) return data_columns;
    data_columns = _;
    return trellis;
  };

  trellis.x_shelf_reserved = function(_) {
    if (!arguments.length) return x_shelf_reserved;
    x_shelf_reserved = _;
    return trellis;
  };

  trellis.y_shelf_reserved = function(_) {
    if (!arguments.length) return y_shelf_reserved;
    y_shelf_reserved = _;
    return trellis;
  };

  trellis.x_shelf_extracol = function(_) {
    if (!arguments.length) return x_shelf_extracol;
    x_shelf_extracol = _;
    return trellis;
  };

  trellis.y_shelf_extracol = function(_) {
    if (!arguments.length) return y_shelf_extracol;
    y_shelf_extracol = _;
    return trellis;
  };

  trellis.x_shelf_name = function(_) {
    if (!arguments.length) return x_shelf_name;
    x_shelf_name = _;
    return trellis;
  };

  trellis.y_shelf_name = function(_) {
    if (!arguments.length) return y_shelf_name;
    y_shelf_name = _;
    return trellis;
  };

  trellis.sort_orders_asc = function(_) {
    if (!arguments.length) return sort_orders_asc;
    sort_orders_asc = _;
    return trellis;
  };

  trellis.rows = function(_) {
    if (!arguments.length) return rows;
    rows = _;
    return trellis;
  };

  trellis.columns = function(_) {
    if (!arguments.length) return columns;
    columns = _;
    return trellis;
  };

  trellis.viz_lib = function(_) {
    if (!arguments.length) return lib;
    lib = _;
    lib.trellis(trellis);
    return trellis;
  };

  trellis.isTransition = function(_) {
    if (!arguments.length) return isTransition;
    isTransition = _;
    return trellis;
  };

  trellis.xIsMeasureTrellis = function(_) {
    if (!arguments.length) return xIsMeasureTrellis;
    xIsMeasureTrellis = _;
    return trellis;
  };

  trellis.yIsMeasureTrellis = function(_) {
    if (!arguments.length) return yIsMeasureTrellis;
    yIsMeasureTrellis = _;
    return trellis;
  };

  trellis.sortColorLegend = function(_) {
    if (!arguments.length) return sortColorLegend;
    sortColorLegend = _;
    return trellis;
  };

  trellis.x_trellis = function() {
    return x_trellis;
  };

  trellis.y_trellis = function() {
    return y_trellis;
  };

  trellis.x_start_idx = function() {
    if (x_trellis.length === 0) {
      return -1;
    }

    return x_trellis[0].colindex();
  };

  trellis.x_end_idx = function() {
    if (x_trellis.length === 0) {
      return -1;
    }

    return x_trellis[x_trellis.length - 1].colindex();
  };

  trellis.x_count = function() {
    return x_trellis.length;
  };

  trellis.y_start_idx = function() {
    if (y_trellis.length === 0) {
      return -1;
    }

    return y_trellis[0].colindex();
  };

  trellis.y_end_idx = function() {
    if (y_trellis.length === 0) {
      return -1;
    }

    return y_trellis[y_trellis.length - 1].colindex();
  };

  trellis.y_count = function() {
    return y_trellis.length;
  };

  trellis.otherTrellisSettings = function(_) {
    if (!arguments.length) return otherTrellisSettings;
    otherTrellisSettings = _;
    return trellis;
  };

  function checkIfTrellisDimension(dim) {
    let error = false;
    for (let i = 0; i < dim.length; i++) {
      if (dim[i].colproperty() !== arc.report.columnTypeEnum.DIMENSION) {
        error = true;
        break;
      }
    }

    return error;
  }

  trellis.setup = function() {

    // Set up default maximum trellises displayed
    if (trellis.viz_lib() && extendedTypes.includes(trellis.viz_lib().viz_type())) {
      trellisMaxSize = Math.max(arc.globals.max_trellis_displayed, 40);
    }

    data_td_sel = viz_div_sel;
    x_trellis = lib.shelf_columns(columns, x_shelf_name);
    y_trellis = lib.shelf_columns(columns, y_shelf_name);

    // Determine indices of trellis
    if (x_trellis.length > 0) {
      x_trellis = x_trellis.slice(0, x_trellis.length - x_shelf_reserved);
    }

    if (y_trellis.length > 0) {
      y_trellis = y_trellis.slice(0, y_trellis.length - y_shelf_reserved);
    }

    // Error check that trellis contains expected values
    if (checkIfTrellisDimension(x_trellis)) {
      lib.alertMessage('Trellis X can only contain dimensions');
      trellis.error_state(true);
      return trellis;
    }

    if (checkIfTrellisDimension(y_trellis)) {
      lib.alertMessage('Trellis Y can only contain dimensions');
      trellis.error_state(true);
      return trellis;
    }

    if (x_trellis.length === 0 && y_trellis.length === 0) {
      lib.toggleTrellisSettings(false, otherTrellisSettings);
    } else {
      lib.toggleTrellisSettings(true, otherTrellisSettings);
    }

    // <<< ⚠️ SORT ⚠️ >>>

    // These variables are defined within the 'trellis' object
    unique_x_values = [];
    unique_y_values = [];
    unique_x_values_to_pos = {};
    unique_y_values_to_pos = {};
    unique_x_pos_to_values = {};
    unique_y_pos_to_values = {};

    const getMeasureSortOrders = (sortOrders) => {
      var measureSortOrders = Object.assign({}, sortOrders);
      delete measureSortOrders['arc-selected-params'];
      return measureSortOrders;
    };

    var measure_sort_orders = getMeasureSortOrders(sort_orders_asc);

    const mapColToNames = (trellis) => trellis.map((col) => col.colname());

    const mapColToSortOrder = (trellis, sortOrders) => trellis.map((col) => {
      const sortOrder = sortOrders[col.colname()];
      if (sortOrder != null) {
        return sortOrder;
      }

      return arc.consts.SORT_OPTION_UNSORTED;
    });

    const removeDimsFromMeasureSortOrders = (cols, measureSortOrders) => {
      cols.forEach((colName) => {
        delete measureSortOrders[colName];
      });

      Object.keys(measureSortOrders).forEach((colName) => {
        if (!cols.includes(colName)) {
          delete measureSortOrders[colName];
        }
      });
    };

    const xColNames = mapColToNames(x_trellis);
    const yColNames = mapColToNames(y_trellis);

    removeDimsFromMeasureSortOrders([...xColNames, ...yColNames], measure_sort_orders);

    const x_sort_orders = mapColToSortOrder(x_trellis, sort_orders_asc);
    const y_sort_orders = mapColToSortOrder(y_trellis, sort_orders_asc);

    const convertNullOrUndefinedToEmptyString = (rows) => {
      rows.forEach((row) => {
        row.forEach((col, i) => {
          if (col == null) {
            row[i] = '';
          }
        });
      });
    };

    convertNullOrUndefinedToEmptyString(rows);

    const getMeasureCol = (columns, measureSortOrders) =>
      columns.find(col =>
        typeof measureSortOrders[col.colname()] !== 'undefined');

    const expansionSetting = lib.user_settings().find_by_id('totals_above_expansions');
    const showTotalsAbove = expansionSetting && expansionSetting.isChecked;

    if (trellis.x_count()) {
      unique_x_values = arc.misc.arrayUnique(rows, trellis.x_getter);

      if (!xIsMeasureTrellis) {
        arc.misc.arrayMultiSort(unique_x_values, x_sort_orders.map((order) =>
          order == null ? arc.consts.SORT_OPTION_UNSORTED : order), showTotalsAbove);
      }

      unique_x_values.forEach(function(d, i) {
        unique_x_values_to_pos[d] = i;
        unique_x_pos_to_values[i] = d;
      });

      if (x_shelf_extracol) {
        var x_tmp = [];
        unique_x_values.forEach(function(d) {
          d = d.slice(0);
          x_shelf_extracol.colvalues().forEach(function(colval) {
            d.push(colval);
            x_tmp.push(d);
          });
        });

        unique_x_values = x_tmp;
      }

    } else {
      if (x_shelf_extracol) {
        unique_x_values = x_shelf_extracol.colvalues().map(function(c) {
          return [c];
        });
      }
    }

    if (trellis.y_count()) {
      let skipSort = false;
      /**
       * If the user wants to have the trellis (crosstab) sorted by a measure
       * a very weird thing happens by default
       *
       * Basically, it says: if it's sorted by a measure value and not a bar
       * and if it's got filters (it can happen when there's x values)
       */
      const getFilters = (sortOrders) => {
        const filters = Object.assign(
          {},
          sortOrders['arc-selected-params'] || {}
        );
        delete filters['arc-measure-colname'];
        return filters;
      };

      const hasFilters = (sortOrders) => {
        const filters = getFilters(sortOrders);
        return Object.keys(filters).length > 0;
      };

      const measureCol = getMeasureCol(columns, measure_sort_orders);
      const getFilteredCols = (filters, trellis) => {
        const filteredCols = Object.keys(filters).map((colName) =>
          trellis.filter((col) => colName === col.colname())[0]
        );

        return filteredCols.filter((col) => typeof (col) !== 'undefined');
      };

      const getFilteredRows = (rows, filteredCols, sortOrders) => {
        const filteredOutRows = [];
        const filteredRows = rows.filter((row) => {
          const condition = !filteredCols.some((filterCol) => {
            const i = filterCol.colindex();
            const name = filterCol.colname();
            return (row[i] !== sortOrders['arc-selected-params'][name]);
          });

          if (condition) {
            return true;
          }

          filteredOutRows.push(row);
          return false;
        });

        return { filteredRows, filteredOutRows };
      };

      if (
        measureCol &&
        x_trellis.length &&
        hasFilters(sort_orders_asc) &&
        !(xIsMeasureTrellis || yIsMeasureTrellis)
      ) {
        const filteredCols = getFilteredCols(
          getFilters(sort_orders_asc),
          x_trellis
        );
        const {
          filteredRows,
          filteredOutRows,
        } = getFilteredRows(rows, filteredCols, sort_orders_asc);

        /**
         * If there's filtered rows, it's just a subset and we only
         * need to sort the subset based on the measure value
         */
        if (filteredRows.length) {
          const o = {
            [measureCol.colindex()]: measure_sort_orders[measureCol.colname()],
          };
          arc.misc.arrayMultiSort(filteredRows, o, showTotalsAbove);

          // TODO: this was the original code but it's probably
          // not the expected behaviour: it always puts the subset at the
          // beginning of the array 🤷‍♂️. I'll keep it as is for now.
          rows = filteredRows.concat(filteredOutRows);
          skipSort = true;
        }

      }

      const calculateSortObject = (sortObject, sortOrders, measureCol) => {
        const orders = sortObject.map(
          (order) => order == null ? arc.consts.SORT_OPTION_UNSORTED : order
        );
        if (measureCol) {
          if (typeof sortOrders[measureCol.colname()] !== 'undefined') {
            orders[measureCol.colindex()] = sortOrders[measureCol.colname()];
          } else {
            orders[measureCol.colindex()] = arc.consts.SORT_OPTION_UNSORTED;
          }
        }

        return orders;
      };

      unique_y_values = arc.misc.arrayUnique(rows, trellis.y_getter);

      if (!yIsMeasureTrellis && !skipSort) {
        const sortObject = calculateSortObject(y_sort_orders, sort_orders_asc, measureCol);
        arc.misc.arrayMultiSort(unique_y_values, sortObject, showTotalsAbove);
      }

      unique_y_values.forEach(function(d, i) {
        unique_y_values_to_pos[d] = i;
        unique_y_pos_to_values[i] = d;
      });

      if (y_shelf_extracol) {
        var y_tmp = [];
        unique_y_values.forEach(function(d) {
          d = d.slice(0);
          y_shelf_extracol.colvalues().forEach(function(colval) {
            d.push(colval);
            y_tmp.push(d);
          });
        });

        unique_y_values = y_tmp;
      }
    } else {
      if (y_shelf_extracol) {
        unique_y_values = y_shelf_extracol.colvalues().map(function(c) {
          return [c];
        });
      }
    }

    let numTrellisCells = (Math.max(1, unique_y_values.length) *
      Math.max(1, unique_x_values.length));
    if (!ignoreLargeTrellis && numTrellisCells > trellisMaxSize) {
        trellis.drawOverloadError(numTrellisCells);
        trellis.error_state(true);
    }

    trellis.unique_x_pos_to_values = unique_x_pos_to_values;
    trellis.unique_y_pos_to_values = unique_y_pos_to_values;

    set_table_headers();
    return trellis;
  };

  trellis.drawOverloadError = function(numTrellisCells) {
    let allowSaveSetting = lib.inModal() && arc.globals.singleVisualBuilder &&
      arc.globals.is_edit;

    let errorDiv =
      viz_div_sel
        .append('div')
        .classed('alert', true)
        .classed('alert-warning', true);

    errorDiv
      .append('div')
      .append('p')
      .text('You are about to draw a visual trellis with a large number of charts (' +
        numTrellisCells + '). This may render slowly.');

    if (allowSaveSetting) {
      let checkboxLabel =
        errorDiv
          .append('div')
          .classed('checkbox', true)
            .append('label')
            .classed('checkbox', true);

      checkboxLabel
        .html('<input type="checkbox" class="form-text"><small>Permanently skip' +
          ' this error in the future for this field selection configuration.</small>');
    } else {
      errorDiv
        .append('div')
        .append('p')
          .classed('form-text', true)
          .html('<small>Click "Continue" to proceed.</small>');
    }

    errorDiv
      .append('button')
      .attr('type', 'button')
      .classed('btn', true)
      .classed('btn', 'btn-secondary')
      .text('Continue');

    errorDiv
      .select('button')
      .on('click', function() {
        if (allowSaveSetting) {
          let allowLargeTrellisPerm = errorDiv.select('input').property('checked');
          if (allowLargeTrellisPerm && lib && lib.viz()) {
            lib.viz().allowLargeTrellisPerm(true);
            lib.page_needs_save();
          }
        }

        redrawVisualCb();
      });
  };

  function unique_values(array_of_arrays) {
    var all_vals = [];
    array_of_arrays.forEach(function(arrays_vals, i) {
      if (i === 0) {
        arrays_vals.forEach(function(x, xi) {
          all_vals[xi] = [x];
        });

        return;
      }

      arrays_vals.forEach(function(x, xi) {
        all_vals[xi].push(x);
      });
    });

    var uniques_by_pos = [];
    all_vals.forEach(function(vals, i) {
      uniques_by_pos[i] = arc.misc.arrayUnique(vals);
    });

    return uniques_by_pos;
  }

  trellis.x_screen_len = function() {
    if (!trellis.is_active()) {
      return 0;
    }

    // Compute the amount of space on the screen that the trellis will take
    var uniques_by_pos = unique_values(unique_y_values);
    var textlen = [];
    uniques_by_pos.forEach(function(u, i) {
      if (y_trellis[i]) {
        u.push(y_trellis[i].colname());
      }

      textlen[i] = lib.dim_axis_max_textlen(u, undefined,
          lib.getTrellisFontSize());
    });

    return textlen.reduce(
      function(pv, cv) {
        return pv + cv + 20;
      },

      /* initial value */ 20);
  };

  trellis.unique_x_values = function() {
    return unique_x_values;
  };

  trellis.unique_y_values = function() {
    return unique_y_values;
  };

  trellis.unique_x_values_to_pos = function() {
    return unique_x_values_to_pos;
  };

  trellis.unique_y_values_to_pos = function() {
    return unique_y_values_to_pos;
  };

  trellis.unique_x_pos_to_values = function() {
    return unique_x_pos_to_values;
  };

  trellis.unique_y_pos_to_values = function() {
    return unique_y_pos_to_values;
  };

  trellis.x_getter = function(d) {
    if (trellis.x_count() === 0) {
      return undefined;
    }

    return d.slice(trellis.x_start_idx(), trellis.x_end_idx() + 1);
  };

  trellis.getFixedParams = function(d) {
    let params = [];

    if (trellis.x_count() > 0) {
      for (let i = trellis.x_start_idx(); i <= trellis.x_end_idx(); ++i) {
        params = params.concat(lib.param_from_column(columns[i], undefined, d));
      }
    }

    if (trellis.y_count() > 0) {
      for (let i = trellis.y_start_idx(); i <= trellis.y_end_idx(); ++i) {
        params = params.concat(lib.param_from_column(columns[i], undefined, d));
      }
    }

    return params;
  };

  trellis.x_pos_getter = function(d) {
    var x = trellis.x_getter(d);
    if (x === undefined) {
      return 0;
    }

    return unique_x_values_to_pos[x];
  };

  trellis.y_getter = function(d) {
    if (trellis.y_count() === 0) {
      return undefined;
    }

    return d.slice(trellis.y_start_idx(), trellis.y_end_idx() + 1);
  };

  trellis.y_pos_getter = function(d) {
    var y = trellis.y_getter(d);
    if (y === undefined) {
      return 0;
    }

    return unique_y_values_to_pos[y];
  };

  trellis.sorting = function(div_sel, redraw_cb) {
    $(div_sel[0])
      .offOn('click.sortorder', '.viz-col-sort', function() {
        var pos = Number(this.dataset.pos);
        var isMeasure = this.dataset.isMeasure === 'true';

        var colname = !isMeasure ? columns[pos].colname() : data_columns[pos].colname();
        sort_orders_asc['arc-selected-params'] = $(this).data('click-info');

        const $this = $(this);
        if ($this.hasClass('desc')) {
          sort_orders_asc[colname] = arc.consts.SORT_OPTION_UNSORTED;
        } else if ($this.hasClass('asc')) {
          sort_orders_asc[colname] = false;
        } else {
          sort_orders_asc[colname] = true;
        }

        if (lib.build_mode()) {
          lib.page_needs_save();
        }

        redraw_cb();
      });

    return trellis;
  };

  function set_table_headers() {
    var unique_x_data_values = unique_x_values;

    // The first table row describes the x axis columns
    // The next x_cnt table rows describe the values in the x axis columns
    // The final table row is for the measure names
    var x_headers = table.x_headers(),
        y_headers = table.y_headers();
    var desc = '';
    var x_header_txtl = [];
    data_columns = data_columns || [];
    var headerConfig = {
      sort_orders_asc: sort_orders_asc,
      trellis: trellis,
    };

    if (trellis.x_count()) {
      headerConfig.headerType = 'x_header';
      x_trellis.forEach((column) => {
        headerConfig.pos = column.colindex();
        headerConfig.colname = column.colname();
        desc = (column.coldesc() || column.colname() || '');
        x_header_txtl.push(`<span class= "x-label" desc=${desc}>`);
        x_header_txtl.push(arc.misc.getHeaderSorter(headerConfig, desc));
        x_header_txtl.push('</span>');
      });

      x_headers.data(0, 0, 0, x_header_txtl.join(''));
      var currentCol = 0;
      unique_x_data_values.forEach(function(d) {
        x_trellis.forEach(function(column, column_idx) {
          if (column.coldisplayformat(true)) {
            d[column_idx] = lib.formattedDisplay(column.coldisplayformat(), d[column_idx]);
          } else if (lib.viz_type() === 'crosstab' && column.isNumeric()) {
            // override default number format for crosstab
            d[column_idx] = lib.formattedDisplay(d3.format(','), d[column_idx]);
          }
        });

        if (x_shelf_extracol) {
          d = d.slice(0, d.length - x_shelf_extracol.colvalues().length);
        }

        x_headers.data_row_range(1, currentCol, 0, d);
        data_columns.forEach(function (d, j) {
          x_headers.data_row_range(2 + trellis.x_count(), currentCol, 0, [d.colname()]);
          currentCol++;
        });

        if (data_columns.length === 0) {
          currentCol++;
        }
      });

    } else {
      unique_x_data_values.forEach(function(d, i) {
        x_headers.data_row_range(1, i, 0, d);
      });

      if (unique_x_data_values.length === 0) {
        data_columns.forEach(function (d, j) {
          x_headers.data_row_range(0, 1 + j, 0, [d.colname()]);
        });
      }
    }

    headerConfig = {
      sort_orders_asc: sort_orders_asc,
      trellis: trellis,
    };

    if (trellis.y_count()) {
      headerConfig.headerType = 'y_header';
      y_trellis.forEach((column, col_i) => {
        headerConfig.pos = column.colindex();
        headerConfig.colname = column.colname();
        desc = (column.coldesc() || column.colname());
        x_header_txtl.push(`<span desc="${desc}">`);
        y_headers.data(0, 0, col_i, `<span class="y-label" desc="${desc || ''}">${arc.misc.getHeaderSorter(headerConfig, desc)}</span>`);
      });

      unique_y_values.forEach((d, i) => {
        y_trellis.forEach((column, column_idx) => {
          if (column.coldisplayformat(true)) {
            d[column_idx] = lib.formattedDisplay(column.coldisplayformat(), d[column_idx]);
          } else if (lib.viz_type() === 'crosstab' && column.isNumeric()) {
            // override default number format for crosstab
            d[column_idx] = lib.formattedDisplay(d3.format(','), d[column_idx]);
          }
        });

        if (y_shelf_extracol) {
          d = d.slice(0, d.length - y_shelf_extracol.colvalues().length);
        }

        y_headers.data_col_range(i + 1, 0, 0, d);
      });
    }

    if (!showAdjacentDuplicates) {
      y_headers.remove_identical_adjacent_rows();
    }

    return trellis;
  }

  /*
   * Add tooltips to trellis elements.
   * If 'additional_params_cb' is not set, then we do not create tooltips
   * for non-header elements. If 'additional_params_cb' is set, we do create
   * tooltips for non-header elements, and rely on the implementation to
   * provide data relevant to those cells.
   * For header elements, we show the description or name of the column.
   */
  trellis.tooltips = function(marker_name, additional_params_cb) {
    var x_offset = table.y_headers().max_cols(),
        yOffsetWithXTrellis = Object.keys(table.x_headers().rows()).length,
        yOffsetWithoutXTrellis = 1,
        y_offset = yOffsetWithXTrellis ? yOffsetWithXTrellis : yOffsetWithoutXTrellis;

    // There is always at least one data element within the trellis
    var data_cnt = data_columns ? Math.max(data_columns.length, 1) : 1;

    var param_elem = function(col, value) {
      return {
        key: col.colname(),
        value: value,
        desc: col.coldesc(),
        keytype: col.colproperty(),
        valuetype: col.coltype(),
        expr: col.expr(),
        source_visual_id: lib ? lib.report_id() : 0,
        source_dataset_id: lib ? lib.dataset_id() : -1,
        formatter: function(arg) {
          return arg;
        },
      };
    };

    var elem_to_pos = function(elem) {
      var x,
          y,
          data_idx;
      {
        var e_parent = $(elem).parent(),
            siblings = e_parent.children(),
            cur_idx = siblings.index(elem),
            x_tmp = 0;
        for (var i = 0; i < cur_idx; i++) {
          x_tmp += Number(siblings[i].getAttribute('colspan')) || 1;
        }

        x_tmp -= x_offset;

        if (elem.dataset.colidx) {
          x_tmp = elem.dataset.colidx;
        }

        if (x_tmp >= 0) {
          x = Math.floor(x_tmp / data_cnt);
        } else {
          x = x_tmp;
          x_tmp = Math.abs(x_tmp);
        }

        var y_tmp = e_parent.parent().children().index(elem.parentNode);
        y = y_tmp - y_offset;
        if (y_tmp === 0) {
          x = -1;
        }

        data_idx = x_tmp % data_cnt;
      }

      return [x, y, data_idx];
    };

    var params_fn = function(d, i, elem, exclude_base_params) {
      var pos = elem_to_pos(elem);
      var x = pos[0],
          y = pos[1],
          data_idx = pos[2];

      if (x < 0 && y < 0) {
        var desc = elem.getAttribute('desc');
        if (desc) {
          return [
            {
              key: desc,
            },
          ];
        } else {
          return [];
        }
      }

      var params = [],
          new_keys = {},
          x_data = unique_x_pos_to_values[x],
          y_data = unique_y_pos_to_values[y],
          col,
          v;

      if (x_data) {
        x_data = x_data.slice(0, y_offset + y);
        for (var x_i = 0; x_i < x_data.length; ++x_i) {
          col = x_trellis[x_i];
          v = lib.d_string(x_data[x_i]);
          if (!arc.misc.isCrosstabExpandPrefix(v)) {
            params.push(param_elem(col, v));
            new_keys[col.colname()] = true;
          }
        }
      }

      if (y_data) {
        // We add 1 as an additional offset compensating first row with no tooltip
        y_data = y_data.slice(0, x_offset + x + 1);
        for (var y_i = 0; y_i < y_data.length; ++y_i) {
          col = y_trellis[y_i];
          v = lib.d_string(y_data[y_i]);
          if (!arc.misc.isCrosstabExpandPrefix(v)) {
            params.push(param_elem(col, v));
            new_keys[col.colname()] = true;
          }
        }
      }

      if ((x >= 0) && (y >= 0)) {
        additional_params_cb(params, elem, x_data, y_data, data_idx);
        new_keys[data_columns[data_idx].colname()] = true;
      }

      // Return back all the params
      // if there is no explicit 'exlude_base_params' argument
      if (exclude_base_params) {
        return params;
      } else {
        var base_params = lib.getParams().getCopy();
        var ret_params = base_params.filter(function(p) {
          return !Object.keys(new_keys)
                        .map(arc.params.convertKey)
                        .includes(arc.params.convertKey(p.key));
        });

        params.forEach(function(p) {
          ret_params.push(p);
        });

        return ret_params;
      }
    };

    var text_fn = function(d, i, elem) {

      // If hover on icons, do not show tooltips.
      if ($(elem).is('i')) {
        return;
      }

      const aggColIdx = $(elem).find('>i').data('pos');
      if (lib.viz_type() === 'crosstab' && $(elem).hasClass('viz-td-header') &&
          $.isNumeric(aggColIdx)) {
        return data_columns[aggColIdx].coldesc() || data_columns[aggColIdx].colname();
      }

      const params = params_fn(d, i, elem, true);
      return lib.tooltip_from_kvs(params);
    };

    if (!data_td_sel) {
      return trellis;
    }

    var cells =
      data_td_sel.select('table')
                 .selectAll('td');
    if (!additional_params_cb) {
      cells = cells.filter(function(d, i) {
                return $(this).hasClass('viz-td-header');
              });
    }

    if (cells && cells[0] && cells[0].length > 0) {
      arc.marks()
        .viz_lib(lib)
        .highlight_on_select(true)
        .marker_name(marker_name)
        .addSelection(cells)
        .text_fn(text_fn)
        .params_fn(params_fn)
        .activate();
    }

    return trellis;
  };

  function draw_legend_frame() {
    data_td_sel = viz_div_sel;

    if ((legend_column === undefined) && (legends === undefined) && color_is_dim) {
      return trellis;
    }

    if (isTransition) {
      return trellis;
    }

    /*
     * Draw a table containing 2 columns
     * - the first column holds the visualization
     * - the second column holds the trellis
     */

    let d3_tbody =
      viz_div_sel
        .append('table')
        .attr('class', 'viz-trellis-outertable')
          .append('tbody');

    switch (legendPositioning) {
      case 'Right':
        d3_tbody
          .append('tr')
          .selectAll('td')
          .data([0, 1])
          .enter()
            .append('td')
            .attr('id', function() {
              return `outer-trellis-${++arc.visual.trellisId}`;
            })
            .each(function(d, i) {
              if (i === 0) {
                data_td_sel = d3.select(this);
                return;
              }

              legend_td_sel =
                d3.select(this)
                  .style('vertical-align', 'top');
            });

        break;
      case 'Above':
        d3_tbody
          .append('tr')
          .selectAll('td')
          .data([0])
          .enter()
            .append('td')
            .attr('id', function(d, i) {
              legend_td_sel =
                d3.select(this)
                  .style('vertical-align', 'top');

              return `outer-trellis-${++arc.visual.trellisId}`;
            });

        d3_tbody
          .append('tr')
          .selectAll('td')
          .data([0])
          .enter()
            .append('td')
            .attr('id', function(d, i) {
              data_td_sel = d3.select(this);
              return `outer-trellis-${++arc.visual.trellisId}`;
            });

        break;
      case 'Bottom':
        d3_tbody
          .append('tr')
          .selectAll('td')
          .data([0])
          .enter()
            .append('td')
            .attr('id', function(d, i) {
              data_td_sel = d3.select(this);
              return `outer-trellis-${++arc.visual.trellisId}`;
            });

        d3_tbody
          .append('tr')
          .selectAll('td')
          .data([0])
          .enter()
            .append('td')
            .attr('id', function(d, i) {
              legend_td_sel =
                d3.select(this)
                  .style('vertical-align', 'top');

              return `outer-trellis-${++arc.visual.trellisId}`;
            });

        break;
      default:
        break;
    }

    return trellis;
  }

  trellis.draw_legend = function() {
    if ((legend_column === undefined) && (legends === undefined) && color_is_dim) {
      return trellis;
    }

    if (!(legendPositioning && legendPositioning !== 'None')) {
      // Don't draw if legendPositioning is None or is a falsy value
      return trellis;
    }

    // If the legends are numeric, set up a soft function so we display the
    // legends in a natural order.
    let sort_fn;
    if ((legend_column &&
         legend_column.colindex &&
         lib.idx_is_numeric(rows, legend_column.colindex())) ||
        (legends && lib.idx_is_numeric(legends))) {
      sort_fn = function (a, b) {
          return a - b;
      };
    }

    if (!legend_td_sel) {
      return;
    }

    let ldiv;
    if (isTransition) {
      ldiv = legend_td_sel.select('.arc-legend-container');
    } else {
      ldiv = legend_td_sel.append('div')
                          .classed('arc-legend-container', true)
                          .style('overflow-y', 'auto')
                          .style('overflow-x', 'hidden');
    }

    // If the legend is being placed Above or Bottom, don't give a size to the container.
    // Else, the div holding the color palette is sized to the height of the container
    //   minus some padding. That way, the legend svg will scroll within the div.
    let legendContainerWidth;
    if (legendPositioning === 'Right') {
      const padding = 20;
      ldiv.style('height', `${$(viz_div_sel[0]).height() - padding}px`);
    } else if (legendPositioning === 'Above' || legendPositioning === 'Bottom') {
      legendContainerWidth = Math.max(
                              $(viz_div_sel.node()).find('table.viz-trellis-outertable').width(),
                              $(viz_div_sel.node()).width()
                            );

      ldiv.style('width', `${legendContainerWidth}px`);
    }

    let lsvg;
    if (isTransition) {
      lsvg = ldiv.select('.arc-viz-legend');
      trellis.destroyLegendHighlights();
    } else {
      lsvg = ldiv.append('svg').classed('arc-viz-legend', true);
    }

    let legend_values;
    if (legends) {
      if (sortColorLegend) {
        legend_values = legends.sort(sort_fn);
      } else {
        legend_values = legends;
      }
    } else if (legend_column) {
      let temp_col_index = legend_column.colindex();
      legend_values = arc.misc.arrayUnique(rows, function(d) {
        return d[temp_col_index];
      }).sort(sort_fn);
    } else if (!color_is_dim) {
      legend_values = [];
      if (color_palette) {
        for (let i = 0; i < color_palette.length; ++i) {
          legend_values.push(color.invert(i));
        }
      }
    }

    let legendType = 'continuous';
    if (color_is_dim || !color_palette) {
      // Legends need to be be discrete when:
      //  config.color_is_dim: There is no aggregate in scatter plots, heat maps, etc
      //  EXCEPT: When aggregates are used as colors in bar/line/area, etc graphs
      //  Currently, trellises do not support area legends.
      legendType = 'discrete';
    }

    let displayFunc;
    if (legend_column) {
      displayFunc = legend_column.formatForDisplay;
    }

    let formatted_values = displayFunc ?
        legend_values.map(d => lib.safeFormatting({ formatter: displayFunc, value: d })) :
        legend_values;

    let legend_bounds;
    if (!displayFunc && lib.idx_is_numeric(legend_values)) {
      formatted_values = legend_values.map(d => lib.tickFormatDefaultNumeric(d));
    }

    formatted_values = lib.axisValuesFitToMax(formatted_values);
    legend_bounds = lib.axis_values_maxbounds(formatted_values, undefined,
        lib.getLegendFontSize());

    legend_single_element_height = legend_bounds.height;

    // Add width to legend svg so legend appears
    if (legend_width_override) {
      legend_width = legend_width_override;
    } else {
      const legend_extra_horizontal_margin = 40;

      legend_width = legend_bounds.width + legend_extra_horizontal_margin;
      if (legend_single_element_height > 10) {
        legend_width += legend_single_element_height - 10;
      }
    }

    if (legendPositioning === 'Right') {
      lsvg.style('width', arc.misc.parseD3Style(legend_width));
    } else if (legendPositioning === 'Above' || legendPositioning === 'Bottom') {
      lsvg.style('width', arc.misc.parseD3Style(legendContainerWidth));
    }

    let config = {
      legendType,
      legendPositioning,
      legendContainerWidth,
      color,
      legend_column,
      color_is_dim,
      color_palette,
      colorSettings,
      legend_width,
      legend_single_element_height,
      reverse_legend_order,
      isTransition,
      svg: lsvg,
      width: 0,
      legends: formatted_values,
      unformatted_legends: legend_values,
      sort_domain: true,
      cm_show_cb(contextmenu, params) {
        if (legend_show_cb) {
          legend_show_cb(contextmenu, params);
        }
      },

      cm_hide_cb(contextmenu) {
        if (legend_hide_cb) {
          legend_hide_cb(contextmenu);
        }
      },
    };

    lib.draw_legend(config);
    legend_height = config.legend_height || 0;

    return trellis;
  };

  trellis.addLegendHighlights = function(config) {
    if (!legend_td_sel) {
      return trellis;
    }

    legendMarks = legend_td_sel.selectAll('.arc-legend-container rect');
    legendLabels = legend_td_sel.selectAll('.arc-legend-container text.arc-legend-label');

    if (config) {
      const {
        getLegendFromRow,
        highlightFn,
      } = config;

      legendMarks.each(function(legendLabel) {
        const rowsForLegend = config.rows.filter((row) => getLegendFromRow(row) === legendLabel);
        $(this)
          .offOn('mouseenter.legend', () => {
            highlightFn(rowsForLegend);
          })
          .offOn('mouseleave.legend', () => {
            highlightFn([]);
          });
      });
    } else {
      const marksByData = {};
      lib.marks().forEach((mark) => {
        const getLegendVal = mark.legendValueGetter();
        if (!getLegendVal) {
          return;
        }

        mark.selections().forEach((sel) => {
          sel.each(function(mark_d, mark_d_i) {
            const data = getLegendVal(mark_d, mark_d_i);
            if (marksByData[data]) {
              marksByData[data].push(d3.select(this));
            } else {
              marksByData[data] = [d3.select(this)];
            }
          });
        });
      });

      const createLegendHighlights = ($legend, marksForLegend) => {
        $legend
        .offOn('mouseenter.legend', () => {
          marksForLegend.forEach((sel) => {
            sel.classed('highlight-hover', true);
          });
        })
        .offOn('mouseleave.legend', () => {
          marksForLegend.forEach((sel) => {
            sel.classed('highlight-hover', false);
          });
        });
      };

      legendMarks.each(function(legend_d) {
        if (marksByData[legend_d]) {
          marksByData[legend_d].push(d3.select(this));
        } else {
          marksByData[legend_d] = [d3.select(this)];
        }

        createLegendHighlights($(this), marksByData[legend_d]);
      });

      legendLabels.each(function(data) {
        createLegendHighlights($(this), marksByData[data]);
      });
    }

    return trellis;
  };

  trellis.draw_skeleton = function(redraw_cb) {
    if (destroyed) {
      console.log('error: redrawing destroyed trellis');
      return trellis;
    }

    draw_legend_frame();
    if (!trellis.is_active()) {
      return trellis;
    }

    var trellis_data = table.data();

    var ux = unique_x_values;
    var uy = unique_y_values;

    ux.forEach(function(x_val, x_i) {
      if (uy.length === 0) {
        trellis_data.data(0, x_i, 0,
            '<div data-xpos="' + x_i +
            '" class="viz-trellis-div" id="trellis-' +
            (++arc.visual.trellisId) + '"></div>');
      }

      uy.forEach(function(y_val, y_i) {
        trellis_data.data(y_i, x_i, 0,
            '<div data-xpos="' + x_i + '" data-ypos="' + y_i +
            '" class="viz-trellis-div" id="trellis-' +
            (++arc.visual.trellisId) + '"></div>');
      });
    });

    if (ux.length === 0) {
      var x_i = 0;
      uy.forEach(function(y_val, y_i) {
        trellis_data.data(y_i, x_i, 0,
            '<div data-xpos="' + x_i + '" data-ypos="' + y_i +
            '" class="viz-trellis-div" id="trellis-' +
            (++arc.visual.trellisId) + '"></div>');
      });
    }

    let borders = true;
    if (lib) {
      borders = lib.trellisBorders();
    }

    var div_sel = data_td_sel.append('div');
    const tableString = `table ${borders ? 'table-bordered' : 'table-noborder'} viz-trellis-table`;
    var rendered_table = table.draw(tableString, sort_orders_asc, trellis);
    div_sel.html(rendered_table);

    const trellisFontSize = lib.getTrellisFontSize();
    if (trellisFontSize) {
      div_sel.selectAll('.viz-td-header')
             .style('font-size', trellisFontSize + 'px');
    }

    trellis.sorting(div_sel, redraw_cb);
    return trellis;
  };

  function handleVisibilityOfTrellisLabels() {
    /* y_t = Y trellis label, y_v = Y trellis value, v = value
              [          ][x_t] <-- hide    |   [y_t][ ] <-- hide      |  [x_t] <-- hide
     hide  -->[y_t1][y_t2][x_v]             |   [y_v][v]               |  [ v ]
              [y_v1][y_v2][x_v]             |   [y_v][v]               |  [ v ]
              [y_v1][y_v2][x_v]             |   [y_v][v]               |  [ v ]
              [y_v1][y_v2][x_v]             |   [y_v][v]               |  [ v ]
    */
    const $chartDiv = $(`#${lib.chart_div()}`);
    const $xTrellisLabelContainer = $chartDiv.find('.x-label').closest('.viz-tr-header');
    const hideXTrellisSetting = lib.user_settings().find_by_id('hide_x_trellis');
    const hideYTrellisSetting = lib.user_settings().find_by_id('hide_y_trellis');

    if (!hideXTrellisSetting && !hideYTrellisSetting) {
      return;
    }

    if (hideXTrellisSetting.value() === 'true') {
      $xTrellisLabelContainer.hide();
    } else {
      $xTrellisLabelContainer.show();
    }

    const $yTrellisLabel = $chartDiv.find('.y-label');
    const $yTrellisLabelContainer = $yTrellisLabel.closest('.viz-tr-header');

    // Y label can be on the top (just like the X as above),
    // but if both trellis is given it is in the cross section of vertical and horizontal
    const $yTrellisLabelToHide =
     $yTrellisLabelContainer.length ? $yTrellisLabelContainer : $yTrellisLabel;
    if (hideYTrellisSetting.value() === 'true') {
      $yTrellisLabelToHide.hide();
    } else {
      $yTrellisLabelToHide.show();
    }
  }

  trellis.draw_visuals = function(draw_cb) {
    if (!trellis.is_active()) {
      draw_cb(data_td_sel, rows, undefined, undefined, 0);
      return;
    }

    data_td_sel
      .selectAll('.viz-trellis-div')
      .each(function(_d, i) {
        var xpos = this.dataset.xpos,
            ypos = this.dataset.ypos,
            xmeasure,
            ymeasure;
        if (xpos !== undefined) {
          if (x_shelf_extracol) {
            xmeasure = x_shelf_extracol.colvalues()[
                xpos % x_shelf_extracol.colvalues().length];
            xpos = Math.floor(xpos / x_shelf_extracol.colvalues().length);
          }
        }

        if (ypos !== undefined) {
          if (y_shelf_extracol) {
            ymeasure = y_shelf_extracol.colvalues()[
                ypos % y_shelf_extracol.colvalues().length];
            ypos = Math.floor(ypos / y_shelf_extracol.colvalues().length);
          }
        }

        var xy_rows = rows.filter(function(row) {
          if (xpos !== undefined) {

            // xpos can be either number or string, so double equality works here
            if (xpos != trellis.x_pos_getter(row)) {
              return false;
            }

          }

          if (ypos !== undefined) {
            if (ypos != trellis.y_pos_getter(row)) {
              return false;
            }
          }

          return true;
        });

        draw_cb(d3.select(this), xy_rows, xmeasure, ymeasure, i);
      });

      handleVisibilityOfTrellisLabels();
    return trellis;
  };

  trellis.trellisCellsCount = function() {
    if (!trellis.is_active()) {
      return 1;
    }

    return data_td_sel.selectAll('.viz-trellis-div').size();
  };

  trellis.trellisCellsCb = function(cb) {
    if (!trellis.is_active()) {
      cb(data_td_sel);
      return;
    }

    data_td_sel
      .selectAll('.viz-trellis-div')
      .each(function(d, i) {
        cb(d3.select(this), i);
      });

    return trellis;
  };

  trellis.is_active = function() {
    if (x_trellis.length > 0) {
      return true;
    }

    if (y_trellis.length > 0) {
      return true;
    }

    if (x_shelf_extracol) {
      return true;
    }

    if (y_shelf_extracol) {
      return true;
    }

    return false;
  };

  trellis.destroyLegendHighlights = function() {
    if (legendMarks) {
      legendMarks.each(function() {
        $(this).off('mouseenter.legend');
        $(this).off('mouseleave.legend');
      });

      legendMarks = undefined;
    }

    if (legendLabels) {
      legendLabels.each(function() {
        $(this).off('mouseenter.legend');
        $(this).off('mouseleave.legend');
      });

      legendLabels = undefined;
    }
  };

  trellis.destroy = function() {
    if (destroyed) {
      return;
    }

    destroyed = true;
    d3.selectAll('.viz-col-sort')
      .on('click.sortorder', undefined);

    trellis.destroyLegendHighlights();

    viz_div_sel = undefined;
    data_td_sel = undefined;
    legend_td_sel = undefined;

    legend_show_cb = undefined;
    legend_hide_cb = undefined;
    redrawVisualCb = undefined;
  };

  return trellis;
};

}());
