window.arc = window.arc || {};

(function() {
'use strict';

arc.report = arc.report || {};

arc.report.conditionalAggHandler = function() {
  let f = function() { return 'conditionalAggHandler'; };

  let element,
      d3_elem;

  const $propertiesPanel = $('.properties-panel');

  f.element = function(_) {
    if (!arguments.length) return element;
    element = _;
    return f;
  };

  f.d3_elem = function(_) {
    if (!arguments.length) return d3_elem;
    d3_elem = _;
    return f;
  };

  f.setup = function() {
    const $modal = $('#conditional-agg-modal'),
          container = 'conditional-relative-date-holder',
          $container = $(`#${container}`);

    if (arc.misc.modalShown($modal)) {
      console.log('modal already open');
      return;
    }

    let currentSelectionsRelative;
    let conditionalAggData = element.conditionalAgg();
    if (conditionalAggData) {
      currentSelectionsRelative = conditionalAggData.relative_date;
    }

    arc.filter.helpers.drawRelative({
        $container,
        currentSelectionsRelative,
        timeformat: 'YYYY-MM-DD',
        showtime: false,
        container_div_id: container,
        $applyBtn: $('#conditional-agg-apply'),
        applyCb: function(data) {
          element.conditionalAgg({
            relative_date: data,
          });

          element.col_alias(`${element.fn_name()}(${element.dataset_colname()})`);

          d3_elem.call(arc.report.shelf.settext);
          $modal.modal('hide');
          $propertiesPanel
              .find('a[data-action="shelf-agg-conditional"]')
              .closest('li')
              .addClass('selected');
          arc.report.shelf.selectConditionalAgg(true);
        },
    });

    $modal.modal('show');
    $modal.offOn('shown.bs.modal', function configureDatePicker() {
            $('#relative-date-selector').trigger('click');

            const opts = {
              applyClass: 'btn-primary',
              ranges: arc.misc.defaultRanges(),
              format: 'YYYY-MM-DD',
            };

            $('#conditional-fixed-datepicker')
                .daterangepicker(opts);
          });

    return f;
  };

  function getAgg(aggId) {
    let cnt = 0;
    findAggs(function(shelf, el) {
      if (cnt === aggId) {
        return el;
      }

      ++cnt;
    });
  }

  function findAggs(cb) {
    element.shelf().shelves().iterateElements(function checkShelf(shelf, el) {
      if (!el.fn_name()) {
        return;
      }

      if (el.fn_type() !== arc.report.fn_types.AGGREGATE) {
        return;
      }

      if (element === el) {
        return;
      }

      if (el.conditionalAgg() === undefined) {
        return;
      }

      return cb(shelf, el);
    });
  }

  return f;
};

}());
