window.arc = window.arc || {};

(function() {
"use strict";

arc.dateranges = arc.dateranges || {};

arc.dateranges.fetch = function(cb) {
  if (arc.testutil && typeof arc.testutil.mockDateRanges !== 'undefined') {
    onReceivingResponse(null, arc.testutil.mockDateRanges);
    return;
  }

  if (arc.dateranges.data) {
    return;
  }

  arc.staticfetcher.fetch([{
      asset: arc.frontend.globals.urls.daterangesUrl,
      postprocess: d3.json,
    }],
    onReceivingResponse);

  function onReceivingResponse(error, dateranges) {
    if (error) {
      arc.report.alertMessage("Failed to fetch date ranges");
      return;
    }

    arc.dateranges.data = dateranges;
    if (cb) {
      cb();
    }
  }
};

arc.dateranges.get = function() {
  if (arc.dateranges.data) {
    return arc.dateranges.data.slice();
  }
  return undefined;
};

arc.dateranges.getQuickFilterHTML = function(ranges, disableButtons) {
  let buttonHTML = '<div class="btn-group btn-group-sm quick-filters" role="group">';
  Object.keys(ranges).forEach((k) => {
    buttonHTML += `<button type="button" class="btn btn-secondary" value="${k}"${disableButtons ? ' disabled ' : ''}>${k}</button>`;
  });

  buttonHTML += '</div>';

  return buttonHTML;
};

}());
