window.arc = window.arc || {};

(function() {
'use strict';

arc.format = arc.format || {};

arc.format.formattingIsNaN = function(value) {
  if (!isNaN(value)) {
    return false;
  }

  if (value === 'Invalid date') {
    return true;
  }

  value = String(value);
  if (value.indexOf('NaN') === 0 ||
      value.indexOf('NaN') === 1 ||
      value.indexOf('NaN') === 2) {
    return true;
  }

  return false;
};

arc.misc = arc.misc || {};
arc.format.defaultFormatter = arc.misc.default_formatter;

arc.format.formattedDisplay = function(displayFormat, value, ...args) {
  if (displayFormat) {
    return arc.format.safeFormatting({ formatter: displayFormat, value: value, args: args });
  } else {
    return arc.format.defaultFormatter(value);
  }
};

// c is a hash that expects:
// 1: a formatter:
//    "formatter" [OPTIONAL]
//    "config" and "formatterName" [OPTIONAL]
// 2: "value" to be formatted
arc.format.safeFormatting = function (c) {
  if (!c.args) {
    c.args = [];
  }

  const value = c.value;

  try {
    if (arc.misc.isCrosstabExpandPrefix(value)) {
      return value;
    }

    let formatter;

    if (c.formatter) {
      formatter = c.formatter;
    } else if (c.config) {
      formatter = c.config[c.formatterName];
    }

    if (!formatter) {
      return arc.format.defaultFormatter(value);
    }

    const formattedValue = formatter(value, ...c.args);
    if (arc.format.formattingIsNaN(formattedValue)) {
      throw c.formatterName + ' display format making ' + value + ' NaN';
    } else {
      return formattedValue;
    }
  } catch (e) {
    console.log(e);
    if (c.config) {
      c.config[c.formatterName] = undefined;
    } else {
      c.formatter = undefined;
    }

    return arc.format.defaultFormatter(value);
  }
};

}());
