window.arc = window.arc || {};

(function() {
'use strict';

arc.addColorSettings = (userSettings, colorStyleTabConfig) => {
    if (!userSettings) {
        return;
    }

    const {
        includeUseCustomColorSetting,
        includeDimensionMapSetting,
        includeMeasureRangeMapSetting,
        includeOpacitySetting,
        includeFixLegendSetting,
        excludeColorPaletteSetting,
      } = colorStyleTabConfig;

    // Note the order is not irrelevant,
    // the first created first attached on order on the color style tab!
    const customDatasetColorSetting =
    includeUseCustomColorSetting ? arc.datasetcustomcolorsetting() : null;

    const colorpaletteSetting = excludeColorPaletteSetting ? null : arc.colorpalette.setting();

    const opacitySetting =
    includeOpacitySetting ? arc.report.user_settings.color_opacity() : null;

    const fixedLegendSetting = includeFixLegendSetting ?
    arc.report.user_settings.fixed_color_legend() : null;

    const colorMapSetting = includeDimensionMapSetting ?
    arc.colormap.dimToColorMappingSetting() : null;

    const colorRangeSetting =
    includeMeasureRangeMapSetting ? arc.colormap.measureRangesSetting() : null;

    const baseColorStyleSettings =
    [colorpaletteSetting, opacitySetting, fixedLegendSetting, colorMapSetting, colorRangeSetting];

    if (includeUseCustomColorSetting && customDatasetColorSetting) {
    customDatasetColorSetting.addDependents(
        baseColorStyleSettings.filter((setting) => setting), ['true'], ['false']
        );
    }

    userSettings.addSetting([customDatasetColorSetting, ...baseColorStyleSettings]
        .filter((setting) => setting));
};
}());
