window.arc = window.arc || {};

(function() {
"use strict";

arc.visual = arc.visual || {};
arc.visual.extentions = arc.visual.extensions || [];

arc.visual.getExtension = function(viz_name) {
  var found_extension;
  arc.visual.extensions.some(function(extension) {
    if (extension.viz_name() === viz_name) {
      found_extension = extension;
      return true;
    }

    return false;
  });

  return found_extension;
};

arc.visual.extensionCb = function(cb) {
  arc.visual.extensions.forEach(function(extension) {
    cb(extension);
  });
};

arc.visual.extensionNames = function() {
  return arc.visual.extensions.map(function(extension) {
    return extension.viz_name();
  });
};

arc.visual.addBuilderIcons = function() {
  /*
   * Code for adding in visual icons dynamically to the list of visuals.
   * For now, this code is disabled by this comment. In the future, when
   * we permit adding in new visuals dynamically, this code can be re-enabled.

  var pos =
    d3.select("#chart-type-menu")
      .select("ul");

  var existing_names = {};
  pos.selectAll("li")
     .each(function(d) {
       existing_names[$(this).attr("id")] = true;
     });

  arc.visual.extensionCb(function(extension) {
    var name = "chart-" + extension.viz_name();
    if (existing_names[name]) {
      return;
    }
    pos.append("li")
       .attr("id", "chart-" + extension.viz_name())
         .append("span")
         .attr("data-toggle", "tooltip")
         .attr("title", extension.viz_tooltip())
         .classed("chart-icon", true)
         .style("background", extension.viz_background())
         .style("background-position", extension.viz_background_position());
  });
  */

  $("#chart-type-menu").show();
};

arc.visual.axis = function() {
  var axis = function() { return "arc.visual.axis"; };

  var scale,
      is_dim,
      is_date,
      is_datetime,
      is_log10,
      is_percentage,
      colname,
      coldesc,
      scale_type,
      tickFormat,
      flip_ticks,
      ticks;

  axis.scale = function(_) {
    if (!arguments.length) return scale;
    scale = _;
    return axis;
  };

  axis.is_log10 = function(_) {
    if (!arguments.length) return is_log10;
    is_log10 = _;
    return axis;
  };

  axis.is_percentage = function(_) {
    if (!arguments.length) return is_percentage;
    is_percentage = _;
    return axis;
  };

  axis.is_dim = function(_) {
    if (!arguments.length) return is_dim;
    is_dim = _;
    return axis;
  };

  axis.is_date = function(_) {
    if (!arguments.length) return is_date;
    is_date = _;
    return axis;
  };

  axis.is_datetime = function(_) {
    if (!arguments.length) return is_datetime;
    is_datetime = _;
    return axis;
  };

  axis.colname = function(_) {
    if (!arguments.length) return colname;
    colname = _;
    return axis;
  };

  axis.coldesc = function(_) {
    if (!arguments.length) return coldesc;
    coldesc = _;
    return axis;
  };

  axis.tickFormat = function(_) {
    if (!arguments.length) return tickFormat;
    tickFormat = _;
    return axis;
  };

  axis.scale_type = function(_) {
    if (!arguments.length) return scale_type;
    scale_type = _;
    return axis;
  };

  axis.flip_ticks = function(_) {
    if (!arguments.length) return flip_ticks;
    flip_ticks = _;
    return axis;
  };

  axis.ticks = function(_) {
    if (!arguments.length) return ticks;
    ticks = _;
    return axis;
  };

  return axis;
};

}());
