#!/bin/bash
# To get zip file, navigate to http://www12.statcan.gc.ca/census-recensement/2011/geo/bound-limit/files-fichiers/gfsa000b11a_e.zip
# Then rename the file to fsa.zip
echo "unzipping files"
unzip fsa.zip -d fsa

echo "converting shapefile to geojson"
shp2json fsa/gfsa000b11a_e.shp -o fsa.json

echo "converting geojson to topojson"
geo2topo fsa.json > fsa_topojson.json

echo "compressing topojson file through point elimination"
toposimplify -p .005 < fsa_topojson.json > fsa_topojson_simple.json

echo "compressing topojson files via delta simplification"
topoquantize 1e5 < fsa_topojson_simple.json > fsa_topojson_quantized.json

echo "removing unneeded files"
rm -rf fsa
rm fsa.json fsa_topojson.json fsa_topojson_simple.json