#!/bin/bash

# To get the zip file, navigate to http://www12.statcan.gc.ca/census-recensement/2011/geo/bound-limit/files-fichiers/2016/lpr_000b16a_e.zip
# Reaname file to canada_territory.zip
echo "unzipping files"
unzip canada_territory.zip -d canada_territory

echo "converting shapefile to geojson"
shp2json canada_territory/gpr_000b11a_e.shp -o canada_geojson.json

echo "converting geojson to topojson"
geo2topo canada_geojson.json > canada_topojson.json

echo "compressing topojson file through point elimination"
toposimplify -p .005 < canada_topojson.json > canada_topojson_simple.json

echo "compressing topojson files via delta simplification"
topoquantize 1e5 < canada_topojson_simple.json > canada_topojson_quantized.json

echo "removing unneeded files"
rm -rf canada_territory
rm canada_geojson.json canada_topojson.json canada_topojson_simple.json