
predicate = (     whitespace* p:(equality_predicate / inequality_predicate / in_predicate / notin_predicate) whitespace* { return p; } /
    whitespace* LPAREN SPACE* p:(equality_predicate / inequality_predicate / in_predicate / notin_predicate) SPACE* RPAREN whitespace* { return p; });

equality_predicate = c:colname SPACE* e:EQUALS SPACE* l:literal {
  return arc.report.shelf.element()
            .filter_column(c)
            .add_filter_data(l);
};

inequality_predicate = c:colname SPACE* n:notequals SPACE* l:literal {
  return arc.report.shelf.element()
            .filter_column(c)
            .filter_exclude(true)
            .add_filter_data(l);
};

additional_literal = SPACE* COMMA SPACE* l:literal SPACE* {return l; }

in_predicate = c:colname SPACE* IN SPACE* LPAREN SPACE* l:literal ln:additional_literal* SPACE* RPAREN {
  var e = arc.report.shelf.element()
             .filter_column(c)
             .add_filter_data(l);
  ln.forEach(function(d) {
    e.add_filter_data(d);
  });
  return e;
};

notin_predicate = c:colname SPACE* NOT SPACE+ IN SPACE* LPAREN SPACE* l:literal ln:additional_literal* SPACE* RPAREN {
  var e = arc.report.shelf.element()
             .filter_column(c)
             .filter_exclude(true)
             .add_filter_data(l);
  ln.forEach(function(d) {
    e.add_filter_data(d);
  });
  return e;
};

colname = c:(oldcol / newcol) { return c;};

oldcol = s:[a-zA-Z] n:[_a-zA-Z0-9\(\)'"]* {
  return s + n.join("");
}

newcol = LBRACKET s:[^\]\[] n:[^\]\[]* RBRACKET {
  return s + n.join("");
}

literal = l:(number_literal / string_literal) { return l; }

number_literal = d:[0-9.]+ { return d.join(""); }
string_literal = s:dquoted_string { return s; } / s:squoted_string { return s; }

squoted_string = squote chars:schar* squote {return "'" + chars.join("") + "'"; }
schar = d:sq_unescaped {return d; } / escape s:("'" / "\\" / "/" / "b" / "f" / "n" / "r" / "t") {return "\\" + s;}
sq_unescaped = [\x20-\x26\x28-\x5B\x5D-\u10FFFF]

dquoted_string = dquote chars:dchar* dquote {return '"' + chars.join("") + '"'; }
dchar = d:dq_unescaped {return d; } / escape s:('"' / "\\" / "/" / "b" / "f" / "n" / "r" / "t") {return "\\" + s;}
dq_unescaped = [\x20-\x21\x23-\x5B\x5D-\u10FFFF]

notequals = "!" SPACE* "=" { return "!="; }

whitespace = [ \r\n\t]

escape = "\\"
dquote = '"'
squote = "'"
EQUALS = "="
SPACE = " "
NOT = "not"
IN = "in"
COMMA = ","
LPAREN = "("
RPAREN = ")"
LBRACKET = "["
RBRACKET = "]"


