QUnit.module('dashboards_arc_reportbuilder', {});

QUnit.test('server info stored', (assert) => {
  arc.testutil.ds.mock_arcl();
  const builder = arc.reportbuilder();

  const dataset = arc.testutil.ds.create_dataset();
  arc.testutil.ds.patch_dataset_init_from_fetch(dataset);

  arc.staticfetcher.fetch = function (asset, callback) {
    callback(null, [
      {
        perms: [],
        created: '2023-03-05',
        updated: '2023-03-05',
        events: [],
        segments: [],
      },
    ]);
  };

  builder.showDatasetDetail({ headersOnly: true });

  const ds_info = builder.get_dataset_server_info();

  assert.deepEqual(ds_info?.column_aliases_by_fqn, {
    'testdb.a.name': 'Name A',
    'testdb.b.name': 'Name B',
  });
});

QUnit.test('server info computation accepts null and undefined', (assert) => {
  const builder = arc.reportbuilder();

  const dataset = arc.testutil.ds.create_dataset();

  builder.store_dataset_server_info(dataset);
  assert.ok(builder.get_dataset_server_info());

  builder.store_dataset_server_info(null);
  assert.notOk(builder.get_dataset_server_info());

  builder.store_dataset_server_info(dataset);
  assert.ok(builder.get_dataset_server_info());

  builder.store_dataset_server_info(undefined);
  assert.notOk(builder.get_dataset_server_info());
});
