QUnit.module('data_arc_data', {});

QUnit.test(
  'Color domain, where first color is ascending, second color is descending',
  () => {
    const col1 = arc.data
      .column()
      .colname('column1')
      .coltype('STRING')
      .colproperty(arc.report.columnTypeEnum.DIMENSION)
      .colsource('color_shelf')
      .colindex(1)
      .order({
        priority: () => 2,
        ascending: () => true,
      });
    const col2 = arc.data
      .column()
      .colname('column2')
      .coltype('INT')
      .colproperty(arc.report.columnTypeEnum.AGGREGATE)
      .colsource('color_shelf')
      .colindex(2)
      .order({
        priority: () => 3,
        ascending: () => true,
      });

    const col3 = arc.data
      .column()
      .colname('column3')
      .coltype('INT')
      .colproperty(arc.report.columnTypeEnum.AGGREGATE)
      .colsource('color_shelf')
      .colindex(3)
      .order({
        priority: () => 1,
        ascending: () => true,
      });

    const col4 = arc.data
      .column()
      .colname('column4')
      .coltype('INT')
      .colproperty(arc.report.columnTypeEnum.AGGREGATE)
      .colsource('color_shelf')
      .colindex(4)
      .order({
        priority: () => 0,
        ascending: () => true,
      });

    const columns = [col1, col2, col3, col4];
    const expectedSortedColumns = [col4, col3, col1, col2];

    QUnit.assert.deepEqual(
      columns.sort(arc.data.sortColumnsByPriority),
      expectedSortedColumns,
      'Columns ordered in ascending order by priority',
    );
  },
);
