QUnit.module('framework_arc_batch', {});

QUnit.test('base', (assert) => {
  window.arc = window.arc || {};
  arc.grammar = arc.grammar || {};
  arc.globals = arc.globals || {};
  arc.globals.arcviz_settings = arc.globals.arcviz_settings || {};
  arc.globals.arcviz_settings.ctds = true;
  const restartQUnit = assert.async();

  const b = arc.data.batch();
  const url = 'abc/def/asyncstatus?qhandle=';

  b.url(url);
  b.asyncCaller((paramsToSend, cb) => {
    restartQUnit();
    assert.equal(paramsToSend.qhandles, 'one,two,three');

    cb(undefined, [
      {
        response: 'abc',
      },
      {
        error: 'aa',
        response: 'def',
      },
      {
        response: 'ghi',
      },
    ]);
  });

  b.add(1, 'one', (error, response) => {
    assert.equal(error, undefined);
    assert.equal(response.response, 'abc');
  });

  b.add(2, 'two', (error, response) => {
    assert.equal(error, 'aa');
    assert.equal(response.response, 'def');
  });

  b.add(3, 'three', (error, response) => {
    assert.equal(error, undefined);
    assert.equal(response.response, 'ghi');
  });
});
