QUnit.module('framework_arc_colnames', {});

QUnit.test('parser', (assert) => {
  window.arc = window.arc || {};
  arc.grammar = arc.grammar || {};

  const colnames = arc.grammar._colnames;

  let i = ' abc [def] ghi';
  let e = colnames.parse(i);

  assert.equal(e.cols.length, 1);
  assert.equal(e.cols[0], 'def');

  assert.equal(e.others.length, 2);
  assert.equal(e.others[0], ' abc ');
  assert.equal(e.others[1], ' ghi');

  i = '[ff]';
  e = colnames.parse(i);
  assert.equal(e.cols.length, 1);
  assert.equal(e.cols[0], 'ff');

  assert.equal(e.others.length, 0);

  i = ' abc [def] ghi [jkl] mno';
  e = colnames.parse(i);

  assert.equal(e.cols.length, 2);
  assert.equal(e.cols[0], 'def');
  assert.equal(e.cols[1], 'jkl');

  assert.equal(e.others.length, 3);
  assert.equal(e.others[0], ' abc ');
  assert.equal(e.others[1], ' ghi ');
  assert.equal(e.others[2], ' mno');
});
