QUnit.module('framework_arc_counters', {});

QUnit.test('afterCountersEqual', (assert) => {
  const restartQUnit = assert.async();

  arc.counters.increment('cnt1');
  arc.counters.increment('cnt2');

  let cbCnt = 0;

  arc.misc.afterCountersEqual({
    counter1: 'cnt1',
    counter2: 'cnt2',
    cb() {
      cbCnt += 1;
    },
  });

  assert.equal(cbCnt, 1);

  arc.counters.increment('cnt1');

  const d1 = new Date();
  arc.misc.afterCountersEqual({
    counter1: 'cnt1',
    counter2: 'cnt2',
    finalTimeout: 1000,
    cb() {
      const d2 = new Date();
      cbCnt += 1;

      restartQUnit();

      assert.ok(d2 - d1 >= 1000, `test completed: ${d2 - d1}`);
      arc.counters.increment('cnt2');
    },
  });

  // Still 1
  assert.equal(cbCnt, 1);
});

QUnit.test('afterCountersEqualDelay', (assert) => {
  const restartQUnit = assert.async();

  arc.counters.increment('cnt1');
  arc.counters.increment('cnt2');

  assert.equal(arc.counters.data.cnt1, arc.counters.data.cnt2);
  arc.counters.increment('cnt1');
  arc.misc.afterCountersEqual({
    counter1: 'cnt1',
    counter2: 'cnt2',
    cb() {
      restartQUnit();
      assert.ok(true, 'cb completed');
      assert.equal(arc.counters.data.cnt1, arc.counters.data.cnt2);
    },
  });

  assert.equal(arc.counters.data.cnt1, arc.counters.data.cnt2 + 1);
  arc.counters.increment('cnt2');
});
