// to test counter functions and any other test functions

QUnit.module('utils_arc_counter', {});

QUnit.test('arc.counters.increment properly increments', (assert) => {
  arc.counters.increment('apple');
  arc.counters.increment('banana', 5);
  assert.equal(
    arc.counters.data.apple,
    1,
    'No second argument, and no data in counter',
  );
  assert.equal(
    arc.counters.data.banana,
    5,
    'second argument, no data in counter',
  );

  arc.counters.increment('apple');
  arc.counters.increment('banana', 2);
  assert.equal(
    arc.counters.data.apple,
    2,
    'value present in counter, no second argument',
  );
  assert.equal(
    arc.counters.data.banana,
    7,
    'second argument, data previously in counter',
  );

  arc.counters.increment('orange', -1);
  arc.counters.increment('peach', -2);
  assert.equal(
    arc.counters.data.apple,
    2,
    'value present in counter, no second argument',
  );
  assert.equal(
    arc.counters.data.banana,
    7,
    'second argument, data previously in counter',
  );
  assert.equal(
    arc.counters.data.orange,
    -1,
    'decrement, individual counter, data in counter',
  );
  assert.equal(
    arc.counters.data.peach,
    -2,
    'decrement, individual counter, data not in counter',
  );
});
