QUnit.module('utils_expession_editor');

QUnit.test(
  'snippetsGenerator: Hive/Impala/Arcengine/Sqlite Connections have all functions',
  (assert) => {
    const actualFunctionsByConnectionType = {
      hive: arc.utils.snippetsGenerator('hive'),
      impala: arc.utils.snippetsGenerator('impala'),
      arcengine: arc.utils.snippetsGenerator('impala_arcengine'),
      mysql_sqlite: arc.utils.snippetsGenerator('mysql_sqlite'),
      solr: arc.utils.snippetsGenerator('solr'),
      sql: arc.utils.snippetsGenerator('sql'),
    };
    const expectedFunctionsByConnectionType = {
      hive: [
        'LIKE',
        'BETWEEN',
        'NOT',
        'IS NULL',
        'IS NOT NULL',
        'RLIKE',
        'REGEXP',
        'AND',
        'OR',
        'IN',
        'NOT IN',
        'EXISTS',
        'NOT EXISTS',
        'round',
        'bround',
        'floor',
        'ceil',
        'rand',
        'exp',
        'ln',
        'log10',
        'log2',
        'log',
        'pow',
        'sqrt',
        'bin',
        'hex',
        'unhex',
        'conv',
        'abs',
        'pmod',
        'sin',
        'asin',
        'cos',
        'acos',
        'tan',
        'atan',
        'degrees',
        'radians',
        'positive',
        'negative',
        'sign',
        'e',
        'pi',
        'factorial',
        'cbrt',
        'shiftleft',
        'shiftright',
        'shiftrightunsigned',
        'greatest',
        'least',
        'size',
        'map_keys',
        'map_values',
        'array_contains',
        'sort_array',
        'binary',
        'cast',
        'from_unixtime',
        'unix_timestamp',
        'to_date',
        'year',
        'quarter',
        'month',
        'day',
        'hour',
        'minute',
        'second',
        'weekofyear',
        'datediff',
        'date_add',
        'date_sub',
        'from_utc_timestamp',
        'to_utc_timestamp',
        'add_months',
        'last_day',
        'next_day',
        'trunc',
        'months_between',
        'date_format',
        'if',
        'isnull',
        'isnotnull ',
        'nvl',
        'COALESCE',
        'CASE',
        'CASE',
        'ascii',
        'base64',
        'concat',
        'context_ngrams',
        'concat_ws',
        'concat_ws',
        'decode',
        'encode',
        'find_in_set',
        'format_number',
        'get_json_object',
        'instr',
        'length',
        'locate',
        'lower',
        'lpad',
        'ltrim',
        'ngrams',
        'parse_url',
        'printf',
        'regexp_extract',
        'regexp_replace',
        'repeat',
        'reverse',
        'rpad',
        'rtrim',
        'sentences',
        'space',
        'split',
        'str_to_map',
        'substr',
        'substr',
        'substring_index',
        'translate',
        'trim',
        'unbase64',
        'upper',
        'initcap',
        'levenshtein',
        'soundex',
        'java_method',
        'reflect',
        'hash',
        'md5',
        'sha1',
        'sha',
        'crc32',
        'sha2',
        'aes_encrypt',
        'aes_decrypt',
        'count',
        'sum',
        'avg',
        'min',
        'max',
        'variance',
        'var_samp',
        'stddev_pop',
        'stddev_samp',
        'covar_pop',
        'covar_samp',
        'corr',
        'percentile',
        'percentile_approx',
        'histogram_numeric',
        'collect_set',
        'collect_list',
        'ntile',
      ],
      impala: [
        'CASE',
        'CASE WHEN',
        'COALESCE',
        'decode',
        'if',
        'IFNULL',
        'isnull',
        'NULLIF',
        'nullifzero',
        'nvl',
        'zeroifnull',
        'current_database',
        'pid',
        'user',
        'version',
        'ascii',
        'char_length',
        'concat',
        'concat_ws',
        'find_in_set',
        'group_concat',
        'initcap',
        'instr',
        'length',
        'locate',
        'lower',
        'lpad',
        'ltrim',
        'parse_url',
        'regexp_extract',
        'regexp_replace',
        'repeat',
        'reverse',
        'rpad',
        'rtrim',
        'space',
        'strleft',
        'strright',
        'substr',
        'translate',
        'trim',
        'upper',
        'add_months',
        'adddate',
        'current_timestamp',
        'date_add',
        'date_part',
        'date_sub',
        'datediff',
        'day',
        'dayname',
        'dayofweek',
        'dayofyear',
        'days_add',
        'days_sub',
        'extract',
        'extract',
        'extract',
        'from_unixtime',
        'from_utc_timestamp',
        'hour',
        'hours_add',
        'hours_sub',
        'microseconds_add',
        'microseconds_sub',
        'milliseconds_add',
        'milliseconds_sub',
        'minute',
        'minutes_add',
        'minutes_sub',
        'month',
        'months_add',
        'months_sub',
        'nanoseconds_add',
        'nanoseconds_sub',
        'now',
        'second',
        'seconds_add',
        'seconds_sub',
        'subdate',
        'to_date',
        'to_utc_timestamp',
        'trunc',
        'unix_timestamp',
        'weekofyear',
        'weeks_add',
        'weeks_sub',
        'year',
        'years_add',
        'years_sub',
        'asin',
        'atan',
        'bin',
        'ceil',
        'conv',
        'cos',
        'degrees',
        'e',
        'exp',
        'floor',
        'fmod',
        'fnv_hash',
        'greatest',
        'hex',
        'is_inf',
        'is_nan',
        'least',
        'ln',
        'log',
        'log10',
        'log2',
        'max_int',
        'min_int',
        'negative',
        'pi',
        'pmod',
        'positive',
        'pow',
        'precision',
        'quotient',
        'radians',
        'rand',
        'round',
        'scale',
        'sign',
        'sin',
        'sqrt',
        'tan',
        'unhex',
        'abs',
        'acos',
      ],
      arcengine: ['gcdo', 'boolean_and', 'boolean_or'],
      mysql_sqlite: [
        'abs',
        'char',
        'COALESCE',
        'glob',
        'IFNULL',
        'instr',
        'hex',
        'length',
        'like',
        'likelihood',
        'likely',
        'lower',
        'ltrim',
        'max',
        'min',
        'NULLIF',
        'printf',
        'quote',
        'random',
        'randomblob',
        'replace',
        'round',
        'rtrim',
        'soundex',
        'substr',
        'trim',
        'typeof',
        'unlikely',
        'unicode',
        'upper',
        'zeroblob',
        'avg',
        'count',
        'group_concat',
        'max',
        'min',
        'sum',
        'total',
        'date',
        'time',
        'datetime',
        'julianday',
        'strftime',
      ],
      solr: [
        'stddev',
        'avg',
        'count',
        'max',
        'min',
        'sum',
        'distinct',
        'missing',
        'sumOfSquares',
        'exists',
        'def',
        'not',
        'and',
        'or',
        'xor',
        'gt',
        'gte',
        'lt',
        'lte',
        'eq',
        'if',
        'equal',
        'ms',
        'dist',
        'sqedist',
        'hsin',
        'strdist',
        'sub',
        'product',
        'div',
        'pow',
        'abs',
        'log',
        'sqrt',
        'map',
        'scale',
        'query',
        'linear',
        'recip',
        'round',
        'add',
        'mult',
        'field',
        'bottom',
        'ord',
        'rordsearch',
        'docfreq',
        'termfreq',
        'totaltermfreq',
        'sumtotaltermfreq',
        'idf',
        'tf',
        'norm',
        'maxdoc',
        'numdocs',
        'concat',
      ],
      sql: [
        'avg',
        'count',
        'max',
        'min',
        'sum',
        'CASE',
        'COALESCE',
        'IFNULL',
        'NULLIF',
        'abs',
        'round',
        'cast',
        'group_concat',
        'instr',
        'lower',
        'ltrim',
        'substr',
        'upper',
        'AND',
        'BETWEEN ',
        'EXISTS',
        'IN',
        'IS NULL',
        'IS NOT NULL',
        'LIKE',
        'NOT',
        'NOT EXISTS',
        'NOT IN',
        'OR',
        'CASE WHEN',
      ],
    };

    Object.entries(expectedFunctionsByConnectionType).forEach(
      ([connection, expectedFunctions]) => {
        const actualFunctions = actualFunctionsByConnectionType[connection];
        expectedFunctions.forEach((func) => {
          assert.notEqual(
            actualFunctions.indexOf(func),
            -1,
            `${func} is in the ${connection} connection`,
          );
        });
      },
    );
  },
);

QUnit.test('snippetsGenerator: Strings', (assert) => {
  const strings = {
    shared: arc.utils.snippetsGenerator('shared'),
    hiveAndImpala: arc.utils.snippetsGenerator('hiveAndImpala'),
    hive: arc.utils.snippetsGenerator('hive'),
    arcengine: arc.utils.snippetsGenerator('impala_arcengine'),
    impala: arc.utils.snippetsGenerator('impala'),
    mysql: arc.utils.snippetsGenerator('mysql'),
    mysql_sqlite: arc.utils.snippetsGenerator('mysql_sqlite'),
    pgsql: arc.utils.snippetsGenerator('pgsql'),
    solr: arc.utils.snippetsGenerator('solr'),
    sql: arc.utils.snippetsGenerator('sql'),
    javascript: arc.utils.snippetsGenerator('javascript'),
    css: arc.utils.snippetsGenerator('css'),
  };
  let randomLine;
  const sharedLines = strings.shared.split('\n');

  Object.entries(strings).forEach(([connection, currentConnection]) => {
    // Exists
    assert.notEqual(
      currentConnection.length,
      0,
      `There is a ${connection} snippet`,
    );
    // Data connection specific tests
    if (['javascript', 'css', 'solr'].indexOf(connection) === -1) {
      // Shared snippets work
      randomLine = getRandomValues(121);
      assert.notEqual(
        strings[connection].indexOf(sharedLines[randomLine]),
        -1,
        `The shared snippet ${sharedLines[randomLine]} are in ${connection}`,
      );
      randomLine = getRandomValues(121);
      assert.notEqual(
        strings[connection].indexOf(sharedLines[randomLine]),
        -1,
        `The shared snippet ${sharedLines[randomLine]} are in ${connection}`,
      );
    }
  });

  // Nested shared snippets work
  const impalaLines = strings.impala.split('\n');
  const hiveAndImpalaLines = strings.hiveAndImpala.split('\n');
  assert.notEqual(
    strings.arcengine.indexOf(impalaLines[30]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    strings.arcengine.indexOf(hiveAndImpalaLines[30]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    strings.arcengine.indexOf(impalaLines[15]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    strings.arcengine.indexOf(hiveAndImpalaLines[15]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    strings.arcengine.indexOf(impalaLines[0]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    strings.arcengine.indexOf(hiveAndImpalaLines[0]),
    -1,
    'The shared snippets are in arcengine',
  );
});

QUnit.test('snippetsGenerator: Hashes', (assert) => {
  const hashes = {
    shared: arc.utils.snippetsGenerator('shared', 'hash'),
    hiveAndImpala: arc.utils.snippetsGenerator('hiveAndImpala', 'hash'),
    hive: arc.utils.snippetsGenerator('hive', 'hash'),
    arcengine: arc.utils.snippetsGenerator('impala_arcengine', 'hash'),
    impala: arc.utils.snippetsGenerator('impala', 'hash'),
    mysql: arc.utils.snippetsGenerator('mysql', 'hash'),
    mysql_sqlite: arc.utils.snippetsGenerator('mysql_sqlite', 'hash'),
    pgsql: arc.utils.snippetsGenerator('pgsql', 'hash'),
    sql: arc.utils.snippetsGenerator('sql', 'hash'),
    solr: arc.utils.snippetsGenerator('solr', 'hash'),
    javascript: arc.utils.snippetsGenerator('javascript', 'hash'),
    css: arc.utils.snippetsGenerator('css', 'hash'),
  };
  let sharedFunctions;
  let randIndex;
  Object.entries(hashes).forEach(([connection, currentConnection]) => {
    // Data connection specific tests
    if (['javascript', 'css', 'solr'].indexOf(connection) === -1) {
      // Shared snippets work
      sharedFunctions = hashes.shared.String;
      randIndex = getRandomValues(12);
      assert.notEqual(
        currentConnection.String.indexOf(sharedFunctions[randIndex]),
        -1,
        `The shared snippets are in ${connection}`,
      );

      // Shared property doesn't appear
      assert.equal(
        currentConnection.shared,
        undefined,
        `The shared property is not in ${connection}`,
      );
    }

    // Has expected hashes
    assert.notEqual(
      Object.keys(currentConnection).length,
      0,
      `There is a ${connection} snippet`,
    );

    // Has unique values
    if (connection !== 'shared') {
      Object.entries(currentConnection).forEach(
        ([connectionType, functions]) => {
          const uniqueFunctions = new Set();
          const uniqueCaptions = new Set();

          functions.forEach((func) => {
            const caption =
              arc.utils.snippetsGenerator.convertSnippetToDisplay(func);

            assert.equal(
              uniqueFunctions.has(func),
              false,
              `The function ${func} doesn't already exist in ${connection} (${connectionType})`,
            );

            uniqueFunctions.add(func);

            assert.equal(
              uniqueCaptions.has(caption),
              false,
              `The caption ${caption} doesn't already exist in ${connectionType} (${connectionType})`,
            );

            uniqueCaptions.add(caption);
          });
        },
      );
    }
  });

  // Nested shared snippets work
  const impalaFunctions = hashes.impala.Mathematical;
  const hiveAndImpalaFunctions = hashes.hiveAndImpala.Mathematical;
  randIndex = getRandomValues(35);
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(impalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(hiveAndImpalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
  randIndex = getRandomValues(35);
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(impalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(hiveAndImpalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
  randIndex = getRandomValues(35);
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(impalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
  assert.notEqual(
    hashes.arcengine.Mathematical.indexOf(hiveAndImpalaFunctions[randIndex]),
    -1,
    'The shared snippets are in arcengine',
  );
});

function testCaptionAndSnippet(assert, expected, helpText) {
  const actual = arc.utils.snippetsGenerator.parseText(expected.function);
  assert.equal(actual.caption, expected.caption, `Caption: ${helpText}`);
  assert.equal(actual.snippet, expected.snippet, `Snippet: ${helpText}`);
}

QUnit.test('snippetsGenerator.parseText: Regular Function', (assert) => {
  const expectedResults = {
    param0: {
      function: 'e()',
      caption: 'e',
      snippet: 'e()',
    },
    param1: {
      function: 'e again(snippet|snip)',
      caption: 'e again',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'e again(${1:snippet|snip})',
    },
    param2: {
      function: 'e again(snippet|snip, or)',
      caption: 'e again',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'e again(${1:snippet|snip}, ${2:or})',
    },
    after0: {
      function: 'hello() function',
      caption: 'hello',
      snippet: 'hello() function',
    },
    after1: {
      function: 'hello(again) function',
      caption: 'hello',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'hello(${1:again}) function',
    },
    after2: {
      function: 'hello(again, there) function',
      caption: 'hello',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'hello(${1:again}, ${2:there}) function',
    },
  };
  // Handles regular Function: 0 params, 1 param, 2 param, 3 param
  testCaptionAndSnippet(assert, expectedResults.param0, '0 params');
  testCaptionAndSnippet(assert, expectedResults.param1, '1 param');
  testCaptionAndSnippet(assert, expectedResults.param2, '2 params');

  // Handles when there's something after ()
  testCaptionAndSnippet(
    assert,
    expectedResults.after0,
    '0 params with text after ()',
  );
  testCaptionAndSnippet(
    assert,
    expectedResults.after1,
    '1 param with text after ()',
  );
  testCaptionAndSnippet(
    assert,
    expectedResults.after2,
    '2 params with text after ()',
  );
});

QUnit.test('snippetsGenerator.parseText: parseSpecialSnippet', (assert) => {
  const expectedResults = {
    noParam: {
      function: 'hello there',
      caption: 'hello there',
      snippet: 'hello there',
    },
    escapeCurly: {
      function: 'if ({true}) \\{\n\t\t{true_statement}\n\t}',
      caption: 'if ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'if (${1:true}) {\n\t\t${2:true_statement}\n\t}',
    },
    escapeBracket: {
      function: 'if ({true}) \\[\n\t\t{true_statement}\n\t]',
      caption: 'if ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'if (${1:true}) [\n\t\t${2:true_statement}\n\t}',
    },
    curly1: {
      function: "hello { there } I'm here",
      caption: 'hello ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: "hello ${1: there } I'm here",
    },
    curly2: {
      function: 'We need { to {nest} these } brackets',
      caption: 'We need ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'We need ${1: to ${2:nest} these } brackets',
    },
    bracket1: {
      function: 'We can [ also [nest]] these',
      caption: 'We can ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'We can ${1: also ${2:nest}} these',
    },
    bracket2: {
      function: 'We can indicate [optional] params',
      caption: 'We can indicate ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'We can indicate ${1:optional} params',
    },
    curlyBracket: {
      function: 'There can be { nested [optional]}',
      caption: 'There can be ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'There can be ${1: nested ${2:optional}}',
    },
    bracketCurly: {
      function: 'Optional [can { also be}] first',
      caption: 'Optional ',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: 'Optional ${1:can ${2: also be}} first',
    },
    specialCaption1: {
      function: 'if..there=>{expression} is [there]',
      caption: 'if..there',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: '${1:expression} is ${2:there}',
    },
    specialCaption2: {
      function: 'if..else =>     {There} are {many {snippets}}',
      caption: 'if..else',
      // eslint-disable-next-line no-template-curly-in-string
      snippet: '${1:There} are ${2:many ${3:snippets}}',
    },
  };

  Object.entries(expectedResults).forEach(([test, result]) => {
    testCaptionAndSnippet(assert, result, test);
  });
});

QUnit.test(
  'snippetsGenerator.parseText: All CSS/JS/Impala snippets well-formed',
  (assert) => {
    // Removes the {} around the snippet parameters
    const impala = arc.utils.snippetsGenerator('impala', 'hash');
    const javascript = arc.utils.snippetsGenerator('javascript', 'hash');
    const css = arc.utils.snippetsGenerator('css', 'hash');

    testAllFunctions(impala, 'impala');
    testAllFunctions(javascript, 'javascript');
    testAllFunctions(css, 'css');

    function testAllFunctions(hash, mode) {
      Object.entries(hash).forEach(([snippetType, snippets]) => {
        snippets.forEach((snip) => {
          const { snippet, caption } =
            arc.utils.snippetsGenerator.parseText(snip);
          const parsedSnippets = snippet;
          const name = `${mode}(${snippetType}) ${parsedSnippets}`;
          assert.equal(!caption.length, false, `${name}: there is a caption`);
          assert.equal(
            parsedSnippets.indexOf('=>'),
            -1,
            `${name}: there is no user-defined arrow left`,
          );
          assert.equal(
            parsedSnippets.split('{').length,
            parsedSnippets.split('}').length,
            `${name}: close/end curly braces match`,
          );
          assert.equal(
            parsedSnippets.split('[').length,
            parsedSnippets.split(']').length,
            `${name}: close/end brackets match`,
          );
          if (parsedSnippets.indexOf('${') !== -1) {
            const partialSnippet = parsedSnippets.split('${');
            assert.equal(
              partialSnippet.length - 1,
              partialSnippet[partialSnippet.length - 1][0],
              `${name}: number of snippets matches`,
            );
          }
        });
      });
    }
  },
);

QUnit.test('snippetsGenerator.convertSnippetToDisplay', (assert) => {
  // Removes the {} around the snippet parameters
  const snippetsToConvert = {
    'snippet {with [options]}': 'snippet with [options]',
    'snippet => snippet {with [options]}': 'snippet with [options]',
    'snippet [with {options}]': 'snippet [with options]',
    'snippet => snippet [with {options}]': 'snippet [with options]',
    'snippet ()': 'snippet ()',
    'snippet => snippet ()': 'snippet ()',
  };

  Object.entries(snippetsToConvert).forEach(([snippet, convertedSnippet]) => {
    assert.equal(
      arc.utils.snippetsGenerator.convertSnippetToDisplay(snippet),
      convertedSnippet,
      `Curly braces are removed for ${snippet}`,
    );
  });
});

function getRandomValues(upperLimit) {
  return Math.floor(Math.random() * upperLimit);
}
