QUnit.module('utils_sort_workspace');

QUnit.test('arc.workspace.sortWorkspaces: Numbers first', (assert) => {
  const testWorkspaces = [{ name: 'a' }, { name: '1' }, { name: '2' }];
  const expectedOrder = [{ name: '1' }, { name: '2' }, { name: 'a' }];

  assert.deepEqual(
    arc.workspace.sortWorkspaces(testWorkspaces),
    expectedOrder,
    'Numbers appear before alphabet',
  );
});

QUnit.test(
  'arc.workspace.sortWorkspaces: Numbers and then letters',
  (assert) => {
    const testWorkspaces = [
      { name: '2 Park' },
      { name: '1 Elephant' },
      { name: '2 Hyde' },
      { name: '1 Castle' },
    ];
    const expectedOrder = [
      { name: '1 Castle' },
      { name: '1 Elephant' },
      { name: '2 Hyde' },
      { name: '2 Park' },
    ];

    assert.deepEqual(
      arc.workspace.sortWorkspaces(testWorkspaces),
      expectedOrder,
      'Alphabetical sorting if number sorting fails',
    );
  },
);

QUnit.test(
  'arc.workspace.sortWorkspaces: Disregard capitalization',
  (assert) => {
    const testWorkspaces = [
      { name: 'Anyways' },
      { name: 'answers' },
      { name: 'always' },
      { name: 'Alphabet' },
    ];
    const expectedOrder = [
      { name: 'Alphabet' },
      { name: 'always' },
      { name: 'answers' },
      { name: 'Anyways' },
    ];

    assert.deepEqual(
      arc.workspace.sortWorkspaces(testWorkspaces),
      expectedOrder,
      'Alphabetical regardless of capitalization',
    );
  },
);
