QUnit.module('visuals_arc_html', {
  beforeEach() {
    // main chart object
    const htmlViz = arc.visual.plugins.html();
    this.viz = htmlViz;

    // create the lib object
    this.driver = arc.report.driver(htmlViz).chart_div('chart-div');

    this.user_settings = this.driver.user_settings();

    // provide the data
    const result = arc.data.result();

    // create the visual by setting the data and then drawing it
    this.viz.viz_setDataResult(result);
    this.viz.viz_drawVisual('chart-div');

    // store elements on the page to be tested
    this.$viz_div = $('#chart-div');
    this.editorContainer = this.$viz_div.find('.viz-htmleditor');
  },

  afterEach() {
    $('#chart-div').empty();
  },
});

QUnit.test('HTML Editor Present', function (assert) {
  assert.equal(this.editorContainer.length, 1, 'This html editor is present');
});
