QUnit.module('visuals_arc_link', {
  beforeEach() {
    // main chart object
    const link = arc.visual.plugins.link();

    // create the lib object
    arc.report.driver(link);

    // provide the settings
    const settings = {};
    this.link_name = 'https://www.cloudera.com';
    settings.viz_type = {};
    settings.viz_type.link = {};
    settings.viz_type.link.link_name = this.link_name;

    // create the visual by setting the data and then drawing it
    link.viz_setSettings(settings);
    link.viz_drawVisual('chart-div');

    // store elements on the page to be tested
    this.iframe = $('iframe');
  },

  afterEach() {
    $('#chart-div').empty();
  },
});

QUnit.test('Link Present', function (assert) {
  assert.equal(this.iframe.length, 1, 'There is 1 iframe element');
  assert.equal(this.iframe.attr('src'), this.link_name, 'Link URL is correct');
});
