QUnit.module('visuals_arc_report_params_history', {
  beforeEach() {
    arcl.params_history = arc.report.params_history();
  },

  afterEach() {
    delete arcl.params_history;
  },
});

QUnit.test('params_history.update', function testUpdateParamsHistory(assert) {
  assert.deepEqual(
    arcl.params_history.update([], []),
    [],
    'Empty params update successfully',
  );
  assert.deepEqual(
    arcl.params_history.update(
      [
        {
          key: 'throwable',
          value: 'java.lang.reflect.InvocationTargetException',
          filtername: 'throwable',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: '2231',
          source_dataset_id: 159,
          source_shelf: 'y_shelf',
          expr: '[throwable]',
        },
      ],
      [
        {
          key: 'timestamp.start',
          value: '2017-08-14T08:16:13Z',
          value_list: '2017-08-14T08:16:13Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
        {
          key: 'timestamp.end',
          value: '2017-08-15T11:14:16Z',
          value_list: '2017-08-15T11:14:16Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
      ],
    ),
    [
      {
        key: 'timestamp.start',
        value: '2017-08-14T08:16:13Z',
        value_list: '2017-08-14T08:16:13Z',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: 2230,
        source_dataset_id: 159,
      },
      {
        key: 'timestamp.end',
        value: '2017-08-15T11:14:16Z',
        value_list: '2017-08-15T11:14:16Z',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: 2230,
        source_dataset_id: 159,
      },
      {
        key: 'throwable',
        value: 'java.lang.reflect.InvocationTargetException',
        filtername: 'throwable',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: '2231',
        source_dataset_id: 159,
        source_shelf: 'y_shelf',
        expr: '[throwable]',
      },
    ],
    'Independent params update successfully',
  );

  assert.deepEqual(
    arcl.params_history.update(
      [
        {
          key: 'timestamp',
          value: 'hello',
          value_list: 'hello',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
      ],
      [
        {
          key: 'timestamp.start',
          value: '2017-08-14T08:16:13Z',
          value_list: '2017-08-14T08:16:13Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
        {
          key: 'timestamp.end',
          value: '2017-08-15T11:14:16Z',
          value_list: '2017-08-15T11:14:16Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
      ],
    ),
    [
      {
        key: 'timestamp',
        value: 'hello',
        value_list: 'hello',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: 2230,
        source_dataset_id: 159,
      },
    ],
    'Suffixed params are overridden successfully',
  );

  assert.deepEqual(
    arcl.params_history.update(
      [
        {
          key: 'timestamp.start',
          value: '2017-08-14T08:16:13Z',
          value_list: '2017-08-14T08:16:13Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
        {
          key: 'timestamp.end',
          value: '2017-08-15T11:14:16Z',
          value_list: '2017-08-15T11:14:16Z',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
      ],
      [
        {
          key: 'timestamp',
          value: 'hello',
          value_list: 'hello',
          keytype: 1,
          valuetype: 'STRING',
          source_visual_id: 2230,
          source_dataset_id: 159,
        },
      ],
    ),
    [
      {
        key: 'timestamp.start',
        value: '2017-08-14T08:16:13Z',
        value_list: '2017-08-14T08:16:13Z',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: 2230,
        source_dataset_id: 159,
      },
      {
        key: 'timestamp.end',
        value: '2017-08-15T11:14:16Z',
        value_list: '2017-08-15T11:14:16Z',
        keytype: 1,
        valuetype: 'STRING',
        source_visual_id: 2230,
        source_dataset_id: 159,
      },
    ],
    'Suffixed params override existing params successfully',
  );
});
