QUnit.module('visuals_arc_wordcloud', {
  beforeEach: function beforeEach() {
    // main chart object
    const wordcloud = arc.visual.plugins.wordcloud();
    this.wordcloud = wordcloud;

    // create the lib object
    this.driver = arc.report.driver(wordcloud).chart_div('chart-div');

    // provide the data
    const result = arc.data.result();
    result.rows([
      ['First Word', 20],
      ['Second Word', 20],
      ['Third Word', 30],
      ['Fourth Word', 40],
      ['Fourth ', 40],
      ['Fbalh', 40],
      ['boo', 40],
      ['Fifth Word', 50],
    ]);

    const col1 = arc.data
      .column()
      .colname('Wordphrase')
      .coltype('STRING')
      .colproperty(arc.report.columnTypeEnum.DIMENSION)
      .colsource('dimensions_shelf')
      .colindex(0);

    const col2 = arc.data
      .column()
      .colname('record_count')
      .coltype('INT')
      .colproperty(arc.report.columnTypeEnum.AGGREGATE)
      .colsource('aggregates_shelf')
      .colindex(1);

    result.columns([col1, col2]).finalize();

    // create the visual by setting the data and then drawing it
    wordcloud.viz_setDataResult(result);
    wordcloud.viz_drawVisual('chart-div');
  },

  afterEach: function afterEach() {
    $('#chart-div').empty();
  },
});

QUnit.test('Chart Element Present', function (assert) {
  const _this = this;
  const restartQUnit = assert.async();
  setTimeout(() => {
    restartQUnit();

    // store elements on the page to be tested
    _this.viz_div = d3.select('#chart-div');
    _this.svg = _this.viz_div.selectAll('svg');
    _this.gs = _this.svg.selectAll('g');

    assert.equal(_this.svg.size(), 1, 'There should be only 1 svg elements');
    assert.equal(
      _this.gs.size(),
      1,
      'The svg element should contain contains 1 g elements',
    );
  }, 3700);
});
