// eslint-disable-next-line no-use-before-define, no-var
var QUnit = QUnit || {};

(function () {
  QUnit.module('visuals.common.arc_report_driver', {
    beforeEach() {
      this.viz = arc.visual.plugins.html();

      // create the lib object
      this.driver = arc.report.driver(this.viz).chart_div('chart-div');

      this.user_settings = this.driver.user_settings();

      // provide the data
      const result = arc.data.result();

      // create the visual by setting the data and then drawing it
      this.viz.viz_setDataResult(result);
      this.viz.viz_drawVisual('chart-div');

      // store elements on the page to be tested
      this.$viz_div = $('#chart-div');
      this.editorContainer = this.$viz_div.find('.viz-htmleditor');
    },

    afterEach() {
      $('#chart-div').empty();
    },
  });

  function ensure_number(n) {
    if (Number.isFinite(n)) {
      return n;
    }

    return 0;
  }

  async function test_refreshing(assert) {
    let { viz_drawVisual } = arc.counters.data;
    viz_drawVisual = ensure_number(viz_drawVisual);

    this.driver.refresh();
    await arc.misc.poll(
      1000,
      () => viz_drawVisual + 1 === arc.counters.data.viz_drawVisual,
    );

    assert.equal(viz_drawVisual + 1, arc.counters.data.viz_drawVisual);
  }

  QUnit.test('driver refreshing works', async function (assert) {
    await test_refreshing.call(this, assert);
  });

  QUnit.test('driver refreshing works with limit set', async function (assert) {
    try {
      arc.globals.gflags = {
        is_snapshot: true,
        limit: 50,
      };
      await test_refreshing.call(this, assert);
    } finally {
      delete arc.globals.gflags;
    }
  });
}());
