import * as path from "path";
import { Configuration } from "webpack";
import { merge } from "webpack-merge";

import {
  commonWebpackConfiguration,
  staticDirectoryPath,
} from "./webpack.common";

const developmentWebpackConfiguration: Configuration = merge(
  commonWebpackConfiguration,
  {
    mode: "development",
    devtool: "source-map",
    output: {
      path: path.resolve(staticDirectoryPath, "js/build/development/arc"),
    },
  }
);

export default developmentWebpackConfiguration;
