import * as path from "path";
import { Configuration } from "webpack";
import { merge } from "webpack-merge";

import {
  commonWebpackConfiguration,
  staticDirectoryPath,
} from "./webpack.common";

const productionWebpackConfiguration: Configuration = merge(
  commonWebpackConfiguration,
  {
    mode: "production",
    devtool: 'source-map',
    output: {
      path: path.resolve(staticDirectoryPath, "js/build/production/arc"),
    },
  }
);

export default productionWebpackConfiguration;
