# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.test import TestCase

from vizlib.tests import test_report_operations as test_utils


class OpenAPISpecViewTest(TestCase):
    def setUp(self):
        self.user = test_utils.make_user('user1', is_superuser=False)

    def test_openapi_spec_view_returns_yaml(self):
        self.client.login(username=self.user.username, password=self.user.username)
        response = self.client.get('/apps/apidemo-v2/swagger-yaml/')
        self.assertEqual(response.status_code, 200)
        self.assertEqual(response['Content-Type'], 'application/yaml')

    def test_openapi_spec_view_requires_authentication(self):
        self.client.logout()  
        response = self.client.get('/apps/apidemo-v2/swagger-yaml/')
        self.assertNotEqual(response.status_code, 200)
