# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
urls for trusted auth
"""

from django.urls import re_path

from trustedauth import views

urlpatterns = [
  re_path(r'^getticket$', views.getticket, name='getticket'),
  re_path(r'^trusted/(?P<ticket>[A-za-z0-9\-_]+)/app/(?P<report_id>\d+)$', views.trustedapp),
  re_path(r'^trusted/(?P<ticket>[A-za-z0-9\-_]+)/appgroup/(?P<appgroup_id>\d+)$', views.trustedappgroup),
  re_path(r'^trusted/(?P<ticket>[A-za-z0-9\-_]+)/dataapi$', views.trustedapi),
  re_path(r'^trusted/(?P<ticket>[A-za-z0-9\-_]+)/redirect$', views.trustedredirect),
]

