# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.http import JsonResponse
import json
from .models import EventsTracker

def save_frontend_events_tracker_data(request):
  # received data sent from frontend here
  if request.method == 'POST':
    load_time_data_str = request.POST.get('data')
    jsErrors = request.POST.get('jsErrors')
    visualErrors = request.POST.get('visualErrors')

    url_counts = {}
    load_time_buckets = {
      0: 0,
      1: 0,
      5: 0,
      10: 0,
      30: 0,
      60: 0,
      120: 0,
      121: 0
    }

    load_time_data = json.loads(load_time_data_str)

    for item in load_time_data:
      url = item['url']
      loading_time = item['loadTime']

      if url not in url_counts:
        url_counts[url] = 1
      else:
        url_counts[url] += 1

      if 0 <= loading_time < 1:
        load_time_buckets[0] += 1
      elif 1 <= loading_time < 5:
        load_time_buckets[1] += 1
      elif 5 <= loading_time < 10:
        load_time_buckets[5] += 1
      elif 10 <= loading_time < 30:
        load_time_buckets[10] += 1
      elif 30 <= loading_time < 60:
        load_time_buckets[30] += 1
      elif 60 <= loading_time < 120:
        load_time_buckets[60] += 1
      elif 120 <= loading_time < 121:
        load_time_buckets[120] += 1
      else:
        load_time_buckets[121] += 1


    EventsTracker.update_events_tracker(
      url_counts, 
      load_time_buckets, 
      jsErrors=jsErrors, 
      visualErrors=visualErrors, 
    )

    return JsonResponse({'message': 'Load time data updated successfully.'})
  else:
    return JsonResponse({'message': 'Invalid request method.'}, status=400)


