# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import json

URL_PREFIX = "cdv_ff."


class UrlFlipper:
    @staticmethod
    def get_url_flippers(request):
        if not request:
            return []

        flippers_cookies = request.COOKIES.get("flippers")
        if flippers_cookies:
            flippers = json.loads(flippers_cookies)
        else:
            flippers = []

        if request.method == "GET":
            get_dict = request.GET.dict()
            for key in get_dict.keys():
                pos = -1
                if key.startswith(URL_PREFIX):
                    for i, flipper in enumerate(flippers):
                        if flipper["id"] == key[len(URL_PREFIX) :]:
                            pos = i
                    val = get_dict[key].lower() == "true"
                    if pos > -1:
                        flippers[pos]["value"] = val
                    else:
                        flippers.append(
                            {
                                "id": key[len(URL_PREFIX) :],
                                "value": val,
                            }
                        )

        return flippers
