# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
def create_group(rbac_role, group_name):
    import json
    from rbac.models import Role
    from apps.views import _groups_create

    role = Role.objects.filter(name=rbac_role).first()
    if role is None:
        print("Could not find rbac role %s. Not creating group" % rbac_role)
        return

    class SuperUser(object):
        def __init__(self):
            self.is_superuser = True

    class Request(object):
        def __init__(self, _user, _post):
            self.user = _user
            self.POST = _post

    r = Request(SuperUser(), {
        'name': group_name,
        'roles': json.dumps([role.id]),
    })

    response = _groups_create(r)

    if response.status_code == 200:
        print(f"{group_name} Group created")
        return True
    else:
        print(f'Failed to create {group_name} group.\
            Error {response.status_code}, Response: {response.content}')

    return False
