# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import json

from django.conf import settings

#
# Set separators in the calls to json.dump(s) below so we can take away unnecessary spaces
#
# Try json.dump with both settings for ensure_ascii, but start with the setting in
#   JSON_ENSURE_ASCII
#

ensure_ascii = getattr(settings, 'JSON_ENSURE_ASCII', False)

def json_dumps(obj, **kwargs):
  try:
    return json.dumps(obj, separators=(',', ':'), ensure_ascii=ensure_ascii)
  except:
    return json.dumps(obj, separators=(',', ':'), ensure_ascii=(not ensure_ascii))

def json_dump(row, s):
  try:
    return json.dump(row, s, separators=(',', ':'), ensure_ascii=ensure_ascii)
  except UnicodeDecodeError:
    return json.dump(row, s, separators=(',', ':'), ensure_ascii=(not ensure_ascii))

