# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

from django.contrib.auth.models import User
from datasets.models import DataSet


def check_dataset_permission(user: User, dataset_id: int, permission: str):
  if user.is_superuser:
    return

  dataset = DataSet.objects.only(
    'id', 'dataconnection_id', 'create_user', 'version_group_id').get(id=dataset_id)
  dataset.checkPerm(user, permission)


def user_dataset_ids(user: User) -> list[int]:
  return [d.id for d in DataSet.objects.only('id', 'dataconnection_id', 'create_user', 'version_group_id').all() if 'ds_appview' in d.getPerms(user)]
