# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import string
from django.http import HttpRequest
from django.contrib.auth.models import User

def create_request(user: User, client_ip: string = None) -> HttpRequest:
  req = HttpRequest()
  req.user = user
  if client_ip:
    req.META['HTTP_X_FORWARDED_FOR'] = client_ip
  return req

