# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
# A django script to convert tables to use engine INNODB

from django.db import connections

def set_innodb(dryrun=True):

  connection = connections['default']
  if connection.vendor != 'mysql':
    print('Not using MySQL metastore')
    return

  cursor = connection.cursor()
  cursor.execute("SHOW TABLE STATUS");
  for row in cursor.fetchall():
    table = row[0]
    cureng = row[1]
    if cureng != "InnoDB":
      print(("Converting %s from %s to INNODB" % (table, cureng)))
      if not dryrun:
        cursor.execute("ALTER TABLE %s ENGINE=INNODB" % table)
    else:
      print(("Table %s is already using %s" % (table, cureng)))
