# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
This script analyzes and suggests acceleration for apps
"""

class SelectStatement(object):
  def __init__(self):
    self.__groups = []
    self.__aggregates = []
    self.__table = None

  def table(self, table):
    self.__table = table

  def addGroup(self, group):
    self.__groups.append(group)

  def addAggregate(self, aggregate):
    self.__aggregates.append(aggregate)

  def sql(self):
    c = ['select']
    for g in self.__groups:
      c.append(g)
      c.append(',')
    for a in self.__aggregates:
      c.append(a)
      c.append(',')
    c[len(c)-1] = 'from'
    c.append(self.__table)
    if len(self.__aggregates) and len(self.__groups):
      c.append('group by')
      for idx, val in enumerate(self.__groups):
        c.append(str(idx + 1))
        c.append(",")
      c[len(c) - 1] = ''
    return ' '.join(c)

