# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import re

# Returns all the table names from a query (first words after join, from etc)
def extract_tablenames_from_sqlquery(query):
  # every item after from or join is a tablename (might extended with dataase name)
  matches = re.findall("from\s+[\w\d\.]+|join\s+[\w\d\.]+", query)
  table_names = []
  for i in matches:
      # datababase_name.table, or table or table only given after from or join
      tablename = re.sub("from\s+|join\s+","",i) 
      if tablename:
        if tablename not in table_names:
              table_names.append(tablename)
  return table_names