# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from django.test import TestCase

from util.init_utils import create_group
from django.contrib.auth.models import Group
from rbac.models import Role



class InitUtilsTest(TestCase):
    def test_when_create_group_and_role_exists_should_create(self):
        # Given & When
        create_group('System Admin', 'test-group')
        # Then
        test_group = Group.objects.filter(name='test-group').first()
        self.assertIsNotNone(test_group)

    def test_when_create_group_and_role_does_not_exists_should_not_create(self):
        # Given
        r = Role.objects.filter(name='System Admin').first()
        if r:
            r.name = "Not System Admin"
            r.save()

        # When
        create_group('System Admin', 'test-group')
        # Then
        test_group = Group.objects.filter(name='test-group').first()
        self.assertIsNone(test_group)
