# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
ABANDONED_TIME = 20

# See the corresponding types in admin/arc_querylogs.js
class ComponentType:
  # Component type
  APP = 1
  DATASET = 2
  DATACONNECTION = 3
  USER = 4
  APPGROUP = 5
  CUSTOMSTYLE = 6
  CUSTOMCOLOR = 7
  SNAPSHOT = 8
  THUMBNAIL = 9
  STATICASSET = 10
  ROLE = 11
  CUSTOMEMAIL = 12
  CUSTOMDATERANGE = 13
  WORKSPACE = 14
  SEARCH = 15
  RAW_QUERY = 16
  SEGMENT = 17
  FILTERASSOCIATION = 18
  JOB = 19
  EXTRACT = 20

  typeStr = {
    1: 'Dashboard',
    2: 'Dataset',
    3: 'Data Connection',
    4: 'User',
    5: 'App',
    6: 'Custom Style',
    7: 'Custom Color',
    8: 'Snapshots',
    9: 'Thumbnail',
    10: 'Static Asset',
    11: 'Role',
    12: 'Custom Email',
    13: 'Custom Date Range',
    14: 'Workspace',
    15: 'Search',
    16: 'Direct Query',
    17: 'Segment',
    18: 'Filter Association',
    19: 'Job',
    20: 'Extract',
  }

  @staticmethod
  def getStr(id):
    return ComponentType.typeStr.get(id, 'Unknown')

class ActionType:
  # Action type
  CREATE = 1
  READ = 2
  UPDATE = 3
  DELETE = 4
  UNKNOWN = 5

  typeStr = {
    1: 'Create',
    2: 'View',
    3: 'Update',
    4: 'Delete',
  }

  @staticmethod
  def getStr(id):
    return ActionType.typeStr.get(id, 'Unknown')

class QueryState:
  # Query States
  STARTED = 1
  COMPLETE = 2
  QUEUED = 3
  CANCELED = 4
  ABANDONED = 5

  typeStr = {
    1: 'Started',
    2: 'Completed',
    3: 'Queued',
    4: 'Canceled',
    5: 'Abandoned',
  }

  @staticmethod
  def getStr(id):
    return QueryState.typeStr.get(id, 'Unknown')
