# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from settings import *

import warnings
import django.core.cache

warnings.simplefilter("ignore", django.core.cache.CacheKeyWarning)

DATABASES['default']['NAME'] = "/home/ubuntu/larry_webserver_data/arcviz.sqlite3"

CACHES = {
  'default': {
    # To disable caching
    # 'BACKEND': 'django.core.cache.backends.dummy.DummyCache',
    'BACKEND': 'django.core.cache.backends.filebased.FileBasedCache',
    'LOCATION': '/home/ubuntu/django_cache',
    'TIMEOUT': 3600,
    'OPTIONS': {
      'MAX_ENTRIES': 10000
    }
  }
}

FORCE_SCRIPT_NAME = "/arc"

