# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
"""
Django settings local development.
Put this file in arcviz/arcweb/arcwebbase
and
export DJANGO_SETTINGS=arcweb.settings_local_dev
"""

from settings import *

DEBUG = True
TEMPLATE_DEBUG = DEBUG
RUN_FROM_SOURCE_DEBUG = DEBUG
if RUN_FROM_SOURCE_DEBUG:
  ARCSQL = ('%s/../../../arcadia/arcexec/arcsql/arcsql' % THISDIR)

DATABASES = {
  'default': {
    # Add 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
    'ENGINE': 'django.db.backends.sqlite3',
    # Or path to database file if using sqlite3.
    'NAME': '../arcweb.django.sqlite3',
    # The following settings are not used with sqlite3:
    'USER': '',
    'PASSWORD': '',
    # Empty for localhost through domain sockets or '127.0.0.1' for
    # localhost through TCP.
    'HOST': '',
    # Set to empty string for default.
    'PORT': '',
    }
}

INSTALLED_APPS = (
  # The 5 apps below are necessary for admin
  'django.contrib.admin',
  'django.contrib.auth',
  'django.contrib.contenttypes',
  'django.contrib.sessions',
  'django.contrib.messages',

  # 'django.contrib.sites',
  'django.contrib.staticfiles',

  'south',
  'apps',
  'datasets',
  'reports',
  'datasources',
  'debug_toolbar',
  # Uncomment the next line to enable admin documentation:
  # 'django.contrib.admindocs',
)

MIDDLEWARE = (
  'debug_toolbar.middleware.DebugToolbarMiddleware',
  'django.middleware.common.CommonMiddleware',
  'django.contrib.sessions.middleware.SessionMiddleware',
  'django.middleware.csrf.CsrfViewMiddleware',
  'django.contrib.auth.middleware.AuthenticationMiddleware',
  'django.contrib.messages.middleware.MessageMiddleware',
  # Uncomment the next line for simple clickjacking protection:
  # 'django.middleware.clickjacking.XFrameOptionsMiddleware',
)
