# Changing database schemas

Please read the documentation on the django 'south' plugin

When making changes, do the following:
- modify `models.py` in the apps to reflect the new schemas
- `python manage.py makemigrations`

On a system with a db schema in the old version:
- `python manage.py migrate <app>`

To move from a system without south to a system with south:
- Note that this is only necessary because we did not start with south
  in this repo, and have added it after the fact.
  This should never be necessary on a customer system - all customers
  systems are starting with south installed already
- `python manage.py migrate <app> 0001 --fake`

To upgrade larry, I ran:
```
export DJANGO_SETTINGS_MODULE=arcweb.settings_larry
python manage.py syncdb
python manage.py migrate reports 0001 --fake
python manage.py migrate datasets 0001 --fake
python manage.py migrate reports
python manage.py migrate datasets
```
