# `dockerrun`

A simple tool for managing docker containers for local development

It is able to build the image for the local development and run any command
inside the container. The container is equipped with docker, and it shares the
hosts `/var/run/docker.sock` so you can run commands using docker as well, all
containers will be started in the host.

If you have permission problems with `docker-credential-desktop` on mac then
follow [this article](https://cri.dev/posts/2020-07-06-How-to-solve-Docker-docker-credential-desktop-not-installed-or-not-available-in-PATH/)

## Features

### `./dockerrun build`

Builds the image with the `viz/devenv` name, it contains all the necessary
dependencies for local development.

### `./dockerrun run [-h <HOME_DIR>] [-c] <COMMAND>`

Runs any shell command in the docker container. The container attaches the
local development folder as a volume, so you can change the files it will
affect the container as well. The container also attaches your home folder as
the `/root/`, in this way it can use the `.arc` folder from your home.
If you want to setup a sqlite data connection in the app then store the `.db`
file somewhere inside your home directory, but make sure you address it with
`/root/` in the app instead of your home.

Example:

```sh
./dev/dockerrun run ./dev/startup  # runs the application
```

You can specify the path for your home directory if you don't want to share
the whole home with the container using the `-h` flag

Example:

```sh
./dev/dockerrun run -h /Users/youruser/viz ./dev/startup
```

You can use the `-c` flag for not binding any ports, by default it opens binds
the 8090 port for serving the application.


### `./dev/dockerrun sh [-h <HOME_DIR>] [-c]` or `./dev/dockerrun [-h <HOME_DIR>] [-c]`

Starts a Bash shell in the container, you can specify your home directory path,
and you can prevent port binding.
