/** @type {import('@typescript-eslint/utils').TSESLint.Linter.Config} */

module.exports = {
  parser: '@typescript-eslint/parser',
  parserOptions: {
    sourceType: 'module',
    ecmaFeatures: {
      jsx: true,
    },
  },
  settings: {
    react: {
      version: 'detect',
    },
    'import/resolver': {
      node: {
        extensions: [
          '.ts',
          '.tsx',
        ],
      },
    },
  },
  extends: [
    'react-app',
    'react-app/jest',
    'prettier',
  ],
  rules: {
    "no-debugger": "error",
    "no-restricted-imports": [
      "error",
      {
        "paths": [
          {
            "name": "@tanstack/react-table",
            "importNames": ["useReactTable"],
            "message": "Please use the custom wrapper useTable instead of importing useReactTable directly from @tanstack/react-table."
          }
        ]
      }
    ],
  }
};
