import type { Config } from 'jest';

const config = {
  clearMocks: true,
  coverageDirectory: 'coverage',
  coverageProvider: 'v8',
  coverageReporters: ['text', 'html', 'lcov'],
  collectCoverageFrom: [
    'src/**/*.{ts,tsx}',
    '!src/components/what-s-new-modal/*',
  ],
  preset: 'ts-jest',
  testEnvironment: 'jest-environment-jsdom',
  moduleDirectories: ['node_modules', 'src'],
  moduleNameMapper: {
    '\\.(css|scss)$': 'identity-obj-proxy',
    '^lodash-es$': 'lodash',
  },
  transform: {
    '^.+\\.svg$': 'jest-transformer-svg',
  },
  transformIgnorePatterns: ['/node_modules/(?!(@cloudera-internal))/'],
} satisfies Config;

export default config;
