import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const deleteAlias = async ({ slug }: { slug: string }) => {
  return vizHttp.delete({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.urlShortenerUrl}`,
    params: {
      slug,
    },
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });
};
