import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { DataSet } from 'apis/get-dataset-versions';

const arc = getGlobalArc();
type ChangeVersionNameData = {
  id: number;
  version_name: string;
  dataset_name?: string;
  dataset_type?: string;
  dataset_detail?: string;
  dataset_info?: string;
  is_named_version?: boolean;
};

const changeDatasetVersionName = (data: ChangeVersionNameData) =>
  vizHttp
    .put<DataSet[]>({
      url: `${arc.frontend.globals.urls.datasetUrl}/${data.id}?is_create_new_ds_version=False`,
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
      isOldEndpoint: true,
      data,
    })
    .then(({ data }) => {
      return data;
    });

export { changeDatasetVersionName };
