import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { DataSet } from 'apis/get-dataset-versions';

const arc = getGlobalArc();
type ChangeData = {
  master_id: string;
  version_id: number;
};

const changeDatasetVersion = (data: ChangeData) =>
  vizHttp
    .post<DataSet[]>({
      url: `${arc.frontend.globals.urls.datasetUrl}/version_control/`,
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
      isOldEndpoint: true,
      data,
    })
    .then(({ data }) => data);

export { changeDatasetVersion };
