import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();

export const changeOwnPassword = (
  oldPassword: string,
  newPassword: string,
  confirmPassword: string
) => {
  const data = {
    csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    old_password: oldPassword,
    new_password: newPassword,
    confirm_password: confirmPassword,
  };

  return vizHttp.put({
    url: `${arc.frontend.globals.urls.usersDetailedApiUrl}/${arc.frontend.globals.authentication.username}`,
    data,
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
    isOldEndpoint: true,
  });
};
