import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';
import { DataConnection } from 'types/data-connection.type';

const arc = getGlobalArc();

export const cloneDataconnection = async ({
  id,
}: {
  id: number;
}): Promise<DataConnection> => {
  const { data } = await vizHttp.get<DataConnection>({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.cloneDataconnectionUrl}/${id}`,
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });

  return data;
};
