import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const deleteDataconnection = async ({
  id,
}: {
  id: number;
}): Promise<void> => {
  await vizHttp.delete({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.dataConnectionUrl}/${id}`,
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });
};
