import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const deleteDataset = async ({ id }: { id: number }) => {
  return vizHttp.delete({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.datasetUrl}/${id}`,
    params: {
      delete_table: 'false',
    },
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });
};
