import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();

export const deleteReport = async (report: {
  id: number;
  type: string;
  workspace: { id: number };
}) => {
  const baseUrl =
    report.type === 'app'
      ? arc.frontend.globals.urls.appgroupUrl
      : arc.frontend.globals.urls.reportUrl;

  return vizHttp
    .delete({
      isOldEndpoint: true,
      url: `${baseUrl}/${report.id}`,
      data: {
        csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
      },
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
    })
    .then(() => report);
};
