import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();
export const appsQueryToken = 'apps';
export type BackendApp = Awaited<ReturnType<typeof getApps>>[number];

export const getApps = async () => {
  const { data } = await vizHttp.get<
    {
      group_id: number;
      group_type: string;
      name: string;
      group_options: string;
      create_user: string;
      update_user: string;
      created: string;
      updated: string;
      workspace_name: string;
      workspace_id: number;
      workspace_perm: string[];
      baseImg: string;
      perm: string[];
      num_apps: number;
      apps: [number, number][];
      rw: boolean;
      in_userlist: string;
      subgroups:
        | {
            subgroup_order: null | number;
            group_id: number;
            group_type: string;
            name: string;
            group_options: string;
            create_user: string;
            update_user: string;
            created: string;
            updated: string;
            workspace_name: string;
            workspace_id: number;
            workspace_perm: string[];
            baseImg: string;
            perm: string[];
            num_apps: number;
            apps: [number, number][];
            rw: boolean;
            in_userlist: string;
            group_parent_id: number;
          }[]
        | undefined;
    }[]
  >({
    url: arc.frontend.globals.urls.appgroupUrl,
    isOldEndpoint: true,
  });
  return data;
};
