import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { Warehouse } from '../components/data-connection-modal/types/dataconnection-types';

const arc = getGlobalArc();

export const warehouseQueryToken = 'cdwWarehouses';

export const getCDWWarehouses = async ({
  type,
}: {
  type: string;
}): Promise<Warehouse[]> => {
  const { data } = await vizHttp.get<Warehouse[]>({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.cdwWarehouseUrl}?type=${type}`,
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });

  return data;
};
