import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();
export const datasetVersionQueryToken = 'dataset-versions';

export type DataSet = {
  id: number;
  dc_id: number;
  dc_type: string;
  dc_name: string;
  dc_type_display: string;
  name: string;
  type: string;
  info: string;
  detail: string;
  detail_display: string;
  description: string;
  settings: string;
  lvname: string;
  lvcolumns: string;
  created: string;
  created_by: string;
  updated: string;
  updated_by: string;
  perms: string[];
  updatedLV: boolean;
  extractSource: boolean;
  extractTarget: boolean;
  is_active_version: boolean;
  version_name: string;
  version_id: number;
  version_group_id: number;
};

export const getDatasetVersions = async ({
  id,
}: {
  id: string;
}): Promise<DataSet[]> => {
  const { data } = await vizHttp.get<DataSet[]>({
    url: `${arc.frontend.globals.urls.datasetUrl}/${id}?version_group_id=${id}`,
    isOldEndpoint: true,
  });

  return data;
};
