import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { NotificationInfo } from 'types/notification-info.type';

const arc = getGlobalArc();

export const getNotifications = async () => {
  if (!arc.frontend.globals.permissions.system.includes('sys_viewlogs')) {
    return [];
  }

  const { data } = await vizHttp.get<NotificationInfo[]>({
    isOldEndpoint: false,
    url: arc.frontend.globals.urls.notificationsUrl,
  });

  return data;
};
