import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const getReportCountPerGroupQueryToken = 'get-report-count-per-group';

export const getReportCountPerGroup = async () => {
  const { data } = await vizHttp.get<{
    favorites_report_count: number;
    workspace_id_to_report_count: { [workspaceId: number]: number };
    workspace_id_to_app_count: { [workspaceId_1: number]: number };
    samples_report_count: number | null;
  }>({
    url: arc.frontend.globals.urls.getReportCountPerGroup,
    isOldEndpoint: false,
  });

  return {
    favoritesReportCount: data.favorites_report_count,
    workspaceIdToReportCount: data.workspace_id_to_report_count,
    workspaceIdToAppCount: data.workspace_id_to_app_count,
    samplesReportCount: data.samples_report_count,
  };
};
