import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();

export const pinNotification = async (id: string) => {
  await vizHttp.put({
    isOldEndpoint: true,
    url: arc.frontend.globals.urls.notificationsUrl,
    data: {
      id,
      action: 'pin',
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });
};
