import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();

export const readNotifications = async (ids: string[]) => {
  try {
    await vizHttp.put({
      isOldEndpoint: true,
      url: arc.frontend.globals.urls.notificationsUrl,
      data: {
        ids: JSON.stringify(ids),
        action: 'read',
        csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
      },
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
    });
  } catch (error) {
    console.error(error);
  }
};
