type PopoverOptions =
  | {
      container?: string | Element | boolean;
      content?: string | Element;
      placement?: 'auto' | 'top' | 'bottom' | 'left' | 'right';
      title?: string | Element;
      html?: boolean;
      trigger?: 'hover' | 'click';
      delay?: { show: number };
    }
  | 'destroy'
  | 'show'
  | 'hide';

type TooltipOptions = PopoverOptions & {
  animation?: boolean;
  selector?: string | false;
  template?: string;
  offset?: number | string;
  fallbackPlacement?: string | string[];
  boundary?: string | HTMLElement;
};

type ChosenOptions = {
  // eslint-disable-next-line camelcase
  allow_single_deselect: boolean;
};

type Chosen = {
  change(callback: (event: Event, value?: { selected: string }) => void): void;
};

// eslint-disable-next-line @typescript-eslint/no-unused-vars
interface JQuery {
  offOn: <T extends Event>(
    eventName: string,
    callback: (event: T, alternativeSuccessCb: () => unknown) => void
  ) => void;
  // support for JQuery popover plugin from Bootstrap 4
  popover(options?: PopoverOptions): void;
  tooltip(options?: TooltipOptions): void;
  chosen(options?: ChosenOptions): Chosen;
}
