type Session = {
  setValue(value: string): void;
  getValue(): string;
  on(event: 'change', callback: () => void): unknown;
  removeAllListeners(event: string): void;
  insert(cursorPosition: any, text: string): void;
  getSelection(): SessionSelection;
  getTextRange(range: SelectionRange): string;
};

export interface SessionSelection {
  $isEmpty: boolean;
  rangeCount: number;
  ranges: Array<SelectionRange>;
}

export interface SelectionRange {
  cursor: RangePosition;
  end: RangePosition;
  start: RangePosition;
  marker: number;
}

export interface RangePosition {
  row: number;
  column: number;
}

export interface AceEditor {
  commands: {
    addCommand(commandDescprition: {
      name: string;
      bindKey: { win: string; mac: string };
      exec(param: unknown): void;
    }): void;
  };
  getSession(): Session;
  getCursorPosition(): { row: number; column: number };
  focus(): void;
  destroy(): void;
}
export interface EditorWrapper {
  value(): string;
  value(value: string): void;
  aceEditor(): AceEditor;
  destroy(): void;
}
