/* eslint-disable camelcase */
import type { Arc } from './arc.type';

export type SettingType =
  Arc['visual']['settingTypeEnum'][keyof Arc['visual']['settingTypeEnum']];
export interface Setting {
  id(): string;
  id(value: string): Setting;

  value(): unknown;
  value(value: unknown): Setting;

  div_id(): string;
  div_id(value: string): Setting;

  type(): SettingType;
  type(value: SettingType): Setting;

  tab(): string;
  tab(value: string): Setting;

  add_name(): string;
  add_name(value: string): Setting;

  paint_fn(): (
    containerWrapper: d3.Selection<HTMLElement, unknown, HTMLElement, unknown>
  ) => void;
  paint_fn(
    value: (
      containerWrapper: d3.Selection<HTMLElement, unknown, HTMLElement, unknown>
    ) => void
  ): Setting;

  fetch_fn(): () => unknown;
  fetch_fn(value: () => unknown): Setting;
}
