// For use with bootstrap-validator plugin http://1000hz.github.io/bootstrap-validator/
const requiresymbol = ($el: JQuery<HTMLInputElement>): string | undefined => {
  const symbolRequired = $el.data('requiresymbol');

  if (!symbolRequired) {
    return undefined;
  }

  if ($el.val()?.toString().match(/\W+/) === null) {
    return 'Must include at least one symbol.';
  }

  return undefined;
};

const requirenumber = ($el: JQuery<HTMLInputElement>): string | undefined => {
  const numberRequired = $el.data('requirenumber');

  if (!numberRequired) {
    return undefined;
  }

  if ($el.val()?.toString().match(/\d+/) === null) {
    return 'Must include at least one number.';
  }

  return undefined;
};

export const passwordValidators = {
  custom: {
    requiresymbol,
    requirenumber,
  },
};
