import React from 'react';
import OverlayTrigger from 'react-bootstrap/OverlayTrigger';
import type { OverlayTriggerProps } from 'react-bootstrap/OverlayTrigger';

export const VizTooltip = ({
  children,
  delay = 500,
  disabled,
  ...props
}: OverlayTriggerProps & { disabled?: boolean }) => {
  if (disabled) {
    return <>{children}</>;
  }

  return (
    <OverlayTrigger {...props} delay={delay}>
      {children}
    </OverlayTrigger>
  );
};
