import classNames from 'classnames';
import React, { PropsWithChildren } from 'react';
import BootstrapAccordion from 'react-bootstrap/Accordion';

import classes from './Accordion.module.scss';

type AccordionProps = {
  eventKey: string;
  isOpen: boolean;
  toggle: () => void;
  title: JSX.Element;
};

export const Accordion = ({
  eventKey,
  isOpen,
  toggle,
  title,
  children,
}: PropsWithChildren<AccordionProps>): JSX.Element => (
  <BootstrapAccordion activeKey={isOpen ? eventKey : undefined}>
    <div className={classes.header} onClick={toggle}>
      <i
        className={classNames(
          classes.arrowIcon,
          'fa fa-caret-right',
          isOpen ? classes.open : ''
        )}
      />
      <h5 className={classes.title}>{title}</h5>
    </div>

    <BootstrapAccordion.Collapse eventKey={eventKey}>
      <div className={classes.items}>{children}</div>
    </BootstrapAccordion.Collapse>
  </BootstrapAccordion>
);
