import { QueryLog } from 'apis/get-query-logs';

export const generateCsvData = (
  queryLogs: QueryLog[]
): (string | number | boolean)[][] => {
  if (!queryLogs || queryLogs.length === 0) {
    return [];
  }

  return [
    [
      'State',
      'Time',
      'User',
      'IP',
      'Action',
      'Component Type',
      'Component ID',
      'Visual',
      'Dashboard',
      'Dataset',
      'Dataconnection',
      'Connection',
      'Type',
      'Fallback',
      'Cache',
      'Cache Check',
      'Extract Used',
      'Runtime',
      'Error',
      'Error Detail',
      'Query',
    ],
    ...queryLogs.map(
      ({
        query_state,
        ts,
        username,
        ip,
        action,
        component_type,
        component_id,
        visual,
        app,
        dataset,
        dataconnection,
        dataconnection_name,
        dataconnection_type,
        dataconnection_fbid,
        cache,
        cache_check,
        rewrite_target,
        runtime,
        error,
        error_detail,
        query,
      }) => [
        query_state,
        ts,
        username,
        ip,
        action,
        component_type,
        component_id,
        visual,
        app,
        dataset,
        dataconnection,
        dataconnection_name,
        dataconnection_type,
        dataconnection_fbid,
        cache,
        cache_check,
        rewrite_target,
        runtime,
        error,
        error_detail,
        query,
      ]
    ),
  ];
};
