import { QueryLog } from 'apis/get-query-logs';
import { DataConnection } from 'types/data-connection.type';
import { SummaryDataset } from 'types/dataset.type';

export const mockQueryLogs: QueryLog[] = [
  {
    ts: '2024-10-16 12:18:44.478777',
    action: 4,
    action_name: 'Delete',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 96,
    action_id: '26fcdc58-4523-41d9-91fe-60190f90b18f',
    query_state: 0,
    query_state_name: 'Unknown',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: '',
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '',
    rewrite_target: '',
    query: '',
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: 'dashboard',
    visual_name: 'VIZ-2919',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:18:44.462064',
    action: 4,
    action_name: 'Delete',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 95,
    action_id: '9fe3d098-3a68-41c2-9804-2a2fe54eb9a5',
    query_state: 0,
    query_state_name: 'Unknown',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 95,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '',
    rewrite_target: '',
    query: '',
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: 'table',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:45.888362',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 95,
    action_id: '30db592b-f628-41db-976a-7009390075fe',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 95,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.222605',
    rewrite_target: '',
    query:
      'SELECT TA_0.`pickup_neighborhood` as `pickup_neighborhood`, TA_0.`pickup_boro` as `pickup_boro`, TA_0.`pickup_hour` as `pickup_hour`, TA_0.`ride_cnt` as `ride_cnt`, TA_0.`total_amount` as `total_amount`, TA_0.`trip_time_in_secs` as `trip_time_in_secs`\n  FROM `main`.`trips`  TA_0 \n  LIMIT 100',
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:45.884382',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 98,
    action_id: '82f6342c-4c58-4dc2-af62-a0663db5c8fe',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 98,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.222336',
    rewrite_target: '',
    query:
      'SELECT TA_0.`pickup_boro` as `pickup_boro`, sum(1) as `Record Count`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((1 = 1))\n  GROUP BY 1\n  ORDER BY 1 ASC\n  LIMIT 1001',
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:45.079763',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 95,
    action_id: 'aea7ac55-9d12-4693-81a8-890989fb75ab',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 95,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.231664',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_neighborhood` as `pickup_neighborhood`, TA_0.`pickup_boro` as `pickup_boro`, TA_0.`pickup_hour` as `pickup_hour`, TA_0.`ride_cnt` as `ride_cnt`, TA_0.`total_amount` as `total_amount`, TA_0.`trip_time_in_secs` as `trip_time_in_secs`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Astoria')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  LIMIT 100",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:45.076103',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 98,
    action_id: '387ec49b-ef93-4cf5-8856-6a7fd66f7518',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 98,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.231835',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_boro` as `pickup_boro`, sum(1) as `Record Count`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Astoria')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  GROUP BY 1\n  ORDER BY 1 ASC\n  LIMIT 1001",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:43.481619',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 95,
    action_id: '7f0d1c4c-449d-4b04-937a-964f87f52101',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 95,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.236423',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_neighborhood` as `pickup_neighborhood`, TA_0.`pickup_boro` as `pickup_boro`, TA_0.`pickup_hour` as `pickup_hour`, TA_0.`ride_cnt` as `ride_cnt`, TA_0.`total_amount` as `total_amount`, TA_0.`trip_time_in_secs` as `trip_time_in_secs`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Airport', 'Astoria')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  LIMIT 100",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:43.476412',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 98,
    action_id: '25c2778a-9b8d-4cb9-ab44-3aa7394f395f',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 98,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.236024',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_boro` as `pickup_boro`, sum(1) as `Record Count`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Airport', 'Astoria')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  GROUP BY 1\n  ORDER BY 1 ASC\n  LIMIT 1001",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:36.319904',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 95,
    action_id: 'e55754ac-a38c-40f0-8030-98f623b59054',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 95,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.246016',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_neighborhood` as `pickup_neighborhood`, TA_0.`pickup_boro` as `pickup_boro`, TA_0.`pickup_hour` as `pickup_hour`, TA_0.`ride_cnt` as `ride_cnt`, TA_0.`total_amount` as `total_amount`, TA_0.`trip_time_in_secs` as `trip_time_in_secs`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Airport')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  LIMIT 100",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
  {
    ts: '2024-10-16 12:15:36.313650',
    action: 2,
    action_name: 'View',
    component_type: 1,
    component_type_name: 'Dashboard',
    component_id: 98,
    action_id: '912277bd-a211-4760-9fde-409eabd07bf4',
    query_state: 2,
    query_state_name: 'Completed',
    username: 'vizapps_admin',
    ip: '127.0.0.1',
    visual: 98,
    app: 96,
    appgroup: '',
    dataset: 1,
    dataconnection: 1,
    dataconnection_fbid: '',
    dataconnection_type: 'sqlite',
    sync: false,
    cache: false,
    cache_check: false,
    runtime: '0.241743',
    rewrite_target: '',
    query:
      "SELECT TA_0.`pickup_boro` as `pickup_boro`, sum(1) as `Record Count`\n  FROM `main`.`trips`  TA_0 \n  WHERE ((((TA_0.`pickup_neighborhood`) in ('Airport')) or ((TA_0.`pickup_neighborhood`) is NULL)))\n  GROUP BY 1\n  ORDER BY 1 ASC\n  LIMIT 1001",
    rewrite: '',
    error: false,
    error_detail: '',
    process_id: 1,
    visual_type: '',
    visual_name: '',
    dataset_name: 'NYC Taxicab Rides',
    dataconnection_name: 'samples',
    appgroup_name: '',
    dashboard_name: '',
    user_id: 1,
  },
];

export const mockDataconnections: DataConnection[] = [
  {
    id: 2,
    type: 'sqlite',
    typeName: 'SQLite',
    name: 'Cloudera Data Visualization Usage',
    info: JSON.parse(
      '{"PARAMS": {"FILE": "/Users/juditpuski/.arc/usage.db", "CACHE": {"ENABLED": 0, "RETENTION": 86400}}}'
    ),
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 5,
    type: 'impyla',
    typeName: 'Impala',
    name: 'Impala Judit',
    info: JSON.parse(
      '{"PARAMS": {"CONCURRENCY": 100, "CONCURRENCY_USER": 5, "QUERY_TIMEOUT": 10, "QUERY_LOADING_WARNING_SECONDS": 20, "UPLOAD_MAXROWS": 1000000, "APP_NAME": "viz", "ACCOUNT": "", "HOST": "szhou-datavizimpala-3.vpc.cloudera.com", "PORT": "21050", "USERNAME": "", "SETTINGS": {}, "SOCKET_TIMEOUT": 60, "MODE": "binary", "HS2_HTTP_SQLPATH": "", "HS2_HTTP_ACCESS_TOKEN": "", "IMPERSONATION": false, "IMPERSONATION_TRUSTED": false, "AUTH": "nosasl", "SOCK": "normal", "KERBSERV": "", "SSLCERT_NAME_MISMATCH": false, "CACHE": {"ENABLED": 0, "RETENTION": 86400}, "ARCENGINE_HISTORY_ETL": {"ENABLED": 0, "TARGET_TABLE": "", "JOB_NAME": "", "SCHEDULE": "Weekly"}}}'
    ),
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 4,
    type: 'mysql',
    typeName: 'MySQL',
    name: 'MySQL BoFA Judit',
    info: JSON.parse(
      '{"PARAMS": {"CONCURRENCY": 100, "CONCURRENCY_USER": 5, "QUERY_TIMEOUT": 10, "QUERY_LOADING_WARNING_SECONDS": 20, "UPLOAD_MAXROWS": 1000000, "ACCOUNT": "", "HOST": "viz-team-6.cc-os.cloudera.com", "PORT": "3311", "USERNAME": "root", "DATABASE": "", "DRIVER": "", "DSN": "", "Authentication": "No Authentication", "CACHE": {"ENABLED": 0, "RETENTION": 86400}, "ARCENGINE_HISTORY_ETL": {"ENABLED": 0, "TARGET_TABLE": "", "JOB_NAME": "", "SCHEDULE": "Weekly"}}}'
    ),
    isPasswordSet: true,
    supportsImportData: true,
  },
  {
    id: 3,
    type: 'mysql',
    typeName: 'MySQL',
    name: 'MySQL Judit',
    info: JSON.parse(
      '{"PARAMS": {"CONCURRENCY": 100, "CONCURRENCY_USER": 5, "QUERY_TIMEOUT": 10, "QUERY_LOADING_WARNING_SECONDS": 20, "UPLOAD_MAXROWS": 1000000, "ACCOUNT": "", "HOST": "viz-team-6.cc-os.cloudera.com", "PORT": "3308", "USERNAME": "root", "DATABASE": "", "DRIVER": "", "DSN": "", "Authentication": "No Authentication", "CACHE": {"ENABLED": 0, "RETENTION": 86400}, "ARCENGINE_HISTORY_ETL": {"ENABLED": 0, "TARGET_TABLE": "", "JOB_NAME": "", "SCHEDULE": "Weekly"}}}'
    ),
    isPasswordSet: true,
    supportsImportData: true,
  },
  {
    id: 1,
    type: 'sqlite',
    typeName: 'SQLite',
    name: 'samples',
    info: JSON.parse(
      '{"PARAMS": {"FILE": "/Users/juditpuski/Projects/viz/arcweb/util/../samples/samples.sqlite"}}'
    ),
    isPasswordSet: false,
    supportsImportData: true,
  },
];

export const mockSummaryDatasets: SummaryDataset[] = [
  {
    id: 10,
    name: 'Cereals',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 9,
    name: 'Earthquake Data January 2019',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 11,
    name: 'Food Stores Inspection in NYC',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 5,
    name: 'Global Information Security Threats',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 3,
    name: 'Iris',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 1,
    name: 'NYC Taxicab Rides',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 2,
    name: 'NYC Taxicab Rides Detail',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 4,
    name: 'Restaurant Inspection SF',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 7,
    name: 'US County Population',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 6,
    name: 'US State Populations Over Time',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 8,
    name: 'World Life Expectancy',
    dc_id: 1,
    dc_name: 'samples',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
  {
    id: 12,
    name: 'World Population',
    dc_id: 5,
    dc_name: 'Impala Judit',
    type: 'sqlite',
    created: { by: 'vizapps_admin' },
  },
];
