import { intervalSchema } from 'pages/job-overview-page/components/interval-modal/interval-schema';
import * as yup from 'yup';

export const analyticalJobFormSchema = yup.object({
  name: yup.string().required().label('Name'),
  scheduleGroupId: yup.number().required().label('Schedule interval'),
  scheduleGroup: intervalSchema
    .notRequired()
    .default(undefined)
    .when('scheduleGroupId', {
      is: -2,
      then: (schema) => schema.required(),
    }),
  errorTo: yup.array(yup.string().email().required()).required(),
});

export type AnalyticalJobFormSchema = yup.InferType<
  typeof analyticalJobFormSchema
>;
