import React from 'react';
import classes from './ChatbotLoadingIndicator.module.scss';
import { LoadingStatus } from 'types/chatbot-message.type';

type LoadingIndicatorProps = {
  loadingStatus: LoadingStatus;
};

export const ChatbotLoadingIndicator = ({
  loadingStatus,
}: LoadingIndicatorProps): JSX.Element | null => {
  let loadingMessage: JSX.Element | null = null;

  if (loadingStatus === 'None') {
    return null;
  }

  if (loadingStatus === 'Vector') {
    loadingMessage = (
      <span>
        Performing <strong>Vector Search</strong>
      </span>
    );
  } else {
    loadingMessage = (
      <span>
        Processing <strong>{loadingStatus}</strong> Request
      </span>
    );
  }

  return (
    <div data-test-id="chatbot-loading-indicator" className={classes.container}>
      <span data-test-id="chatbot-loading-message" className={classes.fadeIn}>
        {loadingMessage}
        <span className={classes.loadingCircle} />
      </span>
    </div>
  );
};
