import React from 'react';
import ReactMarkdown from 'react-markdown';

type MarkdownProps = {
  markdownText: string;
};

const Markdown = ({ markdownText }: MarkdownProps) => {
  return (
    <ReactMarkdown
      components={{
        pre: ({ node, ...props }) => (
          <pre
            style={{
              background: 'rgba(0,0,0, .1)',
              padding: '10px',
              margin: '10px',
              borderRadius: '5px',
              overflow: 'auto',
              maxWidth: 'calc(100% - 20px)',
            }}
            {...props}
          />
        ),
        code: ({ node, ...props }) => (
          <code
            style={{
              fontSize: '0.9em',
              lineHeight: '1.5',
            }}
            {...props}
          />
        ),
      }}
    >
      {markdownText}
    </ReactMarkdown>
  );
};

export default Markdown;
