import React from 'react';

import { VizLink } from 'components/viz-link/VizLink';

import classes from './ChromeBrowserSuggestion.module.scss';

const isChrome = navigator.userAgent.match(/chrome|chromium|crios/i);

export const ChromeBrowserSuggestion = (): JSX.Element | null => {
  if (isChrome) {
    return null;
  }

  return (
    <div className={classes.container}>
      <i className="fa fa-leaf" /> For best results, use Google Chrome.{' '}
      <VizLink
        href="http://www.google.com/intl/en/chrome/browser/desktop/"
        target="_blank"
        rel="noreferrer"
      >
        Get Chrome
      </VizLink>
    </div>
  );
};
