import React, { AnchorHTMLAttributes, PropsWithChildren } from 'react';
import classes from './ClouderaLink.module.scss';
import classNames from 'classnames';

type ClouderaLinkProps = {
  testId?: string;
  disabled?: boolean;
} & PropsWithChildren<AnchorHTMLAttributes<HTMLAnchorElement>>;

export const ClouderaLink = ({
  children,
  testId,
  disabled,
  ...props
}: ClouderaLinkProps): JSX.Element => {
  return (
    <a
      {...props}
      className={classNames(
        classes.link,
        disabled && classes.disabled,
        props.className
      )}
      data-test-id={testId}
    >
      {children}
    </a>
  );
};
