import React from 'react';
import { ColumnTypeClass } from 'arc/types/dataset.type';
import styles from './ColumnLabel.module.scss';
import { Tooltip } from 'react-bootstrap';
import { VizTooltip } from 'components/VizTooltip';
import classNames from 'classnames';

export const ColumnLabel = (
  columnName: string,
  columnTypeClass: ColumnTypeClass
): JSX.Element => {
  return (
    <VizTooltip
      placement="top"
      overlay={<Tooltip id={`${columnName}-tooltip`}>{columnName}</Tooltip>}
    >
      <div className="d-flex align-items-center">
        <div className={styles.label}>
          <span className={classNames('dim-icon-type', columnTypeClass)}></span>
          {columnName}
        </div>
      </div>
    </VizTooltip>
  );
};
