import React, { useState } from 'react';
import classes from '../chatbot/Chatbot.module.scss';
import classNames from 'classnames';

import { copyToClipboard } from 'arc/misc/misc';

type CopyToClipboardProps = {
  text: string;
};

export const CopyToClipboard = ({
  text,
}: CopyToClipboardProps): JSX.Element => {
  const [copied, setCopied] = useState(false);

  return (
    <span
      data-test-id="copy-icon"
      className={classNames(
        classes.icon,
        classes.copyIcon,
        `fa fa-${copied ? 'check' : 'clipboard'}`
      )}
      onClick={() => {
        if (copied) return;

        copyToClipboard(text).then(() => {
          setCopied(true);

          setTimeout(() => {
            setCopied(false);
          }, 2000);
        });
      }}
    />
  );
};
