import React from 'react';
import * as d3 from 'd3';

type CsvImportTabContentProps = {
  connectionMaxRowUpload: number;
  setIsFormValid: (isFormValid: boolean) => void;
  connectionType: string;
};

export const CsvImportTabContent = ({
  connectionMaxRowUpload,
  setIsFormValid,
  connectionType,
}: CsvImportTabContentProps): JSX.Element => (
  <>
    <div>
      Import data from CSV file
      <div className="help-text">
        For performance reasons, we suggest uploading files 50MB or less.
        <br />
        The maximum number of rows that can be imported in for this connection
        is {d3.format(',')(connectionMaxRowUpload)}.
      </div>
      <div
        className={
          connectionType.toLowerCase() === 'solr'
            ? 'text-info'
            : 'arc-invisible'
        }
      >
        <i className="fa fa-exclamation-triangle" aria-hidden="true"></i>
        This feature is supported for Solr running in SolrCloud mode.
      </div>
    </div>

    <br />

    <input type="hidden" name="data-type" value="csv" />

    <input
      type="file"
      name="datasource_file"
      onChange={(event) => {
        setIsFormValid(!!event.target.value);
      }}
    />
  </>
);
