type BaseField = {
  label: string;
  type: 'input' | 'radio' | 'checkbox' | 'password' | 'dropdown' | 'textarea';
  placeholder?: string;
  info?: string;
  checkbox_label?: string;
  options?: Array<{ id: string; label: string; value: string }>;
};

export type ConfigField = {
  show?: string;
  config: BaseField;
  // for special data connections
  // we need to overwrite the defaults
  label?: string;
  type?: 'input' | 'radio' | 'checkbox' | 'password' | 'dropdown' | 'textarea';
  placeholder?: string;
  info?: string;
  checkbox_label?: string;
  options?: Array<{ id: string; label: string; value: string }>;
};

export type Warehouse = {
  namespace: string;
  hostName: string;
  port: number;
  connectionMode: string;
  httpPath: string;
  socketType: string;
  authenticationMode: string;
  username: string;
};
