import { DataConnection } from 'types/data-connection.type';

export const mockDataconnections: DataConnection[] = [
  {
    id: 1,
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'szhou-datavizimpala-1.vpc.cloudera.com',
        PORT: '10000',
        USERNAME: 'admin',
        MODE: 'binary',
        HS2_HTTP_SQLPATH: 'gateway/cdp-proxy-api/hive',
        HS2_HTTP_ACCESS_TOKEN: '',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: true,
        AUTH: 'plain',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        USER_DEPENDENT_CACHE: false,
        APP_NAME: 'viz134',
        SETTINGS: {
          'hive.server2.async.exec.async.compile': 'false',
          ffg: 'juyu',
        },
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: true,
    name: 'test_hive',
    type: 'hyve',
    typeName: 'Hive',
    cml: {
      id: null,
      isAvailable: false,
    },
    supportsImportData: true,
  },
  {
    id: 2,
    info: {
      PARAMS: {
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        SOLRTYPE: 'cloud',
        SOLR_JOINCHAR: '',
        KERBSERV: '',
        AUTH: 'nosasl',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        ACCOUNT: '',
        HOST: 'mock-host.com',
        PORT: '8983',
        USERNAME: '',
        DATABASE: '',
        DSN: '',
        CACHE: {
          ENABLED: 0,
          RETENTION: 86400,
        },
        ARCENGINE_HISTORY_ETL: {
          ENABLED: 0,
          TARGET_TABLE: '',
          JOB_NAME: '',
          SCHEDULE: 'Weekly',
        },
      },
    },
    isPasswordSet: false,
    name: 'test_solr',
    type: 'solr',
    typeName: 'Solr (Tech Preview)',
    cml: {
      id: null,
      isAvailable: false,
    },
    supportsImportData: true,
  },
  {
    id: 3,
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'szhou-datavizimpala-3.vpc.cloudera.com',
        PORT: '21050',
        USERNAME: '',
        MODE: 'binary',
        HS2_HTTP_SQLPATH: '',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        AUTH: 'nosasl',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        USER_DEPENDENT_CACHE: false,
        APP_NAME: 'viz',
        SETTINGS: {},
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: {
          ENABLED: 0,
          RETENTION: '86400',
        },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    name: 'test_impala',
    type: 'impyla',
    typeName: 'Impala',
    cml: {
      id: null,
      isAvailable: false,
    },
    supportsImportData: true,
  },
  {
    id: 4,
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: '10.96.131.181',
        PORT: '8080',
        USERNAME: 'admin',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        AUTH: 'nosasl',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        USER_DEPENDENT_CACHE: false,
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: {
          ENABLED: 0,
          RETENTION: '86400',
        },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    name: 'Trino Judit',
    type: 'trino',
    typeName: 'Trino (Tech Preview)',
    cml: {
      id: null,
      isAvailable: false,
    },
    supportsImportData: true,
  },
  {
    id: 5,
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-6.cc-os.cloudera.com',
        PORT: '5432',
        DATABASE: 'viz_test_db',
        USERNAME: 'viz',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: {
          ENABLED: 0,
          RETENTION: '86400',
        },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: true,
    name: 'test_postgresql',
    type: 'postgres',
    typeName: 'PostgreSQL',
    cml: {
      id: null,
      isAvailable: false,
    },
    supportsImportData: true,
  },
  {
    id: 6,
    type: 'hyve',
    typeName: 'Cloudera Data Warehouse Hive',
    name: 'test_cdw_hive',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: 'cdw-hyve',
        HOST: 'hiveserver2-service.compute-1736820433-r9kl.svc.cluster.local',
        PORT: '80',
        USERNAME: 'hive',
        MODE: 'http',
        HS2_HTTP_SQLPATH: 'cliservice',
        HS2_HTTP_ACCESS_TOKEN: '',
        SOCK: 'normal',
        AUTH: 'ldap',
        SOCKET_TIMEOUT: 600,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: true,
        USER_DEPENDENT_CACHE: false,
        APP_NAME: 'viz',
        SETTINGS: { 'hive.server2.async.exec.async.compile': 'false' },
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 7,
    type: 'impyla',
    typeName: 'Cloudera Data Warehouse Impala',
    name: 'test_cdw_impala',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: 'cdw-impyla',
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        APP_NAME: 'viz',
        ACCOUNT: undefined,
        HOST: 'coordinator.impala-1739180273-9kcj.svc.cluster.local',
        PORT: '28000',
        USERNAME: 'srv_env-fwkk6k',
        SETTINGS: {},
        SOCKET_TIMEOUT: 600,
        MODE: 'http',
        HS2_HTTP_SQLPATH: '',
        HS2_HTTP_ACCESS_TOKEN: '',
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: true,
        AUTH: 'ldap',
        SOCK: 'normal',
        KERBSERV: '',
        SSLCERT_NAME_MISMATCH: false,
        CACHE: { ENABLED: 0, RETENTION: 0 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 8,
    type: 'sqlite',
    typeName: 'SQLite',
    name: 'test_sqlite',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        FILE: '/home/cdsw/data.sqlite',
        CONCURRENCY: 10,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 48,
        QUERY_LOADING_WARNING_SECONDS: 25,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 9,
    type: 'mysql',
    typeName: 'MySQL',
    name: 'test_mysql',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-6.cc-os.cloudera.com',
        PORT: '3311',
        DATABASE: '',
        USERNAME: 'root',
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 10,
    type: 'mysql',
    typeName: 'MySQL',
    name: 'test_maria',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-6.cc-os.cloudera.com',
        PORT: '3310',
        DATABASE: '',
        USERNAME: 'root',
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 11,
    type: 'solr',
    typeName: 'Solr',
    name: 'test_solr',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-5.cc-os.cloudera.com',
        PORT: '8983',
        SOLRTYPE: 'cloud',
        SOLR_JOINCHAR: ',',
        USERNAME: 'vizapps_admin',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        AUTH: 'nosasl',
        KERBSERV: '',
        SOCKET_TIMEOUT: 0,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        SETTINGS: {},
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        UPLOAD_MAXROWS: 1000000,
        QUERY_LOADING_WARNING_SECONDS: 20,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 12,
    type: 'mariadb',
    typeName: 'MariaDB',
    name: 'test_mariadb',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-6.cc-os.cloudera.com',
        PORT: '3310',
        DATABASE: '',
        USERNAME: 'root',
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 13,
    type: 'snowflake',
    typeName: 'Snowflake',
    name: 'test_snowflake',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        WAREHOUSE: 'compute_wh',
        DATABASE: 'viz_sample_data',
        USERNAME: 'viz_team',
        ROLE: '',
        ACCOUNT: 'sx41684.us-east-2.aws',
        SETTINGS: {},
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 14,
    type: 'sparksql',
    typeName: 'Spark SQL',
    name: 'test_spark_sql',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'szhou-datavizimpala-1.vpc.cloudera.com',
        PORT: '10000',
        USERNAME: 'admin',
        MODE: 'binary',
        HS2_HTTP_SQLPATH: '',
        HS2_HTTP_ACCESS_TOKEN: '',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        AUTH: 'plain',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        SETTINGS: {},
        CONCURRENCY: 100,
        CONCURRENCY_USER: 5,
        QUERY_TIMEOUT: 10,
        UPLOAD_MAXROWS: 1000000,
        QUERY_LOADING_WARNING_SECONDS: 20,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 15,
    type: 'trino',
    typeName: 'Trino',
    name: 'test_trino',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: '10.96.131.181',
        PORT: '8080',
        USERNAME: 'admin',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        AUTH: 'nosasl',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        USER_DEPENDENT_CACHE: false,
        CONCURRENCY: 22,
        CONCURRENCY_USER: 22,
        QUERY_TIMEOUT: 22,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 16,
    type: 'phoenix',
    typeName: 'Phoenix',
    name: 'test_phoenix',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-1.cc-os.cloudera.com',
        PORT: '8765',
        USERNAME: '',
        MODE: 'http',
        HS2_HTTP_SQLPATH: '',
        SOCK: 'sslcert',
        SSLCERT_NAME_MISMATCH: true,
        AUTH: 'kerberos',
        KERBSERV: '',
        SOCKET_TIMEOUT: 60,
        IMPERSONATION: false,
        IMPERSONATION_TRUSTED: false,
        USER_DEPENDENT_CACHE: false,
        CONCURRENCY: 22,
        CONCURRENCY_USER: 22,
        QUERY_TIMEOUT: 22,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 10000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
  {
    id: 17,
    type: 'druid',
    typeName: 'Druid',
    name: 'test_druid',
    info: {
      PARAMS: {
        CONNECTIONNAME_EXTENDED: '',
        HOST: 'viz-team-6.cc-os.cloudera.com',
        PORT: '3311',
        DATABASE: '',
        USERNAME: '',
        SOCK: 'normal',
        SSLCERT_NAME_MISMATCH: false,
        CONCURRENCY: 22,
        CONCURRENCY_USER: 22,
        QUERY_TIMEOUT: 22,
        QUERY_LOADING_WARNING_SECONDS: 20,
        UPLOAD_MAXROWS: 1000000,
        CACHE: { ENABLED: 0, RETENTION: 86400 },
        ARCENGINE_HISTORY_ETL: {},
      },
    },
    isPasswordSet: false,
    supportsImportData: true,
  },
];

export const allConnectionTypesMock = {
  mariadb: 'MariaDB',
  mysql: 'MySQL',
  sqlite: 'SQLite',
  sparksql: 'Spark SQL',
  solr: 'Solr (Tech Preview)',
  postgres: 'PostgreSQL',
  duckdb: 'DuckDB',
  druid: 'Druid (Tech Preview)',
  hive: 'Hive (legacy)',
  hyve: 'Hive',
  impala: 'Impala (legacy)',
  impyla: 'Impala',
  arcengine: 'Arcadia (legacy)',
  arcengine_v2: 'Arcadia',
  aster: 'TD Aster',
  redshift: 'Amazon Redshift',
  mssqlserver: 'Microsoft SQL Server',
  oracle: 'Oracle',
  denodo: 'Denodo',
  drill: 'Apache Drill',
  bigquery: 'Google BigQuery',
  snowflake: 'Snowflake (Tech Preview)',
  ksql: 'Confluent KSQL',
  teradata: 'Teradata',
  vertica: 'Vertica',
  elasticsearch: 'Elasticsearch',
  cassandra: 'Apache Cassandra',
  athena: 'Amazon Athena',
  phoenix: 'Phoenix (Tech Preview)',
  trino: 'Trino (Tech Preview)',
  'impyla:cdw-impyla': 'Cloudera Data Warehouse Impala',
  'hyve:cdw-hyve': 'Cloudera Data Warehouse Hive',
  'postgres:ssb': 'SQL Stream Builder (Tech Preview)',
};
