import { DatasetProfileTab } from 'components/data-profile-tab/DatasetProfileTab';
import { Dataset } from 'arc/types/dataset.type';
import React, { useCallback, useState } from 'react';
import { useLegacyBridge } from 'services/legacy-bridge';
export const DatasetProfileContainer = (): JSX.Element | null => {
  const [dataset, setDataset] = useState<Dataset>();
  const [title, setTitle] = useState('');

  const onDatasetChange = useCallback(
    ({ payload }: { payload?: { dataset: Dataset; title: string } }) => {
      if (payload) {
        setDataset({ ...payload.dataset });
        setTitle(payload.title);
      }
    },

    [setDataset]
  );
  useLegacyBridge('profile-dataset-event', onDatasetChange);
  return <DatasetProfileTab dataset={dataset} title={title} />;
};
