import React from 'react';
import styles from './DatasetColumnPill.module.scss';
import classNames from 'classnames';
import { Badge } from 'react-bootstrap';
import CloseIcon from '@cloudera-internal/cuix-core/icons/react/CloseIcon';

export const DatasetColumnPill = ({
  label,
  variant,
  onClick,
  onDelete,
}: {
  label: String;
  variant: 'dimension' | 'measure';
  onClick?: () => void;
  onDelete?: () => void;
}): JSX.Element => {
  return (
    <Badge
      className={classNames(
        styles.pill,
        'm-1',
        'p-2',
        variant === 'measure' ? styles.measure : styles.dimension,
        onClick ? 'cursor-pointer' : 'cursor-default'
      )}
      pill
    >
      <div className={'d-flex align-items-center align-content-center'}>
        <div onClick={onClick}>{label}</div>
        {onDelete && <CloseIcon className={styles.remove} onClick={onDelete} />}
      </div>
    </Badge>
  );
};
