import React, { useEffect } from 'react';

import { getGlobalArc } from 'utils/get-global-arc';
import { setupNavbarSearch } from 'arc/misc/speech-detection';

import classes from './GlobalSearch.module.scss';
import classNames from 'classnames';

const arc = getGlobalArc();

const isSpeechRecognitionEnabled = arc.frontend.featureFlipper.getValueById(
  'enable_speech_recognition'
);

export const GlobalSearch = (): JSX.Element => {
  useEffect(() => {
    setupNavbarSearch($('#arc-search-global'));
  }, []);

  return (
    <div className={classes.container} id="arc-search-global">
      <div className={classes.searchIconContainer}>
        <i className="fa fa-search pop-search-icon" />
      </div>

      <input
        className={classNames(classes.searchInput, 'search arc-speech-text')}
        placeholder="search docs / create or find assets"
      />

      {isSpeechRecognitionEnabled && (
        <div
          className={classNames(
            classes.speechRecognition,
            'arc-speech-trigger'
          )}
        >
          <i className="fa fa-microphone" />
        </div>
      )}

      <div className={classNames(classes.removeIcon, 'pop-search-remove')}>
        <i className="fa fa-times-circle" />
      </div>
    </div>
  );
};
