import { getGlobalArc } from 'utils/get-global-arc';
import { isBrowserInternetExplorer } from 'arc/misc/misc';
import { VizButton } from 'components/viz-button/VizButton';
import { setIncompatiblyBrowserWarningDismissed } from 'apis/set-incompatible-browser-warning-dismissed';
import React, { useState } from 'react';
import Modal from 'react-bootstrap/Modal';
const arc = getGlobalArc();
const initialState =
  isBrowserInternetExplorer() &&
  !arc.frontend.globals.incompatibleBrowserWarningDismissed;

export const IncompatibleBrowserAlertModal = (): JSX.Element => {
  const [isOpen, setIsOpen] = useState(initialState);
  const onConfirm = () => {
    setIncompatiblyBrowserWarningDismissed().then(() => {
      setIsOpen(false);
    });
  };
  return (
    <Modal show={isOpen} backdrop="static">
      <Modal.Header closeButton onClick={() => setIsOpen(false)}></Modal.Header>
      <Modal.Body>
        <div>
          For best result we recommend using Google Chrome or Microsoft Edge
          browser.
        </div>
        <br></br>
        <div>Some features may not function properly with other browsers.</div>
      </Modal.Body>
      <Modal.Footer>
        <VizButton color="secondary" size="medium" onClick={onConfirm}>
          OK
        </VizButton>
      </Modal.Footer>
    </Modal>
  );
};
