import { getGlobalArc } from 'utils/get-global-arc';
import moment from 'moment';
import React from 'react';

import classes from './LastLogin.module.scss';

const arc = getGlobalArc();

export const LastLogin = (): JSX.Element => {
  const lastLoginMoment = moment(
    arc.frontend.globals.authentication.lastLoginDate
  );

  const formattedLastLogin = lastLoginMoment.isValid()
    ? lastLoginMoment.format('MMM DD, YYYY [at] hh:mm a')
    : 'N/A';

  return (
    <div className={classes.container}>
      <span>Your last login was on:</span>
      <span>{formattedLastLogin}</span>
    </div>
  );
};
