import { VizButton } from 'components/viz-button/VizButton';
import React from 'react';

export const LoadingIndicatorActionButton = ({
  onClick,
  isValid = true,
  isSaving,
  label,
  type = 'button',
}: {
  onClick?: () => void;
  isValid?: boolean;
  icon?: JSX.Element;
  isSaving: boolean;
  label: string;
  type?: 'submit' | 'reset' | 'button';
}): JSX.Element => {
  return (
    <VizButton
      color="primary"
      size="medium"
      disabled={!isValid || isSaving}
      onClick={onClick}
      className="pl-3"
      testId={'confirm-btn'}
      type={type}
    >
      {isSaving && <i className="fa fa-spinner fa-spin mr-1" />}
      {label}
    </VizButton>
  );
};
