import classNames from 'classnames';
import React, { useEffect, useState } from 'react';

import classes from './NaturalLanguageSearch.module.scss';
import { legacyBridge } from 'services/legacy-bridge';

export const NaturalLanguageSearch = (): JSX.Element => {
  const [isDisabled, setIsDisabled] = useState(true);

  useEffect(() => {
    const subscription = legacyBridge.arcLoadedEvent.subscribe((isLoaded) => {
      setIsDisabled(!isLoaded);

      if (isLoaded) {
        window.arc.topnav.setup();
      }
    });

    return () => subscription.unsubscribe();
  }, []);

  return (
    <span
      className={classNames(
        classes.container,
        'topmenu-search-link',
        isDisabled && 'natural-language-disabled'
      )}
    >
      <i className="sym-search-plus" /> SEARCH
    </span>
  );
};
