import React from 'react';

import { getGlobalArc } from 'utils/get-global-arc';

import { NewButton } from 'components/new-button/NewButton';
import classes from './NewAppButton.module.scss';

const arc = getGlobalArc();

type NewAppButtonProps = {
  size?: 'sm' | 'lg';
};

export const NewAppButton = ({ size }: NewAppButtonProps): JSX.Element => (
  <NewButton
    href={arc.frontend.globals.urls.appGroupEditUrl}
    isFullWidth
    icon={<span className="fa sym-app" />}
    text="New App"
    buttonClassName={classes.button}
    plusIconClassName={classes.icon}
    size={size}
    testId="new-app-btn"
  />
);
