import classNames from 'classnames';
import React from 'react';
import { Button } from 'react-bootstrap';

import { VizWrapperLink } from 'components/viz-wrapper-link/VizWrapperLink';

import classes from './NewButton.module.scss';

type NewButtonProps = {
  href: string;
  testId?: string;
  isFullWidth?: boolean;
  icon: JSX.Element;
  text: string;
  buttonClassName: string;
  plusIconClassName: string;
  size?: 'sm' | 'lg';
};

export const NewButton = ({
  href,
  testId,
  isFullWidth,
  icon,
  text,
  buttonClassName,
  plusIconClassName,
  size,
}: NewButtonProps): JSX.Element => {
  return (
    <VizWrapperLink href={href} data-test-id={testId} isFullWidth={isFullWidth}>
      <Button
        size={size}
        className={classNames(classes.button, buttonClassName)}
      >
        <i
          className={classNames(
            classes.plusIcon,
            'fa fa-plus',
            plusIconClassName
          )}
        />{' '}
        {icon} {text}
      </Button>
    </VizWrapperLink>
  );
};
