import React from 'react';

import { getGlobalArc } from 'utils/get-global-arc';

import { NewButton } from 'components/new-button/NewButton';

import classes from './NewDashboardButton.module.scss';

type NewDashboardButtonProps = {
  testId: string;
  size?: 'sm' | 'lg';
};

const arc = getGlobalArc();

export const NewDashboardButton = ({
  testId,
  size,
}: NewDashboardButtonProps): JSX.Element => {
  const newDashboardUrl = `${arc.frontend.globals.urls.reportBuilderUrl}/0?report_type=dashboard`;

  return (
    <NewButton
      testId={testId}
      href={newDashboardUrl}
      isFullWidth
      icon={<i className="fa sym-dashboard" />}
      text="New Dashboard"
      buttonClassName={classes.button}
      plusIconClassName={classes.plusIcon}
      size={size}
    />
  );
};
