import { getGlobalArc } from 'utils/get-global-arc';
import React from 'react';

import type { NotificationInfo } from 'types/notification-info.type';
import { VizNavLink } from '../viz-nav-link/VizNavLink';
import classes from './NotifcationCenter.module.scss';

type NotificationCenterProps = {
  openNotificationCenterModal: () => void;
  notifications: NotificationInfo[];
};

export const NotifcationCenter = ({
  openNotificationCenterModal,
  notifications,
}: NotificationCenterProps): JSX.Element => {
  const hasUnreadNotifications = notifications.some(
    ({ status }) => status === 'U'
  );

  const arc = getGlobalArc();
  const muteNotification =
    arc.frontend.featureFlipper.getValueById('mute_notifications');

  return (
    <VizNavLink onClick={openNotificationCenterModal}>
      <i className="position-relative fa fa-bell">
        {!muteNotification && hasUnreadNotifications && (
          <span className={classes.badge} />
        )}
      </i>
    </VizNavLink>
  );
};
