import React from 'react';

import { getGlobalArc } from 'utils/get-global-arc';

import classes from './ReleaseItemImage.module.scss';

type ReleaseItemImageProps = {
  srcInfo: {
    version: string;
    feature: number;
    index: number;
    extension?: string;
  };
  alt: string;
};

const arc = getGlobalArc();

export const ReleaseItemImage = ({
  srcInfo: { version, feature, index, extension = 'png' },
  alt,
}: ReleaseItemImageProps): JSX.Element => {
  const src = `${arc.frontend.globals.urls.staticUrl}/img/what-s-new-modal/${version}-${feature}-${index}.${extension}`;

  return <img className={classes.image} src={src} alt={alt} loading="lazy" />;
};
