import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { Accordion } from '../accordion/Accordion';
import classes from './ReleaseItem.module.scss';

type ReleaseItemProps = {
  id: string;
  releaseItem: WhatSNewRelease['items'][number];
  openAccordionIds: string[];
  toggle: (id: string) => void;
};

export const ReleaseItem = ({
  id,
  releaseItem,
  openAccordionIds,
  toggle,
}: ReleaseItemProps): JSX.Element => {
  const isOpen = openAccordionIds.includes(id);

  return (
    <div className={classes.container}>
      <Accordion
        isOpen={isOpen}
        eventKey={id}
        title={<>{releaseItem.title}</>}
        toggle={() => toggle(id)}
      >
        {releaseItem.content}
      </Accordion>
    </div>
  );
};
