import React from 'react';
import classes from '../settings-navigation/SettingsNavigation.module.scss';
import classNames from 'classnames';

type SettingsNavigationItemProps = {
  href: string;
  id: string;
  label: string;
  ariaControls: string;
  isActive: boolean;
};

const SettingsNavigationItem = ({
  href,
  id,
  label,
  ariaControls,
  isActive,
}: SettingsNavigationItemProps) => {
  return (
    <li
      className={classNames(classes.settingsNavItem, {
        [classes.active]: isActive,
      })}
      role="presentation"
    >
      <a
        className={classes.settingsNavLink}
        href={href}
        id={id}
        role="tab"
        aria-controls={ariaControls}
        aria-selected="false"
      >
        {label}
      </a>
    </li>
  );
};

export default SettingsNavigationItem;
