import React, { PropsWithChildren, useState } from 'react';
import styles from './TableList.module.scss';
export const ToggleContainer = ({
  open = true,
  children,
}: PropsWithChildren<{
  open: boolean;
}>): JSX.Element => {
  const [isTableListContainerOpen, setIsTableListContainerOpen] =
    useState(open);

  const toggleTableListContainer = () => {
    setIsTableListContainerOpen((prev) => !prev);
  };

  return (
    <div
      className={`pr-2 ${styles.container} ${
        isTableListContainerOpen ? styles.width30 : styles.width0
      }`}
    >
      <div
        className={`${styles.toggle} fa fa-caret-${
          isTableListContainerOpen ? 'left' : 'right'
        }`}
        onClick={toggleTableListContainer}
      ></div>

      {isTableListContainerOpen && (
        <div className="h-100 d-flex flex-column">{children}</div>
      )}
    </div>
  );
};
