import React, { PropsWithChildren } from 'react';
import Row from 'react-bootstrap/Row';
import Col from 'react-bootstrap/Col';
import Container from 'react-bootstrap/Container';

import ClouderaLogo from 'assets/logos/cloudera-logo-orange.svg';

import classes from './UnauthorizedLayout.module.scss';

export const UnauthorizedLayout = ({ children }: PropsWithChildren<{}>) => (
  <Container className={classes.container} fluid>
    <Row>
      <Col xs={12}>
        <div className={classes.logoContainer}>
          <ClouderaLogo className={classes.logo} height={100} width={100} />
        </div>
      </Col>

      {children}
    </Row>
  </Container>
);
