import React from 'react';

type UrlImportTabContentProps = {
  setIsFormValid: (isFormValid: boolean) => void;
};

export const UrlImportTabContent = ({
  setIsFormValid,
}: UrlImportTabContentProps): JSX.Element => (
  <div>
    <div className="form-group">
      <label>
        Enter a URL to a page that contains a CSV file ({urlExampleLink}) or an
        Open Data API endpoint ({apiExampleLink}).
      </label>

      <input type="hidden" name="data-type" value="url" />

      <input
        type="text"
        name="url"
        className="form-control"
        onChange={(event) => setIsFormValid(!!event.target.value)}
      />
    </div>
  </div>
);

const urlExampleLink = (
  <a
    target="_blank"
    href="https://github.com/fivethirtyeight/data/blob/master/airline-safety/airline-safety.csv"
    rel="noreferrer"
  >
    example
  </a>
);

const apiExampleLink = (
  <a
    target="_blank"
    href="https://data.cityofchicago.org/resource/tt4n-kn4t.json"
    rel="noreferrer"
  >
    example
  </a>
);
