import React from 'react';
import Tooltip from 'react-bootstrap/Tooltip';

import { getGlobalArc } from 'utils/get-global-arc';
import { VizTooltip } from 'components/VizTooltip';

import classes from './UserIcon.module.scss';
import classNames from 'classnames';

const arc = getGlobalArc();

export const UserIcon = (): JSX.Element => (
  <>
    <i className="fa fa-user" />

    <span className={classes.suffixContainer}>
      <VizTooltip
        placement="bottom"
        overlay={<Tooltip id="is-super-user">Admin user</Tooltip>}
      >
        <i
          className={classNames(
            classes.smallIcon,
            arc.frontend.globals.authentication.isSuperUser
              ? ''
              : classes.hidden,
            'fa fa-asterisk'
          )}
        />
      </VizTooltip>

      <VizTooltip
        placement="bottom"
        overlay={
          <Tooltip id="authentication-mode">
            {arc.frontend.globals.authentication.authenticationMode}{' '}
            authenticated user
          </Tooltip>
        }
      >
        <i
          className={classNames(
            classes.smallIcon,
            arc.frontend.globals.authentication.isDefaultAuthenticationMode
              ? classes.hidden
              : '',
            'fa fa-check'
          )}
        />
      </VizTooltip>
    </span>
  </>
);
