import classNames from 'classnames';
import React from 'react';
import styles from './VisualContainer.module.scss';
// NOTE: this html template relies on the old code => I don't remove their css(arcadia.scss) here to the module
// because I have to use the original class names to make sure arc_loader.js works as expected.
// The use the classnames twice would be more misleading in my opinion.
export const ArcVisualContainer = ({ id }: { id: string }): JSX.Element => (
  <div
    className={classNames(
      'd-flex flex-row align-items-center justify-content-center',
      styles.visualContainer
    )}
    id={id}
  >
    <div
      id="chart-refresh-indicator"
      className={classNames(
        'viz-permanent viz-refresh-indicator',
        styles.visualLoadingIndicator
      )}
    >
      <div className="loader-detail viz-permanent">
        <div className="loader-text viz-permanent">
          Loading<span className="arc-loading"></span>
        </div>
        <div className="progress viz-permanent">
          <div
            className={classNames(
              'progress-bar progress-bar-info viz-permanent',
              styles.progressBarWidth
            )}
            role="progressbar"
          ></div>
        </div>
      </div>
    </div>
  </div>
);
