import classNames from 'classnames';
import React from 'react';

import classes from './VizLink.module.scss';

type VizLinkProps = {
  testId?: string;
} & JSX.IntrinsicElements['a'];

export const VizLink = ({
  children,
  className,
  testId,
  ...props
}: VizLinkProps): JSX.Element => (
  <a
    className={classNames(classes.link, className)}
    {...props}
    data-test-id={testId}
  >
    {children}
  </a>
);
