import React from 'react';
import Dropdown from 'react-bootstrap/Dropdown';
import { VizNavLink } from '../viz-nav-link/VizNavLink';

import classes from './VizNavDropdown.module.scss';

type VizNavDropdownProps = {
  toggle: {
    id: string;
    testId: string;
    content: JSX.Element;
    isActive?: boolean;
  };
  menu: {
    testId: string;
    content: JSX.Element;
  };
};

export const VizNavDropdown = ({
  toggle,
  menu,
}: VizNavDropdownProps): JSX.Element => {
  return (
    <Dropdown className={classes.dropdown}>
      <Dropdown.Toggle
        id={toggle.id}
        data-test-id={toggle.testId}
        as={VizNavLink}
        className={toggle.isActive ? 'active' : ''}
      >
        {toggle.content}
      </Dropdown.Toggle>

      <Dropdown.Menu
        data-test-id={menu.testId}
        className={classes.menu}
        renderOnMount
        align="right"
      >
        {menu.content}
      </Dropdown.Menu>
    </Dropdown>
  );
};
