import classNames from 'classnames';
import React, { forwardRef, Ref } from 'react';

import classes from './VizNavLink.module.scss';

export const VizNavLink = forwardRef(
  (
    { className, children, ...props }: JSX.IntrinsicElements['a'],
    ref: Ref<HTMLAnchorElement>
  ): JSX.Element => (
    <a ref={ref} className={classNames(classes.link, className)} {...props}>
      {children}
    </a>
  )
);
