import classNames from 'classnames';
import React from 'react';

import classes from './VizWrapperLink.module.scss';

type VizWrapperLinkProps = JSX.IntrinsicElements['a'] & {
  isFullWidth?: boolean;
  testId?: string;
};

export const VizWrapperLink = ({
  children,
  className,
  isFullWidth,
  testId,
  ...props
}: VizWrapperLinkProps): JSX.Element => (
  <a
    data-test-id={testId}
    className={classNames(classes.link, isFullWidth ? 'w-100' : '', className)}
    {...props}
  >
    {children}
  </a>
);
