import React from 'react';

import { VizLink } from 'components/viz-link/VizLink';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

const version = '6.3.0';

export const r630: WhatSNewRelease = {
  version,
  releaseDate: 'July 30, 2021',
  items: [
    {
      title: 'Visualize through Natural Language Search',
      content: (
        <>
          <ReleaseItemText>
            Speed up insights and visual creation by{' '}
            <VizLink
              href="https://docs.cloudera.com/data-visualization/latest/configure-nls/topics/viz-nls-enable.html"
              target="_blank"
            >
              enabling search-based data exploration
            </VizLink>
          </ReleaseItemText>

          <ReleaseItemText>
            See{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-kpp123a.html"
              target="_blank"
            >
              docs{' '}
            </VizLink>
            for more information
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
              extension: 'gif',
            }}
            alt="search visualization"
          />
        </>
      ),
    },
  ],
};
