import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

const version = '6.3.4';

export const r634: WhatSNewRelease = {
  version,
  releaseDate: 'December 10, 2021',
  items: [
    {
      title: 'Create custom filter expressions with ease',
      content: (
        <>
          <ReleaseItemText>
            With the new "Expression" tab you can add custom filter expressions
            efficiently.
          </ReleaseItemText>

          <ReleaseItemText>
            <VizLink
              href="https://docs.cloudera.com/r/viz-ghi749a.html"
              target="_blank"
            >
              Read more
              <i className="fa fa-external-link ml-1" />
            </VizLink>
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
              extension: 'gif',
            }}
            alt='New "Expression" tab in the filter modal'
          />
        </>
      ),
    },
  ],
};
