import React from 'react';

import { VizLink } from 'components/viz-link/VizLink';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

const version = '6.3.5';

export const r635: WhatSNewRelease = {
  version,
  releaseDate: 'December 17, 2021',
  items: [
    {
      title:
        'In this release we addressed CVE-2021-44228 which affects Apache Log4j2 versions 2.0 through 2.14.1',
      content: (
        <>
          <ReleaseItemText>
            CDV itself is not written in Java and hence is not vulnerable.
            However the CML legacy engine version of CDV is built upon the CML
            engine, therefore we updated to the newly released engine.
          </ReleaseItemText>

          <ReleaseItemText>
            For more information visit{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-jkl749a.html"
              target="_blank"
            >
              here
              <i className="fa fa-external-link ml-1" />
            </VizLink>
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
