import React from 'react';

import { VizLink } from 'components/viz-link/VizLink';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

const version = '6.4.2';

export const r642: WhatSNewRelease = {
  version,
  releaseDate: 'June 17, 2022',
  items: [
    {
      title: 'Improved Dataset Management',
      content: (
        <>
          <ReleaseItemText>
            Admins now have greater insight into affected users and dashboards
            when deleting a dataset.
          </ReleaseItemText>

          <ReleaseItemText>
            Read more about dataset management{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-aaa2vz7.html"
              target="_blank"
            >
              here
            </VizLink>
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Direct access button"
          />
        </>
      ),
    },
  ],
};
