import React from 'react';

import { VizLink } from 'components/viz-link/VizLink';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

const version = '6.4.3';

export const r643: WhatSNewRelease = {
  version,
  releaseDate: 'September 21, 2022',
  items: [
    {
      title: 'Improved date range filters',
      content: (
        <>
          <ReleaseItemText>
            Date range filters can now be set to "Default to the latest
            available timestamp".
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="'Default to the latest available timestamp' Setting"
          />

          <ReleaseItemText>
            Additionally, relative date range filters can now be used in emails.
          </ReleaseItemText>

          <ReleaseItemText>
            Read more about relative date range filters{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-aaa2vz9.html"
              target="_blank"
            >
              here
            </VizLink>
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Validation of dataset field names',
      content: (
        <>
          <ReleaseItemText>
            To improve behavior of dataset fields as filters, parenthesis are
            not allowed in the display name. Parenthetical information can still
            be added as a field comment.
          </ReleaseItemText>

          <ReleaseItemText>
            <VizLink
              href="https://docs.cloudera.com/r/viz-aaa2vz8.html"
              target="_blank"
            >
              Read more
              <i className="fa fa-external-link ml-1" />
            </VizLink>
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 2,
              index: 1,
            }}
            alt="Dataset field validation"
          />
        </>
      ),
    },
  ],
};
