import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.0.3';

export const r703: WhatSNewRelease = {
  version,
  releaseDate: 'September 30, 2022',
  items: [
    {
      title: 'Improved alerts for slow queries',
      content: (
        <>
          <ReleaseItemText>
            We've added{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-ttx1vz9.html"
              target="_blank"
            >
              settings{' '}
            </VizLink>{' '}
            to fine-tune the appearance of the alert when a query is is taking
            an unusually long time.
          </ReleaseItemText>

          <ReleaseItemText>
            A data connection admin user can control the time before the warning
            appears on a connection-by-connection basis using the "Query Still
            Loading Warning (Seconds)" setting.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="'Query Still Loading Warning (Seconds)' setting"
          />

          <ReleaseItemText>
            You will also be able to control whether this message appears when
            viewing a dashboard.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 2,
            }}
            alt="Site setting for showing warning in view mode"
          />
        </>
      ),
    },
    {
      title: 'Option to cancel queries immediately available',
      content: (
        <>
          <ReleaseItemText>
            Query cancelling is now immediately visible for every visual as it
            loads.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 2,
              index: 1,
            }}
            alt="Visible query cancelling"
          />
        </>
      ),
    },
  ],
};
