import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.0.5';

export const r705: WhatSNewRelease = {
  version,
  releaseDate: 'December 7, 2022',
  items: [
    {
      title: 'Drag and drop filters',
      content: (
        <>
          <ReleaseItemText>
            When building dashboards, filters can now be added by dragging and
            dropping into the dashboard.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 2,
              index: 1,
            }}
            alt="Dragging filter into dashboard"
          />

          <ReleaseItemText>
            See{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-zzz1vz9.html"
              target="_blank"
            >
              docs{' '}
            </VizLink>
            for more information
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Improved page loading experience',
      content: (
        <>
          <ReleaseItemText>
            There is better visual feedback for when data is being loaded on the
            homepage.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 3,
              index: 1,
            }}
            alt="Loading homepage"
          />

          <ReleaseItemText>
            We've also bundled some CSS and JS assets to improve load speeds for
            every page.
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
