import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.1.3';

export const r713: WhatSNewRelease = {
  version,
  releaseDate: 'May 31, 2023',
  items: [
    {
      title: 'Management page for URL aliases',
      content: (
        <>
          <ReleaseItemText>
            Users can now manage all their URL aliases on one page. There, they
            can view, edit, delete, and copy their short urls.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Manage URL alias page"
          />
        </>
      ),
    },
    {
      title: 'Improved image and data downloading',
      content: (
        <>
          <ReleaseItemText>
            There are improvements in PNG and PDF downloads or emails containing
            multi-sheet dashboards.
          </ReleaseItemText>

          <ReleaseItemText>
            Along with existing global language support for CSV and Excel
            downloads, there is now support for PNG and PDF downloads that
            contain East Asian characters.
          </ReleaseItemText>

          <ReleaseItemText>
            We have also improved support for CSV and Excel downloads for null,
            NaN, and infinity values.
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Support cloning dashboards with unsaved changes',
      content: (
        <>
          <ReleaseItemText>
            Now, unsaved changes on the parent dashboard will be persisted when
            cloning the dashboard.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 3,
              index: 1,
            }}
            alt="Cloning dashboard"
          />
        </>
      ),
    },
  ],
};
