import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.1.5';

export const r715: WhatSNewRelease = {
  version,
  releaseDate: 'August 30, 2023',
  items: [
    {
      title: 'Better visualization of negative values for stacked bars',
      content: (
        <>
          <ReleaseItemText>
            Visualizing dimensions with mixed negative and positive values on a
            stacked bar chart is now improved.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Stacked bars with positive and negative values"
          />

          <ReleaseItemText>
            See{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-abc246z.html"
              target="_blank"
            >
              docs{' '}
            </VizLink>
            for more information on stacked bar visuals.
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Improved extract creation experience',
      content: (
        <>
          <ReleaseItemText>
            When configuring a data extract, users can now search for a column
            by name, as well as view the field types and complex data types
            available.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 2,
              index: 1,
            }}
            alt="Improved data extract creation"
          />

          <ReleaseItemText>
            See{' '}
            <VizLink
              href="https://docs.cloudera.com/r/viz-abc468a.html"
              target="_blank"
            >
              docs{' '}
            </VizLink>
            for more information on creating data extracts
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
