import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.1.6';

export const r716: WhatSNewRelease = {
  version,
  releaseDate: 'September 19, 2023',
  items: [
    {
      title: 'Package upgrades and CVE fixes',
      content: (
        <>
          <ReleaseItemText>
            This release contains image and package upgrades for CVE mitigation.
          </ReleaseItemText>

          <ReleaseItemText>
            For more information and a full list of the changes we've made,&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-ezx1vz0.html"
              target="_blank"
            >
              view the complete release notes.
            </VizLink>
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
