import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.1.8';

export const r718: WhatSNewRelease = {
  version,
  releaseDate: 'December 4, 2023',
  items: [
    {
      title: "We're continuing to improve your experience of using CDV",
      content: (
        <>
          <ReleaseItemText>
            This release of Cloudera Data Visualization contains performance,
            usability and security enhancements. For more information and a full
            list of the changes we've made,&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-ezx1vz0.html"
              target="_blank"
            >
              view the complete release notes.
            </VizLink>
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
