import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemImage } from '../release-item-image/ReleaseItemImage';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.2.3';

export const r723: WhatSNewRelease = {
  version,
  releaseDate: 'April 29, 2024',
  items: [
    {
      title: 'Better understand email and extract jobs application-wide',
      content: (
        <>
          <ReleaseItemText>
            We’ve enhanced the "Job Status" management interface with
            performance improvements and a new “More Info” option to view job
            and email details alongside logs of previous runs.
          </ReleaseItemText>
          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="New Job Details Page"
          />
        </>
      ),
    },
  ],
};
