import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';
import { ReleaseItemImage } from 'components/release-item-image/ReleaseItemImage';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.2.6';

export const r726: WhatSNewRelease = {
  version,
  releaseDate: 'Aug 29, 2024',
  items: [
    {
      title: 'Support for dataset versioning (Tech Preview)',
      content: (
        <>
          <ReleaseItemText>
            Using dataset versioning allows you to manage different versions of
            your datasets, which is especially useful when dealing with frequent
            updates or iterative changes. Versioning helps you to track changes
            and roll back to an earlier version if an error is introduced or an
            earlier version is preferred, ensuring data consistency and
            reliability. It also adds a layer of security and control, ensuring
            that data integrity is maintained even as datasets evolve. See&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-ccc246c.html"
              target="_blank"
            >
              docs
            </VizLink>
            &#32;for more information on Version Control.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Data Versioning Site Settings"
          />

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 2,
            }}
            alt="Data page Data Versioning"
          />
        </>
      ),
    },
  ],
};
