import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';
import { ReleaseItemImage } from 'components/release-item-image/ReleaseItemImage';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.2.7';

export const r727: WhatSNewRelease = {
  version,
  releaseDate: 'Sept 30, 2024',
  items: [
    {
      title: 'Faster job management page',
      content: (
        <>
          <ReleaseItemText>
            Email and extract jobs can now be managed on a freshly designed and
            faster "Job Status" page. Each job now also has a dedicated page for
            reviewing run history, with both a summary and detailed view of each
            run. See&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-eee321a.html"
              target="_blank"
            >
              docs
            </VizLink>
            &#32;for more information on Jobs.
          </ReleaseItemText>

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Freshly designed Job Status page"
          />

          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 2,
            }}
            alt="Dedicated detailed page"
          />
        </>
      ),
    },
  ],
};
