import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '7.2.8';

export const r728: WhatSNewRelease = {
  version,
  releaseDate: 'Oct 30, 2024',
  items: [
    {
      title: 'Data Profiling for sql and datasets',
      content: (
        <>
          <ReleaseItemText>
            SQL queries or datasets can now be explored using our data profiler.
            Users can select columns of interest in order to generate basic
            statistical insights on them. See&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-eee000a.html"
              target="_blank"
            >
              docs
            </VizLink>
            &#32;for more information.
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Improved filter fields behavior on search',
      content: (
        <>
          <ReleaseItemText>
            Now when a user creates cascading filters, they apply even after
            subsequent searches. To learn more about cascading filters and how
            to create them, see&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-eee135e.html"
              target="_blank"
            >
              docs
            </VizLink>
            .
          </ReleaseItemText>
        </>
      ),
    },
    {
      title: 'Add range settings to histogram',
      content: (
        <>
          <ReleaseItemText>
            The histogram visual now allows users to specify a minimum and/or
            maximum value to visualize. See&#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-eee654a.html"
              target="_blank"
            >
              docs
            </VizLink>
            &#32;for more information on how to create a histogram visual.
          </ReleaseItemText>
        </>
      ),
    },
  ],
};
