import React from 'react';

import type { WhatSNewRelease } from 'types/what-s-new-release.type';
import { ReleaseItemText } from '../release-item-text/ReleaseItemText';
import { VizLink } from 'components/viz-link/VizLink';
import { ReleaseItemImage } from 'components/release-item-image/ReleaseItemImage';
import { getGlobalArc } from 'utils/get-global-arc';

// UPDATE WHATSNEWVER in arcweb/apps/views.py with latest
const version = '8.0.1';
const arc = getGlobalArc();
export const r801: WhatSNewRelease = {
  version,
  releaseDate: 'February 27, 2025',
  items: [
    {
      title: 'In-product documentation of API endpoints',
      content: (
        <>
          <ReleaseItemText>
            You can now access a Swagger UI for interactive API documentation
            according to OpenAPI specification for all supported Cloudera Data
            Visualization API endpoints &#32;
            <VizLink
              href={arc.frontend.globals.urls.swaggerUrl}
              target="_blank"
            >
              here.
            </VizLink>
          </ReleaseItemText>
          <ReleaseItemText>
            See &#32;
            <VizLink
              href="https://docs.cloudera.com/r/viz-eae678a.html"
              target="_blank"
            >
              docs
            </VizLink>
            &#32; for more information about this page and supported API
            endpoints.
          </ReleaseItemText>
          <ReleaseItemImage
            srcInfo={{
              version,
              feature: 1,
              index: 1,
            }}
            alt="Interactive API documentation"
          />
        </>
      ),
    },
  ],
};
