import { useQuery } from '@tanstack/react-query';
import {
  GET_REPORT_CREATION_PERMISSIONS_QUERY_TOKEN,
  getReportCreationPermissions,
} from 'apis/get-report-creation-permissions';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const useReportCreationPermissions = () => {
  const { data: permissions } = useQuery({
    queryKey: [GET_REPORT_CREATION_PERMISSIONS_QUERY_TOKEN],
    queryFn: getReportCreationPermissions,
    enabled: !arc.frontend.globals.authentication.isSuperUser,
    initialData: {
      canCreateDashboard: arc.frontend.globals.authentication.isSuperUser,
      canCreateApp: arc.frontend.globals.authentication.isSuperUser,
    },
  });

  return permissions;
};
