// eslint-disable-next-line no-restricted-imports
import { TableOptions, useReactTable } from '@tanstack/react-table';

// Stable reference to an empty array: https://github.com/TanStack/table/issues/4566
const EMPTY_ARRAY = [];

export const useTable = <TData extends unknown>({
  data,
  ...props
}: Omit<TableOptions<TData>, 'data'> & { data: TData[] | undefined }) =>
  useReactTable({ ...props, data: data ?? EMPTY_ARRAY });
