import { useCallback, useState } from 'react';

export const useToggle = (
  defaultIsOpen: boolean = false
): [isOpen: boolean, toggle: () => void, reset: () => void] => {
  const [isOpen, setIsOpen] = useState(defaultIsOpen);

  const toggle = useCallback(() => setIsOpen((current) => !current), []);

  const reset = useCallback(() => setIsOpen(false), []);

  return [isOpen, toggle, reset];
};
