import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

import { HomepageDataset } from '../types/home-page-dataset.type';

const arc = getGlobalArc();

export const getDatasets = async (
  { limit } = { limit: 30 }
): Promise<HomepageDataset[]> => {
  try {
    const { data } = await vizHttp.get<{ datasets: HomepageDataset[] }>({
      url: arc.frontend.globals.urls.homepageDatasetsUrl,
      params: {
        limit: limit.toString(),
      },
      isOldEndpoint: true,
    });

    return data.datasets;
  } catch (error) {
    console.error(error);

    return [];
  }
};
