import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import type { Dashboard } from 'types/dashboard.type';

import type { DashboardDatasetInfo } from '../types/dashboard-dataset-info.type';

const arc = getGlobalArc();

export const getFavoriteDashboards = () =>
  vizHttp
    .get<{
      data: {
        id: number;
        report: Dashboard;
        datasetInfo: DashboardDatasetInfo;
      }[];
    }>({
      url: arc.frontend.globals.urls.homepageFavoriteDashboardsUrl,
      isOldEndpoint: false,
    })
    .then(({ data }) => data.data);
