import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import type { Report } from 'types/report.type';

import type { DashboardDatasetInfo } from '../types/dashboard-dataset-info.type';

const arc = getGlobalArc();

export const getLastViewedReportsByUser = () =>
  vizHttp
    .get<{
      data: { id: number; report: Report; datasetInfo: DashboardDatasetInfo }[];
    }>({
      url: arc.frontend.globals.urls.homepageLastViewedReportsByUserUrl,
      isOldEndpoint: false,
    })
    .then(({ data }) => data.data);
