import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

import type { HomePageCreatedRecently } from '../types/home-page-created-recently.type';

const arc = getGlobalArc();

export const getNumberOfRecentlyCreatedResources = async () => {
  try {
    const { data } = await vizHttp.get<HomePageCreatedRecently>({
      url: arc.frontend.globals.urls
        .homepageNumberOfRecentlyCreatedResourcesUrl,
      isOldEndpoint: false,
    });

    return data;
  } catch (error) {
    console.error(error);

    const fallbackCreatedRecently: HomePageCreatedRecently = {
      apps: 0,
      dashboards: 0,
      datasets: 0,
    };

    return fallbackCreatedRecently;
  }
};
