import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

import type { DashboardDatasetInfo } from '../types/dashboard-dataset-info.type';
import { Report } from 'types/report.type';

const arc = getGlobalArc();

export const getSamples = () =>
  vizHttp
    .get<{
      data: {
        id: number;
        report: Report;
        datasetInfo?: DashboardDatasetInfo;
      }[];
    }>({
      url: arc.frontend.globals.urls.homepageSamplesUrl,
      isOldEndpoint: false,
    })
    .then(({ data }) => data.data);
