import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

import type { HomePageStatistics } from '../types/home-page-statistics.type';

const arc = getGlobalArc();

export const getStatistics = async () => {
  try {
    const { data } = await vizHttp.get<HomePageStatistics>({
      url: arc.frontend.globals.urls.homepageStatisticsUrl,
      isOldEndpoint: false,
    });

    return data;
  } catch (error) {
    console.error(error);

    const fallbackStatistics: HomePageStatistics = {
      apps: 0,
      dashboards: 0,
      datasets: 0,
      dataConnections: 0,
      queries: 0,
      views: 0,
    };

    return fallbackStatistics;
  }
};
