import React from 'react';
import type {
  DataConnectionExtendedName,
  DataConnectionType,
} from 'types/data-connection.type';

import classes from './DataConnectionIcon.module.scss';
import { getDataConnectionLogoFilePath } from './get-data-connection-logo-file-path';

export const DataConnectionIcon = ({
  type,
  extendedName,
}: {
  type: DataConnectionType;
  extendedName?: DataConnectionExtendedName;
}): JSX.Element => {
  const logoFilePath = getDataConnectionLogoFilePath({
    type,
    extendedName,
  });

  const connectionLogo = logoFilePath ? (
    <img className={classes.logo} src={logoFilePath} alt="Connection logo" />
  ) : (
    <i className="fa fa-link"></i>
  );

  return connectionLogo;
};
