import React from 'react';
import Popover from 'react-bootstrap/Popover';
import OverlayTrigger from 'react-bootstrap/OverlayTrigger';

import classes from './DataConnectionTileIcon.module.scss';

type DataConnectionTileIconProps = {
  id: string;
  icon: JSX.Element;
  tooltip: {
    content: JSX.Element;
    title?: string;
  };
};

export const DataConnectionTileIcon = ({
  id,
  icon,
  tooltip,
}: DataConnectionTileIconProps): JSX.Element => {
  return (
    <div className={classes.container}>
      <OverlayTrigger
        delay={{ show: 300, hide: 300 }}
        overlay={(props) => (
          <Popover id={id} {...props}>
            {tooltip.title && <Popover.Title>{tooltip.title}</Popover.Title>}

            <Popover.Content>{tooltip.content}</Popover.Content>
          </Popover>
        )}
      >
        {icon}
      </OverlayTrigger>
    </div>
  );
};
