import React from 'react';
import Card from 'react-bootstrap/Card';
import Accordion from 'react-bootstrap/Accordion';

import type { GetStartedItem } from 'pages/home/types/get-started-item.type';

import classes from './GetStartedAccordionItem.module.scss';
import classNames from 'classnames';

type GetStartedAccordionItemProps = GetStartedItem & { index: number };

export const GetStartedAccordionItem = ({
  title,
  content,
  icon,
  index,
}: GetStartedAccordionItemProps): JSX.Element => (
  <Accordion>
    <Card className="border-bottom-0">
      <Accordion.Toggle as="div" eventKey={title}>
        <Card.Header className={classes.header}>
          <div className={classNames(classes.headerContent, 'text-secondary')}>
            <span>
              <div className={classes.numberCircle}>{index + 1}</div>

              <span>{title}</span>
            </span>

            {icon}
          </div>
        </Card.Header>
      </Accordion.Toggle>

      <Accordion.Collapse eventKey={title}>
        <Card.Body>{content}</Card.Body>
      </Accordion.Collapse>
    </Card>
  </Accordion>
);
