import { useWhatSNewModalStore } from 'stores/use-what-s-new-modal-store';
import React, { Fragment } from 'react';

import { getLearnItems } from './get-learn-items';
import classes from './Learn.module.scss';

export type LearnProps = {
  forceOpenGetStartedAccordion: () => void;
};

export const Learn = (props: LearnProps): JSX.Element => {
  const openWhatsNewModal = useWhatSNewModalStore(({ open }) => open);

  const items = getLearnItems({ ...props, openWhatsNewModal });

  return (
    <div className={classes.container}>
      {items.length > 0 && (
        <>
          <div className={classes.title}>LEARN</div>

          {items.map(({ id, element }) => (
            <Fragment key={id}>{element}</Fragment>
          ))}
        </>
      )}
    </div>
  );
};
