import classNames from 'classnames';
import React, { PropsWithChildren } from 'react';

import classes from './LoadingPlaceholderContainer.module.scss';

export type LoadingPlaceholderContainerProps = PropsWithChildren<{
  width: string;
  height: string;
  className?: string;
}>;

export const LoadingPlaceholderContainer = ({
  width,
  height,
  children,
  className,
}: LoadingPlaceholderContainerProps): JSX.Element => (
  <div
    className={classNames(classes.container, className)}
    style={{ width, height }}
  >
    {children}
  </div>
);
