import React from 'react';
import {
  LoadingPlaceholderContainer,
  LoadingPlaceholderContainerProps,
} from '../loading-placeholder-container/LoadingPlaceholderContainer';

import classes from './LoadingStripesPlaceholder.module.scss';

export type LoadingStripesPlaceholderProps =
  LoadingPlaceholderContainerProps & {
    numberOfStipes?: number;
  };

export const LoadingStripesPlaceholder = ({
  numberOfStipes = 4,
  ...containerProps
}: LoadingStripesPlaceholderProps): JSX.Element => {
  const stripes = Array.from({ length: numberOfStipes - 1 }, (_, index) => (
    <div className={classes.stripe} key={index} />
  ));

  return (
    <LoadingPlaceholderContainer {...containerProps}>
      {stripes}
      <div className={classes.stripe} style={{ width: '30%' }} />
    </LoadingPlaceholderContainer>
  );
};
