import React from 'react';

import { getGlobalArc } from 'utils/get-global-arc';
import { NewButton } from 'components/new-button/NewButton';

import classes from './NewSqlButton.module.scss';

const arc = getGlobalArc();

export const NewSqlButton = (): JSX.Element => (
  <NewButton
    href={arc.frontend.globals.urls.sqlUrl}
    isFullWidth
    icon={
      <>
        <span
          style={{
            fontFamily:
              'Impact, Haettenschweiler, "Franklin Gothic Bold", "Arial Black", "sans-serif"',
          }}
        >
          {'{'}
        </span>
        <span
          style={{
            transform: 'translateY(-7px)',
            fontWeight: 'bold',
          }}
        >
          ...
        </span>
        <span
          style={{
            fontFamily:
              'Impact, Haettenschweiler, "Franklin Gothic Bold", "Arial Black", "sans-serif"',
          }}
        >
          {'}'}
        </span>
      </>
    }
    text="NEW SQL"
    buttonClassName={classes.button}
    plusIconClassName={classes.icon}
  />
);
