import classNames from 'classnames';
import React from 'react';

import classes from './ResponsiveTwoColumnLayout.module.scss';

type ResponsiveTwoColumnLayoutProps = {
  text: JSX.Element;
  img: {
    src: string;
    alt: string;
  };
};

export const ResponsiveTwoColumnLayout = ({
  text,
  img,
}: ResponsiveTwoColumnLayoutProps): JSX.Element => {
  return (
    <div className="d-flex flex-wrap">
      <div className={classes.imageContainer}>
        <img className={classes.image} src={img.src} alt={img.alt} />
      </div>

      <div className={classNames(classes.text, 'ml-4')}>{text}</div>
    </div>
  );
};
