import React, { Fragment } from 'react';

import classes from './SqlSyntaxHighlighter.module.scss';

/* Probably later a sophisticated sql highlighter package will be included,
 this is a shortcut for sql highlighting.
 SQL commands are from here: https://www.freecodecamp.org/news/basic-sql-commands/ */
const sqlCommands = [
  'select',
  'from',
  'where',
  'and',
  'check',
  'or',
  'in',
  'between',
  'like',
  'update',
  'set',
  'join',
  'insert',
  'having',
  'as',
  'count',
  'delete',
  'inner',
  'join',
  'left',
  'right',
  'group',
  'by',
  'order',
  'alter',
  'table',
  'create',
];

type SqlSyntaxHighlighterProps = {
  query: string;
};

/* Currently we are not using any syntax highligther library.
This very basic higlihter made to style the SQL code snippets
until we figure out the final solution. */
export const SqlSyntaxHighlighter = ({
  query,
}: SqlSyntaxHighlighterProps): JSX.Element => {
  const words = query.toLocaleLowerCase().split(/\s+/);

  return (
    <>
      {words.map((word, index) => {
        const isCommand = sqlCommands.includes(word);

        if (isCommand) {
          return (
            <span className={classes.command} key={index}>{` ${word}`}</span>
          );
        }

        return <Fragment key={index}>{` ${word}`}</Fragment>;
      })}
    </>
  );
};
