import React from 'react';

import { DataConnectionTileIcon } from '../data-connection-tile-icon/DataConnectionTileIcon';
import classes from './StatusInactiveIcon.module.scss';

type StatusInactiveIconProps = {
  dataConnectionId: number;
};

export const StatusInactiveIcon = ({
  dataConnectionId,
}: StatusInactiveIconProps): JSX.Element => (
  <DataConnectionTileIcon
    id={dataConnectionId.toString()}
    icon={
      <svg
        width="16px"
        height="16px"
        viewBox="0 0 24 24"
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
      >
        <g
          id="Symbols"
          stroke="none"
          strokeWidth="1"
          fill="none"
          fillRule="evenodd"
        >
          <g className={classes.icon} id="status-icons/inactive" fill="#838B92">
            <path
              d="M8.9580665,5.56712036 L5.21670623,5.56712036 L5.21670623,4.0004 L11.8223556,4.0004 L7.88879082,11.4336796 L12.0002,11.4336796 L12.0002,13.0004 L5.0002,13.0004 L8.9580665,5.56712036 Z M15.7622,2.0004 C17.7292,5.6984 16.7092,10.5934 13.6872,13.6754 C11.7272,15.6734 8.9102,16.7424 6.1892,16.7424 C4.7142,16.7424 3.2672,16.4284 2.0002,15.7784 C4.3722,20.2914 8.1382,21.9554 11.2232,22.0004 C14.1512,22.0004 16.7612,20.8904 18.8572,18.8244 C22.9492,14.7514 24.1002,6.2424 15.7622,2.0004 L15.7622,2.0004 Z"
              id="moonman"
            />
          </g>
        </g>
      </svg>
    }
    tooltip={{
      content: (
        <>Project synced connection, currently unavailable for further update</>
      ),
    }}
  />
);
