import { getGlobalArc } from 'utils/get-global-arc';
import { useEffect } from 'react';

import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();

export const usePrefetchResources = () => {
  // Prefetch AJAX/JSON for VISUALS tab
  // We don't use the data on this page, but it precaching the data
  // makes loading the VISUALS page faster
  useEffect(() => {
    setTimeout(() => {
      vizHttp.get({
        url: arc.frontend.globals.urls.appgroupUrl,
        isOldEndpoint: true,
      });
    }, 500);
  }, []);
};
