import React from 'react';
import classes from './ToggleSwitchThreshold.module.scss';

interface ToggleSwitchProps {
  thresholdOnly: boolean;
  onToggle: () => void;
}

export const ToggleSwitchThreshold: React.FC<ToggleSwitchProps> = ({
  thresholdOnly,
  onToggle,
}) => {
  return (
    <div className={classes.container}>
      <span className={classes.span}>Threshold Only</span>
      <label className={classes.toggleSwitch}>
        <input type="checkbox" checked={thresholdOnly} onChange={onToggle} />
        <span className={`${classes.slider} ${classes.round}`}></span>
      </label>
    </div>
  );
};
