import { openInNewWindow } from 'arc/misc/misc';
import { ClouderaButton } from 'components/cloudera-button/ClouderaButton';
import { getSourceDatasetLink } from 'pages/job-page/utils/get-source-dataset-link';
import React from 'react';
import { Modal } from 'react-bootstrap';
import { DataCopyTarget } from 'types/job.type';
import {
  ClouderaDialogBody,
  ClouderaDialogContent,
  ClouderaDialogFooter,
  ClouderaDialogHeader,
  useClouderaDialogContext,
} from 'components/cloudera-dialog/ClouderaDialog';

type EditExtractModalProps = {
  dataCopyTarget: DataCopyTarget;
};

export const EditExtractModal = ({
  dataCopyTarget,
}: EditExtractModalProps): JSX.Element => {
  const { reset } = useClouderaDialogContext();

  return (
    <ClouderaDialogContent>
      <ClouderaDialogHeader closeButton>
        <Modal.Title>Edit Data Extract Job</Modal.Title>
      </ClouderaDialogHeader>
      <ClouderaDialogBody>
        At the moment, editing Data Extracts is only possible on the Data
        Extracts page.
      </ClouderaDialogBody>
      <ClouderaDialogFooter>
        <ClouderaButton onClick={reset}>Cancel</ClouderaButton>
        {!!dataCopyTarget.scrDatasetURL && (
          <ClouderaButton
            color="primary"
            onClick={() =>
              openInNewWindow(
                getSourceDatasetLink(
                  dataCopyTarget.scrDatasetURL!,
                  dataCopyTarget.id
                )
              )
            }
          >
            Go to Data Extract
          </ClouderaButton>
        )}
      </ClouderaDialogFooter>
    </ClouderaDialogContent>
  );
};
