import { VizTooltip } from 'components/VizTooltip';
import { ClouderaButton } from 'components/cloudera-button/ClouderaButton';
import React from 'react';
import { Popover } from 'react-bootstrap';

type JobParameterButtonProps = {
  value: string;
  label: string;
  onSelect: (param: string) => void;
};

export const JobParameterButton = ({
  value,
  label,
  onSelect,
}: JobParameterButtonProps) => {
  return (
    <VizTooltip
      overlay={
        <Popover id={`job-param-${value}`}>
          <Popover.Content>{value}</Popover.Content>
        </Popover>
      }
    >
      <ClouderaButton
        aria-label={`Job Parameter ${label}`}
        type="button"
        variant="link"
        onClick={() => onSelect(value)}
      >
        {label}
      </ClouderaButton>
    </VizTooltip>
  );
};
