import React from 'react';
import Modal from 'react-bootstrap/Modal';

import { VizButton } from 'components/viz-button/VizButton';

type ForgotPasswordModalProps = {
  isOpen: boolean;
  close: () => void;
};

export const ForgotPasswordModal = ({
  isOpen,
  close,
}: ForgotPasswordModalProps): JSX.Element => (
  <Modal show={isOpen} onHide={close}>
    <Modal.Header>
      <Modal.Title>Forgot Password</Modal.Title>
    </Modal.Header>

    <Modal.Body>Please contact your administrator...</Modal.Body>

    <Modal.Footer>
      <VizButton color="secondary" size="medium" onClick={close}>
        Close
      </VizButton>
    </Modal.Footer>
  </Modal>
);
