import { Card } from 'react-bootstrap';
import React from 'react';

type ParametersCardProps = {
  parameters: { [key: string]: string };
};

const ParametersCard = ({ parameters }: ParametersCardProps) => {
  if (!parameters) {
    return null;
  }

  const parameterElements = Object.entries(parameters)
    .filter(([key]) => key !== 'sheet')
    .map(([key, value]) => (
      <div key={key}>
        <p>
          {key}: <strong>{value}</strong>
        </p>
      </div>
    ));

  if (parameterElements.length === 0) {
    return null;
  }

  return (
    <Card>
      <Card.Body>{...parameterElements}</Card.Body>
    </Card>
  );
};

export default ParametersCard;
