export type Option = {
  id: number;
  group_id?: number;
  name: string;
  subgroups?: { id: number; name: string; apps?: number[] }[];
};

export type PayLoad = {
  dashboardId: number | string;
  parameters: { [key: string]: string };
  reportName: string;
  reportType: 'dashboard' | 'apps';
  urlAlias: string;
  urlOrigin: string;
  isCreatedOrUsedInEmail: boolean;
};

export type Sheets = {
  sheet_id: number;
  sheet_handle_title: string;
};

export type Groups = {
  group_id: number;
  name: string;
  apps: number[][];
};

export type UrlAliasRow = {
  updateType: string;
  newAlias: string;
  originAlias: string;
  url_data: string;
};
