import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';

const arc = getGlobalArc();
const submitUserQueryToken = 'homepage-user-defined-submit';

const submitUserDefinedHomePage = async (id: string) =>
  await vizHttp.post({
    url: `${arc.frontend.globals.urls.userDataUrl}/homeapp`,
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
    isOldEndpoint: true,
    data: {
      homeapp: id || '-1',
    },
  });

export { submitUserDefinedHomePage, submitUserQueryToken };
