import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';
import type { Role } from '../types/role-details.type';

const arc = getGlobalArc();
export const rolesByIdQueryToken = 'roles-by-id';

export const getRoleById = async ({ id }: { id: string }) => {
  const { data } = await vizHttp.get<Role[]>({
    url: `${arc.frontend.globals.urls.rbacRolesUrl}/${id}`,
    isOldEndpoint: true,
  });

  return data;
};
