import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { Role } from '../types/role-details.type';

const arc = getGlobalArc();

const submitRoles = (data) =>
  vizHttp
    .post<{ data: Role[] }>({
      url: arc.frontend.globals.urls.rbacRolesUrl,
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
      isOldEndpoint: true,
      data,
    })
    .then(({ data }) => data.data);

export { submitRoles };
