export type Role = {
  id: number;
  name: string;
  desc: string;
  privs: {
    ptype: string;
    perms: string[];
    dclist?: string[];
    dslist?: string[];
    dcid?: string;
    rolelist?: string[];
  }[];
  users: string[];
  groups: string[];
  sentry_groups: string[];
  perms: string[];
  require_all_groups: boolean;
};

export type User = {
  // id is number when exists in db and string when user added it in the ui
  id: number | string;
  is_superuser: boolean;
  username: string;
  first_name: string;
  last_name: string;
  full_name: string;
};

export type Group = {
  // id is number when exists in db and string when user added it in the ui
  id: number | string;
  name: string;
};
