import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { SubmitData, SubmitFlipper } from '../types/site-settings.type';

const arc = getGlobalArc();

const submitSiteSettingsQueryToken = 'site-settings-submit';

const submitSiteSettings = async (data: {
  settings: SubmitData;
  flippers: SubmitFlipper;
}) => {
  await vizHttp.post({
    url: arc.frontend.globals.urls.siteSettingsUrl,
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
    isOldEndpoint: false,
    data,
  });
};

export { submitSiteSettings, submitSiteSettingsQueryToken };
