import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { SettingValue } from '../types/site-settings.type';

const arc = getGlobalArc();

const testEmailQueryToken = 'site-settings-test-email';

const testEmail = async (data: {
  EMAIL_HOST: SettingValue;
  EMAIL_PORT: SettingValue;
  EMAIL_HOST_USER: SettingValue;
  EMAIL_PROTOCOL: SettingValue;
  email_username: SettingValue;
  email_prefix: SettingValue;
  EMAIL_HOST_PASSWORD?: SettingValue;
}) => {
  await vizHttp.post({
    url: arc.frontend.globals.urls.emailTestUrl,
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
    isOldEndpoint: false,
    data,
  });
};

export { testEmail, testEmailQueryToken };
