import { getGlobalArc } from 'utils/get-global-arc';
import { vizHttp } from 'services/viz-http';
import { AiTab, ProfileTestResult } from '../types/ai-settings.type';
import { State } from '../types/site-settings.type';

const arc = getGlobalArc();

const validateAiProfile = async (
  id: string | null,
  tab: AiTab,
  settingState: State['form']
) => {
  const { data } = await vizHttp.post<ProfileTestResult>({
    url: arc.frontend.globals.urls.validateAiProfile,
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
    isOldEndpoint: false,
    data: { id, tab, settings: settingState },
  });

  return data;
};

export { validateAiProfile };
