import React from 'react';
import Form from 'react-bootstrap/Form';
import classes from '../SiteSettingsPage.module.scss';
import classNames from 'classnames';

type SiteSettingsSearchBarProps = {
  doSearch: (term: string) => void;
  searchTerm: string;
  clear: () => void;
};

const SiteSettingsSearchBar = ({
  doSearch,
  searchTerm,
  clear,
}: SiteSettingsSearchBarProps): JSX.Element => (
  <Form.Group className={classes.searchBar}>
    <Form.Control
      id="settingsSearch"
      type="text"
      placeholder="Search settings"
      data-test-id="settingsSearch"
      value={searchTerm}
      autoComplete="off"
      onChange={(e) => doSearch(e.target.value)}
    />
    <i
      className={classNames(
        'fa fa-search attr-search-icon',
        classes.searchIcon
      )}
    />
    {searchTerm && (
      <div
        className={classNames('attr-search-clear', classes.clearIcon)}
        onClick={clear}
      >
        <i className="fa fa-times-circle" />
      </div>
    )}
  </Form.Group>
);

export { SiteSettingsSearchBar };
