import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();

export const deleteWorkspace = ({ id }: { id: number; name: string }) =>
  vizHttp.delete({
    isOldEndpoint: true,
    url: `${arc.frontend.globals.urls.workspacesUrl}/${id}`,
    data: {
      csrfmiddlewaretoken: arc.frontend.globals.authentication.csrfToken,
    },
    headers: {
      'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
    },
  });
