import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();
export const groupsQueryToken = 'groups';

type Groups = {
  id: number;
  name: string;
  roles: {}[];
  users: {}[];
}[];

export const getGroups = async ({ isSummary }: { isSummary: boolean }) => {
  const params: Record<string, string> = {};

  if (isSummary) {
    params.summary = 'true';
  }

  const { data } = await vizHttp.get<Groups>({
    url: arc.frontend.globals.urls.groupsUrl,
    isOldEndpoint: true,
    params,
  });

  return data;
};
