import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();
export const usersQueryToken = 'users';

type Users = {
  id: number;
  username: string;
  is_superuser: boolean;
  is_active: boolean;
  first_name: string;
  last_name: string;
  full_name: string;
  date_joined: string;
  last_login: string;
  is_password_editable: boolean;
  profile: string;
}[];

export const getUsers = async ({ isSummary }: { isSummary: boolean }) => {
  const params: Record<string, string> = {};

  if (isSummary) {
    params.summary = 'true';
  }

  const { data } = await vizHttp.get<Users>({
    url: arc.frontend.globals.urls.usersDetailedApiUrl,
    isOldEndpoint: true,
    params,
  });
  return data;
};
