import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';

const arc = getGlobalArc();
export const workspacesQueryToken = 'workspaces';

export type Workspace = {
  id: number;
  name: string;
  desc: string;
  acl: [[type: 1 | 2, permission: 1 | 2 | 3, name: string]];
  editable: boolean;
  private_user_id: number | null;
  create_time: string;
  create_user: string;
  update_time: string;
  update_user: string;
  perms: string[];
};

export const getWorkspaces = async () => {
  const { data } = await vizHttp.get<Workspace[]>({
    url: arc.frontend.globals.urls.workspacesUrl,
    isOldEndpoint: true,
  });

  return data;
};
