import { vizHttp } from 'services/viz-http';
import { getGlobalArc } from 'utils/get-global-arc';
import { Workspace } from './get-workspaces';

const arc = getGlobalArc();

export const upsertWorkspace = (workspace: {
  id?: number;
  name: string;
  desc: string;
  acl: [type: number, permission: number, name: string][];
}) => {
  return vizHttp
    .post<{ data: Workspace[] }>({
      url: arc.frontend.globals.urls.workspacesUrl,
      isOldEndpoint: true,
      data: {
        data: JSON.stringify([workspace]),
      },
      headers: {
        'X-CSRFTOKEN': arc.frontend.globals.authentication.csrfToken,
      },
    })
    .then(({ data }) => data.data);
};
