export const getDashboardSharedVisuals = (
  sharedVisualIds: string[],
  relatedReportIdToReportMap: Map<
    number,
    { id: number; title: string; workspace: { id: number; name: string } }
  >
) => {
  return sharedVisualIds
    .map((id) => relatedReportIdToReportMap.get(+id))
    .filter(Boolean)
    .map((report) => ({ ...report, type: 'visual' })) as {
    id: number;
    type: 'visual';
    title: string;
    workspace: { id: number; name: string };
  }[];
};
