import { useEffect } from 'react';
import { legacyBridge } from './legacy-bridge';
import type { VIZEvent } from './viz-event.type';

export const useLegacyBridge = (
  type: string,
  callbackFn: (event: VIZEvent) => void
): void => {
  useEffect(() => {
    const { events, ofType } = legacyBridge;

    const subscription = events.pipe(ofType(type)).subscribe(callbackFn);

    return () => subscription.unsubscribe();
  }, [type, callbackFn]);
};
