import { create, StateCreator } from 'zustand';
import { devtools, persist } from 'zustand/middleware';

export const createStore = <T>(
  name: string,
  stateCreator: StateCreator<T, [['zustand/devtools', never]]>
) => create(devtools(stateCreator, { name }));

export const createPersistStore = <T>(
  name: string,
  stateCreator: StateCreator<
    T,
    [['zustand/devtools', never], ['zustand/persist', unknown]],
    [],
    T
  >
) => create(devtools(persist(stateCreator, { name }), { name }));
