import { createStore } from './create-store';

type WhatSNewModalState = {
  isOpen: boolean;

  open: () => void;
  close: () => void;
};

export const useWhatSNewModalStore = createStore<WhatSNewModalState>(
  'what-s-new-modal-store',
  (set) => ({
    isOpen: false,

    open: () =>
      set(
        () => ({
          isOpen: true,
        }),
        false,
        'open'
      ),

    close: () =>
      set(
        () => ({
          isOpen: false,
        }),
        false,
        'close'
      ),
  })
);
