export type Paginated<T> = {
  data: T[];
  total: number;
};

export type PaginationOptions = {
  page?: number;
  pageSize?: number;
};

export type SortingOptions = {
  sort?: string;
  order?: 'asc' | 'desc';
};

export type ErrorResponse = {
  status: number;
  error: string;
};

export type CompletionSuccessResponse = {
  status: number;
  body: {
    choices: {
      message: {
        content: string;
      };
    }[];
  };
};

export type EmbeddingSuccessResponse = {
  status: number;
  body: {
    data: {
      embedding: number[];
    }[];
  };
};

export type Token = {
  content: string;
  isImmediate: boolean;
};
