type BaseMsg = {
  id: string;
  text: string;
  ts: Date;
};

export type Welcome = BaseMsg & {
  type: 'welcome';
  sender: 'bot';
};

export type Question = BaseMsg & {
  type: 'question';
  sender: 'user';
};

export type Answer = BaseMsg & {
  type: 'answer';
  sender: 'bot';
  tooltips: Record<string, string>[];
  embeddings: number[];
  shouldAnimate: boolean;
  hasError?: boolean;
  errorId?: string;
  isChunk?: boolean;
};

export type Message = Welcome | Question | Answer;

export type DownloadInfo = {
  conversation: Message[];
};

export type OverflowPolicy =
  | 'throw-error'
  | 'remove-conversation-first'
  | 'truncate-context-first';

export type AddParamArg = {
  key: string;
  value: string;
  value_list: string[];
  source_visual_id: number;
  source_dataset_id: number;
  valueType: string;
};
export type ParamSource = 'all' | 'first' | 'none';
export type ParamSelection = 'all' | 'used-by-llm';
export type LoadingStatus = 'Embedding' | 'Completion' | 'Vector' | 'None';
