export type CombinedReport = {
  id: number;
  title: string;
  type: string;
  baseImg: string;
  editUrl: string;
  img: string;
  permissions: string[];
  url: string;
  workspace: {
    id: number;
    name: string;
  };
  updated: {
    date: string;
    by: string;
  };
  isClone: boolean;
  numberOfDescendants: number;
  created: {
    date: string;
    by: string;
  };

  // For dashboards and visuals
  datasetInfo?: {
    id: number;
    name: string;
    dataConnectionName: string;
    detail: string;
  };
  sharedVisualDashboardIds?: string[];

  // For apps
  rw?: boolean;

  // For searching
  tags?: string;
};
