import {
  DataCopyTarget,
  EmailTarget,
  JobStatus,
  SnapshotTarget,
} from './job.type';

export type JobLogTask = {
  message: string;
  date?: string;
};

export type JobLog = {
  id: number;
  status: JobStatus;
  jobId: number;
  ownerUsername?: string;
  startTime: string;
  endTime: string;
  totalRunTime: number;
  taskList: JobLogTask[];
  triggeredManually: boolean;
  editorUsername?: string;
  errorMessage?: string;
  triggeredByUsername?: string;
  emailTarget?: EmailTarget;
  snapshotTarget?: SnapshotTarget;
  dataCopyTarget?: DataCopyTarget;
};
