export type Statistics = {
  name: string;
  numberOfNulls: number;
  recordCount: number;
  distinctCount: number;

  fieldType:
    | 'UNKNOWN'
    | 'STRING'
    | 'INT'
    | 'BIGINT'
    | 'REAL'
    | 'DOUBLE'
    | 'BOOLEAN'
    | 'TIMESTAMP'
    | 'BINARY'
    | 'VECTOR'
    | 'TEXT';
};

export type MeasureBaseStatistics = Statistics & {
  min: number;
  max: number;
  avg: number;
  variance: number;
  numberOfZeroes: number;
  duplicatedRows: number;
};

export type DimensionBaseStatistics = Statistics & {
  min: string;
  max: string;
  duplicatedRows: number;
  shortestWord: string;
  longestWord: string;
  numberOfEmpty: number;
};

type Frequency = {
  mostFrequentValue: string | number | Error;
  leastFrequentValue: string | number | Error;
};

export type DimensionStatistics = DimensionBaseStatistics & Frequency;
export type MeasureStatistics = MeasureBaseStatistics & Frequency;
// Future IMPROVEMENT date/boolean handles separately
