import moment from 'moment';
export const formatDate = (datestr: string) => {
  const dateMoment = moment(datestr);
  if (dateMoment.isValid()) {
    return dateMoment.format('MMM DD, YYYY');
  }

  // Return 'N/A' if the datestr value isn't parseable
  return 'N/A';
};

export const formatTimeDifference = (datestr: string) => {
  const dateMoment = moment(datestr);
  if (dateMoment.isValid()) {
    return dateMoment.fromNow();
  }

  // Return 'N/A' if the datestr value isn't parseable
  return 'N/A';
};
