import { merge } from 'lodash-es';
import { getGlobalArc } from './get-global-arc';

export function exposeToGlobal(
  objectToBeExposed: Record<string, unknown>,
  key?: string
): void {
  let globalArc = getGlobalArc();
  if (key) {
    globalArc[key] = merge(globalArc[key] || {}, objectToBeExposed);
  } else {
    globalArc = merge(globalArc, objectToBeExposed);
  }
}
