import type { DataConnectionExtendedName } from '../types/data-connection.type';

export const getDataConnectionExtendedTypeName = ({
  extendedName,
  typeName,
}: {
  extendedName?: DataConnectionExtendedName;
  typeName: string;
}): string => {
  const extendedTypeNamesByExtendedName: Record<
    DataConnectionExtendedName,
    string
  > = {
    'cdw-hyve': 'Cloudera Data Warehouse Hive',
    'cdw-impyla': 'Cloudera Data Warehouse Impala',
    ssb: 'SQL Stream Builder (Tech Preview)',
  };

  if (extendedName) {
    return extendedTypeNamesByExtendedName[extendedName];
  }

  return typeName;
};
