const LOADING = 'Loading...';
const SELECT_AN_OPTION = 'Select an option';
const NO_DB_FOUND = 'No database found';
const NO_TABLE_FOUND = 'No table found';
const SELECT_FROM_DATABASE_LIST_FIRST = 'To load tables, select a database!';

export const getDatabaseListPlaceHolder = (
  isDatabaseListLoading: boolean,
  databaseLoadError?: Error | unknown
) => {
  if (isDatabaseListLoading) {
    return LOADING;
  }

  if (databaseLoadError) {
    return NO_DB_FOUND;
  }

  return SELECT_AN_OPTION;
};

export const getTableListPlaceHolder = (
  isTableListLoading: boolean,
  isDatabaseListLoading: boolean,
  forSelector: boolean,
  tableLoadError?: Error | unknown,
  databaseList?: string[],
  tableList?: string[],
  selectedTable?: string | undefined
) => {
  const tablesAvailable = !!tableList;
  const isTableListEmpty = tableList?.length === 0;

  if (isTableListLoading) {
    return LOADING;
  }

  if (isTableListEmpty || tableLoadError) {
    return NO_TABLE_FOUND;
  }

  if (
    !isDatabaseListLoading &&
    databaseList?.length &&
    !tablesAvailable &&
    !isTableListLoading
  ) {
    return SELECT_FROM_DATABASE_LIST_FIRST;
  }

  if (tablesAvailable && forSelector && !selectedTable) {
    return SELECT_AN_OPTION;
  }
  return '';
};
