type TableData<T> = {
  data: T[];
  currentPage: number;
  entriesPerPage: number;
};

export function paginateTableData<T>(tableData: TableData<T>): T[] {
  const { data, currentPage, entriesPerPage } = tableData;
  const startIndex = (currentPage - 1) * entriesPerPage;
  const endIndex = startIndex + entriesPerPage;
  return data.slice(startIndex, endIndex);
}
