export const savePageLoadTime = (pageStart: number) => {
  const loadTimeData = {
    url: window.location.href,
    loadTime: (Date.now() - pageStart) / 1000,
  };

  const lastArcIndex = loadTimeData.url.lastIndexOf('/arc/');
  const croppedUrl =
    lastArcIndex !== -1
      ? loadTimeData.url.substr(lastArcIndex + 5)
      : loadTimeData.url;
  // we're temporarily replace / with _ and # with * until DSE-31470 is fixed
  loadTimeData.url = croppedUrl.replace(/\//g, '_').replace(/#/g, '*');

  const loadTimesString = localStorage.getItem('loadTimes');
  const existingLoadTimes = loadTimesString ? JSON.parse(loadTimesString) : [];

  existingLoadTimes.push(loadTimeData);
  localStorage.setItem('loadTimes', JSON.stringify(existingLoadTimes));
};
