export const transformUnknownError = (
  unknownError: any | unknown,
  defaultMessage: string
): Error => {
  let error: Error;
  if (typeof unknownError === 'string') {
    error = new Error(`${defaultMessage}: ${unknownError}`);
  } else if (unknownError?.message) {
    error = new Error(`${defaultMessage}: ${unknownError.message}`);
  } else {
    error = new Error(defaultMessage);
  }
  return error;
};
