import '../../wdyr';
import 'scss/index.scss';
import 'services/feature-flipper';
import 'services/globals';
import { renderReactComponent } from 'utils/render-react-component';
import { logger } from 'services/logger';
import { exposeToGlobal } from 'utils/expose-to-global';
import { loadResources } from 'utils/load-resources';
import { savePageLoadTime } from 'utils/save-page-load-time';
import { FeatureFlipper } from 'services/feature-flipper';

logger.initialize();

FeatureFlipper.get().initialize(window.flippersAsJsonString);

exposeToGlobal(
  { renderReactComponent, loadResources, savePageLoadTime },
  'frontend'
);
