import * as path from 'path';
import type { Configuration } from 'webpack';
import { merge } from 'webpack-merge';
import { commonWebpackConfiguration } from './webpack.common';
import EslintWebpackPlugin from 'eslint-webpack-plugin';

const developmentWebpackConfiguration: Configuration = merge(
  commonWebpackConfiguration,
  {
    mode: 'development',
    devtool: 'eval-source-map',
    output: {
      path: path.resolve(
        __dirname,
        '../../arcweb/static/js/build/development/frontend'
      ),
    },
    plugins: [
      // @ts-ignore https://github.com/webpack-contrib/eslint-webpack-plugin/issues/16
      new EslintWebpackPlugin({
        extensions: ['ts'],
        failOnError: false,
      } as EslintWebpackPlugin.Options),
    ],
  }
);

export default developmentWebpackConfiguration;
