import * as path from 'path';
import type { Configuration } from 'webpack';
import { merge } from 'webpack-merge';
import EslintWebpackPlugin from 'eslint-webpack-plugin';

import { commonWebpackConfiguration } from './webpack.common';

const productionWebpackConfiguration: Configuration = merge(
  commonWebpackConfiguration,
  {
    mode: 'production',
    devtool: 'source-map',
    output: {
      path: path.resolve(
        __dirname,
        '../../arcweb/static/js/build/production/frontend'
      ),
    },
    plugins: [
      // @ts-ignore https://github.com/webpack-contrib/eslint-webpack-plugin/issues/16
      new EslintWebpackPlugin({
        extensions: ['ts'],
        failOnWarning: true,
      } as EslintWebpackPlugin.Options),
    ],
  }
);

export default productionWebpackConfiguration;
