#!/usr/bin/env bash

set -x

export VIZ_CONF_DIR=/etc/viz/conf

function set_samlcert() {
  mkdir -pm 755 $VIZ_CONF_DIR/samlcert
  cd $VIZ_CONF_DIR/samlcert
  export RANDFILE=$VIZ_CONF_DIR/samlcert/.rnd
  if [ -z ${PASSPHRASE+x} ]; then
    openssl genrsa -des3 -passout pass:cloudera -out server.pass.key 2048
    openssl rsa -inform PEM -outform PEM -passin pass:cloudera -in server.pass.key -out server.key
    openssl req -new -key server.key -out server.csr -subj "/C=US/ST=California/L=Palo Alto/O=Cloudera/OU=Viz/CN=$EXTERNAL_HOST"
    openssl x509 -req -days 365 -in server.csr -signkey server.key -out server.crt
  else
    echo "#!/bin/bash" > $HUE_CONF_DIR/samlcert/pass.key
    echo "echo \$PASSPHRASE" >> $HUE_CONF_DIR/samlcert/pass.key
    chmod a+x $HUE_CONF_DIR/samlcert/pass.key
    openssl genrsa -des3 -passout pass:$PASSPHRASE -out server.key 2048
    openssl req -new -key server.key -out server.csr -passin pass:$PASSPHRASE -subj "/C=US/ST=California/L=Palo Alto/O=Cloudera/OU=Viz/CN=$EXTERNAL_HOST"
    openssl x509 -req -days 365 -in server.csr -passin pass:$PASSPHRASE -signkey server.key -out server.crt
  fi
  export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/lib64
}

if [ -e "/etc/viz/conf/saml.ini" ]; then
  set_samlcert
fi

/opt/vizapps/tools/arcviz/startviz_repeat.sh

