# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

import os
import logging
from reports.notification_center import NotificationCenter
from reports.models import AppSetting

basedir = os.environ.get("BASEDIR")

should_add_advanced_settings = False
advanced_settings = ''
base_settings = ''

with open(f'{basedir}/settings_local.py', 'r') as f:
  base_settings = f.read()

for a in AppSetting.objects.filter(setting_key="advanced_settings"):
  try:
    advanced_settings = a.setting_value
    exec(base_settings + '\n' + advanced_settings)
    should_add_advanced_settings = True
  except Exception as e:
    error = {'title': 'Error in the custom settings', 'body':f'{advanced_settings} \n stacktrace: {e}'}
    LOGGER = logging.getLogger("arcweb")
    LOGGER.warning(f'Error in the advanced settings: \n{advanced_settings} \ {e}')
    NotificationCenter().add_errors([error], True)

if should_add_advanced_settings:
  with open(f'{basedir}/settings_local.py', 'w') as f:
    f.write(base_settings + '\n' + advanced_settings)
