#!/usr/bin/env python3
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

import os

if os.environ.get('CDSW_APP_PORT'):
  os.environ['VIZ_PORT'] = os.environ.get('CDSW_APP_PORT')
  os.environ['VIZ_HOST'] = "127.0.0.1"
  print(f'setting VIZ_HOST to {os.environ.get("VIZ_HOST")}', flush=True)
  print(f'setting VIZ_PORT to {os.environ.get("VIZ_PORT")}', flush=True)
else:
  print(f'CDSW_APP_PORT not set', flush=True)

sitePackages = "/opt/vizapps/venv/lib64/python3.9/site-packages"
basePath = f"{sitePackages}/arcweb"
# VENV_PATH set by default in Dockerfiles under packaging/assets
#    cdsw: ENV VENV_PATH /opt/vizapps/venv
#    cml: ENV VENV_PATH /opt/vizapps/venv
#
# CDW sets the path a little differently by adding it to the PATH env variable inside the bash profile
#    cdw: RUN echo 'PATH=/opt/vizapps/tools/venv/bin:$PATH' >> ~arcadia/.bash_profile

pyPath = os.environ.get("PYTHONPATH", "")
if pyPath:
  # add site-packages to a position that preceeds system PYTHONPATH
  # needed because system PYTHONPATH can point to older versions of packages needed by viz
  os.environ["PYTHONPATH"] = basePath + ":" + sitePackages +":" + pyPath
else:
  os.environ["PYTHONPATH"] = basePath

# Set Arcweb library path separately in case we need it for other things during startup
os.environ["ARCWEB_PATH"] = basePath

print("PYTHONPATH", os.environ.get("PYTHONPATH"))
print("ARCWEB_PATH", os.environ.get("ARCWEB_PATH"))

os.system("/opt/vizapps/tools/arcviz/startviz_repeat.sh")

