#!/usr/bin/env python
# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.

import sys
import json
import os

def main():
  fname = sys.argv[1]
  if not fname:
    raise Exception("no filename provided")

  PKG_VERSION = os.environ.get('PKG_VERSION')
  with open(fname, "w") as f:
    f.write(json.dumps({
      'version': PKG_VERSION,
      'cdw_container': f'cdwdataviz:{PKG_VERSION}',
      'cmldataviz': f'cmldataviz:{PKG_VERSION}',
      'cdswdataviz': f'cdswdataviz:{PKG_VERSION}',
      'runtimedataviz': f'runtimedataviz:{PKG_VERSION}',
      'cml_tarball': f'cmlvizapps-{PKG_VERSION}.tgz',
      'cml_tarball_installer': f'install.py'
    }, indent=2))
    f.write('\n')

  os.system(f'cat {fname}')

if __name__ == "__main__":
  main()

