# Testing changes to cdwdataviz on mow-dev

1. Build the version of cdwdataviz you would like to test out
   Skip this step if you have an image you want to test already

    - `docker login docker-sandbox.infra.cloudera.com`
      - use your okta credentials

    - `scons docker_push_cdwdataviz_dev`
      - This will push out a container to docker-sandbox.infra.cloudera.com/<okta_username>/cdv/cdwdataviz:<someversion>

2. Startup a virtual warehouse and enable viz on it

    - Download the `kubeconfig` for the environment

    - `kubectl get pods --all-namespaces | grep viz-webapp-0`
      - (Get the namespace from the first column)

    - `kubectl edit statefulset viz-webapp -n <namespace>`

    - Edit the line that contains the image name to point at the image you want
      - image: `docker-sandbox.infra.cloudera.com/<okta_username>/cdv/cdwdataviz:<someversion>`

    - Edit the line that says `imagePullPolicy` and set it to `Always`

    - Save away the file

    - This will automatically restart the pod to run the new version you are pointing to

3. `viz-webapp` should now be running the code in the tagged docker container

    - Now, as you build and publish new images with the same tag, you can restart the
      dataviz pod to get newer bits on there

