#!/bin/bash -x
#
# Cloudera Viz for CDW Docker Image build script
#
# This is a multistage Docker build
# This helps makes builds independent of the os and environment of the build system,
# removing the need to maintain bespoke build AMIs.
#
# Use 'scons cdwdataviz' to invoke it.
#
# Build artifacts are saved to '../artifacts'
# Build logs and other files are saved to 'build_out/'
#

set -e
set -o pipefail

BRANCH=$(git rev-parse --abbrev-ref HEAD)
REPO=$(git rev-parse --show-toplevel)

echo "Building from: ${REPO}#${BRANCH}"

mkdir -p build_out

IMAGENAME="cdv/cdwdataviz"

docker build ${DOCKER_BUILD_ARGS} --build-arg WHEEL_VERSION=${WHEEL_VERSION} --build-arg PKG_VERSION=${PKG_VERSION} -t ${IMAGENAME}:${PKG_VERSION} -f ${REPO}/packaging/assets/Dockerfile_cdwdataviz ${REPO}/packaging/assets | tee build_out/build.log

echo "RUN AS: docker run -p 38888:38888 ${IMAGENAME}:${PKG_VERSION}"

