#!/bin/bash -x
#
# Cloudera Viz for CDW Docker Image build script
#
# This is a multistage Docker build
# This helps makes builds independent of the os and environment of the build system,
# removing the need to maintain bespoke build AMIs.
#
# Use 'scons cdwdataviz' to invoke it.
#
# Build artifacts are saved to '../artifacts'
# Build logs and other files are saved to 'build_out/'
#

set -e
set -o pipefail

mkdir -p build_out
mkdir -p ../cmlvizapps/build_out

docker build ${DOCKER_BUILD_ARGS} -t cdwvizapps_phase1:${PKG_VERSION} -f ../assets/Dockerfile_cdwdataviz_phase1 ../assets | tee build_out/build.log

docker create --name cdwvizapps_phase1 cdwvizapps_phase1:${PKG_VERSION}
docker cp cdwvizapps_phase1:/tmp/arcviz_wheels.tbz2 ../assets/
docker rm cdwvizapps_phase1