#!/bin/bash -x
#
# This is the docker build script for the CML Base Image including Cloudera Viz
#
# Use 'scons cmlengine_viz' to invoke it.
#
# Build logs and other files are saved to 'build_out/'
#

set -x
set -e
set -o pipefail

IMAGENAME="cdv/cmldataviz"

docker build ${DOCKER_BUILD_ARGS} --build-arg WHEEL_VERSION=${WHEEL_VERSION} --build-arg PKG_VERSION=${PKG_VERSION} -t ${IMAGENAME}:${PKG_VERSION} -f ../assets/Dockerfile_cmldataviz ../assets | tee build_out/build.log

echo "RUN AS: docker run -p 8100:8100 ${IMAGENAME}:${PKG_VERSION}"

