#!/bin/bash -x
#
# This is the docker build script for the CML Base Image including Cloudera Viz
#
# Use 'scons runtimedataviz' to invoke it.
#
# Build logs and other files are saved to 'build_out/'
#

set -x
set -e
set -o pipefail

IMAGENAME="cdv/runtimedataviz"

RT_SHORT_VERSION=${PKG_VERSION%-*}
RT_GBN=${GBN}
RT_GIT_HASH=${LAST_COMMIT_ID}
docker build ${DOCKER_BUILD_ARGS} --build-arg WHEEL_VERSION=${WHEEL_VERSION} --build-arg PKG_VERSION=${PKG_VERSION} --build-arg RT_FULL_VERSION=${PKG_VERSION} --build-arg RT_SHORT_VERSION=${RT_SHORT_VERSION} --build-arg RT_GBN=${RT_GBN} --build-arg RT_GIT_HASH=${RT_GIT_HASH} -t ${IMAGENAME}:${PKG_VERSION} -f ../assets/Dockerfile_runtimedataviz ../assets | tee build_out/build.log

echo "RUN AS: docker run -p 8100:8100 ${IMAGENAME}:${PKG_VERSION}"

