# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
import os

def PyCompile(env, source):
  compile_cmd = env.Command(source + 'c', source,
    "python -c 'import py_compile; py_compile.compile(\"${SOURCE}\", \"${SOURCE}c\", None, True)'")
  return compile_cmd

def getPyFiles(dir):
  return getExtensionFiles(dir, set(["py"]))

def getPyJsFiles(dir):
  return getExtensionFiles(dir, set(["py", "js", "scss", "css", "html"]))

def getJSFiles(dir):
  jsFilenames = getExtensionFiles(dir, set(["js"]))
  return jsFilenames

def getExtensionFiles(dir, extensions):
  matches = []

  filenames = os.listdir(dir)
  for f in filenames:
    fullf = os.path.join(dir, f)
    if os.path.isdir(fullf):
      matches.extend(getExtensionFiles(fullf, extensions))
      continue

    fparts = f.partition(".")
    if fparts[2] in extensions:
      matches.append(fullf)
      continue

  return matches
