# Copyright (c) 2013 - 2025 Cloudera, Inc.  All Rights Reserved.
#  
# Unless otherwise agreed to in writing by Cloudera, use of this file is exclusively governed by the Cloudera Standard License (the “License”), a copy of which may be found at https://www.cloudera.com/legal/commercial-terms-and-conditions.html.
#  
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the License for the specific permissions and limitations governing your use of the file.
from subprocess import Popen, PIPE, run, CalledProcessError, check_output
import sys

def run_cmd(cmd):
  try:
    return run(
      cmd,
      shell=True,
      check=True,
      stdout=PIPE,
      stderr=sys.stdout.buffer
    ).stdout.decode("utf-8")
  except CalledProcessError as err:
    sys.stdout.write(err.stdout.decode("utf-8"))
    exit(err.returncode)

def run_cmd_pipe(cmd1, cmd2):
  try:
    process1 = Popen(cmd1.split(" "), stdout=PIPE)
    output = check_output(cmd2.split(" "), stdin=process1.stdout)
    process1.wait()
    return output.decode('utf-8')
  except CalledProcessError as err:
    sys.stdout.write(err.stdout.decode("utf-8"))
    exit(err.returncode)

def touch_targets(target):
  for file in target:
    run_cmd(f'touch {file.abspath}')
