window.arc = window.arc || {};

(function() {
'use strict';

arc.emailApp = arc.emailApp || {};

arc.emailApp = function() {
  const emailApp = function() { return 'arc.emailApp'; };

  let snapshotInstance;
  let $visualTitle = $('#viz-title');

  const $dashboardTitle = $('#dashboard-title');
  if (!$visualTitle.length) {
    $visualTitle = $('.arc-viz-title');
  }

  const getDatasetId = () => {
    const dashboardDataset = document.getElementsByClassName('datasets-sidebar-sel')[0];

      if (dashboardDataset) {
        return dashboardDataset.value;
      }

      if (arc.globals.dashboard) {
        return arc.globals.dashboard.getDatasetId();
      }

        if (arc.globals.singleVisualBuilder) {
        // This shouldn't be needed
        return arc.globals.singleVisualBuilder.dataset_id();
      }
  };

  emailApp.initialize = function() {
    $(document).on('click.email', '.email-visual', (e) => {
      const type = arc.globals.isInModal() || e.currentTarget.dataset.isVisual === 'True' ? 'visual' : 'sheet';
      const id = Number(e.currentTarget.dataset.appid);
      const snapshotDetails = snapshotInstance.getSnapshotParams(false, id);
      const title = (type === 'visual' ? $visualTitle?.text() : $dashboardTitle?.text()) ?? '';

      arc.frontend.legacyBridge.events.next({
        type: 'open-email-job-modal',
        payload: {
          id,
          type,
          title,
          dashboardId: arc.globals.dashboard.dashboard_id(),
          datasetId: getDatasetId(),
          dbWidth: snapshotDetails.dbWidth,
          dbHeight: snapshotDetails.dbHeight,
          paramString: snapshotDetails.paramString,
          url: window.location.pathname,
          disableXlsxAndCsv: arc.report.noResultExcludeTypes.has(e.currentTarget.dataset.reportType) || e.currentTarget.dataset.reportType === 'chatbot',
        }
      });
    });
  };

  emailApp.snapshotInstance = function(_) {
    if (!arguments.length) return snapshotInstance;
    snapshotInstance = _;
    return emailApp;
  };

  return emailApp;
};
}());
